#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>

using namespace std;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n, m, q;
  cin >> n >> m >> q;

  vector<vector<int>> a(n, vector<int>(m));

  vector<set<pair<int, int>>> rows(n), cols(m);

  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      cin >> a[i][j];
      rows[i].insert({ a[i][j], j });
      cols[j].insert({ a[i][j], i });
    }
  }

  int cur = 0;
  if (n <= m) {
    for (int i = 0; i < n; ++i) {
      int bj = rows[i].rbegin()->second;
      if (cols[bj].rbegin()->second == i) cur++;
    }
  }
  else {
    for (int j = 0; j < m; ++j) {
      int bi = cols[j].rbegin()->second;
      if (rows[bi].rbegin()->second == j) cur++;
    }
  }

  while (q--) {
    int r, c, x;
    cin >> r >> c >> x;
    r--, c--;

    rows[r].erase({ a[r][c], c });
    cols[c].erase({ a[r][c], r });

    a[r][c] = x;

    rows[r].insert({ x, c });
    cols[c].insert({ x, r });
    

    int cur = 0;
    if (n <= m) {
      for (int i = 0; i < n; ++i) {
        int bj = rows[i].rbegin()->second;
        if (cols[bj].rbegin()->second == i) cur++;
      }
    }
    else {
      for (int j = 0; j < m; ++j) {
        int bi = cols[j].rbegin()->second;
        if (rows[bi].rbegin()->second == j) cur++;
      }
    }

    cout << cur << '\n';
  }

  return 0;
}