#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>

using namespace std;

typedef long long LL;

const int MAXN = 150001;

struct Buyer {
  int a, b;

  bool operator<(const Buyer &o) const {
    return a != o.a ? a < o.a : b < o.b;
  }
};

int n;
Buyer b[MAXN];

LL calc(int Cip) {
  int end = lower_bound(b, b + n, Buyer{ Cip, -1 }) - b;
  LL cur = (n - end) * 1ll * Cip;

  vector<int> cipleft;
  cipleft.reserve(end);
  for (int i = 0; i < end; ++i)
    cipleft.push_back(b[i].b);
  sort(cipleft.begin(), cipleft.end());

  LL addmax = 0;
  for (int i = 0; i < (int)cipleft.size(); ++i) {
    addmax = max(addmax, cipleft[i] * 1ll * (cipleft.size() - i));
  }

  return cur + addmax;
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  ios::sync_with_stdio(0);

  cin >> n;

  for (int i = 0; i < n; ++i)
    cin >> b[i].a >> b[i].b;

  sort(b, b + n);

  LL ans = 0;

  int CipL = 0, CipR = b[n - 1].a;

  while (CipR - CipL > 2) {
    int CipML = CipL + (CipR - CipL) / 3;
    int CipMR = CipR - (CipR - CipL) / 3;

    LL resL = calc(CipML), resR = calc(CipMR);

    if (resL > resR)
      CipR = CipMR;
    else
      CipL = CipML;

    ans = max(ans, resL);
    ans = max(ans, resR);
  }

  for (int i = CipL; i <= CipR; ++i)
    ans = max(ans, calc(i));

  cout << ans << '\n';
  return 0;
}