#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>

using namespace std;

typedef long long LL;

const int MAXN = 150001;

struct Buyer {
  int a, b;
  
  bool operator<(const Buyer &o) const {
    return b != o.b ? b < o.b : a < o.a;
  }
};

int n;
Buyer b[MAXN];


int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  ios::sync_with_stdio(0);

  cin >> n;

  for (int i = 0; i < n; ++i)
    cin >> b[i].a >> b[i].b;

  sort(b, b + n);

  vector<pair<int, int>> ordera(n);
  for (int i = 0; i < n; ++i) {
    ordera[i] = { b[i].a, i };
  }
  sort(ordera.begin(), ordera.end());

  LL ans = 0;
  int left = n;
  
  int BSIZE = sqrt(n);
  int rebuildt = 0;
  LL bmax = 0;

  vector<int> bs;
  vector<int> pmax;
  int mxpoint = 0;

  for (pair<int, int> a : ordera) {
    ans = max(ans, left * 1ll * a.first + bmax);
    left--;

    pmax.push_back(b[a.second].b);
    sort(pmax.begin(), pmax.end());

    int it = 0;
    for (int i = 0; i < pmax.size(); ++i) {
      int s = (pmax.size() - i);
      it = lower_bound(bs.begin() + it, bs.end(), pmax[i]) - bs.begin();
      s += (int)bs.size() - it;
      bmax = max(bmax, (LL)s * pmax[i]);
    }
    
    {
      int i = lower_bound(pmax.begin(), pmax.end(), mxpoint) - pmax.begin();
      int s = (pmax.size() - i);
      it = lower_bound(bs.begin() + it, bs.end(), mxpoint) - bs.begin();
      s += (int)bs.size() - it;
      bmax = max(bmax, (LL)s * mxpoint);
    }

    if (++rebuildt == BSIZE) {
      // REBUILD
      rebuildt = 0;
      for (auto x : pmax)
        bs.push_back(x);
      sort(bs.begin(), bs.end());
      pmax.clear();

      mxpoint = 0;
      LL mxval = 0;

      for (int i = 0; i < bs.size(); ++i) {
        LL cur = ((LL)bs.size() - i) * bs[i];
        if (mxval < cur) {
          mxval = cur;
          mxpoint = bs[i];
        }
      }
      bmax = mxval;
    }
  }

  cout << ans << '\n';
 
  return 0;
}