#pragma comment(linker, "/Stack:460000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>
#include <bitset>

using namespace std;

typedef long long LL;
typedef long double ahah;

const int MAXL = 508;
const int MAXK = 10001;

typedef ahah Cost;

/*
inline bool operator<(const Cost &a, const Cost &b) {
  for (int i = MAXL - 1; i > -1; --i) {
    if (a[i] != b[i])
      return a[i] < b[i];
  }
  return 0;
}
*/
struct Processor {
  int x, y, id;
};

Cost dist[MAXK];
int prevproc[MAXK];
bool used[MAXK];

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  ios::sync_with_stdio(0);

  int n, m, k;
  cin >> n >> m >> k;

  vector<Processor> a(k);
  for (int i = 0; i < k; ++i) {
    cin >> a[i].x >> a[i].y;
    a[i].id = i;
  }

  for (int i = 1; i < k; ++i)
    dist[i] = (ahah)1e300;
    //dist[i].flip();
    

  while (!used[k - 1]) {
    int v = -1;
    for (int to = 0; to < k; ++to) {
      if (!used[to] && (v == -1 || dist[to] < dist[v])) {
        v = to;
      }
    }
    if (v == -1) break;
    used[v] = 1;

    for (int to = 0; to < k; ++to) {
      if (used[to]) continue;
      int p = max(abs(a[v].x - a[to].x), abs(a[v].y - a[to].y));
      ahah tmp = dist[v] + pow(2, p);
      if (tmp < dist[to]) {
        dist[to] = tmp;
        prevproc[to] = v;
      }
    }
  }

  vector<int> path;
  int cur = k - 1;
  while (cur != 0) {
    path.push_back(cur);
    cur = prevproc[cur];
  }
  path.push_back(0);
  reverse(path.begin(), path.end());

  cout << path.size() << '\n';
  for (auto x : path)
    cout << x + 1 << ' ';
  cout << '\n';

  return 0;
}