#pragma comment(linker, "/Stack:460000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>
#include <bitset>

using namespace std;

typedef long long LL;

const int MAXL = 508;
const int MAXK = 10001;

typedef vector<int> Cost;

inline bool operator<(const Cost &a, const Cost &b) {
  int ita = 0, itb = 0;
  while (ita < a.size() && itb < b.size()) {
    if (a[ita] != b[itb])
      return a[ita] < b[itb];
    ita++;
    itb++;
  }

  return itb < b.size();
}

struct Processor {
  int x, y, id;
};

Cost dist[MAXK];
int prevproc[MAXK];
bool used[MAXK];

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  ios::sync_with_stdio(0);

  int n, m, k;
  cin >> n >> m >> k;

  vector<Processor> a(k);
  for (int i = 0; i < k; ++i) {
    cin >> a[i].x >> a[i].y;
    a[i].id = i;
  }

  for (int i = 1; i < k; ++i)
    dist[i].push_back(20000);

  vector<pair<int, vector<int>>> g(k);
  for (int i = 0; i < k; ++i) {
    g[i].first = 20000;
    for (int j = 0; j < k; ++j) {
      if (i == j || a[j].x < a[i].x - 5 || a[j].y < a[i].y - 5) continue;
      int p = max(abs(a[i].x - a[j].x), abs(a[i].y - a[j].y));
      if (p == g[i].first)
        g[i].second.push_back(j);
      else if (p < g[i].first) {
        g[i].first = p;
        g[i].second.clear();
        g[i].second.push_back(j);
      }
    }
  }

  while (!used[k - 1]) {
    int v = -1;
    for (int to = 0; to < k; ++to) {
      if (!used[to] && (v == -1 || dist[to] < dist[v])) {
        v = to;
      }
    }
    if (v == -1) break;
    used[v] = 1;

    for (int to : g[v].second) {
      if (used[to]) continue;
      int p = g[v].first;
      
      auto tmp = dist[v];
      vector<int> tail;
      while (tmp.size() && tmp.back() < p) {
        tail.push_back(tmp.back());
        tmp.pop_back();
      }
      while (tmp.size() && tmp.back() == p) {
        tmp.pop_back();
        p++;
      }
      tmp.push_back(p);
      while (tail.size()) {
        tmp.push_back(tail.back());
        tail.pop_back();
      }

      if (tmp < dist[to]) {
        dist[to] = tmp;
        prevproc[to] = v;
      }
    }
  }

  vector<int> path;
  int cur = k - 1;
  while (cur != 0) {
    path.push_back(cur);
    cur = prevproc[cur];
  }
  path.push_back(0);
  reverse(path.begin(), path.end());

  cout << path.size() << '\n';
  for (auto x : path)
    cout << x + 1 << ' ';
  cout << '\n';

  return 0;
}