#pragma comment(linker, "/Stack:460000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <cmath>
#include <bitset>

using namespace std;

typedef long long LL;

const int MAXL = 508;
const int MAXK = 10001;

typedef vector<int> Cost;

inline bool operator<(const Cost &a, const Cost &b) {
  int ita = 0, itb = 0;
  while (ita < a.size() && itb < b.size()) {
    if (a[ita] != b[itb])
      return a[ita] < b[itb];
    ita++;
    itb++;
  }

  return itb < b.size();
}

struct Processor {
  int x, y, id;
};

Cost dist[MAXK];
int prevproc[MAXK];
bool used[MAXK];

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  cin.tie(0);
  ios::sync_with_stdio(0);

  int n, m, k;
  cin >> n >> m >> k;

  vector<Processor> a(k);
  for (int i = 0; i < k; ++i) {
    cin >> a[i].x >> a[i].y;
    a[i].id = i;
  }

  for (int i = 1; i < k; ++i)
    dist[i].push_back(20000);

  vector<int> distp(k, 20000);

  for (int i = 1; i < k; ++i) {
    distp[i] = max(abs(a[i].x - a[0].x), abs(a[i].y - a[0].y));
    prevproc[i] = 0;
  }

  used[0] = 1;

  while (!used[k - 1]) {
    int ind = -1;
    vector<int> inds;
    for (int i = 0; i < k; ++i) {
      if (!used[i] && (ind == -1 || distp[i] == distp[ind])) {
        inds.push_back(i);
        ind = i;
      }
      if (!used[i] && (ind == -1 || distp[i] < distp[ind])) {
        inds.clear();
        inds.push_back(i);
        ind = i;
      }
    }
    if (ind == -1) break;
    for (int x : inds)
      used[x] = 1;
    for (int to = 0; to < k; ++to) {
      if (used[to]) continue;
      int pmin = 20000, pid;
      for (int i : inds) {
        if (pmin > max(abs(a[i].x - a[to].x), abs(a[i].y - a[to].y))) {
          pmin = max(abs(a[i].x - a[to].x), abs(a[i].y - a[to].y));
          pid = i;
        }
      }

      if (distp[to] > pmin) {
        distp[to] = pmin;
        prevproc[to] = pid;
      }
    }
  }

  vector<int> path;
  int cur = k - 1;
  while (cur != 0) {
    path.push_back(cur);
    cur = prevproc[cur];
  }
  path.push_back(0);
  reverse(path.begin(), path.end());

  cout << path.size() << '\n';
  for (auto x : path)
    cout << x + 1 << ' ';
  cout << '\n';

  return 0;
}