#define _CRT_SECURE_NO_WARNINGS
// #pragma comment(linker, "/Stack:480000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>

using namespace std;

struct ST {
  int mn, mnid, mx, mxid;

  ST *left, *right;

  ST(int L, int R, vector<int> &a) {
    if (L == R - 1) {
      mn = a[L];
      mx = a[L];
      mnid = mxid = L;
    }
    else {
      int mid = (L + R) / 2;
      left = new ST(L, mid, a);
      right = new ST(mid, R, a);

      if (left->mn <= right->mn) {
        mn = left->mn;
        mnid = left->mnid;
      }
      else {
        mn = right->mn;
        mnid = right->mnid;
      }

      if (left->mx > right->mx) {
        mx = left->mx;
        mxid = left->mxid;
      }
      else {
        mx = right->mx;
        mxid = right->mxid;
      }
    }
  }
};

int getIndLower(ST *root, int L, int R, int ql, int qr) {
  if (L >= qr || ql >= R) return qr;
  if (ql <= L && R <= qr) return root->mnid;
  int mid = (L + R) / 2;
  return min(getIndLower(root->left, L, mid, ql, qr), getIndLower(root->right, mid, R, ql, qr));
}

int getIndMax(ST *root, int L, int R, int ql, int qr) {
  if (L >= qr || ql >= R) return ql;
  if (ql <= L && R <= qr) return root->mxid;
  int mid = (L + R) / 2;
  return max(getIndMax(root->left, L, mid, ql, qr), getIndMax(root->right, mid, R, ql, qr));
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n;
  cin >> n;

  vector<int> a(n);
  for (int i = 0; i < n; ++i)
    cin >> a[i];

  int cnt = 0;

  ST *root = new ST(0, n, a);

  for (int i = 0; i < n; ++i) {
    int L = i, R = n;
    while (R - L > 1) {
      int md = (L + R) / 2;
      int mnid = getIndLower(root, 0, n, i, md + 1);
      if (mnid >= n || a[mnid] < a[i])
        R = md;
      else
        L = md;
    }

    int mxid = getIndMax(root, 0, n, i, L + 1);
    cnt++;
    i = mxid;
  }

  cout << cnt << endl;

  return 0;
}