#define _CRT_SECURE_NO_WARNINGS
// #pragma comment(linker, "/Stack:480000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>

using namespace std;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n;
  cin >> n;

  vector<int> a(n);
  for (int i = 0; i < n; ++i)
    cin >> a[i];

  vector<int> dp(n, (int)1e9);

  vector<pair<int, int>> decr;
  vector<int> incr;

  // decr[i] = {val, ind}
  // incr[i] = ind

  struct Cmp {
    bool operator()(const pair<int, int> &a, const pair<int, int> &b) {
      return a.first != b.first ? a.first > b.first : a.second > b.second;
    }
  };

  for (int i = 0; i < n; ++i) {
    if (i) {
      dp[i] = min(dp[i], dp[i - 1] + 1);
    }
    else {
      dp[i] = 1;
      
      decr.push_back({ a[i], i });
      incr.push_back(0);
      continue;
    }

    int it = lower_bound(decr.begin(), decr.end(), pair<int, int>(a[i], -1), Cmp()) - decr.begin();
    int L = it == decr.size() ? i : decr[it].second;

    while (decr.size() && decr.back().first < a[i])
      decr.pop_back();
    
    int it2 = lower_bound(incr.begin(), incr.end(), L) - incr.begin();
    if (it2 != incr.size()) {
      dp[i] = min(dp[i], dp[incr[it2]]);
      decr.push_back({ a[i], incr[it2] });
    }
    else {
      decr.push_back({ a[i], i });
    }

    while (incr.size() && a[incr.back()] > a[i])
      incr.pop_back();
    incr.push_back(i);
  }

  cout << dp[n - 1] << endl;

  return 0;
}