#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/Stack:480000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <sstream>

using namespace std;

const int MAXMEM = (int)480e6;
char MEM[MAXMEM];
size_t mempos = 0;

inline void* operator new (size_t n) {
  void *res = (void*)(MEM + mempos);
  mempos += n;
  return res;
}
inline void operator delete(void*) {}

const int MAXN = 400001;
int a[MAXN];
int ans[MAXN];

typedef long long LL;

const LL INF = (LL)1e9 + 3 * MAXN;

struct Fenwick {
  unordered_map<int, int> _sum;

  Fenwick() {
    _sum.rehash((int)1e7);
  }

  void inc(int pos, int delta) {
    for (LL i = pos; i < INF; i = i | (i + 1)) {
      _sum[i] += delta;
    }
  }

  int sum(int pos) {
    int s = 0;
    for (int i = pos; i > -1; i = (i & (i + 1)) - 1)
      s += _sum[i];
    return s;
  }
};

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  int n, p;
  scanf("%d%d", &n, &p);

  for (int i = 0; i < n; ++i)
    scanf("%d", &a[i]);
  
  stringstream out;

  if (p == 1) {
    for (int i = 1; i < n; ++i)
      a[i] += i;

    Fenwick left, right;

    for (int i = 0; i < n; ++i)
      right.inc(a[i], 1);

    int shift = 2 * n;
    for (int i = 0; i < n; ++i) {
      right.inc(a[i], -1);

      int p = right.sum(a[i] - 1) + left.sum(a[i] + shift - 1);
      //printf("%d\n", p + 1);
      out << p + 1 << '\n';

      left.inc(a[i] + shift, 1);
      shift -= 2;
    }
  }
  else {
    for (int i = 0; i < n; ++i) {
      int mx = 0;
      
      vector<int> tocheck;
      tocheck.push_back(i);
      tocheck.push_back(n - i - 1);

      for (int delta : tocheck) {
        int less = 0;
        int R = 2 * MAXN + 1, L = -MAXN - 1;

        if (i + delta <= n - 1) R = i + delta;
        if (delta <= i) L = i - delta;

        for (int j = 0; j < n; ++j) {
          int add = min(max(0, j - L), max(0, R - j));
          if (a[j] + add < a[i] + delta) less++;
        }
        mx = max(mx, less);
      }
      
      out << mx + 1 << '\n';
    }
  }

  string tmp = out.str();
  for (char c : tmp)
    putchar(c);

  return 0;
}