#define _CRT_SECURE_NO_WARNINGS
// #pragma comment(linker, "/Stack:480000000")

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>

using namespace std;

const int MAXMEM = (int)480e6;
char MEM[MAXMEM];
size_t mempos = 0;

inline void* operator new (size_t n) {
  void *res = (void*)(MEM + mempos);
  mempos += n;
  return res;
}
inline void operator delete(void*) {}

string result(600000, '0');

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);

  int n;
  cin >> n;

  vector<string> a(n);
  for (int i = 0; i < n; ++i)
    cin >> a[i];

  struct Cmp {
    bool operator()(const string &a, const string &b) {
      if (a.length() != b.length())
        return a.length() < b.length();
      for (int i = 0; i < a.length(); ++i)
        if (a[i] != b[i])
          return a[i] < b[i];
      return 0;
    }
  };

  sort(a.begin(), a.end(), Cmp());

  for (int i = 0; i < n; ++i)
    reverse(a[i].begin(), a[i].end());

  for (int i = n - 1; i > -1; --i) {
    vector<int> st;
    for (int j = a[i].length() - 1; j > -1; --j) { 
      if (a[i][j] == '1' && result[j] == '1') {
        int k = j + 1;
        while (result[k] != '0') {
          if (!st.empty() && st.back() == k) {
            result[k] = '0';
            st.pop_back();
          }
          k++;
        }
        result[k] = '1';
        break;
      }
      if (a[i][j] == '1') {
        st.push_back(j);
        result[j] = '1';
      }
    }
  }

  while (result.length() > 1 && result.back() == '0')
    result.pop_back();
  reverse(result.begin(), result.end());
  cout << result << '\n';

  return 0;
}