﻿//#include "stdafx.h"

#pragma GCC optimize ("Ofast")

#include <fstream>
#include <vector>
#include <set>
#include <math.h>
#include <algorithm>
#include <stack>
#include <random>

using namespace std;

#ifdef _DEBUG
ifstream cin("input.txt");
ofstream cout("output.txt");
#else
#include <iostream>
#endif

typedef pair <int, int> pii;

#define mp make_pair
#define i_o ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL)

struct node {
	node *l = nullptr, *r = nullptr;
	int sz = 1;
	int y = RAND_MAX * rand() + rand();
	int key;
	node(int _key) {
		key = _key;
	}
};

void update(node *v) {
	if (v == nullptr) return;
	v->sz = 1;
	if (v->l != nullptr) v->sz += v->l->sz;
	if (v->r != nullptr) v->sz += v->r->sz;
}

node *merge(node *a, node *b) {
	if (a == nullptr) return b;
	if (b == nullptr) return a;
	if (a->y > b->y) {
		a->r = merge(a->r, b);
		update(a);
		return a;
	}
	else {
		b->l = merge(a, b->l);
		update(b);
		return b;
	}
}

pair <node *, node *> split(node *v, int x) {
	if (v == nullptr) return mp(v, v);
	if (v->key >= x) {
		auto p = split(v->l, x);
		v->l = p.second;
		update(v);
		return mp(p.first, v);
	}
	else {
		auto p = split(v->r, x);
		v->r = p.first;
		update(v);
		return mp(v, p.second);
	}
}

int main() {
	i_o;
	int n, p;
	cin >> n >> p;
	vector <int> a(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	vector <int> ans(n);
	node *tree = nullptr;
	for (int i = 0; i < n; i++) {
		auto p = split(tree, a[i] - i);
		if (p.first != nullptr) ans[i] += p.first->sz;
		tree = merge(merge(p.first, new node(a[i] - i)), p.second);
	}
	tree = nullptr;
	for (int i = n - 1; i >= 0; i--) {
		auto p = split(tree, a[i] - (n - i - 1));
		if (p.first != nullptr) ans[i] += p.first->sz;
		tree = merge(merge(p.first, new node(a[i] - (n - i - 1))), p.second);
	}
	for (int i = 0; i < n; i++) {
		cout << ans[i] + 1 << '\n';
	}
}