#include <bits/stdc++.h>
using namespace std;

typedef unsigned long long ull;
int n, m, k;
vector<int> x, y;

const int B = 63;
const ull MX = 1ull << B;
vector<vector<ull>> dst;
vector<bool> used;
vector<int> prv;

inline bool cmp(vector<ull> &v1, vector<ull> &v2) {
    if (v1.size() < v2.size()) {
        return true;
    }
    if (v1.size() > v2.size()) {
        return false;
    }
    int sz = (int) v1.size();
    for (int j = sz - 1; j >= 0; j--) {
        if (v1[j] != v2[j]) {
            return v1[j] < v2[j];
        }
    }
    return false;
}

int get_min() {
    int mn = -1;
    for (int i = 0; i < k; i++) {
        if (!used[i]) {
            if (mn == -1) {
                mn = i;
                continue;
            }

            if (!cmp(dst[mn], dst[i])) {
                mn = i;
            }
        }
    }

    return mn;
}

void relax(int u, int v) {
    if (used[v]) {
        return;
    }

    int p2 = max(abs(x[u] - x[v]), abs(y[u] - y[v]));
    auto dst1 = dst[u];
    ull cur = 0;
    for (int i = 0; i < dst1.size() || p2 >= 0 || cur > 0; i++) {
        if (i < dst1.size()) {
            cur += dst1[i];
        }

        if (p2 < B) {
            cur += 1ull << p2;
            p2 = -1;
        } else {
            p2 -= B;
        }

        if (cur >= MX) {
            if (i < dst1.size()) {
                dst1[i] = cur - MX;
            } else {
                dst1.push_back(cur - MX);
            }
            cur = 1;
        } else {
            if (i < dst1.size()) {
                dst1[i] = cur;
            } else {
                dst1.push_back(cur);
            }

            cur = 0;
        }
    }

    if (cmp(dst1, dst[v])) {
        dst[v] = dst1;
        prv[v] = u;
    }
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> m >> k;
    x.resize(k);
    y.resize(k);
    for (int i = 0; i < k; i++) {
        cin >> x[i] >> y[i];
    }

    dst.resize(k);
    used.resize(k);
    prv.assign(k, -1);
    for (int i = 1; i < k; i++) {
        dst[i].resize(1000);
    }

    for (int i = 0; i < k; i++) {
        int mn = get_min();
        if (mn == k - 1) {
            break;
        }
        used[mn] = true;
        for (int j = 0; j < k; j++) {
            if (!used[j]) {
                relax(mn, j);
            }
        }
    }

    vector<int> ans;
    int cur = k - 1;
    while (cur != -1) {
        ans.push_back(cur);
        cur = prv[cur];
    }

    reverse(ans.begin(), ans.end());

    cout << ans.size() << endl;
    for (int i : ans) {
        cout << i + 1 << " ";
    }
    cout << endl;

    return 0;
}
