#include <bits/stdc++.h>
using namespace std;

const int INF = 2000000000;
int n;
vector<int> a;
vector<int> xs;

inline int coord(int x) {
    return lower_bound(xs.begin(), xs.end(), x) - xs.begin();
}

struct Fenvick {
    vector<int> fv;

    Fenvick() {
        fv.resize(xs.size());
    }

    void clear() {
        fv.assign(xs.size(), 0);
    }

    void add(int x) {
        int i = coord(x);
        while (i < fv.size()) {
            fv[i]++;
            i = i | (i + 1);
        }
    }

    void rem(int x) {
        int i = coord(x);
        while (i < fv.size()) {
            fv[i]--;
            i = i | (i + 1);
        }
    }

    int get(int x) {
        int i = coord(x) - 1;
        int s = 0;
        while (i >= 0) {
            s += fv[i];
            i = (i & (i + 1)) - 1;
        }
        return s;
    }
};

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p;
    cin >> n >> p;
    if (p == 1) {
        return 1;
    }
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);

    vector<pair<int, int>> ord(n);
    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + n - 1 - i, i};
    }
    sort(ord.begin(), ord.end());
    int eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second < n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + i, i};
    }
    sort(ord.begin(), ord.end());
    eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second >= n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        xs.push_back(a[i]);
        xs.push_back(a[i] + n - 1 - i);
        xs.push_back(a[i] + i);
    }
    sort(xs.begin(), xs.end());
    xs.resize(unique(xs.begin(), xs.end()) - xs.begin());

    Fenvick fv1;
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += fv1.get(a[i] + i);
        fv1.add(a[i] + i);
    }
    fv1.clear();
    Fenvick fv2;
    for (int i = 0; i < n; i++) {
        fv1.add(a[i]);
    }
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += fv1.get(a[i] + i) + fv2.get(a[i] + n - 1 - i);
        if (i + 1 < n / 2) {
            fv1.rem(a[2 * i]);
            fv1.rem(a[2 * i + 1]);
            fv2.add(a[2 * i] + n - 1 - 2 * i);
            fv2.add(a[2 * i + 1] + n - 1 - 2 * i - 1);
            fv2.rem(a[i] + n - 1 - i);
        }
    }

    reverse(a.begin(), a.end());

    fv1.clear();
    for (int i = 0; i < n - n / 2; i++) {
        ans2[n - 1 - i] += fv1.get(a[i] + i);
        fv1.add(a[i] + i);
    }
    fv1.clear();
    fv2.clear();
    for (int i = 0; i < n; i++) {
        fv1.add(a[i]);
    }
    for (int i = 0; i < n - n / 2; i++) {
        ans2[n - 1 - i] += fv1.get(a[i] + i) + fv2.get(a[i] + n - 1 - i);
        if (i + 1 < n - n / 2) {
            fv1.rem(a[2 * i]);
            fv1.rem(a[2 * i + 1]);
            fv2.add(a[2 * i] + n - 1 - 2 * i);
            fv2.add(a[2 * i + 1] + n - 1 - 2 * i - 1);
            fv2.rem(a[i] + n - 1 - i);
        }
    }

    for (int i = 0; i < n; i++) {
        cout << max(ans1[i], ans2[i]) + 1 << "\n";
    }

    return 0;
}
