#include <bits/stdc++.h>
using namespace std;

int n;
vector<int> a;
vector<int> xs1, xs2;

inline int coord1(int x) {
    return lower_bound(xs1.begin(), xs1.end(), x) - xs1.begin();
}

inline int coord2(int x) {
    return lower_bound(xs2.begin(), xs2.end(), x) - xs2.begin();
}

vector<int> fv1, fv2;

inline void clear1() {
    fv1.assign(xs1.size(), 0);
}

inline void clear2() {
    fv2.assign(xs2.size(), 0);
}

inline void add1(int x) {
    int i = coord1(x);
    while (i < fv1.size()) {
        fv1[i]++;
        i = i | (i + 1);
    }
}

inline void add2(int x) {
    int i = coord2(x);
    while (i < fv2.size()) {
        fv2[i]++;
        i = i | (i + 1);
    }
}

inline void rem1(int x) {
    int i = coord1(x);
    while (i < fv1.size()) {
        fv1[i]--;
        i = i | (i + 1);
    }
}

inline void rem2(int x) {
    int i = coord2(x);
    while (i < fv2.size()) {
        fv2[i]--;
        i = i | (i + 1);
    }
}

inline int get1(int x) {
    int i = coord1(x) - 1;
    int s = 0;
    while (i >= 0) {
        s += fv1[i];
        i = (i & (i + 1)) - 1;
    }
    return s;
}

inline int get2(int x) {
    int i = coord2(x) - 1;
    int s = 0;
    while (i >= 0) {
        s += fv2[i];
        i = (i & (i + 1)) - 1;
    }
    return s;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int p;
    cin >> n >> p;
    if (p == 1) {
        return 1;
    }
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);

    vector<pair<int, int>> ord(n);
    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + n - 1 - i, i};
    }
    sort(ord.begin(), ord.end());
    int eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second < n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        ord[i] = {a[i] + i, i};
    }
    sort(ord.begin(), ord.end());
    eq = 0;
    for (int i = 0; i < ord.size(); i++) {
        if (i > 0 && ord[i].first == ord[i - 1].first) {
            eq++;
        } else {
            eq = 0;
        }

        if (ord[i].second >= n / 2) {
            int j = ord[i].second;
            ans1[j] = i - eq;
        }
    }

    for (int i = 0; i < n; i++) {
        xs1.push_back(a[i]);
        xs1.push_back(a[i] + i);
        xs2.push_back(a[i] + n - 1 - i);
    }
    sort(xs1.begin(), xs1.end());
    sort(xs2.begin(), xs2.end());
    xs1.resize(unique(xs1.begin(), xs1.end()) - xs1.begin());
    xs2.resize(unique(xs2.begin(), xs2.end()) - xs2.begin());

    clear1();
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += get1(a[i] + i);
        add1(a[i] + i);
    }
    clear1();
    clear2();
    for (int i = 0; i < n; i++) {
        add1(a[i]);
    }
    for (int i = 0; i < n / 2; i++) {
        ans2[i] += get1(a[i] + i) + get2(a[i] + n - 1 - i);
        if (i + 1 < n / 2) {
            rem1(a[2 * i]);
            rem1(a[2 * i + 1]);
            add2(a[2 * i] + n - 1 - 2 * i);
            add2(a[2 * i + 1] + n - 1 - 2 * i - 1);
            rem2(a[i] + n - 1 - i);
        }
    }

    reverse(a.begin(), a.end());
    xs1.clear();
    xs2.clear();
    for (int i = 0; i < n; i++) {
        xs1.push_back(a[i]);
        xs1.push_back(a[i] + i);
        xs2.push_back(a[i] + n - 1 - i);
    }
    sort(xs1.begin(), xs1.end());
    sort(xs2.begin(), xs2.end());
    xs1.resize(unique(xs1.begin(), xs1.end()) - xs1.begin());
    xs2.resize(unique(xs2.begin(), xs2.end()) - xs2.begin());

    clear1();
    for (int i = 0; i < n - n / 2; i++) {
        ans2[n - 1 - i] += get1(a[i] + i);
        add1(a[i] + i);
    }
    clear1();
    clear2();
    for (int i = 0; i < n; i++) {
        add1(a[i]);
    }
    for (int i = 0; i < n - n / 2; i++) {
        ans2[n - 1 - i] += get1(a[i] + i) + get2(a[i] + n - 1 - i);
        if (i + 1 < n - n / 2) {
            rem1(a[2 * i]);
            rem1(a[2 * i + 1]);
            add2(a[2 * i] + n - 1 - 2 * i);
            add2(a[2 * i + 1] + n - 1 - 2 * i - 1);
            rem2(a[i] + n - 1 - i);
        }
    }

    for (int i = 0; i < n; i++) {
        cout << max(ans1[i], ans2[i]) + 1 << "\n";
    }

    return 0;
}
