#include <bits/stdc++.h>
using namespace std;

char memo[500000000];
int m_it = 0;

inline void *operator new(size_t x) {
    return memo + (m_it += x) - x;
}

inline void operator delete(void *x) {

}

#define null NULL

struct Node {
    int x, y;
    int size;
    int cnt;
    Node *L, *R;

    Node(int x) : x(x) {
        y = rand();
        size = 1;
        cnt = 1;
        L = R = null;
    }
};

int sz(Node *t) {
    return t == null ? 0 : t->size;
}

void update(Node *t) {
    t->size = sz(t->L) + t->cnt + sz(t->R);
}

Node *mrg(Node *a, Node *b) {
    if (a == null) return b;
    if (b == null) return a;
    if (a->y < b->y) {
        a->R = mrg(a->R, b);
        update(a);
        return a;
    } else {
        b->L = mrg(a, b->L);
        update(b);
        return b;
    }
}

pair<Node *, Node *> split(Node *t, int x) {
    if (t == null) {
        return {null, null};
    }
    if (t->x <= x) {
        auto z = split(t->R, x);
        t->R = z.first;
        update(t);
        z.first = t;
        return z;
    } else {
        auto z = split(t->L, x);
        t->L = z.second;
        update(t);
        z.second = t;
        return z;
    }
}

bool find(Node *t, int x, int add) {
    if (t == null) return false;
    if (t->x == x) {
        t->cnt += add;
        update(t);
        return true;
    }
    if (x < t->x) {
        auto res = find(t->L, x, add);
        update(t);
        return res;
    } else {
        auto res = find(t->R, x, add);
        update(t);
        return res;
    }
}

Node *add(Node *t, int x) {
    if (!find(t, x, 1)) {
        auto z = split(t, x);
        t = mrg(mrg(z.first, new Node(x)), z.second);
    }
    return t;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, p;
    cin >> n >> p;
    if (p == 2) {
        return 1;
    }
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<int> ans1(n), ans2(n);
    Node *root = null;
    for (int i = 0; i < n; i++) {
        auto z = split(root, a[i] - i - 1);
        ans1[i] = sz(z.first);
        root = mrg(z.first, z.second);
        root = add(root, a[i] - i);
    }
    root = null;
    for (int i = n - 1; i >= 0; i--) {
        auto z = split(root, a[i] + i - 1);
        ans2[i] = sz(z.first);
        root = mrg(z.first, z.second);
        root = add(root, a[i] + i);
    }

    for (int i = 0; i < n; i++) {
        cout << ans1[i] + ans2[i] + 1 << "\n";
    }

    return 0;
}