#include <iostream>
#include <stdio.h>
#include <algorithm>
#include <math.h>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <deque>
#include <iterator>
#include <random>
using namespace std;
typedef long long ll;

int n;
vector<int> a;

struct item {
	int x, y, cnt, mx, mn, p;
	item *l, *r;
	item(int x1, int y1, int pos) {
		x = x1;
		y = y1;
		cnt = 1;
		mx = pos;
		mn = pos;
		p = pos;
		l = NULL;
		r = NULL;
	}
};

typedef item* treap;

int cnt(treap t) {
	if (t == NULL) {
		return 0;
	}
	else {
		return t->cnt;
	}
}

int mn(treap t) {
	if (t == NULL) {
		return -1;
	}
	else {
		return t->mn;
	}
}

int mx(treap t) {
	if (t == NULL) {
		return -1;
	}
	else {
		return t->mx;
	}
}

void upd(treap &t) {
	if (t != NULL) {
		t->cnt = cnt(t->l) + cnt(t->r) + 1;
		int pl, pr;
		pl = mn(t->l);
		pr = mn(t->r);
		if (pl != -1 && pr != -1) {
			if (a[pl] <= t->x && a[pl] <= a[pr]) {
				t->mn = pl;
			}
			else if (a[pr] < t->x) {
				t->mn = pr;
			}
			else {
				t->mn = t->p;
			}
		}
		else if (pl != -1) {
			if (a[pl] <= t->x) {
				t->mn = pl;
			}
			else {
				t->mn = t->p;
			}
		}
		else if (pr != -1) {
			if (a[pr] < t->x) {
				t->mn = pr;
			}
			else {
				t->mn = t->p;
			}
		}
		else {
			t->mn = t->p;
		}

		pl = mx(t->l);
		pr = mx(t->r);
		if (pl != -1 && pr != -1) {
			if (a[pl] > t->x && a[pl] > a[pr]) {
				t->mx = pl;
			}
			else if (a[pr] >= t->x) {
				t->mx = pr;
			}
			else {
				t->mx = t->p;
			}
		}
		else if (pl != -1) {
			if (a[pl] > t->x) {
				t->mx = pl;
			}
			else {
				t->mx = t->p;
			}
		}
		else if (pr != -1) {
			if (a[pr] >= t->x) {
				t->mx = pr;
			}
			else {
				t->mx = t->p;
			}
		}
		else {
			t->mx = t->p;
		}
	}
}

void split(treap t, treap &l, treap &r, int x, int add = 0) {
	if (t == NULL) {
		l = NULL;
		r = NULL;
		return;
	}
	int cur = add + cnt(t->l);
	if (x <= cur) {
		split(t->l, l, t->l, x, add);
		r = t;
	}
	else {
		split(t->r, t->r, r, x, cur + 1);
		l = t;
	}
	upd(l);
	upd(r);
}

void merg(treap &t, treap l, treap r) {
	if (l == NULL) {
		t = r;
	}
	else if (r == NULL) {
		t = l;
	}
	else if (l->y > r->y) {
		merg(l->r, l->r, r);
		t = l;
	}
	else {
		merg(r->l, l, r->l);
		t = r;
	}
	upd(t);
}

void add(treap &t, int x, int pos) {
	treap t1, t2;
	split(t, t1, t2, pos);
	treap it = new item(x, rand(), pos);
	merg(t1, t1, it);
	merg(t, t1, t2);
}

int getmin(treap t, int l, int r) {
	treap t1, t2, t3;
	split(t, t1, t2, l);
	split(t2, t2, t3, r - l + 1);
	int ans = t2->mn;
	merg(t1, t1, t2);
	merg(t, t1, t3);
	return ans;
}

int getmax(treap t, int l, int r) {
	treap t1, t2, t3;
	split(t, t1, t2, l);
	split(t2, t2, t3, r - l + 1);
	int ans = t2->mx;
	merg(t1, t1, t2);
	merg(t, t1, t3);
	return ans;
}

int ans(treap t, int l, int r) {
	if (l == r) {
		return 1;
	}
	int p2 = getmax(t, l, r);
	if (p2 == l) {
		return 1 + ans(t, l + 1, r);
	}
	int p1 = getmin(t, l, p2 - 1);
	if (p1 == l && p2 == r) {
		return 1;
	}
	else if (p1 == l) {
		return 1 + ans(t, p2 + 1, r);
	}
	else if (p2 == r) {
		return 1 + ans(t, l, p1 - 1);
	}
	else {
		return 1 + ans(t, l, p1 - 1) + ans(t, p2 + 1, r);
	}
}

int main() {
#pragma warning(disable:4996)
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	srand(29546846);
	treap t = NULL;

	cin >> n;
	a = vector<int>(n);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
	}
	for (int i = 0; i < n; i++) {
		add(t, a[i], i);
	}
	cout << ans(t, 0, n - 1);
	return 0;
}