#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
const int INF = 1e9;

struct segTree {
    int n; vector<int> t;
    segTree(int n) : n(n), t(2 * n, INF) {}
    void upd(int v, int x) {
        t[v += n] = x;
        for(v >>= 1; v; v >>= 1) t[v] = min(t[v * 2], t[v * 2 + 1]);
    }
    int get(int l, int r) {
        int ret = INF;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret = min(ret, t[l]);
            if(!(r & 1)) ret = min(ret, t[r]);
        }
        return ret;
    }
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int n; cin >> n;
    vector<int> a(n);
    map<int, int> re;
    int dif = 0;
    for(int i = 0; i < n; i++) cin >> a[i], re[a[i]];
    for(auto it = re.begin(); it != re.end(); it++) it->second = dif++;

    vector<int> r(n, INF); //   
    segTree t1(dif);
    for(int i = n - 1; i >= 0; i--) {
        r[i] = t1.get(0, re[a[i]] - 1);
        t1.upd(re[a[i]], i);
    }

    vector<int> l(n, INF); //   
    segTree t2(dif);
    for(int i = 0; i < n; i++) {
        l[i] = -t2.get(re[a[i]] + 1, dif - 1);
        t2.upd(re[a[i]], -i);
    }

    vector<vector<int>> out(n);
    for(int i = 0; i < n; i++)
        if(r[i] != INF)
            out[r[i]].push_back(i);

    vector<int> dp(n);
    segTree t(n);
    for(int i = 0; i < n; i++) {
        t.upd(i, i ? dp[i - 1] : 0);
        for(int j : out[i])
            t.upd(j, INF);
        int bou = l[i];
        if(bou == -INF) bou = 0;
        else bou++;
        dp[i] = t.get(bou, i) + 1;
    }
    cout << dp[n - 1];
}
