#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
const int INF = 1e9, maxn = 3e3;

struct segTree {
    int n; vector<int> t;
    segTree(int n) : n(n), t(2 * n, 0) {}
    void upd(int v, int x) {
        t[v += n] += x;
        for(v >>= 1; v; v >>= 1) t[v] = t[v * 2] + t[v * 2 + 1];
    }
    int get(int l, int r) {
        int ret = 0;
        for(l += n, r += n; l <= r; l = (l + 1) >> 1, r = (r - 1) >> 1) {
            if(l & 1) ret += t[l];
            if(!(r & 1)) ret += t[r];
        }
        return ret;
    }
};

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    //freopen("in.txt", "r", stdin);
    int n, p; cin >> n >> p;
    assert(p == 1);
    vector<int> a(n);
    vector<int> u1(n), u2(n);
    for(int i = 0; i < n; i++) cin >> a[i], u1[i] = a[i] - i, u2[i] = a[i] + i;
    sort(all(u1)); u1.erase(unique(all(u1)), u1.end());
    sort(all(u2)); u2.erase(unique(all(u2)), u2.end());
    vector<int> re1(n), re2(n);
    for(int i = 0; i < n; i++) {
        int lf = 0, rg = sz(u1) - 1;
        while(lf < rg) {
            int md = (lf + rg) >> 1;
            if(u1[md] >= a[i] - i) rg = md;
            else lf = md + 1;
        }
        re1[i] = lf;

        lf = 0, rg = sz(u2) - 1;
        while(lf < rg) {
            int md = (lf + rg) >> 1;
            if(u2[md] >= a[i] + i) rg = md;
            else lf = md + 1;
        }
        re2[i] = lf;
    }

    segTree t1(sz(u1)), t2(sz(u2));
    for(int i = 0; i < n; i++) t2.upd(re2[i], 1);
    vector<int> opt(n, 1);
    for(int i = 0; i < n; i++) {
        t2.upd(re2[i], -1);
        opt[i] = t1.get(0, re1[i] - 1) + t2.get(0, re2[i] - 1);
        t1.upd(re1[i], 1);
    }
    for(int x : opt) cout << x + 1 << '\n';
}
