#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <string>
#include <random>
#include <ctime>
#include <queue>
#include <deque>
#include <bitset>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>

#pragma comment(linker, "/STACK:256000000")
#pragma GCC optimize("O3")

using namespace std;

#define left left228
#define right right228
#define all(a) a.begin(), a.end()

vector<pair<int, int>> pos;
vector<int> t[2000000];

void build(int v, int tl, int tr) {
	t[v].clear();
	if (tl == tr) {
		t[v].push_back(pos[tl].second);
		return;
	}
	int m = (tl + tr) >> 1;
	build(v << 1, tl, m);
	build((v << 1) + 1, m + 1, tr);
	merge(all(t[v << 1]), all(t[(v << 1) + 1]), back_inserter(t[v]));
}

int les(int v, int tl, int tr, int r, int a) {
	if (r == tr)
		 return lower_bound(all(t[v]), a) - t[v].begin();
	int m = (tl + tr) >> 1;
	if (r <= m)
		return les(v << 1, tl, m, r, a);
	return les(v << 1, tl, m, m, a) + les((v << 1) + 1, m + 1, tr, r, a);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	int n, p;
	cin >> n >> p;
	if (p == 2)
		return 0;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	pos.resize(n);
	for (int i = 0; i < n; ++i)
		pos[i] = { a[i] - i, i };
	sort(all(pos));
	build(1, 0, n - 1);
	vector<int> sum(n);
	for (int i = 0; i < n; ++i) {
		int j = lower_bound(all(pos), pair<int, int>{a[i] - i, 0}) - pos.begin();
		if (j)
			sum[i] += les(1, 0, n - 1, j - 1, i);
	}
	reverse(all(a));
	for (int i = 0; i < n; ++i)
		pos[i] = { a[i] - i, i };
	sort(all(pos));
	build(1, 0, n - 1);
	for (int i = 0; i < n; ++i) {
		int j = lower_bound(all(pos), pair<int, int>{a[i] - i, 0}) - pos.begin();
		if (j)
			sum[n - i - 1] += les(1, 0, n - 1, j - 1, i);
	}
	for (int i = 0; i < n; ++i)
		cout << sum[i] + 1 << '\n';
	return 0;
}