#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int maxN = 150005;
const ll INF = 2e9;

struct Data {
    ll a, b;

    Data() {}
    Data(ll _a, ll _b) : a(_a), b(_b) {}
};

int fw[maxN];
void add(int i, int n, int x) {
    for (; i < n; i = i|(i + 1)) fw[i] += x;
}
int get(int i) {
    int res = 0;
    for (; i >= 0; i = (i&(i + 1)) - 1) res += fw[i];
    return res;
}

Data arr[maxN];

bool operator < (const Data& d1, const Data& d2) {
    return d1.a < d2.a;
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> coords(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].a >> arr[i].b;
        coords[i] = arr[i].b;
    }
    arr[n] = Data(INF, INF);
    coords[n] = INF;

    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());

    sort(arr, arr + n + 1);
    reverse(arr, arr + n + 1);

    ll ans = 0;
    for (int j = 0; j <= n; j++) {
        ll lans = 0;
        for (int i = 0; i <= n; i++) fw[i] = 0;
        for (int i = j + 1; i <= n; i++) {
            int ind = lower_bound(coords.begin(), coords.end(), arr[i].b) - coords.begin();
            add(n - 1 - ind, n, 1);
            int cnt = get(n - 1 - ind);
            lans = max(lans, arr[i].b * cnt);
        }
        ans = max(ans, lans + arr[j].a * j);
    }
    cout << ans << endl;

    return 0;
}
