#include <bits/stdc++.h>

#define ll long long
#define ld long double

using namespace std;

const int maxN = 150005;
const ll INF = 2e9;
const ld eps = 1e-6;

struct Data {
    ll a, b;

    Data() {}
    Data(ll _a, ll _b) : a(_a), b(_b) {}
};

bool operator < (const Data& d1, const Data& d2) {
    return d1.a < d2.a;
}

struct Line {
    ld k, b;
    Line() {}
    Line(ld _k, ld _b) : k(_k), b(_b) {}
};

struct Point {
    ld x, y;
    Point() {}
    Point(ld _x, ld _y) : x(_x), y(_y) {}
};

Point perLine(Line l1, Line l2) {
    ld x = (l2.b - l1.b) / (l1.k - l2.k);
    ld y = x * l1.k + l1.b;
    return Point(x, y);
}

deque<Line> cht;
void add(Line l) {
    while (cht.size() > 1) {
        Point p = perLine(cht[0], cht[1]);
        if (p.y <= p.x * l.k + l.b - eps) cht.pop_front();
        else break;
    }
    cht.push_front(l);
}

ll get(ll x) {
    if (cht.size() == 1) return round(cht[0].k * x + cht[0].b);
    if (x <= perLine(cht[0], cht[1]).x + eps) return round(cht[0].k * x + cht[0].b);
    if (x > perLine(cht.back(), cht[cht.size() - 2]).x) return round(cht.back().k * x + cht.back().b);

    int l = 0, r = cht.size() - 2;
    while (r - l > 1) {
        int m = (l + r) / 2;
        Point p = perLine(cht[m], cht[m + 1]);
        if (p.x + eps >= x) r = m;
        else l = m;
    }

    return round(cht[r].k * x + cht[r].b);
}

Data arr[maxN];

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    vector<int> coords(n + 1);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].a >> arr[i].b;
        assert(arr[i].a == arr[i].b);
        coords[i] = arr[i].b;
    }
    arr[n] = Data(INF, INF);
    coords[n] = INF;

    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());

    sort(arr, arr + n + 1);
    reverse(arr, arr + n + 1);

    ll ans = arr[n].a * n;
    add(Line(-arr[n].b, arr[n].b * n));
    for (int j = n - 1; j >= 0; j--) {
        ans = max(ans, arr[j].a * j + get(j));
        add(Line(-arr[j].b, arr[j].b * j));
    }
    cout << ans << endl;

    return 0;
}
