#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int maxN = 505;
const ll INF = 1e18;

struct Point {
    int x, y;
    Point() {}
    Point(int _x, int _y) : x(_x), y(_y) {}
};

Point arr[maxN];

ll get(int v, int u) {
    return 1LL << max(abs(arr[v].x - arr[u].x), abs(arr[v].y - arr[u].y));
}

bool used[maxN];
ll dist[maxN];
int pr[maxN];

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int h, w, n;
    cin >> h >> w >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr[i].y >> arr[i].x;
        arr[i].x--;
        arr[i].y--;
    }

    for (int i = 0; i < n; i++) dist[i] = INF;

    int v = 0;
    dist[0] = 0;

    while (true) {
        used[v] = 1;

        for (int u = 0; u < n; u++) {
            if (used[u]) continue;
            if (dist[u] > dist[v] + get(v, u)) {
                dist[u] = dist[v] + get(v, u);
                pr[u] = v;
            }
        }
        int nxt = -1;
        for (int u = 0; u < n; u++) {
            if (used[u]) continue;
            if (nxt == -1 || dist[u] < dist[nxt]) nxt = u;
        }

        if (nxt == -1) break;
        v = nxt;
    }

    vector<int> ans;
    int cur = n - 1;
    while (cur > 0) {
        ans.push_back(cur);
        cur = pr[cur];
    }
    ans.push_back(cur);
    reverse(ans.begin(), ans.end());

    cout << ans.size() << endl;
    for (int i : ans) cout << i + 1 << " ";
    cout << endl;

    return 0;
}
