#include <bits/stdc++.h>

#define ll long long

using namespace std;

const int maxN = 11000;
const ll INF = 1e18;

struct Point {
    int x, y;
    Point() {}
    Point(int _x, int _y) : x(_x), y(_y) {}
};

Point arr[maxN];

vector<bool> get(int v, int u) {
    vector<bool> res(maxN, 0);
    res[max(abs(arr[v].x - arr[u].x), abs(arr[v].y - arr[u].y))] = 1;
    return res;
}

vector<bool> add(const vector<bool>& a, const vector<bool>& b) {
    vector<bool> res(maxN);
    int x = 0;
    for (int i = 0; i < maxN; i++) {
        res[i] = (a[i] + b[i] + x) & 1;
        x = (a[i] + b[i] + x) >> 1;
    }
    return res;
}

bool comp(const vector<bool>& a, const vector<bool>& b) {
    for (int i = maxN - 1; i >= 0; i--) {
        if (a[i] > b[i]) return 1;
        if (a[i] < b[i]) return 0;
    }
    return 0;
}

bool used[maxN];
vector<bool> dist[maxN];
int pr[maxN];

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int h, w, n;
    cin >> h >> w >> n;

    for (int i = 0; i < n; i++) {
        cin >> arr[i].y >> arr[i].x;
        arr[i].x--;
        arr[i].y--;
    }

    for (int i = 0; i < n; i++) {
        dist[i].resize(maxN, 0);
        dist[i][maxN - 1] = 1;
    }

    int v = 0;
    dist[0] = vector<bool>(maxN, 0);

    while (true) {
        used[v] = 1;

        for (int u = 0; u < n; u++) {
            if (used[u]) continue;
            if (comp(dist[u], add(dist[v], get(u, v)))) {
                dist[u] = add(dist[v], get(u, v));
                pr[u] = v;
            }
        }
        int nxt = -1;
        for (int u = 0; u < n; u++) {
            if (used[u]) continue;
            if (nxt == -1 || comp(dist[nxt], dist[u])) nxt = u;
        }

        if (nxt == -1) break;
        v = nxt;
    }

    vector<int> ans;
    int cur = n - 1;
    while (cur > 0) {
        ans.push_back(cur);
        cur = pr[cur];
    }
    ans.push_back(cur);
    reverse(ans.begin(), ans.end());

    cout << ans.size() << endl;
    for (int i : ans) cout << i + 1 << " ";
    cout << endl;

    return 0;
}
