#include <bits/stdc++.h>

using namespace std;

const int maxN = 400005;
const int INF = 1e9;

int arr[maxN];
int fwL[maxN];
int fwR[maxN];

void add(int* fw, int i, int n, int x) {
    for (; i < n; i = i|(i + 1)) fw[i] += x;
}

int get(int* fw, int i) {
    if (i < 0) return 0;

    int res = 0;
    for (; i >= 0; i = (i&(i + 1)) - 1) res += fw[i];
    return res;
}

int get_ind(vector<int>& coords, int x) {
    return lower_bound(coords.begin(), coords.end(), x) - coords.begin();
}

int main() {
    #ifdef DEBUG
        freopen("in.in", "r", stdin);
    #endif // DEBUG

    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, p;
    cin >> n >> p;

    assert(p == 1);

    for (int i = 0; i < n; i++) cin >> arr[i];

    vector<int> coordsL;
    vector<int> coordsR;

    for (int i = 0; i < n; i++) coordsR.push_back(arr[i] + i);
    for (int i = 0; i < n; i++) coordsL.push_back(arr[i] - i);

    sort(coordsL.begin(), coordsL.end());
    coordsL.resize(unique(coordsL.begin(), coordsL.end()) - coordsL.begin());
    sort(coordsR.begin(), coordsR.end());
    coordsR.resize(unique(coordsR.begin(), coordsR.end()) - coordsR.begin());

    int deltaL = 0;
    int deltaR = 0;

    for (int i = 1; i < n; i++) {
        add(fwR, get_ind(coordsR, arr[i] + i), coordsR.size(), 1);
    }

    for (int i = 0; i < n; i++) {
        int cntl = get(fwL, get_ind(coordsL, arr[i] - deltaL) - 1);
        int cntr = get(fwR, get_ind(coordsR, arr[i] + deltaR) - 1);

        cout << (cntl + cntr + 1) << " ";

        add(fwL, get_ind(coordsL, arr[i] - deltaL), coordsL.size(), 1);  deltaL++;
        add(fwR, get_ind(coordsR, arr[i + 1] + i + 1), coordsR.size(), -1); deltaR++;
    }
    cout << endl;

    return 0;
}
