#include "bits/stdc++.h"

#define mp make_pair
#define len(v) ((int)v.size())
#define pb push_back
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;

int n, m, k;
vector<pii> v;
vector<vector<int>> g;

int get_dist(int i, int j) {
	return max(abs(v[i].x - v[j].x), abs(v[i].y - v[j].y));
}

int get_dir(int x) {
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}

struct Num {
	vector<int> v{0};

	Num() {}
	Num(int bit) {
		v.resize(bit + 1, 0);
		v[bit] = 1;
	}

	void add(int i, int x) {
		if (!x) return;
		while (len(v) <= i) {
			v.pb(0);
		}	
		v[i] += x;
	}

	void stab() {
		for (int i = 0; i < len(v); i++) {
			add(i + 1, v[i] / 2);
			v[i] %= 2;
		}
		while (len(v) > 1 && v.back() == 0) {
			v.pop_back();
		}
	}

	int size() const {
		return len(v);
	}

	friend Num operator+(const Num &a, const Num &b) {
		Num rez;
		for (int i = 0; i < len(a); i++) {
			rez.add(i, a.v[i]);
		}
		for (int i = 0; i < len(b); i++) {
			rez.add(i, b.v[i]);
		}
		rez.stab();
		return rez;
	}

	friend bool operator<(const Num &a, const Num &b) {
		if (len(a) < len(b)) return true;
		if (len(a) > len(b)) return false;
		for (int i = len(a.v) - 1; i > -1; i--) {
			if (a.v[i] < b.v[i]) return true;
			if (a.v[i] > b.v[i]) return false;
		}
		return false;
	}

	friend bool operator>(const Num &a, const Num &b) {
		return b < a;
	}
};

signed main() {
	{
		cin >> n >> m >> k;
		v.resize(k);
		for (int i = 0; i < k; i++) {
			cin >> v[i].x >> v[i].y;
		}
	}
	{
		g.resize(k);
		for (int i = 0; i < k; i++) {
			for (int dx = -1; dx <= 1; dx++) {
				for (int dy = -1; dy <= 1; dy++) {
					int _min = 1e9;
					for (int j = 0; j < k; j++) {
						if (get_dir(v[i].x - v[j].x) == dx && get_dir(v[i].y - v[j].y) == dy) {
							_min = min(_min, get_dist(i, j));
						}
					}
					for (int j = 0; j < k; j++) {
						if (get_dir(v[i].x - v[j].x) == dx && get_dir(v[i].y - v[j].y) == dy) {
							if (get_dist(i, j) == _min) {
								g[i].pb(j);
							}	
						}
					}
				}
			}
		}
	}
	{
		vector<Num> dist(k, Num(502));
		vector<int> pref(k, -1);
		dist[0] = Num();
		vector<bool> used(k, false);
		while (true) {
			int p = -1;
			for (int i = 0; i < k; i++) {
				if (used[i]) continue;
				if (p == -1 || dist[i] < dist[p]) {
					p = i;					
				}
			}	
			if (p == -1) break;
			used[p] = true;
			for (int sub : g[p]) {
				if (dist[p] + Num(get_dist(p, sub)) < dist[sub]) {
					dist[sub] = dist[p] + Num(get_dist(p, sub));
					pref[sub] = p;
				}
			}
		}
		vector<int> path;
		int end = k - 1;
		while (end != -1) {
			path.pb(end);
			end = pref[end];
		}
		cout << len(path) << endl;
		reverse(path.begin(), path.end());
		for (int x : path) {
			cout << x + 1 << " ";
		}
		cout << endl;
	}
}