#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mk make_pair
#define all(v) (v).begin() (v).end()
#define inb push_back

int solve();

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	solve();
	return 0;
}

const int INF = 1e9 + 7;

struct SegmentTree
{
	vi t;
	SegmentTree() {};
	SegmentTree(int n) : t(vi(n * 4, INF)) {};
	void update(int v, int tl, int tr, int pos, int val)
	{
		if (tl == tr)
		{
			t[v] = val;
			return;
		}
		int tm = tl + tr >> 1;
		if (pos <= tm)
			update(2 * v + 1, tl, tm, pos, val);
		else
			update(2 * v + 2, tm + 1, tr, pos, val);
		t[v] = min(t[2 * v + 1], t[2 * v + 2]);
	}
	int get(int v, int tl, int tr, int l, int r)
	{
		if (tl > r || l > tr)
			return INF;
		if (l <= tl && tr <= r)
			return t[v];
		int tm = tl + tr >> 1;
		return min(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm + 1, tr, l, r));
	}
};

int solve()
{
	int n;
	cin >> n;
	vi a(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
	}
	vector<vi> upinf(n + 1);
	vi lmax(n);
	{
		vi q;
		q.inb(n);
		for (int i = n - 1; i >= 0; --i)
		{
			while (q.back() != n && a[q.back()] >= a[i])
				q.pop_back();
			upinf[q.back()].inb(i);
			q.inb(i);
		}
	}
	{
		vi q;
		q.inb(-1);
		for (int i = 0; i < n; ++i)
		{
			while (q.back() != -1 && a[q.back()] <= a[i])
				q.pop_back();
			lmax[i] = q.back();
			q.inb(i);
		}
	}
	SegmentTree T(n);
	T.update(0, 0, n - 1, 0, 0);
	vi dp(n);
	dp[0] = 1;
	for (int i = 1; i < n; ++i)
	{
		for (int x : upinf[i])
			T.update(0, 0, n - 1, x, INF);
		T.update(0, 0, n - 1, i, dp[i - 1]);
		dp[i] = T.get(0, 0, n - 1, lmax[i] + 1, i) + 1;
	}
	printf("%d\n", dp[n - 1]);
	return 0;
}