#include <stdio.h>
#include <utility>
#include <algorithm>

int p;

struct node {
	int val;
	node *left, *right;
	
	node(){}
	node(int val, node *left, node *right): val(val), left(left), right(right) {}
};

void add(node *n, int ind, int tl, int tr) {
	if (tl == tr) {
		n->val++;
		return;
	}
	if (ind <= tl + (tr - tl) / 2) {
		if (!n->left) {
			n->left = new node(0, NULL, NULL);
		}
		add(n->left, ind, tl, tl + (tr - tl) / 2);
	} else {
		if (!n->right) {
			n->right = new node(0, NULL, NULL);
		}
		add(n->right, ind, tl + (tr - tl) / 2 + 1, tr);
	}
	n->val = (n->left ? n->left->val : 0) + (n->right ? n->right->val : 0);
}

int get(node *n, int l, int r, int tl, int tr) {
	if (!n || l > r) {
		return 0;
	}
	if (l == tl && r == tr) {
		return n->val;
	}
	int m = tl + (tr - tl) / 2;
	if (r <= m) {
		return get(n->left, l, r, tl, m);
	}
	if (l > m) {
		return get(n->right, l, r, m + 1, tr);
	}
	return get(n->left, l, m, tl, m) + get(n->right, m + 1, r, m + 1, tr);
}

int abs(int x) {
	return x < 0 ? -x : x;
}

int main() {
	int n;
	scanf("%d%d", &n, &p);
	int a[n];
	int ans[n] = {};
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
	}
	node *tree = new node(0, NULL, NULL);
	for (int j = 0; j < n; j++) {
		ans[j] += get(tree, 1, a[j] - j + n - 1, 1, (1 << 30));
		add(tree, a[j] - j + n, 1, (1 << 30));
	}
	tree = new node(0, NULL, NULL);
	for (int j = n - 1; j >= 0; j--) {
		ans[j] += get(tree, 1, a[j] + j - 1, 1, (1 << 30));
		add(tree, a[j] + j, 1, (1 << 30));
	}
	for (int i = 0; i < n; i++) {
		printf("%d\n", ans[i] + 1);
	}
	return 0;
}
