#pragma GCC optimize ("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <climits>
#include <algorithm>
#include <queue>
#include <set>
#include <cmath>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define forn(i, a, b) for (int i = a; i < b; ++i)
#define mp make_pair
#define pb push_back

typedef long long LL;
typedef long double LD;
typedef pair<LL, LL> PLL;

struct coord {
	int i, j;
};
int k;
vector<coord> pr;


LL get_dist(int a, int b) {
	LL diff = max(abs(pr[a].i - pr[b].i), abs(pr[a].j - pr[b].j));
	//return 1LL << diff;
	return diff;
}

void djkstra(int st, vector<LL> &d, vector<LL> &p) {
	p.assign(k, -1);
	d.assign(k, INT_MAX);
	priority_queue<pair<LL, PLL>> q;
	q.push(mp(0, mp(0, -1)));

	while (!q.empty()) {
		LL dist = -q.top().first,
			c = q.top().second.first,
			fr = q.top().second.second;
		q.pop();
		if (d[c] <= dist)
			continue;
		//cout << c + 1 << endl;
		d[c] = dist;
		p[c] = fr;
		forn(i, 0, k) {
			if (d[i] > d[c] + get_dist(i, c)) {
				q.push(mp(-(d[c] + get_dist(i, c)), mp(i, c)));
			}
		}
	}
}

int main() {
	ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);
	freopen("input.txt", "r", stdin);

	
	int n, m;
	cin >> n >> m >> k;
	pr.resize(k);
	forn(i, 0, k) {
		cin >> pr[i].i >> pr[i].j;
	}
	vector<LL> d(k), p(k);
	djkstra(0, d, p);

	vector<int> ans(1, k - 1);
	int cur = k - 1;
	while (p[cur] != -1) {
		cur = p[cur];
		ans.pb(cur);
	}
	reverse(all(ans));
	cout << ans.size() << endl;
	for (auto x : ans)
		cout << x + 1 << " ";
}