
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <set>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;

const int N = 100 + 10;

int n, m, k;

int max_len = 100 + 10;

struct number
{
	string num;
	number() { num = "0"; while (num.size() < max_len) num.push_back('0'); }
	number(int dist)
	{
		num = "1";
		for (int i = 0; i < dist; i++)
		{
			num.push_back('0');
		}
		reverse(num.begin(), num.end());
		while (num.size() < max_len)
		{
			num.push_back('0');
		}
		reverse(num.begin(), num.end());
	}

	bool operator<(const number &a) const
	{
		return num < a.num;
	}

	number operator+(const number &a)
	{
		number ret;
		ret.num.clear();
		int add = 0;
		for (int i = max_len - 1; i >= 0; i--)
		{
			int c1 = (int)num[i] - '0';
			int c2 = (int)a.num[i] - '0';
			int c = c1 + c2 + add;
			if (c >= 2)
			{
				add = 1;
			}
			else
			{
				add = 0;
			}
			ret.num.push_back((char)('0' + (c % 2)));
		}
		reverse(ret.num.begin(), ret.num.end());
		return ret;
	}
};

number dist[N];
vector<pair<int, number>> g[N];
int p[N];
pair<int, int> a[N];

pair<int, int> b[N], c[N];

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m >> k;
	for (int i = 0; i < k; i++)
	{
		int x, y;
		cin >> x >> y;
		a[i] = { x, y };
		b[i] = { x, i };
		c[i] = { y, i };
	}

	for (int i = 0; i < k; i++)
	{
		dist[i] = number(max_len - 2);
	}

	dist[0] = number();

	/*for (int i = 0; i < k; i++)
	{
		for (int j = 0; j < i; j++)
		{
			g[i].push_back({ j, number(max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second))) });
			g[j].push_back({ i, number(max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second))) });
		}
	}*/

	sort(b, b + k);
	sort(c, c + k);

	for (int i = 1; i < k; i++)
	{
		g[b[i].second].push_back({b[i - 1].second, number(max(abs(a[b[i].second].first - a[b[i - 1].second].first), 
														  abs(a[b[i].second].second - a[b[i - 1].second].second))) });
		g[b[i - 1].second].push_back({ b[i].second, number(max(abs(a[b[i].second].first - a[b[i - 1].second].first),
			abs(a[b[i].second].second - a[b[i - 1].second].second))) });

		g[c[i].second].push_back({ c[i - 1].second, number(max(abs(a[c[i].second].first - a[c[i - 1].second].first),
			abs(a[c[i].second].second - a[c[i - 1].second].second))) });
		g[c[i - 1].second].push_back({ c[i].second, number(max(abs(a[c[i].second].first - a[c[i - 1].second].first),
			abs(a[c[i].second].second - a[c[i - 1].second].second))) });
	}

	set<pair<number, int>> st;
	st.insert({ dist[0], 0 });
	while (st.size())
	{
		auto it = *st.begin();
		st.erase(st.begin());
		for (auto to : g[it.second])
		{
			if (dist[it.second] + to.second < dist[to.first])
			{
				dist[to.first] = dist[it.second] + to.second;
				p[to.first] = it.second;
				st.insert({dist[to.first], to.first});
			}
		}
	}

	vector<int> path;
	int cur = k - 1;
	while (true)
	{
		path.push_back(cur);
		if (cur == 0) break;
		cur = p[cur];
	}

	reverse(path.begin(), path.end());
	cout << path.size() << "\n";
	for (int i : path) cout << i + 1 << " ";

	system("pause");
}