#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

const int N = 300000 + 10;
const int INF = 1000000000 + 10;

int a[N];
pair<int, int> b[N];

pair<int, int> t[4 * N];

pair<int, int> merge(pair<int, int> a, pair<int, int> b)
{
	if (a.first > b.first) return a;
	return b;
}

void build(int v, int tl, int tr)
{
	if (tl + 1 == tr)
	{
		t[v] = { a[tl], tl };
		return;
	}
	int c = (tl + tr) / 2;
	build(2 * v, tl, c);
	build(2 * v + 1, c, tr);
	t[v] = merge(t[2 * v], t[2 * v + 1]);
}

void upd(int v, int tl, int tr, int pos)
{
	if (tl + 1 == tr)
	{
		t[v] = { -INF, -INF };
		return;
	}
	int c = (tl + tr) / 2;
	if (pos < c)
	{
		upd(2 * v, tl, c, pos);
	}
	else
	{
		upd(2 * v + 1, c, tr, pos);
	}
	t[v] = merge(t[2 * v], t[2 * v + 1]);
}

pair<int, int> get(int v, int tl, int tr, int l, int r)
{
	if (r <= tl || l >= tr)
	{
		return { -INF, -INF };
	}
	if (tl >= l && tr <= r) return t[v];
	int c = (tl + tr) / 2;
	return merge(get(2 * v, tl, c, l, r), get(2 * v + 1, c, tr, l, r));
}

signed main()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		b[i] = { a[i], i };
	}

	set<pair<int, int>> st1, st2;

	for (int i = 0; i < n; i++)
	{
		st1.insert({ a[i], i });
	}
	build(1, 0, n);
	int ans = 0;
	while (st1.size())
	{
		auto it = *st1.begin();
		pair<int, int> res = get(1, 0, n, it.second, n);
		int l = it.second;
		int r = res.second;
		++ans;
		for (int i = l; i <= r; i++)
		{
			st1.erase({ a[i], i });
			upd(1, 0, n, i);
		}
	}
	cout << ans;
	system("pause");
}