#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>

using namespace std;

const int N = 300000 + 10;
const int INF = 1000000000 + 10;

int a[N];
int b[N];

int t[4 * N];
int dp[N];

int merge(int a, int b) { return max(a, b); }

void build(int v, int tl, int tr)
{
	if (tl + 1 == tr)
	{
		t[v] = INF;
		return;
	}
	int c = (tl + tr) / 2;
	build(2 * v, tl, c);
	build(2 * v + 1, c, tr);
	t[v] = merge(t[2 * v], t[2 * v + 1]);
}

void upd(int v, int tl, int tr, int pos, int x)
{
	if (tl + 1 == tr)
	{
		t[v] = x;
		return;
	}
	int c = (tl + tr) / 2;
	if (pos < c)
	{
		upd(2 * v, tl, c, pos, x);
	}
	else
	{
		upd(2 * v + 1, c, tr, pos, x);
	}
	t[v] = merge(t[2 * v], t[2 * v + 1]);
}

int get(int v, int tl, int tr, int l, int r)
{
	if (r <= tl || l >= tr)
	{
		return INF;
	}
	if (tl >= l && tr <= r) return t[v];
	int c = (tl + tr) / 2;
	return merge(get(2 * v, tl, c, l, r), get(2 * v + 1, c, tr, l, r));
}

signed main()
{
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		
	}

	set<pair<int, int>> st;
	for (int i = 0; i < n; i++)
	{
		st.insert({a[i], i});
	}
	int ans = 0;
	while (st.size())
	{
		++ans;
		auto it = *st.begin();
		int l = it.second;
		int r = l;
		int mx = a[l];
		for (int j = l + 1; j < n; j++)
		{
			mx = max(mx, a[j]);
			if (a[j] < it.first) break;
			if (a[j] < mx) continue;
			r = max(r, j);
		}
		for (int i = l; i <= r; i++)
		{
			st.erase({a[i], i});
		}
	}
	cout << ans;
	system("pause");
}