#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <string>
#include <unordered_map>
#include <cassert>

using namespace std;

#define all(a) (a).begin(), (a).end()

const int N = 400000 + 10;
const int M = 3000000 + 10;
const int INF = 1000000000 + 10;

typedef long long ll;

int a[N];
int b[N];
int c[N];

struct tree
{
	int t[M];

	tree()
	{
		for (int i = 0; i < M; i++)
		{
			t[i] = 0;
		}
	}

	int get(int pos)
	{
		if (pos <= 0) return 0;
		int ret = 0;
		for (int i = pos; i > 0; i -= i & (-i))
		{
			ret += t[i];
		}
		return ret;
	}

	int get(int l, int r)
	{
		return get(r) - (l == 1 ? 0 : get(l - 1));
	}

	void upd(int pos, int x)
	{
		if (pos <= 0) assert(false);
		for (int i = pos; i < M; i += i & (-i))
		{
			t[i] += x;
		}
	}
};

signed main()
{
	int n, p;
	cin >> n >> p;

	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
	}

	vector<pair<int, int>> vv;
	for (int i = 0; i < n; i++) vv.push_back({ a[i], i });
	sort(all(vv));

	for (int i = 0; i < n; i++)
	{
		int ans = 0;
		for (int k = 1; k <= max(i, n - i); k++)
		{
			int cnt = 0;

			if (i + k < n)
			for (int j = i + 1; j < min(i + k, n); j++)
			{
				if (a[j] < a[i] + j - i) ++cnt;
			}

			if (i - k >= 0)
			for (int j = i - 1; j > max(i - k, 0); j--)
			{
				if (a[j] < a[i] + i - j) ++cnt;
			}

			for (int j = i + k; j < n; j++)
			{
				if (a[j] < a[i] + k) ++cnt;
			}

			for (int j = i - k; j >= 0; j--)
			{
				if (a[j] < a[i] + k) ++cnt;
			}

			ans = max(ans, cnt);
		}

		cout << ans + 1 << "\n";
	}
	system("pause");
}