#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <functional>
using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
#define all(v) v.begin(), v.end()

const int mod = 1e9;
vector<int> sum(vector<int> &a, vector<int> &b) {
	int n = a.size();
	int m = b.size();
	vector<int> res(max(n, m) + 1);
	for (int i = 0; i < res.size() - 1; i++) {
		if (i < n) res[i] += a[i];
		if (i < m) res[i] += b[i];
		res[i + 1] += res[i] / mod;
		res[i] %= mod;
	} 
	while (res.size() > 1 && res.back() == 0) res.pop_back();
	return res;
}
vector<int> mult2(vector<int> &a) {
	vector<int> res = a;
	res.push_back(0);
	for (int i = 0; i < res.size() - 1; i++)
		res[i] *= 2;
	for (int i = 0; i < res.size() - 1; i++) {
		res[i + 1] += res[i] / mod;
		res[i] %= mod;
	}
	while (res.size() > 1 && res.back() == 0) res.pop_back();
	return res;
}

struct comp {
	bool comp2(const vector<int> &a, const vector<int> &b) const {
		if (a.size() < b.size()) return true;
		if (a.size() > b.size()) return false;
		for (int i = a.size() - 1; i >= 0; i--) {
			if (a[i] < b[i]) return true;
			if (a[i] > b[i]) return false;
		}
		return false;
	}
	bool operator()(const pair<vector<int>, int> &a, 
		const pair<vector<int>, int> &b) const {
		if (a.first == b.first) return a.second < b.second;
		else return comp2(a.first, b.first);
	}
};

const int N = 10001;
short cnt[N][N];
pii v[N];
vector<short> g[N];
vector<int> pows[N];
vector<int> d[N];
int p[N];

int main() {
	ios_base::sync_with_stdio(0);
	int n, m, k;
	cin >> n >> m >> k;
	for (int i = 0; i < k; i++) {
		cin >> v[i].first >> v[i].second;
		cnt[v[i].first][v[i].second] = 1;
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cnt[i + 1][j + 1] += cnt[i][j + 1];
			cnt[i + 1][j + 1] += cnt[i + 1][j];
			cnt[i + 1][j + 1] -= cnt[i][j];
		}
	}
	for (int i = 0; i < k; i++) {
		for (int j = i + 1; j < k; j++) {
			if (i == j) continue;
			int a = v[i].first;
			int b = v[i].second;
			int c = v[j].first;
			int d = v[j].second;
			if (a > c) swap(a, c);
			if (b > d) swap(b, d);
			int cur = 0;
			if (a == c) {
				b++, d--;
				if (b > d) cur = 0;
				else cur = cnt[a][d] - cnt[a][b - 1];
			}
			else if (b == d) {
				a++, c--;
				if (a > c) cur = 0;
				else cur = cnt[c][b] - cnt[a - 1][b];
			}
			else {
				a++, b++, c--, d--;
				if (a > c || b > d) cur = 0;
				else cur = cnt[c][d] - cnt[a - 1][d]
					- cnt[c][b - 1] + cnt[a - 1][b - 1];
			}
			if (cur == 0) {
				g[i].push_back(j);
				g[j].push_back(i);
			}
		}
	}
	int t = max(n, m) + 1;
	pows[0] = { 1 };
	for (int i = 1; i < t; i++) {
		pows[i] = mult2(pows[i - 1]);
	}
	vector<vector<int>> d(k);
	vector<int> p(k);
	for (int i = 0; i < k; i++) {
		d[i] = pows[t - 1];
		p[i] = -1;
	}
	d[0] = { 0 };
	p[0] = 0;
	comp c;
	set<pair<vector<int>, int>, comp> s;
	s.insert({ d[0], 0 });
	while (s.size() > 0) {
		int f = s.begin()->second;
		s.erase(s.begin());
		for (int i : g[f]) {
			vector<int> q = pows[max(abs(v[f].first - v[i].first),
				abs(v[f].second - v[i].second))];
			vector<int> cur = sum(d[f], q);
			if (c.comp2(cur, d[i])) {
				s.erase({ d[i], i });
				d[i] = cur;
				p[i] = f;
				s.insert({ d[i], i });
			}
		}
	}
	vector<int> ans;
	int cur = k - 1;
	while (cur != 0) {
		ans.push_back(cur);
		cur = p[cur];
	}
	ans.push_back(0);
	reverse(all(ans));
	cout << ans.size() << "\n";
	for (int i = 0; i < ans.size(); i++)
		cout << ans[i] + 1 << " ";
}