#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
#define all(v) v.begin(), v.end()
typedef long long ll;
typedef pair<int, int> pii;

const int inf = 1e9;
template <class T> 
class stmin {
	void _build(int v, int l, int r, vector<int> &a) {
		if (l == r - 1) {
			if (l >= a.size()) st[v] = inf;
			else st[v] = a[l];
			return;
		}
		int m = (l + r) / 2;
		_build(v * 2 + 1, l, m, a);
		_build(v * 2 + 2, m, r, a);
		st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
	}
	T _min(int v, int l, int r, int tl, int tr) {
		if (l <= tl && r >= tr) return st[v];
		if (l >= tr || r <= tl) return inf;
		int m = (tl + tr) / 2;
		return min(_min(v * 2 + 1, l, r, tl, m), 
			_min(v * 2 + 2, l, r, m, tr));
	}
	void _update(int v, int l, int r, int pos, T val) {
		if (l == r - 1) {
			st[v] = val;
			return;
		}
		int m = (l + r) / 2;
		if (pos < m) _update(v * 2 + 1, l, m, pos, val);
		else _update(v * 2 + 2, m, r, pos, val);
		st[v] = min(st[v * 2 + 1], st[v * 2 + 2]);
	}
	vector<int> st;
	int sz;

public:
	void build(vector<int> &a) {
		sz = 1;
		while (sz <= a.size()) sz *= 2;
		st.resize(sz * 2);
		_build(0, 0, sz, a);
	}
	T minimum(int l, int r) {
		return _min(0, l, r + 1, 0, sz);
	}
	void update(int pos, T val) {
		_update(0, 0, sz, pos, val);
	}
};


int main() {
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<int> v(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	vector<int> maxz(n);
	vector<pii> cur;
	for (int i = n - 1; i >= 0; i--) {
		while (cur.size() > 0 && cur.back().first < v[i]) {
			maxz[cur.back().second] = i + 1;
			cur.pop_back();
		}
		cur.push_back({ v[i], i });
	}
	while (cur.size()) {
		maxz[cur.back().second] = 0;
		cur.pop_back();
	}
	vector<int> dp(n + 1, n + 1);
	vector<pii> mins;
	vector<int> val(n, inf);
	stmin<int> st;
	st.build(val);
	dp[0] = 0;
	for (int i = 0; i < n; i++) {
		dp[i + 1] = dp[i] + 1;
		while (mins.size() > 0 && v[i] < mins.back().first) {
			st.update(mins.back().second, inf);
			mins.pop_back();
		}
		dp[i + 1] = min(dp[i + 1],
			st.minimum(maxz[i], i) + 1);
		st.update(i, dp[i]);
		mins.push_back({ v[i], i });
	}
	cout << dp[n];
}