#include <iostream>
#include <unordered_map>
#include <ctime>

#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

struct item {
    int x, y;
    int cnt;
    item *l, *r;
    item() {};
};

typedef item *pitem;

int a[400000];
int place[400000];
unordered_map <int, int> m;

int cnt(pitem t) {
    if (!t)
        return 0;
    return t->cnt;
}

void update(pitem t) {
    if (!t)
        return;
    t->cnt = m[t->x] + cnt(t->l) + cnt(t->r);
}

void split(pitem t, int x, pitem &l, pitem &r) {
    if (!t) {
        l = 0;
        r = 0;
        return;
    }
    if (t->x > x) {
        split(t->l, x, l, t->l);
        r = t;
    }
    else {
        split(t->r, x, t->r, r);
        l = t;
    }
    update(t);
}

int get(pitem t, int x) {
    if (!t)
        return 0;
    if (t->x >= x)
        return get(t->l, x);
    else
        return m[t->x] + cnt(t->l) + get(t->r, x);
}

void insert(pitem &t, pitem p) {
    if (!t) {
        t = p;
        return;
    }
    if (p->y > t->y) {
        split(t, p->x, p->l, p->r);
        t = p;
    } else {
        insert((t->x > p->x ? t->l : t->r), p);
    }
    update(t);
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    srand(85276);
    int n, f;
    cin >> n >> f;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    pitem root = 0;
    for (int i = 0; i < n; i++) {
        int d = a[i] + n - i;
        if (m[d] == 0) {
            m[d] = 1;
            pitem p = new item();
            p->x = d;
            p->y = rand();
            p->cnt = 1;
            p->l = p->r = 0;
            insert(root, p);
        }
        else {
            m[d]++;
            pitem t = root;
            while (1) {
                t->cnt++;
                if (t->x == d)
                    break;
                if (t->x > d)
                    t = t->l;
                else
                    t = t->r;
            }
        }
        place[i] += get(root, d);
    }
    m.clear();
    root = 0;
    for (int i = n - 1; i >= 0; i--) {
        int d = a[i] + i + 1;
        if (m[d] == 0) {
            m[d] = 1;
            pitem p = new item();
            p->x = d;
            p->y = rand();
            p->cnt = 1;
            p->l = p->r = 0;
            insert(root, p);
        }
        else {
            m[d]++;
            pitem t = root;
            while (1) {
                t->cnt++;
                if (t->x == d)
                    break;
                if (t->x > d)
                    t = t->l;
                else
                    t = t->r;
            }
        }
        place[i] += get(root, d);
    }
    for (int i = 0; i < n; i++)
        cout << place[i] + 1 << ' ';
    return 0;
}
