#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int min_quest(vector <vector <int> > &st, vector <int> &powers, vector <int> &prev_power, int l, int r) {
    int lvl, res;
    lvl = prev_power[r - l];
    res = min(st[lvl][l], st[lvl][r - powers[lvl]]);
    return res;
}

int max_quest(vector <vector <int> > &st, vector <vector <int> > &max_id, vector <int> &powers, vector <int> &prev_power, int l, int r) {
    int lvl, res;
    lvl = prev_power[r - l];
    if (st[lvl][l] > st[lvl][r - powers[lvl]]) {
        return max_id[lvl][l];
    }
    return max_id[lvl][r - powers[lvl]];
}

int main() {
    int n, counter, now, maxid, maximum, next, max_power, l, r, mid;
    pair <int, int> p;
    set <pair <int, int> > s;
    cin >> n;
    vector <int> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
    }
    vector <int> powers;
    powers.push_back(1);
    while (powers[powers.size() - 1] <= n) {
        powers.push_back(powers[powers.size() - 1] * 2);
    }
    max_power = powers.size();
    vector <int> prev_power(n + 1);
    prev_power[0] = -1;
    for (int i = 1; i <= n; i++) {
        if (i == powers[prev_power[i - 1] + 1]) {
            prev_power[i] = prev_power[i - 1] + 1;
        }
        else {
            prev_power[i] = prev_power[i - 1];
        }
    }
/*
    cout << "prev_power: ";
    for (int i = 0; i <= n; i++) {
        cout << prev_power[i] << ' ';
    }
    cout << '\n';
*/
    vector <vector <int> > min_st(max_power, vector <int> (n));
    for (int i = 0; i < n; i++) {
        min_st[0][i] = v[i];
    }
    for (int lvl = 1; lvl < max_power; lvl++) {
        for (int i = 0; i < n - powers[lvl] + 1; i++) {
            min_st[lvl][i] = min(min_st[lvl - 1][i], min_st[lvl - 1][i + powers[lvl - 1]]);
        }
    }
/*
    cout << "min_st:\n";
    for (int lvl = 1; lvl < max_power; lvl++) {
        for (int i = 0; i < n - powers[lvl] + 1; i++) {
            cout << min_st[lvl][i] << ' ';
        }
        cout << '\n';
    }
    cout << '\n';
*/
    vector <vector <int> > max_st(max_power, vector <int> (n));
    vector <vector <int> > max_id(max_power, vector <int> (n));
    for (int i = 0; i < n; i++) {
        max_st[0][i] = v[i];
        max_id[0][i] = i;
    }
    for (int lvl = 1; lvl < max_power; lvl++) {
        for (int i = 0; i < n - powers[lvl] + 1; i++) {
            if (max_st[lvl - 1][i] > max_st[lvl - 1][i + powers[lvl - 1]]) {
                max_id[lvl][i] = max_id[lvl - 1][i];
            }
            else {
                max_id[lvl][i] = max_id[lvl - 1][i + powers[lvl - 1]];
            }
            max_st[lvl][i] = max(max_st[lvl - 1][i], max_st[lvl - 1][i + powers[lvl - 1]]);
        }
    }

    vector <int> next_min(n);
    for (int i = 0; i < n; i++) {
        l = i + 1;
        r = n + 1;
        while (r - l > 1) {
            mid = (r + l) / 2;
            if (min_quest(min_st, powers, prev_power, i, mid) < v[i]) {
                r = mid;
            }
            else {
                l = mid;
            }
        }
        next_min[i] = l;
    }
/*
    cout << "next_min: ";
    for (int i = 0; i < n; i++) {
        cout << next_min[i] << ' ';
    }
    cout << '\n';
*/
    counter = 0;
    now = 0;
    while(now < n) {
        counter++;
        now = max_quest(max_st, max_id, powers, prev_power, now, next_min[now]) + 1;
    }
/*
    for (int i = 0; i < n; i++) {
        while (v[i] < v[now]) {
            counter++;
            p = *s.begin();
            next = -p.second + 1;
            //cout << i << ' ' << now << ' ' << next << '\n';
            for (int j = now; j < next; j++) {
                s.erase(make_pair(-v[j], -j));
            }
            now = next;
        }
        s.insert(make_pair(-v[i], -i));
    }
    while (now != n) {
        counter++;
        p = *s.begin();
        next = -p.second + 1;
        //cout << n << ' ' << now << ' ' << next << '\n';
        for (int j = now; j < next; j++) {
            s.erase(make_pair(-v[j], -j));
        }
        now = next;
    }
*/
    cout << counter << '\n';
    return 0;
}

