#include <iostream>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

struct very_long{
    vector <int> v;
    very_long() {}
    very_long(string s) {
        int n = s.size();
        v.resize(n);
        for (int i = 0; i < n; i++) {
            v[i] = s[n - i - 1] - '0';
        }
    }
};

bool operator < (const very_long &a, const very_long &b) {
    if (a.v.size() < b.v.size()) {
        return true;
    }
    if (a.v.size() > b.v.size()) {
        return false;
    }
    for (int i = a.v.size() - 1; i >= 0; i--) {
        if (a.v[i] < b.v[i]) {
            return true;
        }
        if (a.v[i] > b.v[i]) {
            return false;
        }
    }
    return false;
}

void print(very_long &a) {
    if (a.v.size() == 0) {
        cout << "0\n";
    }
    else {
        int n = a.v.size();
        for (int i = 0; i < n; i++) {
            cout << a.v[n - i - 1];
        }
        cout << '\n';
    }
}

bool check(const very_long &a, const very_long &b) {
    int n = min(a.v.size(), b.v.size());
    for (int i = 0; i < n; i++) {
        if (a.v[i] == 1 && b.v[i] == 1) {
            return false;
        }
    }
    return true;
}

void add(very_long &a, very_long b) {
    int n = b.v.size();
    if (a.v.size() < n) {
        a.v.resize(n, 0);
    }
    for (int i = 0; i < n; i++) {
        a.v[i] += b.v[i];
    }
}

void change(vector <int> &v, int id) {
    for (int i = 0; i < id; i++) {
        v[i] = 0;
    }
    v[id] = 1;
}

bool cmp(vector <int> &a, vector <int> &b, int id) {
    for (int i = id; i >= 0; i--) {
        if (a[i] > b[i]) {
            return true;
        }
        if (a[i] < b[i]) {
            return false;
        }
    }
}

int main() {
    int n, id, len;
    bool flag;
    string s;
    cin >> n;
    vector <very_long> v(n);
    len = 0;
    for (int i = 0; i < n; i++) {
        cin >> s;
        v[i] = very_long(s);
    }
    vector <int> v1, v2;
    v1 = v[0].v;
    v2 = v[1].v;
    while(v1.size() < v2.size()) {
        v1.push_back(0);
    }
    while (v2.size() < v1.size()) {
        v2.push_back(0);
    }
    v1.push_back(0);
    v2.push_back(0);
    n = v1.size();
    for (int i = n - 1; i >= 0; i--) {
        if (v1[i] == 1 && v2[i] == 1) {
            id = i;
            while (v1[id] == 1 || v2[id] == 1) {
                id++;
            }
            if (cmp(v1, v2, id)) {
                change(v1, id);
            }
            else {
                change(v2, id);
            }
            break;
        }
    }
    vector <int> res(n);
    for (int i = 0; i < n; i++) {
        res[i] = v1[i] + v2[i];
    }
    if (res[n - 1] == 0) {
        res.pop_back();
        n--;
    }
    for (int i = 0; i < n; i++) {
        cout << res[n - 1 - i];
    }
    cout << '\n';
    return 0;
}
