#include <iostream>
#include <vector>

const long long INF = 1000000000000000000;

long long Abs(long long a);
void GetAns(int start, int end, int **rUsed, std::vector <int> &ans);

int main(void) {
    int n = 0, m = 0, k = 0;
    std::cin >> n >> m >> k;
    long long **matrix = new long long*[k];
    int **rUsed = new int*[k];
    long long *x = new long long[k];
    long long *y = new long long[k];
    for (int i = 0; i < k; i++) {
        matrix[i] = new long long[k];
        rUsed[i] = new int[k];
        for (int j = 0; j < k; j++) {
            matrix[i][j] = INF;
            rUsed[i][j] = -1;
        }
        matrix[i][i] = 0;
    }
    for (int i = 0; i < k; i++) {
        std::cin >> y[i] >> x[i];
        for (int j = 0; j < k; j++)
            matrix[i][j] = matrix[j][i] = (1 << std::max(Abs(y[i] - y[j]), Abs(x[i] - x[j])));
    }
    for (int i = 0; i < k; i++)
        for (int j = 0; j < k; j++)
            for (int r = 0; r < k; r++)
                if (matrix[i][j] > matrix[i][r] + matrix[r][j]) {
                    rUsed[i][j] = rUsed[j][i] = r;
                    matrix[j][i] = matrix[i][j] = matrix[i][r] + matrix[r][j];
                    //std::cout << i << "-" << r << "-" << j << "=>" << matrix[i][j] << std::endl;
                }

    std::vector <int> ans;
    GetAns(0, k - 1, rUsed, ans);
    std::cout << ans.size() + 1 << std::endl;
    for (unsigned int i = 0; i < ans.size(); i++)
        std::cout << ans[i] + 1 << " ";
    std::cout << k << std::endl;
    return 0;
}

long long Abs(long long a) {
    if (a < 0)
        return -a;
    return a;
}

void GetAns(int start, int end, int **rUsed, std::vector <int> &ans) {
    //std::cout << start << "-" << end << "|" << rUsed[start][end] << std::endl;
    if (rUsed[start][end] >= 0) {
        GetAns(start, rUsed[start][end], rUsed, ans);
        GetAns(rUsed[start][end], end, rUsed, ans);
    }
    else
        ans.push_back(start);
}
