#include <iostream>

struct Tree {
    int minI, maxI;
    int l, r;
    Tree *left, *right;
};

void BuildTree(Tree *root, int a[], int l, int r);
int Count(int a[], int l, int r, Tree *root);
void GetI(Tree *root, int a[], int l, int r, int &minI, int &maxI);

int main(void) {
    int n = 0;
    std::cin >> n;
    int *a = new int[n];
    for (int i = 0; i < n; i++)
        std::cin >> a[i];
    Tree *root = new Tree;
    BuildTree(root, a, 0, n - 1);
    std::cout << Count(a, 0, n - 1, root);
    return 0;
}

int Count(int a[], int l, int r, Tree *root) {
    int minI = l, maxI = l;
    GetI(root, a, l, r, minI, maxI);
    if (minI == l && maxI == r)
        return 1;
    if (r - maxI >= minI - l)
        return Count(a, maxI + 1, r, root) + Count(a, l, maxI, root);
    //else
    return Count(a, l, minI - 1, root) + Count(a, minI, r, root);
}

void BuildTree(Tree *root, int a[], int l, int r) {
    root->l = l;
    root->r = r;
    if (r > l) {
        root->left = new Tree;
        BuildTree(root->left, a, l, (l + r) / 2);
        root->right = new Tree;
        BuildTree(root->right, a, (l + r) / 2 + 1, r);
        if (a[root->left->minI] <= a[root->right->minI])
            root->minI = root->left->minI;
        else
            root->minI = root->right->minI;
        if (a[root->left->maxI] > a[root->right->maxI])
            root->maxI = root->left->maxI;
        else
            root->maxI = root->right->maxI;
    }
    else {
        root->minI = root->maxI = l;
        root->left = root->right = NULL;
    }
}

void GetI(Tree *root, int a[], int l, int r, int &minI, int &maxI) {
    if (!root)
        return;
    if (root->l >= l && root->r <= r) {
        if (a[root->minI] < a[minI] || (a[root->minI] == a[minI] && root->minI < minI))
            minI = root->minI;
        if (a[root->maxI] > a[maxI] || (a[root->maxI] == a[maxI] && root->maxI > maxI))
            maxI = root->maxI;
    }
    if (root->l <= r && root->r >= l) {
        GetI(root->left, a, l, r, minI, maxI);
        GetI(root->right, a, l, r, minI, maxI);
    }
}
