#include <bits/stdc++.h>
#define x first
#define y second
#define pb push_back
using namespace std;
 
typedef pair<long double, long double> line;

int n;
vector<pair<int, int>> arr;

const int MAXN = 1.5e5 + 10;
const int B = 500;

long double cross(line a, line b) {
    double x =  (b.y - a.y) / (a.x - b.x);
    return (b.y - a.y) / (a.x - b.x);
}

struct block {
    int suf;
    vector<int> arr;
    vector<pair<long long, long long>> a;
    vector<long double> cur;

    block() {
        suf = 0;
    }

    void build() {
        a.clear();
        for (int i = 0; i < arr.size(); ++i) {
            if (!i || arr[i] != arr[i - 1]) {
                line C = {arr[i], -1LL * i * arr[i]};
                while (a.size() >= 2) {
                    line B = a.back();
                    line A = a[(int)a.size() - 2];
                    if (cross(A, B) > cross(B, C)) {
                        a.pop_back();
                    } else {
                        break;
                    }
                }
                a.pb(C);
            }
        }
        cur.clear();
        for (int i = 1; i < a.size(); ++i) {
            cur.pb(cross(a[i - 1], a[i]));
        }
    }

    long long get() {
        if (arr.size() == 0) return 0;
        int X = arr.size() + suf;
        int Y = lower_bound(cur.begin(), cur.end(), X) - cur.begin();
        long long ans = 0;
        for (int M = Y - 2; M <= Y + 2; ++M) {
            if (M >= 0 && M < a.size()) {
                ans = max(ans, a[M].x * X + a[M].y);
            }
        }
        return ans;
    }
};

block cur[B];

void rebuild() {
    vector<int> all;
    for (int i = 0; i < B; ++i) {
        for (auto j : cur[i].arr) {
            all.pb(j);
        }
        cur[i].suf = 0;
        cur[i].arr.clear();
        cur[i].a.clear();
    }
    int L = 0;
    for (int i : all) {
        if (cur[L].arr.size() == B) {
            cur[L].build();
            ++L;
        } 
        cur[L].arr.pb(i);
    }
    int cnt = 0;
    cur[L].build();
    for (int i = L + 1; i--;) {
        cur[i].suf = cnt;
        cnt += cur[i].arr.size();
    }
}

int cnt_added = 0;

void add(int w) {
    if (cnt_added == 0) {
        cur[0].arr.pb(w);
        cur[0].build();
        return;
    }
    int curw = 0;
    for (int i = 0;; ++i) {
        curw += cur[i].arr.size();
        if (cur[i].arr.back() >= w || curw == cnt_added) {
            cur[i].arr.insert(lower_bound(cur[i].arr.begin(), cur[i].arr.end(), w), w);
            if (cur[i].arr.size() == B * 2) {
                rebuild();
            } else {
                cur[i].build();
            }
            ++cnt_added;
            return;
        } else { 
            ++cur[i].suf;
        }
    }
    assert(false);
}

long long get_max() {
    long long w = 0;
    for (int i = 0; i < B; ++i) {
        w = max(w, cur[i].get());
    }
    return w;
}

int main() {
    ios::sync_with_stdio(0);
    //assert(freopen("input.in", "r", stdin));
    cin >> n;
    arr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> arr[i].x >> arr[i].y;
    }
    sort(arr.begin(), arr.end());
    long long ans = 0;
    int alive = n;
    for (auto i : arr) {
        long long cur = 1LL * alive * i.x;
        //cout << cur << ' ' << get_max() << endl; 
        ans = max(ans, cur + get_max());
        add(i.y);
        --alive;
    }
    cout << ans << endl;
}