#include <bits/stdc++.h>
using namespace std;

void doRoutine() {
#ifdef LOCAL
    freopen("/home/roi/clion_main/input.txt", "r", stdin);
    freopen("/home/roi/clion_main/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

#define pii pair<int, int>
#define fi first
#define se second
#define vc vector
#define vi vector<int>
#define vvi vector<vi>
#define pb push_back
#define all(x) x.begin(), x.end()
#define vb vector<bool>

#define int long long
#define D double

// ------------------------------- CODE NOW ------------------------

const D INF = 1000000000;
const int MAXN = 150005;
int a[MAXN], b[MAXN];
int n;

vi inds;

bool cmp(int i, int j) {
    if (a[i] != a[j]) {
        return a[i] < a[j];
    }
    else {
        return i < j;
    }
}

int get(vi &vals) {
    sort(all(vals));
    int ans = 0;
    for (int i = 0; i < vals.size(); ++i) {
        ans = max(ans, vals[i] * ((int)vals.size() - i));
    }
    return ans;
}

int eval(pii line, int x) {
    return line.fi * x + line.se;
}

D cross(pii a, pii b) {
    return (b.se - a.se) / (a.fi - b.fi);
}

struct Hull {
    vector<D> p;
    vector<pii> lines;

    Hull() {}

    void add(pii line) {
        if (p.empty()) {
            p.pb(-INF);
            lines.pb(line);
        }
        else {
            while (!p.empty() && eval(line, p.back()) > eval(lines.back(), p.back())) {
                p.pop_back();
                lines.pop_back();
            }
            if (p.empty()) {
                p.pb(-INF);
            }
            else {
                p.pb(cross(line, lines.back()));
            }
            lines.pb(line);
        }
    }

    int get(int x) {
        int L = -1, R = p.size();
        while (R - L > 1) {
            int m = (L + R) / 2;
            if (p[m] < x) {
                L = m;
            }
            else {
                R = m;
            }
        }
        return eval(lines[L], x);
    }
};

bool b_cmp(int i, int j) {
    if (b[i] != b[j]) {
        return b[i] > b[j];
    }
    else {
        return i < j;
    }
}

signed main() {
    doRoutine();

    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        inds.pb(i);
    }
    sort(all(inds), cmp);

    bool FLAG_1 = true, FLAG_2 = true;
    for (int i = 0; i < n; ++i) {
        if (b[i] != 0) {
            FLAG_1 = false;
        }
        if (a[i] != b[i]) {
            FLAG_2 = false;
        }
    }

    if (FLAG_2) {
        sort(a, a + n);
        vi dp(n + 1);
        Hull hull;
        dp[1] = a[0];
        hull.add({a[0], 0});

        for (int i = 1; i < n; ++i) {
            dp[i + 1] = hull.get(i + 1);
            if (a[i] > a[i - 1]) {
                hull.add({a[i], -i * a[i]});
            }
        }

        int ans = 0;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, dp[i] + (n - i) * a[i]);
        }

        cout << ans << endl;

        return 0;
    }
    else if (FLAG_1 || n <= 3000) {
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            int id = inds[i];
            if (FLAG_1) {
                ans = max(ans, (n - i) * a[id]);
            } else {
                vi vals;
                for (int j = 0; j < i; ++j) {
                    vals.pb(b[inds[j]]);
                }
                ans = max(ans, (n - i) * a[id] + get(vals));
            }
        }
        cout << ans << endl;
        return 0;
    }

    vi binds(n);
    for (int i = 0; i < n; ++i) {
        binds[i] = i;
    }
    sort(binds.begin(), binds.end(), b_cmp);
    vi id_to_bind(n);
    for (int i = 0; i < n; ++i) {
        id_to_bind[binds[i]] = i;
    }

    const int B = 300;
    int blocks_cnt = (n + B - 1) / B;
    vc<Hull> hulls(blocks_cnt);
    vi cnt_used(blocks_cnt);
    vb used(n);

    int ans = a[0] * n;
    for (int i = 0; i < n; ++i) {
        int el_id = inds[i];
        int bind = id_to_bind[el_id];
        int block_id = bind / B;

        hulls[block_id] = Hull();
        used[bind] = true;
        ++cnt_used[block_id];
        int cnt_r = 0;
        for (int t = block_id + 1; t < blocks_cnt; ++t) {
            cnt_r += cnt_used[t];
        }

        int cur_used = 0;
        for (int j = B * (block_id + 1) - 1; j >= B * block_id; --j) {
            cur_used += used[j];
            hulls[block_id].add({b[el_id], b[el_id] * cur_used});
        }

        // now update ans
        cur_used = 0;
        for (int j = blocks_cnt - 1; j >= 0; --j) {
            ans = max(ans, a[el_id] * (n - i) + hulls[j].get(cur_used));
            cur_used += cnt_used[j];
        }
    }

    cout << ans << endl;

    return 0;
}