#include <iostream>
#include <vector>
#include <set>
#include <queue>
#include <algorithm>
#include <bitset>
using namespace std;
#define int long long

bool operator<(const bitset<520> & a, const bitset<520> & b)
{
	int k = 519;
	while (k >= 0 && a[k] == b[k])
		--k;
	return k >= 0 && b[k];
}

struct cmp {
	bool operator()(const pair<bitset<520>, int> a, const pair<bitset<520>, int> b) const {
		return b.first < a.first || !(a.first < b.first) && a.second < b.second;
	}
};

bitset<520> sum(bitset<520> a, int x)
{
	while (a[x]) {
		a[x] = false;
		++x;
	}
	a[x] = true;
	return a;
}

signed main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int>> v(k);
	for (int i = 0; i < k; ++i)
		cin >> v[i].first >> v[i].second;
	vector<bitset<520>> dist(k);
	vector<int> pr(k);
	for (int i = 1; i < k; ++i)
		dist[i] = ~dist[i];
	priority_queue<pair<bitset<520>, int>, vector<pair<bitset<520>, int>>, cmp> s;
	vector<bool> used(k);
	for (int i = 0; i < k; ++i)
		s.push({ dist[i], i });
	for (int i = 0; i < k; ++i) {
		auto x = s.top().second;
		s.pop();
		if (used[x])
			continue;
		used[x] = true;
		if (x == k - 1)
			break;
		for (int i = 0; i < k; ++i) {
			if (!used[i]) {
				if (sum(dist[x], max(abs(v[x].first - v[i].first), abs(v[x].second - v[i].second))) < dist[i]) {
					dist[i] = sum(dist[x], max(abs(v[x].first - v[i].first), abs(v[x].second - v[i].second)));
					pr[i] = x;
					s.push({ dist[i], i });
				}
			}
		}
	}
	vector<int> a;
	a.push_back(k - 1);
	while (a.back() != 0)
		a.push_back(pr[a.back()]);
	cout << a.size() << '\n';
	reverse(a.begin(), a.end());
	for (int i = 0; i < a.size(); ++i)
		cout << a[i] + 1 << ' ';
}

