#include <iostream>
#include <vector>
#include <string>
using namespace std;
#define int long long
#define INF 1791791791
struct rmin
{
	int x;
	int pos;
	int l, r;
	rmin *left = nullptr, *right = nullptr;
	rmin(int l, int r, vector<int> & a) : l(l), r(r) {
		if (r - l > 1) {
			int m = (l + r) / 2;
			left = new rmin(l, m, a);
			right = new rmin(m, r, a);
			if (right->x < left->x) {
				x = right->x;
				pos = right->pos;
			}
			else {
				x = left->x;
				pos = left->pos;
			}
		}
		else {
			pos = l;
			x = a[l];
		}
	}
	pair<int, int> query(int L, int R) {
		if (L >= r || R <= l)
			return { INF, -1 };
		if (L <= l && r <= R)
			return { x, pos };
		auto a = left->query(L, R), b = right->query(L, R);
		if (b.first < a.first)
			return b;
		else
			return a;
	}
};

struct rmax
{
	int x;
	int pos;
	int l, r;
	rmax *left = nullptr, *right = nullptr;
	rmax(int l, int r, vector<int> & a) : l(l), r(r) {
		if (r - l > 1) {
			int m = (l + r) / 2;
			left = new rmax(l, m, a);
			right = new rmax(m, r, a);
			if (right->x >= left->x) {
				x = right->x;
				pos = right->pos;
			}
			else {
				x = left->x;
				pos = left->pos;
			}
		}
		else {
			pos = l;
			x = a[l];
		}
	}
	pair<int, int> query(int L, int R) {
		if (L >= r || R <= l)
			return { -1, -1 };
		if (L <= l && r <= R)
			return { x, pos };
		auto a = left->query(L, R), b = right->query(L, R);
		if (b.first >= a.first)
			return b;
		else
			return a;
	}
};

int s(rmin & a, rmax & b, int l, int r) {
	if (r - l == 1)
		return 1;
	if (r - l == 0)
		return 0;
	int m = a.query(l, r).second;
	if (m == l)
		m = b.query(l, r).second;
	else
		return s(a, b, l, m) + s(a, b, m, r);
	if (m == r - 1)
		return 1;
	return 1 + s(a, b, m + 1, r);
}

signed main()
{
	cin.tie();
	cout.tie();
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	rmin x(0, n, a);
	rmax y(0, n, a);
	cout << s(x, y, 0, n);
}

