#include <algorithm>
#include <iostream>
#include <bitset>
#include <vector>
#include <list>

using namespace std;

typedef bitset<300000> bs;

int fst(bs &a) {
    for (int i = 0; i < a.size(); i++)
        if (a[i])
            return i;
    return -1;
}

int lst(bs &a) {
    for (int i = a.size(); i-- > 0;)
        if (a[i])
            return i;
    return -1;
}

bool le(bs &a, bs &b) {
    for (int i = a.size(); i-- > 0;)
        if (a[i] < b[i])
            return true;
    return false;
}

bs comp2(bs a, bs b) {
    {
        const bs t = a | b;
        if (t == (a ^ b))
            return t;
    }

    bs ansA = ~bs(), ansB = ~bs();

    {
        bs t = a;
        int f = fst(t) + 1, l = lst(t) + 1;
        for (int i = f; i <= l; i++) {
            bool c = (t[i] == 0);

            t[i - 1] = 0;
            t[i] = 1;

            if (c) {
                const bs tt = t | b;
                if (tt == (t ^ b)) {
                    ansA = tt;
                    break;
                }
            }
        }
    }

    {
        bs t = b;
        int f = fst(t) + 1, l = lst(t) + 1;
        for (int i = f; i <= l; i++) {
            bool c = (t[i] == 0);

            t[i - 1] = 0;
            t[i] = 1;

            if (c) {
                const bs tt = a | t;
                if (tt == (a ^ t)) {
                    ansB = tt;
                    break;
                }
            }
        }
    }

    if (le(ansA, ansB))
        return ansA;
    return ansB;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin.sync_with_stdio(false);
    cout.sync_with_stdio(false);

    int n = 2;
    cin >> n;

    bs a;
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        if (i == 0)
            a = bs(t);
        else
            a = comp2(a, bs(t));
    }

    for (int i = lst(a) + 1; i-- > 0;)
        cout << a[i];
    cout << endl;

    return 0;
}