#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

int n;
vector<int> a;

int tmn[1200000];
pair<int, int> tmx[1200000];

void build1(int i = 0, int l = 0, int r = n - 1)
{
    if (l == r) {
        tmn[i] = n;
        return;
    }
    int m = (l + r) / 2;
    build1(2 * i + 1, l, m);
    build1(2 * i + 2, m + 1, r);
    tmn[i] = min(tmn[2 * i + 1], tmn[2 * i + 2]);
}

void build2(int i = 0, int l = 0, int r = n - 1)
{
    if (l == r) {
        tmx[i] = make_pair(a[l], l);
        return;
    }
    int m = (l + r) / 2;
    build2(2 * i + 1, l, m);
    build2(2 * i + 2, m + 1, r);
    if (tmx[2 * i + 1].first > tmx[2 * i + 2].first) {
        tmx[i] = tmx[2 * i + 1];
    }
    else {
        tmx[i] = tmx[2 * i + 2];
    }
}

void ch1(int ind, int k, int l = 0, int r = n - 1, int i = 0)
{
    if (l == r) {
        tmn[i] = k;
        return;
    }
    int m = (l + r) / 2;
    if (ind <= m) {
        ch1(ind, k, l, m, 2 * i + 1);
    }
    else {
        ch1(ind, k, m + 1, r, 2 * i + 2);
    }
    tmn[i] = min(tmn[2 * i + 1], tmn[2 * i + 2]);
}

int ask1(int vl, int vr, int i = 0, int l = 0, int r = n - 1)
{
    if (vl > vr) {
        return n;
    }
    if (l == vl && r == vr) {
        return tmn[i];
    }
    int m = (l + r) / 2;
    if (m >= vr) {
        return ask1(vl, vr, 2 * i + 1, l, m);
    }
    if (vl > m) {
        return ask1(vl, vr, 2 * i + 2, m + 1, r);
    }
    return min(ask1(vl, m, 2 * i + 1, l, m), ask1(m + 1, vr, 2 * i + 2, m + 1, r));
}

pair<int, int> ask2(int vl, int vr, int i = 0, int l = 0, int r = n - 1)
{
    if (l == vl && r == vr) {
        return tmx[i];
    }
    int m = (l + r) / 2;
    if (m >= vr) {
        return ask2(vl, vr, 2 * i + 1, l, m);
    }
    if (vl > m) {
        return ask2(vl, vr, 2 * i + 2, m + 1, r);
    }
    pair<int, int> al = ask2(vl, m, 2 * i + 1, l, m), ar = ask2(m + 1, vr, 2 * i + 2, m + 1, r);
    if (al.first > ar.first) {
        return al;
    }
    return ar;
}

#define fin cin

int main()
{
    //ifstream fin("input.txt");
    ios_base::sync_with_stdio(false);
    //fin.tie(NULL);
    fin >> n;
    a.resize(n);
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        fin >> a[i];
        b[i] = a[i];
    }
    sort(b.begin(), b.end());
    vector<int> c;
    c.push_back(b[0]);
    for (int i = 1; i < n; i++) {
        if (b[i] != b[i - 1]) {
            c.push_back(b[i]);
        }
    }
    for (int i = 0; i < n; i++) {
        int l = 0, r = c.size();
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (c[m] > a[i]) {
                r = m;
            }
            else {
                l = m;
            }
        }
        a[i] = l;
    }
    build1();
    build2();
    int near[n];
    for (int i = n - 1; i >= 0; i--) {
        near[i] = ask1(0, a[i] - 1) - 1;
        ch1(a[i], i);
    }
    int ind = 0;
    int ans = 0;
    int l, r, i2;
    while (ind < n) {
        i2 = near[ind];
        l = ask2(ind, i2).second;
        ind = l + 1;
        ans++;
    }
    cout << ans;
    /*
    int lft[n];
    lft[0] = 0;
    for (int i = 1; i < n; i++) {
        if (a[i] == a[i - 1]) {
            lft[i] = lft[i - 1];
        }
        else if (a[i] < a[i - 1]) {
            lft[i] = i;
        }
        else {
            int u = i - 1;
            int mn = a[i - 1];
            int umn = i - 1;
            while (u >= 0 && a[u] <= a[i]) {
                if (mn >= a[lft[u]]) {
                    umn = lft[u];
                    mn = a[lft[u]];
                }
                u = lft[u] - 1;
            }
            lft[i] = max(u + 1, umn);
        }
    }
    int ans = 0;
    int ind = n - 1;
    while (ind >= 0) {
        ans++;
        ind = lft[ind] - 1;
    }
    cout << ans;*/
}
