#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

mt19937_64 rnd(239);

const int B = 512;
const int K = 293;
const int M = B * K;
const ll INF = 1e18;
const int BIG = 1e9 + 239;

struct line
{
    ll a, b;

    line()
    {
        a = b = 0;
    }

    line(ll _a, ll _b)
    {
        a = _a, b = _b;
    }

    ll gett(ll x)
    {
        return (a * x + b);
    }

    bool operator<(const line &l) const
    {
        return (make_pair(a, b) < make_pair(l.a, l.b));
    }
};

ld inter(line l1, line l2)
{
    return (ld)(l2.b - l1.b) / (ld)(l1.a - l2.a);
}

struct cht
{
    vector<pair<ld, line> > v;

    cht()
    {
        v = {};
    }

    void add(ll a, ll b)
    {
        line l = line(a, b);
        while (!v.empty())
        {
            pair<ld, line> t = v.back();
            if (t.second.a == l.a)
            {
                if (t.second.a >= l.a)
                    break;
                if (t.second.a < l.a)
                {
                    v.pop_back();
                    continue;
                }
            }
            ld now = inter(l, t.second);
            if (now <= t.first)
            {
                v.pop_back();
                continue;
            }
            v.push_back(make_pair(now, l));
            break;
        }
        if (v.empty())
            v.push_back(make_pair(-INF, l));
    }

    ll gett(ll x)
    {
        if (v.empty()) return 0;
        int id = upper_bound(v.begin(), v.end(), make_pair((ld)x, line(0, 0))) - v.begin() - 1;
        return v[id].second.gett(x);
    }
};

cht c[K];
int n, kol[K];
ll a[M], b[M], sb[M], si[M], pos[M];
bool used[M];

void add(int id)
{
    id = pos[id];
    used[id] = true;
    int b = id / B;
    kol[b]++;
    int l = b * B;
    int r = (b + 1) * B;
    int be = 0;
    vector<pair<ll, ll> > now;
    for (int i = l; i < r; i++)
    {
        if (!used[i]) continue;
        now.push_back(make_pair(sb[i], -(ll)be * sb[i]));
        be++;
    }
    c[b] = cht();
    for (pair<ll, ll> t : now)
        c[b].add(t.first, t.second);
}

ll gett()
{
    ll ans = 0;
    ll be = 0;
    for (int i = K - 1; i >= 0; i--)
    {
        be += kol[i];
        ans = max(ans, c[i].gett(be));
    }
    return ans;
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    cin.sync_with_stdio(0);
    memset(kol, 0, sizeof(kol));
    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    vector<pair<ll, ll> > p;
    for (int i = 0; i < n; i++)
        p.push_back(make_pair(a[i], b[i]));
    sort(p.begin(), p.end());
    for (int i = 0; i < n; i++)
        a[i] = p[i].first, b[i] = p[i].second;
    a[n] = 0;
    p.clear();
    for (int i = 0; i < n; i++)
        p.push_back(make_pair(b[i], i));
    sort(p.begin(), p.end());
    for (int i = 0; i < n; i++)
        sb[i] = p[i].first, si[i] = p[i].second;
    for (int i = 0; i < n; i++)
        pos[si[i]] = i;
    ll ans = a[0] * (ll)n;
    for (int i = 0; i < n; i++)
    {
        add(i);
        ans = max(ans, gett() + a[i + 1] * (ll)(n - i - 1));
    }
    cout << ans;
    return 0;
}
