#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int BIG = 1e9 + 239;
const int M = 4 * 1e5 + 239;
const int T = (1 << 20);

mt19937_64 rnd(239);

struct Node
{
    Node *l, *r;
    int kol;
    pair<int, int> x;
    ll y;

    Node(int a, int i)
    {
        x = make_pair(a, i);
        kol = 1;
        y = rnd();
        l = NULL;
        r = NULL;
    }
};

Node *root;

inline int getkol(Node *d)
{
    return ((d == NULL) ? 0 : d->kol);
}

inline void upd(Node *d)
{
    if (d == NULL) return;
    d->kol = 1 + getkol(d->l) + getkol(d->r);
}

inline pair<Node*, Node*> split(Node *d, pair<int, int> x)
{
    if (d == NULL)
    {
        Node *nul = NULL;
        return make_pair(nul, nul);
    }
    if (d->x <= x)
    {
        pair<Node*, Node*> t = split(d->r, x);
        d->r = t.first;
        upd(d);
        return make_pair(d, t.second);
    }
    else
    {
        pair<Node*, Node*> t = split(d->l, x);
        d->l = t.second;
        upd(d);
        return make_pair(t.first, d);
    }
}

inline Node* merge_(Node *a, Node *b)
{
    if (a == NULL) return b;
    if (b == NULL) return a;
    if (a->y < b->y)
    {
        Node *t = merge_(a, b->l);
        b->l = t;
        upd(b);
        return b;
    }
    else
    {
        Node *t = merge_(a->r, b);
        a->r = t;
        upd(a);
        return a;
    }
}

inline void add(int a, int i)
{
    pair<Node*, Node*> t = split(root, make_pair(a, i));
    root = merge_(merge_(t.first, new Node(a, i)), t.second);
}

inline int gett(int a)
{
    pair<Node*, Node*> t = split(root, make_pair(a, -1));
    int ans = getkol(t.first);
    root = merge_(t.first, t.second);
    return ans;
}

int n, a[M], G;
int ans[M];

inline void solve1()
{
    for (int i = 0; i < n; i++)
        ans[i] = 1;
    root = NULL;
    for (int i = 0; i < n; i++)
    {
        ans[i] += gett(a[i] - i);
        add(a[i] - i, i);
    }
    root = NULL;
    for (int i = n - 1; i >= 0; i--)
    {
        ans[i] += gett(a[i] + i);
        add(a[i] + i, i);
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
}

inline void solve2()
{
    for (int i = 0; i < n; i++)
        ans[i] = 1;
    for (int i = 0; i <= n; i++)
        for (int j = i; j <= n; j++)
        {
            if (i > 1 && j < n - 1) continue;
            if (i == 0 && j != n - 1) continue;
            if (j == n && i != 1) continue;
            if (i == 1 && j < n - 1) continue;
            if (j == n - 1 && i > 1) continue;
            if (i == 0 && j == n) continue;
            vector<pair<int, int> > v;
            for (int x = 0; x < n; x++)
            {
                if (x < i || x >= j)
                    v.push_back(make_pair(a[x], x));
                else
                {
                    int now = n;
                    if (i != 0) now = min(now, abs(x - i + 1));
                    if (j != n) now = min(now, abs(x - j));
                    v.push_back(make_pair(a[x] + now, x));
                }
            }
            sort(v.begin(), v.end());
            int now = 0;
            int it = 0;
            for (pair<int, int> t : v)
            {
                if (it != 0 && t.first != v[it - 1].first)
                    now = it;
                ans[t.second] = max(ans[t.second], now + 1);
                it++;
            }
        }
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    ios::sync_with_stdio(0);
    cin >> n >> G;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    if (G == 1)
        solve1();
    else
        solve2();
    return 0;
}
