#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int BIG = 1e9 + 239;
const int M = 4 * 1e5 + 239;
const int T = (1 << 20);

mt19937_64 rnd(239);

struct Node
{
    Node *l, *r;
    int kol;
    pair<int, int> x;
    ll y;

    Node(int a, int i)
    {
        x = make_pair(a, i);
        kol = 1;
        y = rnd();
        l = NULL;
        r = NULL;
    }
};

Node *root;

inline int getkol(Node *d)
{
    return ((d == NULL) ? 0 : d->kol);
}

inline void upd(Node *d)
{
    if (d == NULL) return;
    d->kol = 1 + getkol(d->l) + getkol(d->r);
}

inline pair<Node*, Node*> split(Node *d, pair<int, int> x)
{
    if (d == NULL)
    {
        Node *nul = NULL;
        return make_pair(nul, nul);
    }
    if (d->x <= x)
    {
        pair<Node*, Node*> t = split(d->r, x);
        d->r = t.first;
        upd(d);
        return make_pair(d, t.second);
    }
    else
    {
        pair<Node*, Node*> t = split(d->l, x);
        d->l = t.second;
        upd(d);
        return make_pair(t.first, d);
    }
}

inline Node* merge_(Node *a, Node *b)
{
    if (a == NULL) return b;
    if (b == NULL) return a;
    if (a->y < b->y)
    {
        Node *t = merge_(a, b->l);
        b->l = t;
        upd(b);
        return b;
    }
    else
    {
        Node *t = merge_(a->r, b);
        a->r = t;
        upd(a);
        return a;
    }
}

inline void add(int a, int i)
{
    pair<Node*, Node*> t = split(root, make_pair(a, i));
    root = merge_(merge_(t.first, new Node(a, i)), t.second);
}

inline void del(int a, int i)
{
    pair<Node*, Node*> t = split(root, make_pair(a, i));
    pair<Node*, Node*> u = split(t.first, make_pair(a, i - 1));
    root = merge_(u.first, t.second);
}

inline int gett(int a)
{
    pair<Node*, Node*> t = split(root, make_pair(a, -1));
    int ans = getkol(t.first);
    root = merge_(t.first, t.second);
    return ans;
}

int n, a[M], G;
int ans[M];
int f1[M];
int f2[M];
bool u1[M], u2[M];

inline void solve1()
{
    for (int i = 0; i < n; i++)
        ans[i] = 1;
    root = NULL;
    for (int i = 0; i < n; i++)
    {
        ans[i] += gett(a[i] - i);
        add(a[i] - i, i);
    }
    root = NULL;
    for (int i = n - 1; i >= 0; i--)
    {
        ans[i] += gett(a[i] + i);
        add(a[i] + i, i);
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
}

inline void solve2()
{
    if (n == 1)
    {
        cout << "1\n";
        return;
    }
    for (int i = 0; i < n; i++)
        ans[i] = 1;
    vector<pair<int, int> > v;
    for (int x = 0; x < n; x++)
        v.push_back(make_pair(a[x] + x, x));
    sort(v.begin(), v.end());
    int now = 0;
    int it = 0;
    for (pair<int, int> t : v)
    {
        if (it != 0 && t.first != v[it - 1].first)
            now = it;
        ans[t.second] = max(ans[t.second], now + 1);
        it++;
    }
    v.clear();
    for (int x = 0; x < n; x++)
        v.push_back(make_pair(a[x] - x, x));
    sort(v.begin(), v.end());
    now = 0;
    it = 0;
    for (pair<int, int> t : v)
    {
        if (it != 0 && t.first != v[it - 1].first)
            now = it;
        ans[t.second] = max(ans[t.second], now + 1);
        it++;
    }
    for (int i = 0; i < n; i++)
        f1[i] = 1, f2[i] = 1;
    for (int i = 0; i < n - 1; i++)
    {
        int j = n - 1;
        if ((i + j) & 1) continue;
        int t = (i + j) >> 1;
        u2[t] = 1;
    }
    for (int j = 1; j < n; j++)
    {
        int i = 0;
        if ((i + j) & 1) continue;
        int t = (i + j) >> 1;
        u1[t] = 1;
    }
    root = NULL;
    for (int i = n - 1; i > 0; i--)
    {
        add(a[i], i);
        if (i & 1) continue;
        f1[i >> 1] += gett(a[i >> 1] + (i >> 1));
    }
    root = NULL;
    for (int i = 0; i < n - 1; i++)
    {
        add(a[i], i);
        if ((i + n - 1) & 1) continue;
        f2[(i + n - 1) >> 1] += gett(a[(i + n - 1) >> 1] + ((i + n - 1) >> 1) - n + 1);
    }
    root = NULL;
    for (int i = 1; i < n; i++)
    {
        if (u1[i]) f1[i] += gett(a[i] + i);
        add(a[i] + i, i);
    }
    root = NULL;
    for (int i = n - 2; i >= 0; i--)
    {
        if (u2[i]) f2[i] += gett(a[i] - i);
        add(a[i] - i, i);
    }
    root = NULL;
    int r = 0;
    for (int i = 0; i < n; i++)
    {
        del(a[i] - i, i);
        for (int x = max(r, i + 1); x < 2 * i; x++)
            add(a[x] - x, x);
        r = 2 * i;
        if (u1[i]) f1[i] += gett(a[i] - i);
    }
    root = NULL;
    r = n - 1;
    for (int i = n - 2; i >= 0; i--)
    {
        del(a[i] + i, i);
        for (int x = min(r, i - 1); x > (2 * i - n + 1); x--)
            add(a[x] + x, x);
        r = (2 * i - n + 1);
        if (u2[i]) f2[i] += gett(a[i] + i);
    }
    for (int i = 0; i < n - 1; i++)
    {
        int j = n - 1;
        if ((i + j) & 1) continue;
        int t = (i + j) >> 1;
        int func = a[t] + min(abs(j - t), abs(t - i));
        if (t < i || t >= j) func = a[t];
        int kol = 0;
        for (int x = n - 1; x < n; x++)
        {
            if (x < i || x >= j)
                kol += (func > a[x]);
            else
                kol += (func > (a[x] + min(abs(x - j), abs(x - i))));
        }
        f2[t] += kol;
    }
    for (int j = 1; j < n; j++)
    {
        int i = 0;
        if ((i + j) & 1) continue;
        int t = (i + j) >> 1;
        int func = a[t] + min(abs(j - t), abs(t - i));
        if (t < i || t >= j) func = a[t];
        int kol = 0;
        for (int x = 0; x < 1; x++)
        {
            if (x < i || x >= j)
                kol += (func > a[x]);
            else
                kol += (func > (a[x] + min(abs(x - j), abs(x - i))));
        }
        f1[t] += kol;
    }
    for (int i = 0; i < n; i++)
    {
        ans[i] = max(f1[i], ans[i]);
        ans[i] = max(f2[i], ans[i]);
    }
    for (int i = 0; i < n; i++)
        cout << ans[i] << "\n";
}

int main()
{   /*
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout); /**/
    ios::sync_with_stdio(0);
    cin >> n >> G;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    if (G == 1)
        solve1();
    else
        solve2();
    return 0;
}
