#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>

using namespace std;

#define LL long long
#define np nullptr

struct dd
{
	int pr, size, x;
	dd *l, *r;

	dd(int nx)
	{
		l = r = np;
		size = 1;
		pr = rand();
		x = nx;
	}
};

int size(dd *root)
{
	if (root == np) return 0;
	return root->size;
}

void relax(dd *root)
{
	if (root == np) return;

	root->size = 1 + size(root->l) + size(root->r);
}

pair<dd*, dd*> split(dd *root, int x)
{
	if (root == np) return { np, np };

	if (root->x > x)
	{
		auto p = split(root->l, x);
		root->l = p.second;
		relax(root);
		return { p.first, root };
	}
	else
	{
		auto p = split(root->r, x);
		root->r = p.first;
		relax(root);
		return { root, p.second  };
	}
}

dd* merge(dd*root1, dd*root2)
{
	if (root1 == np) return root2;
	if (root2 == np) return root1;

	if (root1->pr > root2->pr)
	{
		root1->r = merge(root1->r, root2);
		relax(root1);
		return root1;
	}
	else
	{
		root2->l = merge(root1, root2->l);
		relax(root2);
		return root2;
	}
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	ios_base::sync_with_stdio(NULL); cin.tie(0); cout.tie(0);

	int n, p;
	cin >> n >> p;

	if (p == 1)
	{
		vector< int > v(n), vl(n), vr(n);

		//dd *rootl = np;
		//dd *rootr = np;

		for (size_t i = 0; i < n; i++)
		{
			cin >> v[i];
			vr[i] = v[i] + i;
			//merge(rootl);
			vl[i] = v[i] - i;
		}

		vector< int > l(n), r(n);

		for (size_t i = 0; i < n; i++)
			for (size_t j = i + 1; j < n; j++)
				if (vr[j] < vr[i])
					r[i]++;

		for (size_t i = 0; i < n; i++)
			for (int j = i - 1; j >= 0; j--)
				if (vl[j] < vl[i])
					l[i]++;

		for (size_t i = 0; i < n; i++)
			cout << l[i] + r[i] + 1 << "\n";
	}
	else
	{

	}


	return 0;
}