#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct point
{
    ll x, y;
};

vector<vector<ll>> fen;
ll n;

void add(ll a, ll b, ll x)
{
    for (ll i = a; 0 <= i && i < n; i |= (i + 1))
        for (ll j = b; 0 <= j && j < n; j |= (j + 1))
            fen[i][j] += x;
}

ll sum(ll a, ll b)
{
    ll res = 0;

    for (ll i = a; 0 <= i && i < n; i = (i & (i + 1)) - 1)
        for (ll j = b; 0 <= j && j < n; j = (j & (j + 1)) - 1)
            res += fen[i][j];

    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    ll i, j;
    cin >> n;

    fen.resize(n, vector<ll>(n, 0));
    vector<point> points(n);
    set<ll> sx_extract;
    set<ll> sy_extract;
    for (i = 0; i < n; i++)
    {
        cin >> points[i].x >> points[i].y;

        sx_extract.insert(points[i].x);
        sy_extract.insert(points[i].y);
    }

    unordered_map<ll, ll> x_compress;
    unordered_map<ll, ll> y_compress;
    vector<ll> x_extract;
    vector<ll> y_extract;
    auto itx = sx_extract.begin();
    auto ity = sy_extract.begin();
    for (i = 0; i < n; i++)
    {
        x_compress[*itx] = i;
        y_compress[*ity] = i;

        x_extract.push_back(*itx);
        y_extract.push_back(*ity);

        itx++;
        ity++;
    }

    for (i = 0; i < n; i++)
        add(x_compress[points[i].x], y_compress[points[i].y], 1);

    ll ans = -1;
    for (i = 0; i < n; i++)
    {
        for (j = 0; j < n; j++)
        {
            ll price_plus = x_extract[i];
            ll price_normal = y_extract[j];

            if (price_plus < price_normal)
                break;

            ll people_plus = sum(n - 1, n - 1) - sum(i - 1, n - 1);
            ll people_normal = sum(i - 1, n - 1) - sum(i - 1, j - 1);

            ans = max(ans, people_plus * price_plus +
                           people_normal * price_normal);
        }
    }

    cout << ans << endl;

    return 0;
}
