import java.util.*;
import java.io.*;

public class Main {
    public static void main(String args[]) throws IOException {
        InReader in = new InReader();
        OutWriter out=new OutWriter();

        int n = in.nextInt();
        int m = in.nextInt();
        int q = in.nextInt();
        int a[][] = new int[n][m];
        int lines[] = new int[n];
        int towers[] = new int[m];
        boolean usedLine[] = new boolean[n];
        boolean usedTower[] = new boolean[m];
        Pair linePair[]=new Pair[n];
        Pair towerPair[]=new Pair[m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j] = in.nextInt();
            }
        }
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                lines[i] = Math.max(lines[i], a[i][j]);
            }
        }
        for (int j = 0; j < m; j++) {
            for (int i = 0; i < n; i++) {
                towers[j] = Math.max(towers[j], a[i][j]);
            }
        }
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (lines[i] == towers[j]) {
                    usedLine[i] = true;
                    usedTower[j] = true;
                    linePair[i]=new Pair(i,j);
                    towerPair[j]=linePair[i];
                    ans++;
                }
            }
        }
        for (int i = 0; i < q; i++) {
            int x = in.nextInt()-1;
            int y = in.nextInt()-1;
            int v = in.nextInt();

            if (usedLine[x] && usedTower[y] && towers[y]==lines[x]) {
                lines[x] = v;
                towers[y] = v;
            } else {
                if (!usedLine[x] && !usedTower[y]) {
                    lines[x] = Math.max(lines[x], v);
                    towers[y] = Math.max(towers[y], v);
                    if (lines[x] == towers[y]) {
                        ans++;
                        usedLine[x] = true;
                        usedTower[y] = true;
                        linePair[x]=new Pair(x,y);
                        towerPair[y]=linePair[x];
                    }
                }
                else {
                    if(lines[x]<v && usedLine[x]){
                        usedLine[x]=false;
                        usedTower[linePair[x].y]=false;
                        ans--;
                        lines[x] = Math.max(lines[x], v);
                    }
                    if(towers[y]<v && usedTower[y]){
                        usedTower[y]=false;
                        usedLine[towerPair[y].x]=false;
                        ans--;
                        towers[y]=Math.max(towers[y],v);
                    }
                    lines[x] = Math.max(lines[x], v);
                    towers[y]=Math.max(towers[y],v);
                    if (lines[x] == towers[y]) {
                        ans++;
                        usedLine[x] = true;
                        usedTower[y] = true;
                        linePair[x]=new Pair(x,y);
                        towerPair[y]=linePair[x];
                    }
                }
            }
            out.println(ans);

        }
        out.close();
    }
    static class Pair{
        int x;
        int y;
        Pair(int xx,int yy){
            x=xx;
            y=yy;
        }
    }

    static class InReader {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer tokenizer = new StringTokenizer("");

        void update() throws IOException {
            if (!tokenizer.hasMoreTokens()) {
                String a = in.readLine();
                if (a != null) {
                    tokenizer = new StringTokenizer(a);
                }
            }
        }

        int nextInt() throws IOException {
            update();
            return Integer.parseInt(tokenizer.nextToken());
        }
    }

    static class OutWriter {
        PrintWriter out = new PrintWriter(System.out);
        StringBuilder cout = new StringBuilder();

        <T> void print(T a) {
            cout.append(a);
        }

        <T> void println(T a) {
            cout.append(a);
            cout.append('\n');
        }

        void close() {
            out.print(cout.toString());
            out.close();
        }
    }

}

