#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


int n;
vector<int> p;


#define left(v) 2 * v + 1
#define right(v) 2 * v + 2
#define parent(v) (v - 1) / 2

class LST {
    struct dd {
        int min, maxi;
    };

    static dd merge(const dd &a, const dd &b) {
        dd res;

        res.min = min(a.min, b.min);

        if (a.maxi == -1) {
            res.maxi = b.maxi;

            return res;
        }

        if (b.maxi == -1) {
            res.maxi = a.maxi;

            return res;
        }

        if (p[a.maxi] > p[b.maxi] || p[a.maxi] == p[b.maxi] && a.maxi > b.maxi) {
            res.maxi = a.maxi;
        } else {
            res.maxi = b.maxi;
        }

        return res;
    }

    vector<dd> data;
    int head_size;

    void update(int v) {
        data[v] = merge(data[left(v)], data[right(v)]);
    }

    dd get(int L, int R) {
        L += head_size;
        R += head_size - 1;

        dd l, r;
        l = r = {1000000001, -1};

        while (L < R) {
            if (L % 2 == 0) {
                l = merge(l, data[L++]);
            }

            L = parent(L);

            if (R % 2 == 1) {
                r = merge(data[R--], r);
            }

            R = parent(R);
        }

        if (L == R) {
            l = merge(l, data[L]);
        }

        return merge(l, r);
    }

public:
    LST() {
        int m = 1;
        for (; m < n; m <<= 1);

        head_size = m - 1;

        data.resize(head_size + m);

        for (int i = 0; i < n; ++i) {
            data[head_size + i] = {p[i], i};
        }

        for (int i = head_size - 1; i >= 0; --i) {
            update(i);
        }
    }

    int maxi(int L, int R) {
        return get(L, R).maxi;
    }

    bool any_lower(int L, int R, int v) {
        return get(L, R).min < v;
    }

    int bins(int L) {
        int low = L, high = n;
        int mid = (low + high) / 2;

        while (high - low > 1) {
            if (any_lower(L, mid + 1, p[L])) {
                high = mid;
            } else {
                low = mid;
            }

            mid = (low + high) / 2;
        }

        return high;
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;

    p.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i];
    }

    LST tree;

    int cnt = 0;

    int i = 0;
    while (i < n) {
        i = tree.maxi(i, tree.bins(i)) + 1;
        ++cnt;
    }

    cout << cnt;

    return 0;
}