#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>


using namespace std;


vector<vector<int>> pos, cones;


struct CC {
    bool operator()(int a, int b) const {
        return pos[a].size() > pos[b].size();
    }
};


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    string s;

    int maxl = 0;

    multiset<int, CC> poses;
    pos.resize(n);
    cones.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> s;

        int k = s.length();

        maxl = max(maxl, k);

        pos[i].resize(k);
        for (int j = 0; j < k; ++j) {
            pos[i][j] = (s[k - j - 1] == '1');
        }

        cones[i].resize(k + 1);
        for (int j = k - 1; j >= 0; --j) {
            if (pos[i][j]) {
                cones[i][j] = cones[i][j + 1] + 1;
            }
        }

        poses.insert(i);
    }

    for (int i = 0; i < maxl; ++i) {
        vector<int> colls, to_erase;
        for (int c : poses) {
            if (pos[c].size() <= i) {
                to_erase.push_back(c);

                continue;
            }

            if (pos[c][i]) {
                colls.push_back(c);
            }
        }

        for (int j : to_erase) {
            poses.erase(j);
        }

        if (colls.size() < 2) {
            continue;
        }

        int minc = 0;
        for (int j : colls) {
            minc = max(minc, cones[j][i]);
        }

        bool used = false;
        for (int j : colls) {
            int cc = cones[j][i];

            if (!used && cc == minc) {
                used = true;

                continue;
            }

            for (int k = 0; k < cc; ++k) {
                pos[j][i + k] = 0;
                cones[j][i + k] = 0;
            }

            if (i + cc >= pos[j].size()) {
                pos[j].push_back(1);
                cones[j][i + cc] = 1;
                cones[j].push_back(0);

                maxl = max(maxl, (int)pos[j].size());
            } else {
                pos[j][i + cc] = 1;
                cones[j][i + cc] = cones[j][i + cc + 1] + 1;
            }
        }
    }

    poses.clear();
    for (int i = 0; i < n; ++i) {
        poses.insert(i);
    }

    vector<int> answ;

    for (int i = 0; i < maxl; ++i) {
        vector<int> colls, to_erase;
        for (int c : poses) {
            if (pos[c].size() <= i) {
                to_erase.push_back(c);

                continue;
            }

            if (pos[c][i]) {
                colls.push_back(c);
            }
        }

        for (int j : to_erase) {
            poses.erase(j);
        }

        answ.push_back(colls.size() > 0);
    }

    reverse(answ.begin(), answ.end());

    for (int i : answ) {
        cout << i;
    }

    return 0;
}