#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <stack>
using namespace std;

const int len = 5e5;
int x, p;
int a[len];
int ans[len];

const int sz = 2;
int b[len];
int s[len];
int upd[len];

inline int block(int pos){
	return pos / sz;
}

void build(){
	for(int i = 0;i < x;i++){
		a[i] = a[i] + i;
		s[i] = a[i];
	}

	for(int i = 0;i <= block(x - 1);i++){
		sort(s + i * sz, s + min(x, (i + 1) * sz));
	}
}

void add_block(int bl, int from, int to, int val){
	int l = bl * sz;
	int r = min(x - 1, bl * sz + sz - 1);

	//cout << l << ' ' << r << endl;

	if(from <= l && r <= to){
		upd[bl] += val;
		return;
	} else {
		for(int i = max(from, l);i <= min(to, r);i++)
			a[i] += val;
		for(int i = l;i <= r;i++){
			a[i] = a[i] + upd[bl];
			s[i] = a[i];
		}
		upd[bl] = 0;
		sort(s + l, s + r + 1);
	}
}

void add(int from, int to, int val){  // [ from, to ]
	for(int i = block(from);i <= block(to);i++){
		add_block(i, from, to, val);
	}
}

int getLowerThan(int bl, int val){
	int l = bl * sz;
	int r = min(x - 1, bl * sz + sz - 1);
	int tl = l;
	int tr = r + 1;

	while(tr - tl > 1){
		int m = tl + tr >> 1;
		if(s[m] + upd[bl] < val)
			tl = m;
		else
			tr = m;
	}
	if(s[tl] + upd[bl] < val)
		return tl - l + 1;
	return 0;
}

int getLowerThan(int val){
	int res = 0;
	for(int i = 0;i < block(x - 1);i++){
		res += getLowerThan(i, val);
	}
	return res;
}

int getVal(int pos){
	return upd[block(pos)] + a[pos];
}

int main(){
	scanf("%d%d", &x, &p);
	for(int i = 0;i < x;i++)
		scanf("%d", &a[i]);
	
	if(x <= 20 && p == 2){
		if(p == 1)
			for(int i = 0;i < x;i++)
				ans[i] = x + 1;

		vector < int > v(x, 1ll << 20);
		vector < pair < int, int > > f(x);

		for(int m = 1;m < (1 << x);m++){
			for(int i = 0;i < x;i++)
				v[i] = 1 << 20;
			for(int i = 0;i < x;i++){
				if((m & (1 << i)) != 0)
					v[i] = 0;
			}

			for(int i = 1;i < x;i++)
				v[i] = min(v[i], v[i - 1] + 1);
			for(int i = x - 2;i >= 0;i--)
				v[i] = min(v[i], v[i + 1] + 1);

			for(int i = 0;i < x;i++){
				f[i] = { a[i] + v[i], i };
			}
			
			sort(f.begin(), f.end());

			int cnt = 0;
			for(int i = 0;i < x;i++){
				if(i != 0 && f[i - 1].first != f[i].first)
					cnt = i;

				if(p == 1)
					ans[f[i].second] = min(ans[f[i].second], cnt + 1);
				else
					ans[f[i].second] = max(ans[f[i].second], cnt + 1);
			}
		}
	} else {
		build();
		for(int i = 0;i < x;i++)
			ans[i] = x + 1;

		for(int i = 0;i < x;i++){
			ans[i] = getLowerThan(getVal(i)) + 1;
			add(i + 1, x - 1, -1);
			add(0, i, 1);
		}
	}

	for(int i = 0;i < x;i++)
		printf("%d\n", ans[i]);
}
