#pragma GCC optimize "Ofast"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, p;

vector<vector<ll>> ss;
vector<ll> ans, v;

bool is_stable(ll x) {
    for (ll i = 0; i < n; ++i) {
        if (ss[x][0] == x) {
            return true;
        }
    }
    return false;
}

bool can_eat(ll a, ll b) {
    // a eats b
    if (v[a] == v[b])
        return false;
    ll va = v[a];
    ll vb = v[b];
    for (ll i = 0; i < n; ++i) {
        if (ss[b][i] == va) {
            return true;
        }
        if (ss[b][i] == vb) {
            return false;
        }
    }
    return false;
}

bool can_move() {
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            if (can_eat(i, j)) {
                return true;
            }
        }
    }
    return false;
}

bool rem(ll x) {
    for (ll i = 0; i < n; ++i) {
        if (v[i] == x)
            return true;
    }
    return false;
}

bool dfs(ll x) {
    if (!rem(x))
        return false;
    if (!can_move())
        return true;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            if (can_eat(i, j)) {
                ll old = v[j];
                v[j] = v[i];
                if (dfs(x)) {
                    return true;
                }
                v[j] = old;
            }
        }
    }
    return false;
}

bool is_livable(ll x) {
    if (is_stable(x)) return true;
    for (ll i = 0; i < n; ++i) {
        v[i] = i;
    }
    return dfs(x);
}

int main() {
    cin >> n;
    ss.resize(n, vector<ll>(n));
    v.resize(n);
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            cin >> ss[i][j];
            ss[i][j]--;
        }
    }

    cin >> p;

    if (p == 1) {
        for (ll i = 0; i < n; ++i) {
            if (is_stable(i)) {
                ans.push_back(i);
            }
        }
    } else {
        for (ll i = 0; i < n; ++i) {
            if (is_livable(i)) {
                ans.push_back(i);
            }
        }
    }

    cout << ans.size() << endl;
    for (ll i : ans) {
        cout << i + 1 << " ";
    }

    return 0;
}