#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n;

vector<pair<ll, ll>> vv;

vector<ll> xa, xb, za, zb;

ll get(ll a, ll b) {
    ll ss = 0;
    for (auto p : vv) {
        if (p.first >= a) {
            ss += a;
        } else {
            if (p.second >= b) {
                ss += b;
            }
        }
    }
    return ss;
}

struct Linear {
    ll k, b;

    double intersect(Linear o) {
        return (double)(o.b - b) / (k - o.k);
    }

    bool operator<(Linear o) {
        if (k != o.k)
            return k < o.k;
        return b < o.b;
    }
};

struct CHT {
    vector<Linear> lines;
    vector<double> intersect;

    bool relevant(Linear l3) {
        if (lines.size() < 2)
            return true;
        auto l2 = lines.back();
        if (l2.k == l3.k) {
            return l2.b < l3.b;
        }
        auto l1 = lines[lines.size() - 2];
        return (l1.intersect(l3) < l2.intersect(l3));
    }

    void add(Linear line) {
        while (!relevant(line)) {
            lines.pop_back();
            intersect.pop_back();
        }
        if (!lines.empty()) {
            if (lines.back().k == line.k) {
                // we are irrelevant
                return;
            }

            intersect.push_back(lines.back().intersect(line));
        }
        lines.push_back(line);
    }

    ll get(ll x) {
        ll i = lower_bound(intersect.begin(), intersect.end(), (double)x) - intersect.begin();
        return lines[i].k * x + lines[i].b;
    }
};

vector<Linear> kk;
CHT cht;

int main() {
    cin >> n;
    vv.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> vv[i].first >> vv[i].second;
        xa.emplace_back(vv[i].first);
        xb.emplace_back(vv[i].second);
    }
    sort(xa.begin(), xa.end());
    sort(xb.begin(), xb.end());
    za.resize(n);
    zb.resize(n);
    for (ll i = 0; i < n; ++i) {
        ll q = xb[i] * (n - i);
        kk.push_back(Linear {-xb[i], q});
    }
    sort(kk.begin(), kk.end());
    for (auto l : kk) {
        cht.add(l);
    }

    ll ans = 0;

    for (ll i = 0; i < n; ++i) {
        ll big = xa[i] * (n - i);
        ll small = cht.get(n - i);
        ans = max(ans, big + small);
    }
    cout << ans << endl;

    return 0;
}