#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n;

vector<pair<ll, ll>> vv;

ll get(ll a, ll b) {
    ll ss = 0;
    for (auto p : vv) {
        if (p.first >= a) {
            ss += a;
        } else {
            if (p.second >= b) {
                ss += b;
            }
        }
    }
    return ss;
}

struct Linear {
    ll k, b;

    double intersect(Linear o) {
        return (double)(o.b - b) / (k - o.k);
    }

    bool operator<(Linear o) {
        if (k != o.k)
            return k < o.k;
        return b < o.b;
    }
};

struct CHT {
    vector<Linear> lines;
    vector<double> intersect;

    bool relevant(Linear l3) {
        if (lines.size() < 2)
            return true;
        auto l2 = lines.back();
        if (l2.k == l3.k) {
            return l2.b > l3.b;
        }
        auto l1 = lines[lines.size() - 2];
        return (l1.intersect(l3) < l2.intersect(l3));
    }

    void add(Linear line) {
        while (!relevant(line)) {
            lines.pop_back();
            intersect.pop_back();
        }
        if (!lines.empty()) {
            if (lines.back().k == line.k) {
                // we are irrelevant
                return;
            }

            intersect.push_back(lines.back().intersect(line));
        }
        lines.push_back(line);
    }

    ll get(ll x) {
        ll i = lower_bound(intersect.begin(), intersect.end(), (double)x) - intersect.begin();
        return lines[i].k * x + lines[i].b;
    }

    void clear() {
        intersect.clear();
        lines.clear();
    }
};

vector<Linear> kk;
CHT cht;

ll stupid() {
    ll ans = 0;
    for (ll i = 0; i < n; ++i) {
        for (ll j = 0; j < n; ++j) {
            ll a = vv[i].first;
            ll b = vv[j].second;
            if (a < b) continue;
            ans = max(ans, get(a, b));
        }
    }
    return ans;
}

ll good() {
    ll ans = 0;

    vector<ll> zz;

    for (ll i = 0; i < n; ++i) {
        sort(zz.begin(), zz.end());
        ll small = 0;
        for (ll j = 0; j < zz.size(); ++j) {
            ll q = (zz.size() - j) * zz[j];
            if (q > small)
                small = q;
        }
        ll big = vv[i].first * (n - i);
        ans = max(ans, big + small);
        zz.push_back(vv[i].second);
    }
    return ans;
}

void run() {
    kk.clear();
    cht.clear();
    sort(vv.begin(), vv.end());
}

int tmain() {
    n = 5;
    vv.resize(n);
    ll z;
    do {
        for (ll i = 0; i < n; ++i) {
            vv[i].first = 1 + (rand() % 5);
            vv[i].second = 1 + (rand() % vv[i].first);
        }
        run();
        z = good();
    } while (z == stupid());
    cout << n << endl;
    for (ll i = 0; i < n; ++i) {
        cout << vv[i].first << " " << vv[i].second << endl;
    }
    cout << "good(): " << z << endl;
    cout << "stupid(): " << stupid() << endl;
    return 0;
}

int main() {
    cin >> n;
    vv.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> vv[i].first >> vv[i].second;
    }
    run();


    cout << good() << endl;

    return 0;
}