#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, m, k;

vector<vector<pair<ll, ll>>> par;
vector<pair<ll, ll>> good;
vector<vector<ll>> dist, have;
vector<vector<bool>> used;

int main() {
    cin >> n >> m >> k;
    par.resize(n, vector<pair<ll, ll>>(m));
    dist.resize(n, vector<ll>(m, INT64_MAX));
    used.resize(n, vector<bool>(m));
    have.resize(n, vector<ll>(m));
    for (ll i = 0; i < k; ++i) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        have[a][b] = i + 1;
        good.emplace_back(a, b);
    }

    dist[0][0] = 0;


    for (;;) {
        ll mi = -1, mj = -1;
        for (auto p : good) {
            ll i, j;
            tie(i, j) = p;
            if (!used[i][j]) {
                if (mi == -1 || dist[i][j] < dist[mi][mj]) {
                    tie(mi, mj) = make_pair(i, j);
                }
            }
        }
        if (mi == -1) break;
        used[mi][mj] = true;
        for (auto p : good) {
            ll i, j;
            tie(i, j) = p;
            if (!used[i][j]) {
                ll q = (1ll << (max(abs(i - mi), abs(j - mj))));
                q += dist[mi][mj];
                if (dist[i][j] > q) {
                    dist[i][j] = q;
                    par[i][j].first = mi;
                    par[i][j].second = mj;
                }
            }
        }
    }

    ll ci = n - 1;
    ll cj = m - 1;

    vector<ll> path;

    while (ci != 0 || cj != 0) {
        path.push_back(have[ci][cj]);
        tie(ci, cj) = par[ci][cj];
    }
    path.push_back(1);
    reverse(path.begin(), path.end());
    cout << path.size() << endl;
    for (ll i : path) {
        cout << i << " ";
    }
    cout << endl;

    return 0;
}