#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, m, k;


struct la {
    bitset<2048> data;

    la() {
        data.reset();
    }

    la(ll x) {
        data.reset();
        data |= x;
    }

    bool operator< (la o) {
        for (ll i = 2047; i>= 0; --i) {
            if (data[i] != o.data[i])
                return data[i] < o.data[i];
        }
        return false;
    }

    void operator= (la x) {
        data = x.data;
    }

    la operator+(la x) {
        la r;
        ll carry = 0;
        for (ll i = 0; i < 2048; ++i) {
            ll bit = x.data[i] + data[i];
            bit += carry;
            if (bit & 1)
                r.data.set(i);
            carry = bit >> 1;
        }
        return r;
    }
};

vector<vector<pair<ll, ll>>> par;
vector<pair<ll, ll>> good;
vector<vector<la>> dist;
vector<vector<ll>> have;
vector<vector<bool>> used;

int main() {
    cin >> n >> m >> k;
    par.resize(n, vector<pair<ll, ll>>(m));
    dist.resize(n, vector<la>(m, la(INT64_MAX)));
    used.resize(n, vector<bool>(m));
    have.resize(n, vector<ll>(m));
    for (ll i = 0; i < k; ++i) {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        have[a][b] = i + 1;
        good.emplace_back(a, b);
    }

    dist[0][0] = 0;


    for (;;) {
        ll mi = -1, mj = -1;
        for (auto p : good) {
            ll i, j;
            tie(i, j) = p;
            if (!used[i][j]) {
                if (mi == -1 || dist[i][j] < dist[mi][mj]) {
                    tie(mi, mj) = make_pair(i, j);
                }
            }
        }
        if (mi == -1) break;
        used[mi][mj] = true;
        for (auto p : good) {
            ll i, j;
            tie(i, j) = p;
            if (!used[i][j]) {
                la q;
                q.data.set(max(abs(i - mi), abs(j - mj)));
                q = q + dist[mi][mj];
                if (q < dist[i][j]) {
                    dist[i][j] = q;
                    par[i][j].first = mi;
                    par[i][j].second = mj;
                }
            }
        }
    }

    ll ci = n - 1;
    ll cj = m - 1;

    vector<ll> path;

    while (ci != 0 || cj != 0) {
        path.push_back(have[ci][cj]);
        tie(ci, cj) = par[ci][cj];
    }
    path.push_back(1);
    reverse(path.begin(), path.end());
    cout << path.size() << endl;
    for (ll i : path) {
        cout << i << " ";
    }
    cout << endl;

    return 0;
}