#pragma GCC optimize "Ofast"

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll n, p;
vector<ll> a;
struct Node;
Node* nullv;

struct Node {
    Node* left, *right, *parent;
    ll key, prio, size, count;

    Node() {
        size = 1;
        count = 1;
        left = nullv;
        right = nullv;
        parent = nullv;
    };
};


void upd(Node* node) {
    if (node == nullv) return;
    node->size = node->left->size + node->right->size + node->count;
}

void split(Node* node, ll key, Node*& left, Node*& right) {
    if (node == nullv) {
        left = nullv;
        right = nullv;
        return;
    }
    if (key < node->key) {
        Node* x, *y;
        split(node->left, key, x, y);
        node->left = y;
        if (y != nullv) y->parent = node;
        left = x;
        right = node;
    } else {
        Node* x, *y;
        split(node->right, key, x, y);
        node->right = x;
        if (x != nullv) x->parent = node;
        right = y;
        left = node;
    }
    upd(left);
    upd(right);
}

Node* merge(Node* a, Node * b) {
    if (a == nullv)
        return b;
    if (b == nullv)
        return a;
    if (a->prio < b->prio) {
        b->left = merge(a, b->left);
        if (b->left != nullv) b->left->parent = b;
        upd(a);
        upd(b);
        return b;
    } else {
        a->right = merge(a->right, b);
        if (a->right != nullv) a->right->parent = a;
        upd(a);
        upd(b);
        return a;
    }
}

Node* find(Node *root, ll val) {
    if (root == nullv)
        return nullv;
    if (root->key == val)
        return root;
    if (root->key < val) {
        return find(root->right, val);
    } else {
        return find(root->left, val);
    }
}

void insert(Node* &root, ll val) {
    auto t = find(root, val);
    if (t != nullv) {
        t->count++;
        while (t != nullv) {
            upd(t);
            t = t->parent;
        }
        return;
    }
    Node* x = new Node();
    x->key = val;
    x->prio = rand();
    Node* a, *b;
    split(root, val, a, b);
    root = merge(merge(a, x), b);
}

void erase(Node* &root, ll val) {
    auto t = find(root, val);
    if (t != nullv && t->count > 1) {
        t->count--;
        while (t != nullv) {
            upd(t);
            t = t->parent;
        }
        return;
    }
    Node* a, *b, *c, *d;
    split(root, val, a, b);
    split(a, val - 1, c, d);
    root = merge(c, b);
}

ll countLess(Node*root, ll val) {
    if (root == nullv)
        return 0;
    if (root->key > val) {
        return countLess(root->left, val);
    } else {
        ll t = root->left->size + countLess(root->right, val);
        if (root->key < val)
            t += root->count;
        return t;
    }
}

vector<ll> solveSmart() {
    nullv = new Node();
    nullv->size = nullv->count = 0;
    nullv->left = nullv->right = nullv->parent = nullv;
    vector<ll> ans;

    Node* left = nullv;
    Node* right = nullv;
    ll cl = 0, cr = 0;
    for (ll i = 0; i < n; ++i) {
        ll t = a[i] + i;
        insert(right, t);
    }
    for (ll i = 0; i < n; ++i) {
        ll t = a[i];
        erase(right, a[i] + i);
        // x < t - cl
        ll k = 1;
        k += countLess(left, t - cl);
        k += countLess(right, t - cr);
        ans.push_back(k);
        cr--;
        insert(left, a[i] - cl);
        cl++;
    }
    return ans;
}

vector<ll> solveStupid() {
    vector<ll> ans;
    for (ll i = 0; i < n; ++i) {
        ll t = a[i];
        ll k = 1;
        for (ll j = 0; j < n; ++j) {
            if (j == i) continue;
            if (a[j] + abs(j - i) < t)
                k++;
        }
        ans.push_back(k);
    }
    return ans;
}

int tmain() {
    vector<ll> my, stupid;

    while (true) {
        n = 3;
        a.resize(n);
        for (ll i = 0; i < n; ++i) {
            a[i] = 1 + rand() % 10;
        }
        my = solveSmart();
        stupid = solveStupid();
        for (ll i = 0; i < n; ++i)
            if (my[i] != stupid[i]) {
                goto qq;
            }
    }
    qq:cout << n << " 1" << endl;
    for (ll i = 0; i < n; ++i) {
        cout << a[i] << " ";
    }
    cout << endl;
    cout << "expected: ";
    for (ll i : stupid) {
        cout << i << " ";
    }
    cout << endl;
    cout << "got: ";
    for (ll i : my) {
        cout << i << " ";
    }
    cout << endl;
}

int main() {
    srand(time(0));
    cin >> n >> p;
    a.resize(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    auto ans = solveSmart();
    for (ll i : ans) {
        cout << i << endl;
    }
    return 0;
}