#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 1 << 20;
const int MAXR = (1 << 19) - 1;

struct T
{
    ll mx[MAXN];
    ll pushed[MAXN];
    T()
    {
        for (int i = 0; i < MAXN; i++)
        {
            mx[i] = 0;
            pushed[i] = 0;
        }
    }
    void push(int v)
    {
        if (v * 2 + 1 < MAXN)
        {
            mx[v * 2] += pushed[v];
            mx[v * 2 + 1] += pushed[v];
            pushed[v * 2] += pushed[v];
            pushed[v * 2 + 1] += pushed[v];
        }
        pushed[v] = 0;
    }
    void upd(int v, int vl, int vr, int l, int r, ll val)
    {
        if (vr < l || r < vl)
            return;
        push(v);
        if (l <= vl && vr <= r)
        {
            pushed[v] += val;
            mx[v] = mx[v] + val;
            return;
        }
        int m = (vl + vr) / 2;
        upd(v * 2, vl, m, l, r, val);
        upd(v * 2 + 1, m + 1, vr, l, r, val);
        mx[v] = max(mx[v * 2], mx[v * 2 + 1]);
    }
    ll get(int v, int vl, int vr, int l, int r)
    {
        if (vr < l || r < vl)
            return 0;
        push(v);
        if (l <= vl && vr <= r)
            return mx[v];
        int m = (vl + vr) / 2;
        return max(get(v * 2, vl, m, l, r), get(v * 2 + 1, m + 1, vr, l, r));
    }
};

const int MAXT = 3010;

multiset <ll> st;

void upd(ll p, int ins)
{
    if (ins == 1)
        st.insert(p);
    else
        st.erase(st.find(p));
}

ll get()
{
    ll res = 0;
    ll cnt = 0;
    for (auto it = st.rbegin(); it != st.rend(); it++)
    {
        cnt++;
        res = max(res, *it);
    }
    return res;
}


T tr;

int main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0);
    int n;
    cin >> n;
    vector <pair <int, int>> arr(n);
    for (auto &i : arr)
        cin >> i.first >> i.second;
    sort(arr.begin(), arr.end());

    for (auto i : arr)
        upd(i.second, 1);

    ll best = get();
    for (int i = n - 1; i >= 0; i--)
    {
        ll cur = (ll)arr[i].first * (ll)(n - i);
        upd(arr[i].second, -1);
        cur += get();
        best = max(best, cur);
    }
    cout << best;
    return 0;
}
