#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int MAXN = 25;

int base = 2;

struct T
{
    vector <int> dgs;
    T()
    {
        dgs.clear();
    }
    T operator + (const T &b) const
    {
        T res;
        res.dgs.resize(max(dgs.size(), b.dgs.size()) + 1);
        for (int i = 0; i < max(dgs.size(), b.dgs.size()); i++)
        {
            res.dgs[i] += (i < dgs.size() ? dgs[i] : 0) + (i < b.dgs.size() ? b.dgs[i] : 0);
            res.dgs[i + 1] += res.dgs[i] / base;
            res.dgs[i] %= base;
        }
        while (res.dgs.size() > 1 && !res.dgs.back())
            res.dgs.pop_back();
        return res;
    }
    bool operator <(const T &b) const
    {
        if (b.dgs.size() == 1 && b.dgs.back() == -1)
            return 1;
        if (dgs.size() == 1 && dgs.back() == -1)
            return 0;
        if (dgs.size() < b.dgs.size())
            return 1;
        if (dgs.size() > b.dgs.size())
            return 0;
        for (int i = (int)dgs.size() - 1; i >= 0; i--)
            if (dgs[i] < b.dgs[i])
                return 1;
            else if (dgs[i] > b.dgs[i])
                return 0;
        return 0;
    }
    void print()
    {
        for (auto it = dgs.rbegin(); it != dgs.rend(); it++)
            cout << (*it);
    }
};

T g[MAXN][MAXN];

T pw(int st)
{
    T res;
    res.dgs.resize(st);
    res.dgs.push_back(1);
    return res;
}

T nl()
{
    T res;
    res.dgs.resize(1);
    return res;
}

T bg()
{
    T res;
    res.dgs.push_back(-1);
    return res;
}

int main()
{
#ifdef POSPELOV
    freopen("in.txt", "r", stdin);
#endif // POSPELOV
    ios_base::sync_with_stdio(0);
    int n, m, k;
    cin >> n >> m >> k;

    vector <pair <int, int>> arr(k);
    for (auto &i : arr)
        cin >> i.first >> i.second;

    for (int i = 0; i < k; i++)
    {
        for (int j = 0; j < k; j++)
        {
            T d = pw(max(abs(arr[i].first - arr[j].first), abs(arr[i].second - arr[j].second)));
            g[i][j] = d;
            g[j][i] = d;
        }
    }

    set <pair <T, int>> st;
    vector <int> p(k);
    vector <T> d(k, bg());
    d[0] = nl();
    st.insert({nl(), 0});
    while (!st.empty())
    {
        T cur = st.begin()->first;
        int u = st.begin()->second;
        st.erase(st.begin());
        for (int v = 0; v < k; v++)
        {
            T dst = cur + g[u][v];
            if (dst < d[v])
            {
                st.erase({d[v], v});
                d[v] = dst;
                st.insert({d[v], v});
                p[v] = u;
            }
        }
    }
    vector <int> ans;
    int cur = k - 1;
    while (cur)
    {
        ans.push_back(cur);
        cur = p[cur];
    }
    ans.push_back(0);
    reverse(ans.begin(), ans.end());
    cout << ans.size() << "\n";
    for (int i : ans)
        cout << i + 1 << " ";
    return 0;
}
