import java.io.*;
import java.math.*;
import java.util.*;

public class D {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	public void run() {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public class Point {
		int x;
		int y;
		int n;
		
		public Point(int x, int y, int n) {
			this.x = x;
			this.y = y;
			this.n = n;
		}
		
		public int dist(Point p) {
			return Math.max(Math.abs(x - p.x), Math.abs(y - p.y));
		}
	}
	
	BigInteger[] pow;
	int[][] edge;
	
	public void solve() {
		int n = nextInt();
		int m = nextInt();
		int k = nextInt();
		pow = new BigInteger[Math.max(m, n) + 1];
		for (int i = 0; i < pow.length; i++) {
			pow[i] = BigInteger.ONE.shiftLeft(i);
		}
		Point[] p = new Point[k];
		for (int i = 0; i < p.length; i++) {
			p[i] = new Point(nextInt(), nextInt(), i + 1);
		}
		edge = new int[k][k];
		for (int i = 0; i < p.length; i++) {
			for (int j = 0; j < p.length; j++) {
				edge[i][j] = p[i].dist(p[j]);
			}
		}
		boolean[] used = new boolean[k];
		BigInteger[] len = new BigInteger[k];
		len[0] = BigInteger.ZERO;
		for (int i = 1; i < len.length; i++) {
			len[i] = pow[pow.length - 1];
		}
		int[] prev = new int[k];
		for (int i = 0; i < prev.length; i++) {
			prev[i] = -1;
		}
		while (true) {
			int number = -1;
			BigInteger min = pow[pow.length - 1];
			for (int i = 0; i < len.length; i++) {
				if (!used[i] && len[i].compareTo(min) < 0) {
					min = len[i];
					number = i;
				}
			}
			used[number] = true;
			if (number == k - 1) {
				break;
			}
			for (int i = 0; i < prev.length; i++) {
				BigInteger bg = min.add(pow[edge[number][i]]);
				if (len[i].compareTo(bg) > 0) {
					len[i] = bg;
					prev[i] = number;
				}
			}
		}
		Stack<Integer> stack = new Stack<>();
		int th = k - 1;
		stack.add(th);
		while (prev[th] != -1) {
			th = prev[th];
			stack.add(th);
		}
		out.println(stack.size());
		while (!stack.isEmpty()) {
			out.print(stack.pop() + 1 + " ");
		}
	}
	
//	4 5 3
//	1 1
//	2 3
//	4 5

	public static void main(String[] args) {
		new D().run();
	}

}
