import java.io.*;
import java.util.*;
import java.math.*;

public class A {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public void solve() {
		int n = nextInt();
		int ans = 0;
		int min = Integer.MAX_VALUE;
		Stack<Integer> stack = new Stack<>();
		for (int i = 0; i < n; i++) {
			int x = nextInt();
			if (x < min) {
				ans += stack.size();
				min = x;
				stack.clear();
			}
			while (!stack.isEmpty() && stack.peek() <= x) {
				stack.pop();
			}
			stack.add(x);
		}
		out.println(ans + stack.size());
	}

	public static void main(String[] args) {
		new A().run();
	}

}
