import java.io.*;
import java.util.*;
import java.math.*;

public class A {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public class Pair {
		int l;
		int r;
		
		public Pair(int l, int r) {
			this.l = l;
			this.r = r;
		}
	}
	
	public class Fenvik {
		int[] min;
		
		public Fenvik(int n) {
			min = new int[n];
			for (int i = 0; i < min.length; i++) {
				min[i] = Integer.MAX_VALUE;
			}
		}
		
		public int min(int r) {
			int ans = Integer.MAX_VALUE;
			for (; r >= 0; r = (r & (r + 1)) - 1) {
				ans = Math.min(ans, min[r]);
			}
			return ans;
		}
		
		public void set(int to, int x) {
			for (; to < min.length; to = (to | (to + 1))) {
				min[to] = Math.min(min[to], x);
			}
		}
	}
	
	HashMap<Integer, Integer> map = new HashMap<>();
	
	public void solve() {
		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < a.length; i++) {
			a[i] = nextInt();
		}
		int[] b = a.clone();
		Arrays.sort(b);
		for (int i = 0; i < b.length; i++) {
			map.put(b[i], i);
		}
		Fenvik l = new Fenvik(n + 1);
		Fenvik nl = new Fenvik(n + 1);
		int[] less = new int[n];
		int[] notLess = new int[n];
		for (int i = n - 1; i >= 0; i--) {
//			notLess[i] = i;
//			for (int j = i + 1; j < notLess.length; j++) {
//				if (a[j] >= a[i]) {
//					notLess[i] = j;
//					break;
//				}
//			}
			int j = nl.min(n - map.get(a[i]));
			if (j == Integer.MAX_VALUE) {
				notLess[i] = i;
			} else {
				notLess[i] = j;
			}
			j = l.min(map.get(a[i]) - 1);
			if (j == Integer.MAX_VALUE) {
				less[i] = n;
			} else {
				less[i] = j;
			}
			nl.set(n - map.get(a[i]), i);
			l.set(map.get(a[i]), i);
//			less[i] = n;
//			for (int j = i + 1; j < notLess.length; j++) {
//				if (a[j] < a[i]) {
//					less[i] = j;
//					break;
//				}
//			}
		}
//		for (int i = n - 1; i >= 0; i--) {
//			Integer nl = first.higherKey(a[i] - 1);
//			if (nl == null) {
//				notLess[i] = i;
//			} else {
//				notLess[i] = first.get(nl);
//			}
//			Integer l = first.lowerKey(a[i]);
//			if (l == null) {
//				less[i] = n;
//			} else {
//				less[i] = first.get(l);
//			}
//			first.put(a[i], i);
//		}
//		for (int i = 0; i < notLess.length; i++) {
//			System.out.println(less[i] + " " + notLess[i]);
//		}
//		System.out.println();
		int ans = 1;
		int left = 0;
		int right = 0;
		while (right != n - 1) {
			if (notLess[right] == right || notLess[right] >= less[left]) {
				left = right + 1;
				right = right + 1;
				ans++;
				continue;
			}
			right = notLess[right];
		}
		out.println(ans);
//		Stack<Pair> stack = new Stack<>();
//		stack.add(new Pair(a[0], a[0]));
//		for (int i = 1; i < n; i++) {
//			Pair p = new Pair(a[i], a[i]);
//			while (!stack.isEmpty()) {
//				Pair p1 = stack.peek();
//				if (p1.l <= p.l && p1.r <= p.r) {
//					p = new Pair(p1.l, p.r);
//					stack.pop();
//				} else {
//					break;
//				}
//			}
//			stack.add(p);
//		}
//		out.println(stack.size());
	}

	public static void main(String[] args) {
		new A().run();
	}

}
