import java.io.*;
import java.util.*;
import java.math.*;

public class C1 {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public class Pair implements Comparable<Pair> {
		int time;
		int n;

		public Pair(int time, int n) {
			this.time = time;
			this.n = n;
		}
		
		public Pair clone() {
			return new Pair(time, n);
		}

		@Override
		public int compareTo(Pair o) {
			return time - o.time;
		}
	}
	
	
	
	public void solve() {
		int n = nextInt();
		nextInt();
		int[] time = new int[n];
		for (int i = 0; i < time.length; i++) {
			time[i] = nextInt();
		}
		int[] ans = new int[n];
		for (int q = 0; q < n; q++) {
			for (int i = 0; i < q; i++) {
				if (time[i] + q - i < time[q]) {
					ans[q]++;
				}
			}
			for (int i = q + 1; i < n; i++) {
				if (time[i] + i - q < time[q]) {
					ans[q]++;
				}
			}
		}
		for (int i = 0; i < ans.length; i++) {
			out.println(ans[i] + 1);
		}
	}

	public static void main(String[] args) {
		new C1().run();
	}

}
