import java.io.*;
import java.util.*;
import java.math.*;

public class D {
	
	BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	PrintWriter out = new PrintWriter(System.out);
	StringTokenizer st;
	
	public String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(in.readLine());
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return st.nextToken();
	}
	
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	public long nextLong() {
		return Long.parseLong(nextToken());
	}
	
	public void run() {
		solve();
		out.close();
	}
	
	public class Pair {
		int l;
		int r;
		
		public Pair(int l, int r) {
			this.l = l;
			this.r = r;
		}
	}
	
	
	
	public void solve() {
		int n = nextInt();
		TreeMap<Integer, Integer> map = new TreeMap<>();
		for (int i = 0; i < n; i++) {
			int x = nextToken().length() - 1;
			if (map.containsKey(x)) {
				map.put(x, map.get(x) + 1);
			} else {
				map.put(x, 1);
			}
		}
		ArrayList<Integer> ans = new ArrayList<>();
		int free = 0;
		while (!map.isEmpty()) {
			int x = map.firstKey();
			if (map.get(x) == 1) {
				map.remove(x);
			} else {
				map.put(x, map.get(x) - 1);
			}
			if (free >= x) {
				ans.add(free);
				free++;
			} else {
				ans.add(x);
				free = x + 1;
			}
		}
		boolean[] b = new boolean[ans.get(ans.size() - 1) + 1];
		for (int i : ans) {
			b[b.length - i - 1] = true;
		}
		for (int i = 0; i < b.length; i++) {
			out.print(b[i] ? 1 : 0);
		}
	}

	public static void main(String[] args) {
		new D().run();
	}

}
