#include <bits/stdc++.h>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

struct node {
    ll x, sz;
    int y;
    node *l, *r;
    node() {}
    node(ll x1) : x(x1), sz(1) {
        y = RAND_MAX * rand() + rand();
        l = r = nullptr;
    }
};

ll tsz(node *t) {
    return (t != nullptr ? t->sz : 0LL);
}

void upd(node *&t) {
    if (t != nullptr) {
        t->sz = 1 + tsz(t->l) + tsz(t->r);
    }
}

node *merge(node *p, node *q) {
    if (p == nullptr) return q;
    if (q == nullptr) return p;
    if (p->y > q->y) {
        p->r = merge(p->r, q);
        upd(p);
        return p;
    }
    else {
        q->l = merge(p, q->l);
        upd(q);
        return q;
    }
}

pair <node*, node*> split(node *t, ll x) {
    if (t == nullptr) return {t, t};
    if (t->x < x) {
        auto p = split(t->r, x);
        t->r = p.f;
        upd(t);
        return {t, p.s};
    }
    else {
        auto p = split(t->l, x);
        t->l = p.s;
        upd(t);
        return {p.f, t};
    }
}

pair <node*, node*> splitsz(node *t, int k) {
    if (t == nullptr || k <= 0) return {nullptr, t};
    if (tsz(t) == k )
        return {t, nullptr};
    if (tsz(t->l) >= k) {
        auto p = splitsz(t->l, k);
        t->l = p.s;
        upd(t);
        return {p.f, t};
    }
    else {
        auto p = splitsz(t->r, k - tsz(t->l) - 1);
        t->r = p.f;
        upd(t);
        return {t, p.s};
    }
}

void add(node *&t, ll x) {
    auto p = split(t, x);
    t = merge(p.f, merge(new node(x), p.s));
}

const int N = 150005;
int n;
ll a[N], b[N];
ll id[N];

int cur;
node *T;




bool cmp(int i, int j) {
    return a[i] < a[j];
}

void dfs(node *t) {
    if (t != nullptr) {
        dfs(t->l);
        cout << t->x << ' ';
        dfs(t->r);
    }
}

set <ll> x, xb;

ll calc(ll A, ll B) {
    ll cost = 0;
    int vl = -1, vr = n;
    while (vr - vl > 1) {
        int vm = (vl + vr) >> 1;
        if (a[id[vm]] >= A) {
            vr = vm;
        }
        else {
            vl = vm;
        }
    }
    cost += (ll)(n - vr) * A;

    while (cur < vr - 1) {
        ++cur;
        add(T, b[id[cur]]);
    }
    auto p = split(T, B);
    cost += tsz(p.second) * B;
    T = merge(p.f, p.s);


    return cost;
}

ll solve_stupid() {
    cur = -1;
    T = nullptr;
    for (int i = 0; i < n; ++i)
        id[i] = i;
    sort(id, id + n, cmp);
    ll ans = 0;
    for (ll A : x) {
        for (ll B : xb) {
            if (B > A) break;
            chkmax(ans, calc(A, B));
        }
        /*ll bl = -1, br = A;
        while (br - bl > 1) {
            ll B = (bl + br) >> 1;
            if (check(A, B))
                bl = B;
            else
                br = B;
        }
        if (A == 70) {
            cout << bl + 1 << "KEKEKEKE\n";
        }
        chkmax(ans, calc(A, bl + 1));*/
    }
    return ans;
}

ll solve() {
    for (int i = 0; i < n; ++i)
        id[i] = i;
    sort(id, id + n, cmp);
    ll ans = 0;
    for (int i = 0; i < n + 1; ++i) {
        ll A = (i < n ? a[id[i]] : 0);

        auto p = splitsz(T, cur);
        auto p1 = splitsz(p.second, 1);
        ll val = (p1.f != nullptr ? p1.f->x : -2e9);
        ll rs = (p1.f != nullptr ? p1.f->x * (tsz(p1.s) + 1) : 0);
        T = merge(p.f, merge(p1.f, p1.s));
        chkmax(ans, A * (ll)(n - i) + rs);

        //dfs(T); cout << endl;

        if (i == n) break;


        ll x = b[id[i]];
        add(T, x);
        if (x < val || cur == -1) cur++;
        while (1) {
            p = splitsz(T, cur);
            auto p1 = splitsz(p.s, 1);
            auto p2 = splitsz(p1.s, 1);

            auto LL = p.first;
            auto L = p1.first;
            auto R = p2.first;
            auto RR = p2.second;
            if (R == nullptr) {
                T = merge(merge(LL, L), merge(R, RR));
                break;
            }
            ll resL = L->x * (ll)(tsz(R) + tsz(RR) + 1);
            ll resR = R->x * (ll)(tsz(RR) + 1);
            T = merge(merge(LL, L), merge(R, RR));
            if (resR >= resL) {
                cur++;
            }
            else break;
        }
    }
    return ans;
}

void stress() {
    cur = 0;
    T = nullptr;
    REP(itr, 0, 20) {
        x.clear();
        xb.clear();
        n = rand() % 20 + 1;
        for (int i = 0; i < n; ++i) {
            a[i] = rand() % 100;
            b[i] = rand() % 100;
            x.insert(a[i]);
            xb.insert(b[i]);
        }
        ll ans = solve();
        ll ans_stupid = solve_stupid();
        if (ans != ans_stupid) {
            cout << n << endl;
            for (int i = 0; i < n; ++i) {
                cout << a[i] << ' ' << b[i] << endl;
            }
            cout << endl;
            cout << ans << ' ' << ans_stupid << endl;
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("C.in", "r", stdin);
#endif // DEBUG

    //stress();
    //return 0;

    cur = -1;
    T = nullptr;

    cin >> n;
//
//    bool bad = false;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        x.insert(a[i]);
//        x.insert(a[i] + 1);
        xb.insert(b[i]);
//        x.insert(b[i] + 1);
//        if (a[i] != b[i] && b[i] > 0)
//            bad = true;
    }

    cout << solve() << endl;




    return 0;
}
