#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define f first
#define s second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define REP(i, st, n) for (int i = (st); i < (n); ++i)

typedef long long ll;

template <typename T1, typename T2> inline void chkmin(T1 &x, T2 y) { if (y < x) x = y; };
template <typename T1, typename T2> inline void chkmax(T1 &x, T2 y) { if (y > x) x = y; };

const int INF = 2e9;
const int N = 400005;
int n, type;
int a[N];
int ans_stupid[N];
int ans_new[N];
int ans_kek[N];
int x[N];
int ord[N];

void read() {
    cin >> n >> type;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
}

void solve_stupid() {
    for (int i = 0; i < n; ++i) {
        ans_stupid[i] = (type == 1 ? INF : -INF);
    }
    for (int mask = 1; mask < (1 << n); ++mask) {
        for (int i = 0; i < n; ++i) x[i] = ((mask & (1 << i)) ? 0 : INF);
        for (int i = 1; i < n; ++i) chkmin(x[i], x[i - 1] + 1);
        for (int i = n - 2; i >= 0; --i) chkmin(x[i], x[i + 1] + 1);

        for (int i = 0; i < n; ++i)
            ord[i] = (x[i] + a[i]);
        sort(ord, ord + n);

        for (int i = 0; i < n; ++i) {
            int l = -1, r = n - 1;
            while (r - l > 1) {
                int mid = (l + r) >> 1;
                if (ord[mid] >= x[i] + a[i])
                    r = mid;
                else
                    l = mid;
            }
            int place = r + 1;
            if (type == 1) {
                chkmin(ans_stupid[i], place);
            }
            else {
                chkmax(ans_stupid[i], place);
            }
        }
    }
}

void solve_new() {
    for (int i = 0; i < n; ++i) ans_new[i] = INF;
    for (int ii = 0; ii < n; ++ii) {
        for (int i = 0; i < n; ++i) x[i] = INF;
        x[ii] = 0;
        for (int i = 1; i < n; ++i) chkmin(x[i], x[i - 1] + 1);
        for (int i = n - 2; i >= 0; --i) chkmin(x[i], x[i + 1] + 1);

        for (int i = 0; i < n; ++i)
            ord[i] = (x[i] + a[i]);
        sort(ord, ord + n);

        for (int i = 0; i < n; ++i) {
            int l = -1, r = n - 1;
            while (r - l > 1) {
                int mid = (l + r) >> 1;
                if (ord[mid] >= x[i] + a[i])
                    r = mid;
                else
                    l = mid;
            }
            int place = r + 1;
            chkmin(ans_new[i], place);
        }
    }
}

struct node {
    int x, y, sz;
    node *l, *r;
    int pull;
    node() {}
    node(int x1): x(x1), pull(0) {
        y = RAND_MAX * rand() + rand();
        sz = 1;
        l = r = nullptr;
    }
};

int tsz(node *t) {
    if (t == nullptr) return 0;
    return t->sz;
}

void upd(node *&t) {
    if (t != nullptr) {
        t->sz = 1 + tsz(t->l) + tsz(t->r);
    }
}

void push(node *&t) {
    if (t == nullptr) return;
    if (t->l != nullptr) {
        t->l->x += t->pull;
        t->l->pull += t->pull;
    }
    if (t->r != nullptr) {
        t->r->x += t->pull;
        t->r->pull += t->pull;
    }
    t->pull = 0;
}

node *merge(node *t1, node *t2) {
    if (t1 == nullptr) return t2;
    if (t2 == nullptr) return t1;
    if (t1->y > t2->y) {
        push(t1);
        t1->r = merge(t1->r, t2);
        upd(t1);
        return t1;
    }
    else {
        push(t2);
        t2->l = merge(t1, t2->l);
        upd(t2);
        return t2;
    }
}

pair <node*,node*> split(node *t, int x) {
    if (t == nullptr) return {t, t};
    push(t);
    if (t->x < x) {
        auto p = split(t->r, x);
        t->r = p.f;
        upd(t);
        return {t, p.s};
    }
    else {
        auto p = split(t->l, x);
        t->l = p.s;
        upd(t);
        return {p.f, t};
    }
}

void add(node *&t, int x) {
    auto p = split(t, x);
    t = merge(p.f ,merge(new node(x), p.s));
}

void remove(node *&t, int x) {
    if (t == nullptr) return;
    push(t);
    if (t->x == x) {
        t = merge(t->l, t->r);
        return;
    }
    remove((t->x < x ? t->r : t->l), x);
    upd(t);
}

void solve_kek() {
    node *ta = nullptr;
    node *tb = nullptr;
    for (int i = 0; i < n; ++i) {
        add(tb, a[i] + i + 1);
    }
    for (int i = 0; i < n; ++i) {
        if (tb != nullptr) {
            tb->x--;
            tb->pull--;
        }

        if (ta != nullptr) {
            ta->x++;
            ta->pull++;
        }
        add(ta, a[i]);

        ans_kek[i] = 0;
        auto p = split(ta, a[i]);
        ans_kek[i] += tsz(p.f);
        ta = merge(p.f, p.s);

        p = split(tb, a[i]);
        ans_kek[i] += tsz(p.f);
        tb = merge(p.f, p.s);

        ans_kek[i]++;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
#ifdef DEBUG
    freopen("C.in", "r", stdin);
#endif // DEBUG

    read();
    /*solve_stupid();
    for (int i = 0; i < n; ++i)
        cout << ans_stupid[i] << ' ';
    cout << endl;
    cout << endl;*/

    solve_kek();
    for (int i = 0; i < n; ++i)
        cout << ans_kek[i] << ' ';

    return 0;
    REP(itr, 0, 20) {
        n = 19;
        type = 2;
        REP(i, 0, n) a[i] = rand();

        solve_new();
        REP(i, 0, n) {
            x[i] = INF;
            ord[i] = -1;
        }
        solve_stupid();

        bool ok = true;
        for (int i = 0; i < n; ++i)
            ok &= (ans_new[i] == ans_stupid[i]);
        if (!ok) {
            cout << n << endl;
            for (int i = 0; i < n; ++i)
                cout << a[i] << ' ';
            cout << endl;
            cout << "ANS_NEW\n";
            for (int i = 0; i < n; ++i)
                cout << ans_new[i] << ' ';
            cout << "ANS_s\n";
            for (int i = 0; i < n; ++i)
                cout << ans_stupid[i] << ' ';


            break;
        }
    }

    return 0;
}
