#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int run();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    run();
    return 0;
}

const int maxn = 3e5 + 10;
const int inf = 2e9;

unordered_map<int, bool> was;
vector<int> all;

struct seg_tree {
    vector<int> cnt;
    int n;

    seg_tree (int n) :
        n(n),
        cnt(4 * n, inf)
    {}

    void upd(int ind, int val, int l, int r, int v) {
        if (l == r) {
            cnt[v] = val;
            return;
        }
        int m = (l + r) >> 1;
        if (ind <= m)
            upd(ind, val, l, m, v * 2 + 1);
        else
            upd(ind, val, m + 1, r, v * 2 + 2);
        cnt[v] = min(cnt[v * 2 + 1], cnt[v * 2 + 2]);
    }

    int get(int l, int r, int tl, int tr, int v) {
        if (l > tr || r < tl)
            return inf;
        if (l <= tl && r >= tr)
            return cnt[v];
        else {
            int tm = (tl + tr) >> 1;
            return min(get(l, r, tl, tm, v * 2 + 1), get(l, r, tm + 1, tr, v * 2 + 2));
        }
    }
};

int n;
int a[maxn];
seg_tree t(maxn);

deque<int> pos[maxn];

void updNxt(int val) {
    assert(!pos[val].empty());
    pos[val].pop_front();
    if (pos[val].empty())
        t.upd(val, inf, 0, n - 1, 0);
    else
        t.upd(val, pos[val].front(), 0, n - 1, 0);
}

int run() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        if (!was[a[i]]) {
            was[a[i]] = 1;
            all.push_back(a[i]);
        }
    }
    sort(all.begin(), all.end());
    for (int i = 0; i < n; ++i) {
        a[i] = (int)(lower_bound(all.begin(), all.end(), a[i]) - all.begin());
        pos[a[i]].push_back(i);
    }
    was.clear();
    for (int i = 0; i < n; ++i) if (!was[a[i]]) {
        was[a[i]] = 1;
        t.upd(a[i], i, 0, n - 1, 0);
    }
    int l = 0;
    int ans = 0;
    while (l < n) {
        ans++;

        int mn = a[l];
        int mx = a[l];
        updNxt(a[l]);
        int r = l;
        while (1) {
            int indMn = t.get(0, mn - 1, 0, n - 1, 0);
            int indMx = t.get(mx, n - 1, 0, n - 1, 0);
            if (indMn == inf && indMx == inf)
                break;
            if (indMn < indMx)
                break;
            while (r < indMx) {
                r++;
                mx = max(a[r], mx);
                updNxt(a[r]);
            }
        }

        l = r + 1;
    }
    cout << ans;
}
/*
5
5 4 3 2 1

4
1 3 2 4

6
2 3 1 1 5 1
*/
