import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
    int[] min;
    int[] max;
    int[] a;
    int z = 1;
    int n;

    void build() {
        while (z < n) {
            z *= 2;
        }
        min = new int[2 * z];
        max = new int[2 * z];
        for (int i = 0; i < n; i++) {
            min[z + i] = max[z + i] = i;
        }
        for (int i = n; i < z; i++) {
            min[z + i] = max[z + i] = n;
        }
        for (int i = z - 1; i > 0; i--) {
            int l = a[min[2 * i]];
            int r = a[min[2 * i + 1]];
            if (l <= r) {
                min[i] = min[2 * i];
            } else {
                min[i] = min[2 * i + 1];
            }
            l = a[max[2 * i]];
            r = a[max[2 * i + 1]];
            if (l > r) {
                max[i] = max[2 * i];
            } else {
                max[i] = max[2 * i + 1];
            }
        }
    }

    int getmin(int i, int l1, int r1, int l, int r) {
        if (l1 > r || l > r1) return n;
        if (l1 <= l && r <= r1) return min[i];
        int l2 = getmin(2 * i, l1, r1, l, (l + r) / 2);
        int r2 = getmin(2 * i + 1, l1, r1, (l + r) / 2 + 1, r);
        if (l2 == n) return r2;
        if (r2 == n) return l2;
        if (a[l2] <= a[r2]) {
            return l2;
        }
        return r2;
    }

    int getmax(int i, int l1, int r1, int l, int r) {
        if (l1 > r || l > r1) return n;
        if (l1 <= l && r <= r1) return max[i];
        int l2 = getmax(2 * i, l1, r1, l, (l + r) / 2);
        int r2 = getmax(2 * i + 1, l1, r1, (l + r) / 2 + 1, r);
        if (l2 == n) return r2;
        if (r2 == n) return l2;
        if (a[l2] > a[r2]) {
            return l2;
        }
        return r2;
    }

    public void solve() throws IOException {
        n = nextInt();
        a = new int[n + 1];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
        }
        int res = 0;
        build();
        int x = getmax(1, z, z + n - 1, z, 2 * z - 1);
        int x2 = 0;
        while (x < n) {
            int x1 = x;
            while (x1 >= x2) {
                res++;
                x1 = getmin(1, z + x2, z + x1, z, 2 * z - 1) - 1;
            }
            x2 = x + 1;
            x = getmax(1, z + x2, z + n - 1, z, 2 * z - 1);
        }
        out.print(res);
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                sc = null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
