#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <stdio.h>
#include <bitset>
#include <map>

using namespace std;

typedef long long ll;
typedef long double dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

vector<ll> tree;
vector<ll> maxi;
vector<ll> add;

void push(int v, int vl, int vr){
    if (vr > vl){
        add[v * 2 + 1] += add[v];
        add[v * 2 + 2] += add[v];
    }
    tree[v] += add[v] * maxi[v];
    add[v] = 0;
}

void update(int v, int vl, int vr, int l, int r){
    push(v, vl, vr);
    if (vl > r || vr < l)
        return;
    if (vl >= l && vr <= r){
        add[v]++;
        push(v, vl, vr);
        return;
    }
    int vm = (vl + vr) / 2;
    update(v * 2 + 1, vl, vm, l, r);
    update(v * 2 + 2, vm + 1, vr, l, r);
    if (tree[v * 2 + 1] > tree[v * 2 + 2]){
        tree[v] = tree[v * 2 + 1];
        maxi[v] = maxi[v * 2 + 1];
    }
    else{
        tree[v] = tree[v * 2 + 2];
        maxi[v] = maxi[v * 2 + 2];
    }
}

ll get(int v, int vl, int vr, int l, int r){
    push(v, vl, vr);
    if (vl > r || vr < l)
        return 0;
    if (vl >= l && vr <= r)
        return tree[v];
    int vm = (vl + vr) / 2;
    return max(get(v * 2 + 1, vl, vm, l, r), get(v * 2 + 2, vm + 1, vr, l, r));
}


bool comp(pair<int, int> a, pair<int, int> b){
    if (a.second != b.second)
        return a.second < b.second;
    return a.first < b.first;
}


int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int> > s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i].first >> s[i].second;
    map<int, int> mapa;
    sort(s.begin(), s.end(), comp);
    int cur = 0;
    vector<int> ind(n, 0);
    for (int i = 0; i < n; i++){
        if (i == 0 || s[i].second != s[i - 1].second){
            ind[cur] = s[i].second;
            mapa[s[i].second] = cur++;
        }
    }
    int b = 1;
    while (b < cur)
        b *= 2;
    tree.resize(2 * b - 1);
    maxi.resize(2 * b - 1);
    add.resize(2 * b - 1);
    for (int i = 0; i < cur; i++)
        maxi[b - 1 + i] = ind[i];
    for (int i = b - 2; i >= 0; i--)
        maxi[i] = max(maxi[i * 2 + 1], maxi[i * 2 + 2]);
    sort(s.begin(), s.end());
    reverse(s.begin(), s.end());
    vector<ll> dp(n + 1, 0);
    for (int i = n - 1; i >= 0; i--){
        update(0, 0, b - 1, 0, mapa[s[i].second]);
        dp[i] = get(0, 0, b - 1, 0, cur - 1);
    }
    print(dp);
    ll answer = 0;
    for (int i = 0; i < n; i++)
        answer = max(answer, (i + 1) * s[i].first + dp[i + 1]);
    cout << answer << endl;
    return 0;
}
