#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <cmath>
#include <stdio.h>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

const int MAX = 500;
bitset<MAX> lose[MAX];
bitset<MAX> good;
bitset<MAX> kek;

int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int> > s(n, vector<int> (n));
    vector<vector<int> > lst(n, vector<int> (n));
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            cin >> s[i][j];
            s[i][j]--;
            lst[s[i][j]][i] = j;
        }
        for (int j = 0; j < lst[i][i]; j++)
            lose[i].set(s[i][j]);
    }
    int p;
    cin >> p;
    if (p == 1){
        vector<int> answer;
        for (int i = 0; i < n; i++)
            if (s[i][0] == i)
                answer.push_back(i + 1);
        cout << answer.size() << endl;
        print(answer);
        return 0;
    }
    vector<int> answer;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            if (lst[i][j] > lst[j][j])
                continue;
            good = kek;
            for (int k = 0; k < n; k++)
                if (lst[k][j] >= lst[i][j])
                    good.set(k);
            bool ok = true;
            for (int k = 0; k < n; k++){
                if (lst[i][j] > lst[k][j] && (good & lose[k]).count() == 0){
                    ok = false;
                    break;
                }
            }
            if (ok){
                answer.push_back(i + 1);
                break;
            }
        }
    }
    cout << answer.size() << endl;
    print(answer);
    return 0;
}
