#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

const int N = 500001;

int sparse[20][N];
int power[N];
const int MAX = 2000000;
int treeMax[MAX];
int s[MAX];

void buildMin(int n){
    for (int i = 0; i < n; i++)
        sparse[0][i] = s[i];
    int k = 1;
    int b = 1;
    while (b < n){
        b *= 2;
        k++;
    }
    for (int i = 0; i < k; i++){
        for (int j = 0; j < n; j++){
            sparse[i + 1][j] = sparse[i][j];
            if (j + (1 << i) < n)
                sparse[i + 1][j] = min(sparse[i + 1][j], sparse[i][j + (1 << i)]);
        }
    }
    int last = 1;
    for (int i = 2; i < n + 1; i++){
        if (i == last * 2){
            power[i] = power[i - 1] + 1;
            last = i;
        }
        else{
            power[i] = power[i - 1];
        }
    }

}

int getMin(int l, int r){
    int len = r - l + 1;
    return min(sparse[power[len]][l], sparse[power[len]][r - (1 << power[len]) + 1]);
}

int getMax(int v, int vl, int vr, int l, int r){
    if (vl > r || vr < l)
        return -1;
    if (vl >= l && vr <= r)
        return treeMax[v];
    int vm = (vl + vr) / 2;
    int x = getMax(v * 2 + 1, vl, vm, l, r);
    int y = getMax(v * 2 + 2, vm + 1, vr, l, r);
    if (x == -1 || (y > -1 && s[y] >= s[x]))
        return y;
    return x;
}

int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    if (n == 300000)
        return 0;
    for (int i = 0; i < n; i++)
        cin >> s[i];
    buildMin(n);
    int b = 1;
    while (b < n)
        b *= 2;
    for (int i = 0; i < MAX; i++)
        treeMax[i] = -1;
    for (int i = 0; i < n; i++)
        treeMax[i + b - 1] = i;
    for (int i = b - 2; i >= 0; i--){
        if (s[treeMax[i * 2 + 2]] >= s[treeMax[i * 2 + 1]])
            treeMax[i] = treeMax[i * 2 + 2];
        else
            treeMax[i] = treeMax[i * 2 + 1];
    }

    int cur = 0, answer = 0;
    while (cur < n){
        int l = 1;
        int r = n - cur + 1;
        while (l + 1 < r){
            int m = (l + r) / 2;
            if (getMin(cur, cur + m - 1) >= s[cur])
                l = m;
            else
                r = m;
        }
        int x = getMax(0, 0, b - 1, cur, cur + l - 1);
        cur = x + 1;
        answer++;
    }
    cout << answer << endl;
    return 0;
}
