#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

typedef long long ll;
typedef long double dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

struct Point{
    int x, y;
    int cnt;
    Point* left;
    Point* right;
};

Point* createPoint(int x){
    Point* p = new Point();
    p -> x = x;
    p -> y = rand();
    p -> cnt = 1;
    p -> left = nullptr;
    p -> right = nullptr;
    return p;
}

Point* update(Point* v){
    if (v == NULL)
        return v;
    v -> cnt = 1;
    if (v -> left != NULL)
        v -> cnt += v -> left -> cnt;
    if (v -> right != NULL)
        v -> cnt += v -> right -> cnt;
    return v;
}

Point* merge(Point* v, Point* u){
    if (v == NULL)
        return u;
    if (u == NULL)
        return v;
    if (v -> y < u -> y){
        v -> right = merge(v -> right, u);
        v = update(v);
        return v;
    }
    else{
        u -> left = merge(v, u -> left);
        u = update(u);
        return u;
    }
}

pair<Point*, Point*> split(Point* v, int x){
    if (v == NULL)
        return make_pair(v, v);
    pair<Point*, Point*> s;
    if (v -> x >= x){
        s = split(v -> left, x);
        v -> left = s.second;
        v = update(v);
        return make_pair(s.first, v);
    }
    else{
        s = split(v -> right, x);
        v -> right = s.first;
        v = update(v);
        return make_pair(v, s.second);
    }
}


int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    srand(time(NULL));
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, p;
    cin >> n >> p;
    vector<int> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    Point* root = nullptr;
    vector<int> cnt1(n, 0);
    for (int i = 0; i < n; i++){
        pair<Point*, Point*> ss = split(root, s[i] + (n - i));
        if (ss.first != NULL)
            cnt1[i] += ss.first -> cnt;
        ss.second = merge(createPoint(s[i] + (n - i)), ss.second);
        root = merge(ss.first, ss.second);
    }
    root = nullptr;
    vector<int> cnt2(n, 0);
    reverse(s.begin(), s.end());
    for (int i = 0; i < n; i++){
        pair<Point*, Point*> ss = split(root, s[i] + (n - i));
        if (ss.first != NULL)
            cnt1[n - 1 - i] += ss.first -> cnt;
        ss.second = merge(createPoint(s[i] + (n - i)), ss.second);
        root = merge(ss.first, ss.second);
    }
    for (int i = 0; i < n; i++)
        cout << cnt1[i] + cnt2[i] + 1 << " ";
    return 0;
}
