#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <stdio.h>
#include <map>


using namespace std;

typedef long long ll;
typedef long double dbl;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}

struct Point{
    int x, y;
    int cnt;
    Point* left;
    Point* right;
};

Point* createPoint(int x){
    Point* p = new Point();
    p -> x = x;
    p -> y = rand();
    p -> cnt = 1;
    p -> left = nullptr;
    p -> right = nullptr;
    return p;
}

Point* update(Point* v){
    if (v == NULL)
        return v;
    v -> cnt = 1;
    if (v -> left != NULL)
        v -> cnt += v -> left -> cnt;
    if (v -> right != NULL)
        v -> cnt += v -> right -> cnt;
    return v;
}

Point* merge(Point* v, Point* u){
    if (v == NULL)
        return u;
    if (u == NULL)
        return v;
    if (v -> y < u -> y){
        v -> right = merge(v -> right, u);
        v = update(v);
        return v;
    }
    else{
        u -> left = merge(v, u -> left);
        u = update(u);
        return u;
    }
}

pair<Point*, Point*> split(Point* v, int x){
    if (v == NULL)
        return make_pair(v, v);
    pair<Point*, Point*> s;
    if (v -> x >= x){
        s = split(v -> left, x);
        v -> left = s.second;
        v = update(v);
        return make_pair(s.first, v);
    }
    else{
        s = split(v -> right, x);
        v -> right = s.first;
        v = update(v);
        return make_pair(v, s.second);
    }
}


int main()
{
    #ifdef ONPC
        freopen("test.in", "r", stdin);
    #endif // ONPC
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, p;
    cin >> n >> p;
    vector<int> s(n), lst1(n), lst2(n), lst3(n);
    for (int i = 0; i < n; i++){
        cin >> s[i];
        lst1[i] = s[i] + i;
        lst2[i] = s[i] + n - 1 - i;
        lst3[i] = s[i] + min(n - 1 - i, i);
    }
    sort(lst1.begin(), lst1.end());
    sort(lst2.begin(), lst2.end());
    sort(lst3.begin(), lst3.end());
    print(lst2);
    for (int i = 0; i < n; i++){
        int answer = 0;
        int x = i;
        int l = 0;
        int r = n;
        while (l + 1 < r){
            int m = (l + r) / 2;
            if (lst1[m] < s[i] + x)
                l = m;
            else
                r = m;
        }
        answer = max(answer, l + 1);

        x = n - 1 - i;
        l = 0;
        r = n;
        while (l + 1 < r){
            int m = (l + r) / 2;
            if (lst2[m] < s[i] + x)
                l = m;
            else
                r = m;
        }
        answer = max(answer, l + 1);

        x = min(i, n - 1 - i);
        l = 0;
        r = n;
        while (l + 1 < r){
            int m = (l + r) / 2;
            if (lst3[m] < s[i] + x)
                l = m;
            else
                r = m;
        }
        answer = max(answer, l + 1);
        cout << answer + 1 << " ";
    }
    return 0;
}
