#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <bitset>
#include <map>
#include <cmath>
#include <cassert>
#include <algorithm>
#include <cstdint>

#define pii pair<int, int>	
#define mp make_pair

typedef long long LL;

using namespace std;

const int N = (int)5e2 + 7;
const LL LINF = int64_t(1e18);

int n, m, k, p[30];
map <pii, int> num;
vector <pii> pr, gr[N];

void read() {
	cin >> n >> m >> k;
	pr.resize(k);
	assert(n <= 20 && m <= 20 && k <= 20);
	for (int i = 0; i < k; i++) {
		cin >> pr[i].first >> pr[i].second;
		num[pr[i]] = i;
	}
}

void precol() {
	p[0] = 1;
	for (int i = 1; i < 30; i++)
		p[i] = p[i - 1] * 2;
}

void make_graph() {
	for (int i = 0; i < k; i++)
		for (int j = i + 1; j < k; j++) {
			int cur = max(abs(pr[i].first - pr[j].first),
				abs(pr[i].second - pr[j].second));
			gr[i].push_back(mp(j, p[cur]));
			gr[j].push_back(mp(i, p[cur]));
		}
}

void Dijkstra() {
	vector <LL> dist(k, LINF);
	dist[0] = 0;
	set <pair<LL, int>> q;
	q.insert(mp(0, 0));
	vector <int> par(k);
	par[0] = -1;
	while (!q.empty()) {
		int v = (*q.begin()).second;
		q.erase(q.begin());
		for (auto it : gr[v]) {
			int to = it.first, len = it.second;
			if (dist[to] > dist[v] + len) {
				q.erase(mp(dist[to], to));
				dist[to] = dist[v] + len;
				q.insert(mp(dist[to], to));
				par[to] = v;
			}
		}
	}
	vector <int> ans;
	int v = k - 1;
	while (v != -1) {
		ans.push_back(v);
		v = par[v];
	}
	reverse(ans.begin(), ans.end());
	cout << (int)ans.size() << endl;
	for (int x : ans)
		cout << x + 1 << ' ';
}

void solve() {
	precol();
	make_graph();
	Dijkstra();
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	read();
	solve();
}