#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cstring>
#include <algorithm>
#include <cstdlib>
#include <bitset>

using namespace std;
void solve();

typedef long long ll;
typedef pair<int, int> pii;

#define X first
#define Y second
#define mp make_pair

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}

struct T {
	static const int siz = 520;
	bitset<520> t;
	T() { ; }
	T(int i) { if(i != -1) t.set(i); }
};

bool operator<=(T a, T b) {
	for (int i = a.siz - 1; i >= 0; --i)
		if (a.t[i] ^ b.t[i])return a.t[i] < b.t[i];
	return true;
}

bool operator<(T a, T b) {
	for (int i = a.siz - 1; i >= 0; --i)
		if (a.t[i] ^ b.t[i])return a.t[i] < b.t[i];
	return false;
}

T operator+ (T a, T b) {
	int dlt = 0;
	for (int i = 0; i < a.siz; ++i) {
		dlt += a.t[i];
		dlt += b.t[i];
		a.t[i] = dlt & 1;
		dlt >>= 1;
	}
	return a;
}

const int maxn = 500;

int n, m, k;
pii p[maxn];
//typedef int T;

T rs[maxn];
int pred[maxn];
bool used[maxn];

vector<int> ans;

void solve() {
	cin >> n >> m >> k;
	for (int i = 0; i < k; ++i)
		cin >> p[i].X >> p[i].Y;
	for (int i = 0; i < k; ++i)
		pred[i] = -1;
	for (int i = 0; i < k; ++i)
		rs[i] = T( max(abs(p[0].X - p[i].X), abs(p[0].Y - p[i].Y)));
	rs[0] = T(-1);
	while (true) {
		int u = -1;
		for (int i = 0; i < k; ++i)
			if (!used[i] && (u == -1 || rs[i] < rs[u]))
				u = i;
		if (u == -1)break;
		used[u] = true;
		for (int i = 0; i < k; ++i)
			if (rs[u] + T(max(abs(p[u].X - p[i].X), abs(p[u].Y - p[i].Y))) <= rs[i]) {
				rs[i] = rs[u] + T(max(abs(p[u].X - p[i].X), abs(p[u].Y - p[i].Y)));
				pred[i] = u;
			}
	}
	int u = k - 1;
	while (u != -1) {
		ans.push_back(u);
		u = pred[u];
	}
	reverse(ans.begin(), ans.end());

	cout << ans.size() << endl;
	for (auto i : ans)cout << i + 1 << ' ';

}