
#define _CRT_SECURE_NO_DEPRECATE

#include <iostream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	solve();
	return 0;
}


struct node {
	node *l, *r;
	int x, y;
	int s;
	node() {
		l = r = 0;
		y = rand();
		s = 1;
		x = 0;
	}
	node(int v) {
		l = r = 0;
		y = rand();
		s = 1;
		x = v;
	}
};
int getss(node* v) { if (!v)return 0; return v->s; }
void rf(node* v) { if (!v)return; v->s = getss(v->l) + 1 + getss(v->r); }

void split(node* v, node*& l, node*& r, int k) {
	if (!v) {
		l = r = 0;
		return;
	}
	if (v->x < k) {
		split(v->r, v->r, r, k);
		l = v;
	}
	else {
		split(v->l, l, v->l, k);
		r = v;
	}
	rf(l);
	rf(r);
}

node* merge(node* l, node* r) {
	if (!l)return r;
	if (!r)return l;
	if (l->y > r->y) {
		l->r = merge(l->r, r);
		rf(l);
		return l;
	}
	else {
		r->l = merge(l, r->l);
		rf(r);
		return r;
	}
}

node* delete_last(node* v) {
	if (!v)return 0;
	if (getss(v->l) == 0) {
		return v->r;
	}
	else v->l = delete_last(v->l);
}

const int N = 400000;

int n, p;
int a[N];

int tms(int p, int l, int r) {
	if (p <= l || r <= p)return 0;
	if (l == -1) return r - p;
	else if (r == n) return p - l;
	else return min(p - l, r - p);
}

void solve() {
	cin >> n >> p;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	if (p == 1) {
		node * L = 0;
		node * R = 0;
		for (int i = 1; i < n; ++i) {
			node* r = 0;
			split(R, R, r, a[i] + i);
			r = merge(new node(a[i] + i), r);
			R = merge(R, r);
			//R = merge(R, new node(a[i] + i));
		}
		for (int i = 0; i < n; ++i) {
			node* l = 0;
			node* r = 0;
			int ans = 0;
			split(L, l, L, a[i] - i);
			ans += getss(l);
			split(R, r, R, a[i] + i);
			ans += getss(r);

			cout << ans + 1 << endl;
			
			L = merge(l, L);
			R = merge(r, R);
			l = r = 0;
			split(L, L, l, a[i] - i);
			l = merge(new node(a[i] - i), l);
			L = merge(L, l);
			l = r = 0;
			split(R, R, r, a[i] + i);
			delete_last(r);
			R = merge(R, r);
		}
	}
	else {
		for (int i = 0; i < n; ++i) {
			int ans = 0;
			for (int k = -1; k < n; ++k) {
				int r = n;
				int l = k;
				if (k == i)continue;
				if (k > i) {
					r = k;
					l = i - (r - i);
					l = max(-1, l);
				}
				else
					r = min(n, i - l + i);
				if (l == -1 && r == n)continue;
				int val = a[i] + tms(i, l, r);
				int cur = 0;
				for (int u = 0; u < n; ++u)
					cur += a[u] + tms(u, l, r) < val;
				ans = max(ans, cur);
			}
			cout << ans + 1 << endl;
		}
	}
}