#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = (int)(1e12);

vector<int> solve_smart(vector<vector<int>> a, vector< pair<pair<int, int>, int>> queues) {
    vector<int> res;

    int n = a.size(), m = a[0].size();

    map<int, int> val_to_x, val_to_y;

    for (int i = 0; i < n; ++i) {
        for (int j = 0;  j < m; ++j) {
            val_to_x[a[i][j]] = i, val_to_y[a[i][j]] = j;
        }
    }

    vector<int> max_n(n, 0), max_m(m, 0);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            max_n[i] = max(max_n[i], a[i][j]);
            max_m[j] = max(max_m[j], a[i][j]);
        }
    }

    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == max_n[i] && a[i][j] == max_m[j]) ++cnt;
        }
    }

    vector<int> ans (queues.size());
    for (int q = 0; q < queues.size(); ++q) {
        int x = queues[q].first.first, y = queues[q].first.second, val = queues[q].second;
        //best in both is [x, y]
        if (a[x][y] == max_n[x] && a[x][y] == max_m[y]) {
            a[x][y] = val;
            max_n[x] = a[x][y], max_m[y] = a[x][y];
            val_to_x[val] = x, val_to_y[val] = y;
            res.push_back(cnt);
            continue;
        }

        // rows
        int best_x = x, best_y = val_to_y[max_n[x]];
        if (a[best_x][best_y] == max_n[best_x] && a[best_x][best_y] == max_m[best_y]) {
            --cnt;
        }

        // columns
        best_x = val_to_x[max_m[y]], best_y = y;
        if (a[best_x][best_y] == max_n[best_x] && a[best_x][best_y] == max_m[best_y]) {
            --cnt;
        }

        a[x][y] = val;
        max_n[x] = max(max_n[x], val);
        max_m[y] = max(max_m[y], val);
        val_to_x[val] = x, val_to_y[val] = y;

        if (a[x][y] == max_n[x] && a[x][y] == max_m[y]) {
            ++cnt;
        }
        res.push_back(cnt);
    }

    return res;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n, m, q;
    cin >> n >> m >> q;
    vector< vector<int> > a(n, vector<int>(m));
    vector< pair<pair<int, int>, int>> queues(q);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    for (int i = 0;  i< q; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        --x, --y;
        queues[i] = {{x, y}, z};
    }
    vector<int> res = solve_smart(a, queues);
    for (int x : res) {
        cout << x << "\n";
    }
}