#include <bits/stdc++.h>
#define ll long long

using namespace std;

const int INF = 1e9 + 7;
const int MAXN = 1e6 + 7;
const double EPS = 1e-7;

int lt[MAXN], rt[MAXN], sum[MAXN];

int last = 0;

int get_sum(int v, int L, int R, int l = 0, int r = INF) {
    if (v == -1 || l >= R || L >= r) {
        return 0;
    }
    if (L <= l && r <= R) {
        return sum[v];
    }
    int m = (l + r) / 2;
    return get_sum(lt[v], L, R, l, m) + get_sum(rt[v], L, R, m, r);
}

void add(int v, int p, int x, int l = 0, int r = INF) {
    if (l > p || r <= p) {
        return;
    }
    sum[v] += x;
    if (r - l == 1) {
        return;
    }
    if (lt[v] == -1) {
        lt[v] = last++;
    }
    if (rt[v] == -1) {
        rt[v] = last++;
    }
    int m = (l + r) / 2;
    add(lt[v], p, x, l, m);
    add(rt[v], p, x, m, r);
}


int main() {
    #ifdef MY
        freopen("input.txt", "r", stdin);
    #else
        ios_base::sync_with_stdio(false);
        cin.tie(0);
        cout.tie(0);
    #endif // MY
    int n, p;
    cin >> n >> p;
    vector <int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    fill_n(lt, MAXN, -1);
    fill_n(rt, MAXN, -1);
    fill_n(sum, MAXN, 0);
    last = 2;
    for (int i = 0; i < n; i++) {
        add(0, a[i] + i, 1);
    }
    for (int i = 0; i < n; i++) {
        int res = get_sum(0, -INF, a[i] + i) + get_sum(1, -INF, a[i] - i + MAXN) + 1;
        add(0, a[i] + i, -1);
        add(1, a[i] - i + MAXN, 1);
        cout << res << "\n";
    }
}
