#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdlib>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int N = 100;
int a[N][N];
int w[N][N];
int n;

bool stable(int v) {
	for (int i = 0; i < n; i++) {
		if (w[v][v] > w[v][i])
			return false;
	}
	return true;
}

bool viable(int v, vector<int> &cur_pos) {
	bool found = false;
	for (int i = 0; i < n; i++) {
		if (a[i][cur_pos[i]] == v)
			found = true;
		if (a[i][cur_pos[i]] == v && cur_pos[i] == 0)
			return true;
	}
	if (!found)
		return false;
	bool are_moves = false;
	for (int i = 0; i < n; i++) {
		if (cur_pos[i]) {
			for (int k = 1; k <= cur_pos[i]; k++) {
				int cur = a[i][cur_pos[i] - k];
				bool can = false;
				for (int j = 0; j < n; j++) {
					if (i != j && a[j][cur_pos[j]] == cur) {
						can = true;
						break;
					}
				}
				if (can) {
					cur_pos[i] -= k;
					if (viable(v, cur_pos)) {
						cur_pos[i] += k;
						return true;
					}
					cur_pos[i] += k;
					are_moves = true;
				}
			}
		}
	}
	if (!are_moves)
		return true;
	return false;
}

void run() {

	cin >> n;
	vector<int> cur_pos(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> a[i][j];
			a[i][j]--;
			w[i][a[i][j]] = j;
		}
		cur_pos[i] = w[i][i];
	}

	int p;
	cin >> p;
	int stable_num = 0;
	vector<int> st_ans;
	for (int i = 0; i < n; i++) {
		if (stable(i)) {
			stable_num++;
			st_ans.push_back(i + 1);
		}
	}

	int viable_num = 0;
	vector<int> vi_ans;
	for (int i = 0; i < n; i++) {
		if (stable(i) || viable(i, cur_pos)) {
			viable_num++;
			vi_ans.push_back(i + 1);
		}
	}
	if (p == 1) {
		cout << stable_num << endl;
		for (auto it : st_ans)
			cout << it << ' ';
	}
	else {
		cout << viable_num << endl;
		for (auto it : vi_ans)
			cout << it << ' ';
	}
}