#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <cstdlib>
#include <cassert>
#include <iterator>
#include <functional>
#include <numeric>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()
#define sz(v) (int)v.size()

void run();

signed main() {
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

struct line {
	int k = 0;
	ll b = 0;
	ll get(int x) {
		return 1LL * k * x + b;
	}
};

const int N = 2e5 + 123;

line tree[8 * N];

void add(line l, int v = 1, int tl = 0, int tr = N) {
	int m = (tl + tr) / 2;
	if (l.k == tree[v].k)
		return;
	if (l.get(m) >= tree[v].get(m)) {
		swap(tree[v], l);
	}

	if (l.get(tl) >= tree[v].get(tl)) {
		add(l, v * 2, tl, m);
	}
	else {
		add(l, v * 2 + 1, m, tr);
	}
}

ll get(int x, int v = 1, int tl = 0, int tr = N) {
	int mid = (tl + tr) / 2;
	if (tl == tr - 1)
		return tree[v].get(x);
	if (x < mid) {
		return max(tree[v].get(x), get(x, v * 2, tl, mid));
	}
	else
		return max(tree[v].get(x), get(x, v * 2 + 1, mid, tr));
}

int solve_neq(int n, vector<pair<int, int>> mas) {
	sort(all(mas));
	ll ans = 0;
	vector<int> cur_b;
	for (int i = 0; i < n; i++) {
		int rcnt = n - i;
		ll cur_ans = 1LL * mas[i].first * rcnt;
		ll add_ans = get(i);
		line kek;
		kek.k = mas[i].first;
		kek.b = -1LL * mas[i].first * i;
		add(kek);

		ans = max(ans, add_ans + cur_ans);
	}
	return ans;
}

void run() {
	int n;
	cin >> n;
	bool b_i = false;
	bool neq = false;
	vector<pair<int, int>> mas(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i].first >> mas[i].second;
		if (mas[i].second)
			b_i = true;
		if (mas[i].first != mas[i].second)
			neq = true;
	}

	if (!neq) {
		cout << solve_neq(n, mas);
		return;
	}

	sort(all(mas));
	ll ans = 0;
	vector<int> cur_b;
	for (int i = 0; i < n; i++) {
		int rcnt = n - i;
		ll cur_ans = 1LL * mas[i].first * rcnt;
		ll add_ans = 0;
		if (b_i) {
			for (int j = 0; j < i; j++) {
				if (mas[j].second > mas[i].first)
					continue;
				auto it = upper_bound(all(cur_b), mas[j].second, greater<int>());
				int lcnt = (int)(it - cur_b.begin());
				add_ans = max(add_ans, 1LL * mas[j].second * lcnt);
			}
			cur_b.push_back(mas[i].second);
			int k = sz(cur_b) - 1;
			while (k > 0 && cur_b[k - 1] < cur_b[k]) {
				swap(cur_b[k - 1], cur_b[k]);
				k--;
			}
		}
		ans = max(ans, add_ans + cur_ans);
	}

	cout << ans;
}