#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <unordered_map>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define int long long
#define sz(v) (int)v.size()
#define all(v) v.begin(),v.end()
#define rall(v) v.rbegin(),v.rend()

void run();

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	iostream::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
#ifdef _DEBUG
	cerr << "\nOK\n";
	while (1);
#endif
}

const int MAXN = 3e5 + 123;
const int INF = 1e9 + 123;

int dp[MAXN][2];

unordered_map<int, int> fenw;

void update(int x, int d) {
	x++;
	for (; x <= INF; x += (x & (-x))) {
		if (!fenw.count(x))
			fenw[x] = d;
		else
			fenw[x] = min(fenw[x], d);
	}
}

int get(int x) {
	x++;
	int ans = INF;
	for (; x > 0; x -= (x & (-x))) {
		if (fenw.count(x))
			ans = min(ans, fenw[x]);
	}
	return ans;
}

void run() {
	int n;
	cin >> n;
	int ans = 0;
	vector<int> mas(n);
	vector<int> suff_max(n);
	for (int i = 0; i < n; i++) {
		cin >> mas[i];
	}
	suff_max[n - 1] = mas[n - 1];
	for (int i = n - 2; i >= 0; i--)
		suff_max[i] = max(mas[i], suff_max[i + 1]);
	suff_max.push_back(0);
	int cmin = mas[0];
	int cmax = mas[0];
	for (int i = 1; i < n; i++) {
		if (mas[i] < cmin) {
			cmin = mas[i];
			cmax = mas[i];
			ans++;
			continue;
		}
		if (mas[i] < cmax)
			continue;
		cmax = max(mas[i], cmax);
		if (suff_max[i + 1] < cmax) {
			ans++;
			cmin = INF;
			cmax = 0;
			continue;
		}
	}
	if (cmin != INF)
		ans++;

	cout << ans;
}