#include <iostream>
#include <vector>
#include <map>
#include <algorithm>

#define fi first
#define se second
#define re return
#define pb push_back

#define F(i, a, b) for (int (i) = (a); (i) < (b); (i)++)
#define f(i, n) F(i, 0, n)

#define all(v) (v).begin(), (v).end()

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

int run();

int main() {
#ifdef home
    freopen("i", "r", stdin);
    freopen("d", "w", stderr);
#endif
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    run();
}

ll a[150500];
ll b[150500];

struct node {
    ll val;
    node *l, *r;

    int cnt = 0;

    int pos = 0;

    node(int pos = 0, int cnt = 0) {
        l = r = 0;
        val = 0;
        this->pos = pos;
        this->cnt = cnt;
    }
} *root = new node();

ll get() {
    re root->val;
}

int sz = 1e9 + 7;

map<int, vector<int>> p;

void push(node *cur) {
    if (cur->l && cur->cnt > 0) {
        cur->l->cnt += cur->cnt;
        cur->l->val += cur->cnt * cur->l->pos;
        cur->cnt = 0;
    }
}

void add(node *cur, int rb, int l = 0, int r = sz) {
//    cerr << "Add " << l << ' ' << r << ' ' << rb << ' ' << cur->val << ' ' << cur->pos << ' ' << cur->cnt << '\n';
    if (l == r - 1) {
//        cur->cnt++;
        cur->val += l;
        return;
    }
    int mid = (l + r) / 2;
    if (rb < mid) {
        if (!cur->l) {
            cur->l = new node(mid - 1);
        }
        push(cur);
        add(cur->l, rb, l, mid);
    } else {
        if (!cur->r) {
            cur->r = new node(r - 1);
        }
        if (cur->l && cur->l->val + cur->cnt * (mid - 1) > cur->r->val) {
            push(cur);
            add(cur->l, rb, l, mid);
        } else {
            cur->cnt++;
        }
        add(cur->r, rb, mid, r);
    }
    if (cur->l) {
        if (cur->l->val > cur->val) {
            cur->val = cur->l->val;
            cur->pos = cur->l->pos;
        }
    }
    if (cur->r) {
        if (cur->r->val > cur->val) {
            cur->val = cur->r->val;
            cur->pos = cur->r->pos;
        }
    }
}


int run() {
    ll n;
    cin >> n;
    f(i, n) {
        cin >> a[i] >> b[i];
        p[a[i]].pb(i);
    }

    ll cnt = n;

    ll ans = 0;

    for (const auto &x : p) {
        ans = max(ans, get() + cnt * x.fi);
        for (const auto &y : x.second) {
            add(root, b[y]);
        }
        cnt -= x.second.size();
//        cerr << x.fi << ' ' << get() << ' ' << root->pos << ' ' << root->cnt << ' ' << root->l->val << "\n";
    }

    cout << ans;

    return 0;
}