#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Tree{
    ll L, R, max;
    Tree *left, *right;
};

Tree *newTree(int L, int R) {
    return new Tree{L, R, 0, nullptr, nullptr};
}

Tree *buildTree(int L, int R, vector<ll> &data) {
    Tree *tree = newTree(L, R);
    if (R - L > 1) {
        int M = (L + R) / 2;
        tree->left = buildTree(L, M, data);
        tree->right = buildTree(M, R, data);
        tree->max = max(tree->left->max, tree->right->max);
    } else {
        tree->max = data[L];
    }
    return tree;
}

ll getMax(Tree *tree, ll l, ll r) {
    if (tree->L >= r || tree->R <= l) {
        return 0;
    }
    if (tree->L >= l && tree->R <= r) {
        return tree->max;
    }
    return max(getMax(tree->left, l, r), getMax(tree->right, l, r));
}

struct Event {
    ll pos, t;

    bool operator<(const Event &e) const {
        return pos < e.pos || pos == e.pos && t < e.t;
    }
};

const ll INF = 1e9;

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    vector<Event> ea, eb;
    bool t4 = 1, t5 = 1;
    vector<pair<ll, ll>> data(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        data[i].first = a[i];
        data[i].second = b[i];
        if (b[i] != 0) {
            t4 = 0;
        }
        if (a[i] != b[i]) {
            t5 = 0;
        }
        ea.push_back({a[i], 0});
        eb.push_back({b[i], 0});
    }
//    if (n <= 100) {
//        ll ans = 0;
//        for (ll i = 0; i <= 100; ++i) {
//            for (ll j = i + 1; j <= 100; ++j) {
//                ll now = 0;
//                for (ll x = 0; x < n; ++x) {
//                    if (j <= a[x]) {
//                        now += j;
//                    } else if (i <= b[x]) {
//                        now += i;
//                    }
//                }
//                ans = max(ans, now);
//            }
//        }
//        cout << ans << "\n";
//        return 0;
//    }
    sort(a.begin(), a.end());
    if (t4) {
        ll cnt = n;
        ll ans = 0;
        for (ll i = 0; i < n; ++i) {
            ans = max(ans, a[i] * cnt);
            --cnt;
        }
        cout << ans << "\n";
        return 0;
    }
    if (t5 && n > 3000) {
        vector<ll> val(n);
        for (ll i = 0; i < n; ++i) {
            val[i] = a[i] * (n - i);
        }
        Tree *tree = buildTree(0, n, val);
        ll cnt = n;
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            ans = max(ans, a[i] * cnt + getMax(tree, 0, i));
            cnt--;
        }
        cout << ans << "\n";
        return 0;
    }
    sort(data.begin(), data.end());
    ll cnt = n;
    ll ans = 0;
    set<ll> q;
    for (int i = 0; i < n; ++i) {
        ll x = n - cnt;
        ll now = 0;
        ll c = x;
        q.insert(data[i].second);
        for (auto x: q) {
            if (x > a[i]) {
                break;
            }
            now = max(now, x * min(x, c));
            c--;
        }
        ans = max(ans, now + cnt * a[i]);
        cnt--;
    }
    cout << ans << "\n";
//    sort(ea.begin(), ea.end());
//    sort(eb.begin(), eb.end());
//    ll cnt = n;
//    vector<pair<ll, ll>> segsa;
//    ll prev = -1;
//    for (ll i = 0; i < ea.size();) {
//        if (prev != ea[i].pos) {
//            segsa.push_back({prev + 1, cnt});
//        }
//        ll j = i;
//        prev = ea[i].pos;
//        while (ea[i].pos == ea[j].pos) {
//            ++j;
//            --cnt;
//        }
//        i = j;
//    }
//    segsa.push_back({ea.back().pos + 1, 0});
//    vector<pair<ll, ll>> segsb;
//    prev = 0;
//    cnt = 0;
//    for (ll i = 0; i < eb.size();) {
//        ll j = i;
//        if (prev != eb[i].pos) {
//            segsb.push_back({prev, cnt});
//        }
//        while (eb[i].pos == eb[j].pos) {
//            if (eb[j].t) {
//                --cnt;
//            } else {
//                ++cnt;
//            }
//            ++j;
//        }
//        prev = eb[i].pos;
//        i = j;
//    }
//    segsb.push_back({eb.back().pos, 0});

}