#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

struct Tree {
    int L, R;
    pair<int, int> max;
    Tree *left, *right;
};

Tree *newTree(int L, int R) {
    return new Tree{L, R, {0, 0}, nullptr, nullptr};
}

Tree *buildTree(int L, int R, vector<int> &data) {
    Tree *tree = newTree(L, R);
    if (R - L > 1) {
        int M = (L + R) / 2;
        tree->left = buildTree(L, M, data);
        tree->right = buildTree(M, R, data);
        tree->max = max(tree->left->max, tree->right->max);
    } else {
        tree->max = {data[L], L};
    }
    return tree;
}

pair<int, int> getMax(Tree *tree, int l, int r) {
    if (tree->L >= r || tree->R <= l) {
        return {0, 0};
    }
    if (tree->L >= l && tree->R <= r) {
        return tree->max;
    }
    return max(getMax(tree->left, l, r), getMax(tree->right, l, r));
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<int> data(n);
    set<pair<int, int>> q, q2;
    for (int i = 0; i < n; ++i) {
        cin >> data[i];
    }
    vector<int> nxt(n, -1), less(n, n);
    for (int i = n - 1; i >= 0; --i) {
        auto it = q.upper_bound({data[i], i});
        if (it != q.end()) {
            if (it->first == data[i]) {
                nxt[i] = nxt[it->second];
            } else {
                nxt[i] = it->second;
            }
        }
        auto it2 = q2.upper_bound({-data[i], i});
        if (it2 != q2.end()) {
            if (it2->first == -data[i]) {
                less[i] = less[it2->second];
            } else {
                less[i] = it2->second;
            }
        }
        q.insert({data[i], i});
        q2.insert({-data[i], i});
    }
    int cnt = 0;
    Tree *tree = buildTree(0, n, data);
    for (int i = 0; i < n; ++i) {
        int pos = less[i];
        auto maxi = getMax(tree, i, pos);
        i = maxi.second;
        ++cnt;
    }
    cout << cnt << "\n";
}