#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

struct Tree {
    int L, R, min;
    pair<int, int> max;
    Tree *left, *right;
};

Tree *newTree(int L, int R) {
    return new Tree{L, R, INF, {0, 0}, nullptr, nullptr};
}

Tree *buildTree(int L, int R, vector<int> &data) {
    Tree *tree = newTree(L, R);
    if (R - L > 1) {
        int M = (L + R) / 2;
        tree->left = buildTree(L, M, data);
        tree->right = buildTree(M, R, data);
        tree->max = max(tree->left->max, tree->right->max);
        tree->min = min(tree->left->min, tree->right->min);
    } else {
        tree->max = {data[L], L};
        tree->min = data[L];
    }
    return tree;
}

pair<int, int> getMax(Tree *tree, int l, int r) {
    if (tree->L >= r || tree->R <= l) {
        return {0, 0};
    }
    if (tree->L >= l && tree->R <= r) {
        return tree->max;
    }
    return max(getMax(tree->left, l, r), getMax(tree->right, l, r));
}

int getMin(Tree *tree, int l, int r) {
    if (tree->L >= r || tree->R <= l) {
        return INF;
    }
    if (tree->L >= l && tree->R <= r) {
        return tree->min;
    }
    return min(getMin(tree->left, l, r), getMin(tree->right, l, r));
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<int> data(n);
    set<pair<int, int>> q, q2;
    for (int i = 0; i < n; ++i) {
        cin >> data[i];
    }
    vector<int> less(n, n);
    data.push_back(-INF);
    Tree *tree = buildTree(0, n + 1, data);
    for (int i = 0; i < n; ++i) {
        int l = i + 1, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int mini = getMin(tree, i + 1, m);
            if (mini >= data[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        less[i] = l;
    }
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        int pos = less[i];
        auto maxi = getMax(tree, i, pos);
        i = maxi.second;
        ++cnt;
    }
    cout << cnt << "\n";
}