#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

struct Tree {
    int L, R;
    pair<int, int> max;
    Tree *left, *right;
};

Tree *newTree(int L, int R) {
    return new Tree{L, R, {0, 0}, nullptr, nullptr};
}

Tree *buildTree(int L, int R, vector<int> &data) {
    Tree *tree = newTree(L, R);
    if (R - L > 1) {
        int M = (L + R) / 2;
        tree->left = buildTree(L, M, data);
        tree->right = buildTree(M, R, data);
        tree->max = max(tree->left->max, tree->right->max);
    } else {
        tree->max = {data[L], L};
    }
    return tree;
}

pair<int, int> getMax(Tree *tree, int l, int r) {
    if (tree->L >= r || tree->R <= l) {
        return {0, 0};
    }
    if (tree->L >= l && tree->R <= r) {
        return tree->max;
    }
    return max(getMax(tree->left, l, r), getMax(tree->right, l, r));
}

int LOGN = 30;

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<int> data(n);
    set<pair<int, int>> q, q2;
    for (int i = 0; i < n; ++i) {
        cin >> data[i];
    }
    vector<int> less(n, n);
    vector<vector<int>> sparse(LOGN, vector<int> (n, INF));
    for (int i = 0; i < n; ++i) {
        sparse[0][i] = data[i];
    }
    for (int i = 1; i < LOGN; ++i) {
        for (int j = 0; j + (1 << i - 1) < n; ++j) {
            sparse[i][i] = min(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
        }
    }
    for (int i = 0; i < n; ++i) {
        int l = i + 1, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int sz = (int) log2(m - i);
            int mini = min(sparse[sz][i], sparse[sz][m - (1 << sz)]);
            if (mini >= data[i]) {
                l = m;
            } else {
                r = m;
            }
        }
        less[i] = l;
    }
//
//        for (int i = n - 1; i >= 0;) {
//        int pos = i;
//        --i;
//        while (data[pos] <= data[i] && data[i + 1] <= data[i]) {
//            if (data[pos] == data[i]) {
//                less[i] = less[pos];
//                break;
//            } else {
//                less[i] = pos;
//                --i;
//            }
//        }
//    }
    int cnt = 0;
    Tree *tree = buildTree(0, n, data);
    for (int i = 0; i < n; ++i) {
        int pos = less[i];
        auto maxi = getMax(tree, i, pos);
        i = maxi.second;
        ++cnt;
    }
    cout << cnt << "\n";
}