#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const ll INF = 1e15;

struct Tree {
    ll key, priority, size;
    Tree *left, *right;
};

Tree *newTree(ll key) {
    return new Tree{key, rand(), 1, nullptr, nullptr};
}

ll safeSize(Tree *tree) {
    if (!tree) {
        return 0;
    }
    return tree->size;
}

void recalc(Tree *tree) {
    if (!tree) {
        return;
    }
    tree->size = 1 + safeSize(tree->left) + safeSize(tree->right);
}

Tree *merge(Tree *ta, Tree *tb) {
    if (!ta) {
        return tb;
    }
    if (!tb) {
        return ta;
    }
    if (ta->priority > tb->priority) {
        ta->right = merge(ta->right, tb);
        recalc(ta);
        return ta;
    } else {
        tb->left = merge(ta, tb->left);
        recalc(ta);
        return tb;
    }
}

pair<Tree *, Tree *> split(Tree *tree, ll key) {
    if (!tree) {
        return {nullptr, nullptr};
    }
    if (tree->key >= key) {
        auto p = split(tree->left, key);
        tree->left = p.second;
        recalc(tree);
        return {p.first, tree};
    } else {
        auto p = split(tree->right, key);
        tree->right = p.first;
        recalc(tree);
        return {tree, p.second};
    }
}

Tree *insert(Tree *tree, ll val) {
    Tree *nt = newTree(val);
    auto p = split(tree, val);
    return merge(p.first, merge(nt, p.second));
}

int main() {
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ll n, p;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> p;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (p == 2) {
        ll ans[n];
        fill_n(ans, n, 1);
        for (ll mask = 1; mask < (1 << n); ++mask) {
            ll fin[n];
            fill_n(fin, n, INF);
            for (ll i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    fin[i] = 0;
                } else {
                    if (i) {
                        fin[i] = fin[i - 1] + 1;
                    }
                }
            }
            for (ll i = n - 1; i >= 0; --i) {
                if (mask & (1 << i)) {
                    fin[i] = 0;
                } else {
                    if (i != n - 1) {
                        fin[i] = min(fin[i + 1] + 1, fin[i]);
                    }
                }
            }
            vector<ll> data(n);
            for (ll i = 0; i < n; ++i) {
                data[i] = {-fin[i] - a[i]};
            }
            sort(data.begin(), data.end());
            for (ll i = 0; i < n; ++i) {
                ll tm = n - (upper_bound(data.begin(), data.end(), -fin[i] - a[i]) - data.begin());
                ans[i] = max(ans[i], tm + 1);
            }
        }
        for (auto x: ans) {
            cout << x << "\n";
        }
    } else {
        ll ans[n];
        fill_n(ans, n, INF);
        for (int q = 0; q < n; ++q) {
            int mask = (1 << q);
            ll fin[n];
            fill_n(fin, n, INF);
            for (ll i = 0; i < n; ++i) {
                if (mask & (1 << i)) {
                    fin[i] = 0;
                } else {
                    fin[i] = abs(i - q);
                }
            }
            ll tm = 0;
            for (int i = 0; i < n; ++i) {
                if (a[i] + fin[i] < a[q] + fin[q]) {
                    ++tm;
                }
            }
            ans[q] = min(ans[q], tm + 1);
        }
        for (auto x: ans) {
            cout << x << "\n";
        }
        return 0;
        vector<ll> place(n, 0);
        Tree *tree = nullptr;
        ll now = n;
        for (ll i = 0; i < n; ++i) {
            ll val = a[i] + now;
            auto pr = split(tree, val);
            place[i] += safeSize(pr.first);
            tree = merge(pr.first, pr.second);
            tree = insert(tree, a[i] + now);
            now--;
        }
        now = n;
        Tree *ntree = nullptr;
        for (ll i = n - 1; i >= 0; --i) {
            ll val = a[i] + now;
            auto pr = split(ntree, val);
            place[i] += safeSize(pr.first);
            ntree = merge(pr.first, pr.second);
            ntree = insert(ntree, a[i] + now);
            --now;
        }
        for (auto x: place) {
            cout << x + 1 << "\n";
        }
    }
}