#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using cd = complex<double>;
using pii = pair<int, int>;

#define mp make_pair
#define mt make_tuple
#define X first
#define Y second
#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)
#define all(x) (x).begin(), (x).end()

#ifdef REK
#define dbg(...) cout << __VA_ARGS__
#else
#define dbg(...) ((void) 0)
#endif

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

constexpr int N = 300005;

int arr [N];

template <size_t MAXN>
struct segtree {

	int tmin [4*MAXN];
	int tmax [4*MAXN];

public:
	void build(int idx, int l, int r) {
		if (r-l == 1) {
			tmin[idx] = l;
			tmax[idx] = l;
			return;
		}

		int mid = (l+r)/2;

		build(idx*2+1, l, mid);
		build(idx*2+2, mid, r);

		if (arr[tmin[idx*2+2]] < arr[tmin[idx*2+1]]) {
			tmin[idx] = tmin[idx*2+2];
		} else {
			tmin[idx] = tmin[idx*2+1];
		}

		if (arr[tmax[idx*2+1]] > arr[tmax[idx*2+2]]) {
			tmax[idx] = tmax[idx*2+1];
		} else {
			tmax[idx] = tmax[idx*2+2];
		}
	}

	int rmq(int idx, int l, int r, int lb, int rb) {
		if (l == lb && r == rb) {
			return tmin[idx];
		}

		int q = rb-1;

		int mid = (l+r)/2;

		if (rb > mid) {
			auto res = rmq(idx*2+2, mid, r, max(lb, mid), rb);
			if (arr[res] <= arr[q]) {
				q = res;
			}
		}

		if (lb < mid) {
			auto res = rmq(idx*2+1, l, mid, lb, min(rb, mid));
			if (arr[res] <= arr[q]) {
				q = res;
			}
		}

		return q;
	}

	int rmaxq(int idx, int l, int r, int lb, int rb) {
		if (l == lb && r == rb) {
			return tmax[idx];
		}

		int q = rb-1;

		int mid = (l+r)/2;

		if (lb < mid) {
			auto res = rmaxq(idx*2+1, l, mid, lb, min(rb, mid));
			if (arr[res] >= arr[q]) {
				q = res;
			}
		}

		if (rb > mid) {
			auto res = rmaxq(idx*2+2, mid, r, max(lb, mid), rb);
			if (arr[res] >= arr[q]) {
				q = res;
			}
		}

		return q;
	}

};

segtree<N> st;
int ans = 0;
int n;

int cnt = 0;

void rec(int l, int r) {
	if (r-l < 1) return;

	auto idx = st.rmaxq(0, 0, n, l, r);
	ans++;

	auto nxt = st.rmq(0, 0, n, l, idx+1);

	if (cnt++ < 25)	dbg(l << " " << r << " " << idx << " " << nxt << endl);

	rec(l, nxt);
	rec(idx+1, r);
}

int main(void) {
	cin >> n;

	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	st.build(0, 0, n);

	rec(0, n);

	cout << ans << endl;

	return 0;
}