#pragma gcc optimize("O3")
#pragma gcc optimize("no-stack-protector")
#pragma gcc optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using cd = complex<double>;
using pii = pair<int, int>;

#define mp make_pair
#define mt make_tuple
#define X first
#define Y second
#define A(x) get<0>(x)
#define B(x) get<1>(x)
#define C(x) get<2>(x)
#define D(x) get<3>(x)
#define all(x) (x).begin(), (x).end()

#define inc flkgdskl
#define dec jfklgjdslf

#ifdef REK
#define dbg(...) cout << __VA_ARGS__
#else
#define dbg(...) ((void) 0)
#endif

inline void boost() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

constexpr int N = 400005;

int arr [N];
int inc [N];
int dec [N];

char buf [1024*1024*128];
size_t ptr = 0;

void *stalloc(size_t n) {
	auto ret = buf+ptr;
	ptr += n;
	return ret;
}

	struct Node {
		Node *l = nullptr, *r = nullptr;
		int cnt = 0;
	public:
		Node() {}
		Node(Node *other) {
			if (other) {
				this->cnt = other->cnt;
				this->l = other->l;
				this->r = other->r;
			}
		}
	};

	inline Node *nonnull(Node *&n) {
		if (!n) n = new (stalloc(sizeof(Node))) Node();
		return n;
	}

	Node *add(Node *n, int l, int r, int at) {
		if (r-l == 1) {
			auto res = new (stalloc(sizeof(Node))) Node(n);
			res->cnt = 1;
			return res;
		}

		int mid = (l+r)/2;
		auto res = new (stalloc(sizeof(Node))) Node(n);

		if (at < mid) {
			res->l = add(res->l, l, mid, at);
		} else {
			res->r = add(res->r, mid, r, at);
		}

		res->cnt = nonnull(res->l)->cnt + nonnull(res->r)->cnt;
		return res;
	}

	int cnt(Node *n, int l, int r, int lb, int rb) {
		if (!n) return 0;
		if (rb - lb < 1) {
			return 0;
		}
		if (l == lb && r == rb) {
			return n->cnt;
		}

		int res = 0;
		int mid = (l+r)/2;

		if (lb < mid) res += cnt(n->l, l, mid, lb, min(rb, mid));
		if (rb > mid) res += cnt(n->r, mid, r, max(mid, lb), rb);

		return res;
	}

//map<int, Node *, greater<int>> inc_segtrees;
//map<int, Node *, greater<int>> dec_segtrees;

vector<pair<int, Node *>> inc_segtrees;
vector<pair<int, Node *>> dec_segtrees;

int main(void) {
	
	boost();

	int n;
	int p;

	cin >> n >> p;

	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}

	for (int i = 0; i < n; i++) {
		inc[i] = i + arr[i];
	}

	for (int i = 0; i < n; i++) {
		dec[i] = (n-i-1) + arr[i];
	}

	vector<pii> inc_pairs;
	vector<pii> dec_pairs;

	for (int i = 0; i < n; i++) {
		inc_pairs.push_back(mp(inc[i], i));
	}

	for (int i = 0; i < n; i++) {
		dec_pairs.push_back(mp(dec[i], i));
	}

	sort(all(inc_pairs));
	sort(all(dec_pairs));

	Node *cur_node = nullptr;
	int prv = -1;

	for (const auto &p : inc_pairs) {
		int val, idx;
		tie(val, idx) = p;

		if (prv != -1 && val != prv) {
			inc_segtrees.push_back(mp(prv, cur_node));
		}
		prv = val;
		cur_node = add(cur_node, 0, n, idx);
	}
	inc_segtrees.push_back(mp(prv, cur_node));

	cur_node = nullptr;
	prv = -1;

	for (const auto &p : dec_pairs) {
		int val, idx;
		tie(val, idx) = p;

		if (prv != -1 && val != prv) {
			dec_segtrees.push_back(mp(prv, cur_node));
		}
		prv = val;
		cur_node = add(cur_node, 0, n, idx);
	}
	dec_segtrees.push_back(mp(prv, cur_node));

	reverse(all(inc_segtrees));
	reverse(all(dec_segtrees));

	if (p == 1) {
		for (int i = 0; i < n; i++) {
			int pos = 0;

			auto it = upper_bound(all(dec_segtrees), mp(dec[i], nullptr), greater<pair<int, Node *>>());

			if (it != dec_segtrees.end()) {
				dbg("best dec st is at " << it->first << endl);
				pos += cnt(it->second, 0, n, 0, i);
			}

			it = upper_bound(all(inc_segtrees), mp(inc[i], nullptr), greater<pair<int, Node *>>());

			if (it != inc_segtrees.end()) {
				dbg("best inc st is at " << it->first << endl);
				pos += cnt(it->second, 0, n, i+1, n);
			}

			cout << pos+1 << "\n";
		}
	}

	return 0;
}