#include<bits/stdc++.h>
using namespace std;

const int MAXN = 10005;
struct B{
    bitset<MAXN> val;
    int lp = 0;
};

B dp[MAXN];
int pre[MAXN];
bool operator <(B &a, B &b){
    if(a.lp != b.lp){
        return a.lp < b.lp;
    }
    for(int i = a.lp - 1; i >= 0; i--){
        if(b.val[i] != a.val[i]) return a.val[i] < b.val[i];
    }
    return 0;
}
B operator + (B a, int d){
    for(int i = d; i < MAXN; i++){
        if(a.val[i] == 1){
            a.val[i] = 0;
        }
        else{
            a.val[i] = 1;
            a.lp = max(a.lp, i);
            break;
        }
    }
    return a;
}

int dist(int x1, int y1, int x2, int y2){
    return max(abs(x1 - x2), abs(y1 - y2));
}

signed main(){
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // DEBUG
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    for(int i = 0; i < MAXN; i++){
        dp[i].val.flip();
        dp[i].lp = MAXN;
        pre[i] = -1;
    }
    vector<pair<int, int>> q(k);
    for(int i = 0; i < k; i++){
        cin >> q[i].first >> q[i].second;
        q[i].first--;q[i].second--;
    }
    dp[0].val.flip();
    dp[0].lp = -1;
    vector<int> used(k);
    while(1){
        int i = -1;
        B dd;
        dd.val.flip();
        dd.lp = MAXN;
        for(int j = 0; j < k; j++){
            if(!used[j] && dp[j] < dd){
                i = j;
                dd = dp[j];
            }
        }
        if(i == -1) break;
        used[i] = 1;
        for(int it = 0; it < k; it++){
            if(used[it]) continue;
            int d = dist(q[i].first, q[i].second, q[it].first, q[it].second);
            B kek = dp[i] + d;
            if(kek < dp[it]){
                dp[it] = kek;
                pre[it] = i;
            }
        }
    }
    int fin = k - 1;
    vector<int> ans;
    while(fin != -1){
        ans.push_back(fin + 1);
        fin = pre[fin];
    }
    reverse(ans.begin(), ans.end());
    cout << ans.size() << '\n';
    for(auto it : ans){
        cout << it << ' ';
    }
    return 0;
}

