#include <iostream>
#include <vector>

const int INF = 1000000000;

int n = 0;
std::vector< std::vector<int> > spmax, spmin;
std::vector<int> a;
std::vector<int> deg;

int Min(int l, int r) {
    int d = deg[(r - l + 1)];
    return std::min(spmin[d][l], spmin[d][r - (1 << d) + 1]);
}

int Max(int l, int r) {
    int d = deg[(r - l + 1)];
    int i1 = spmax[d][l], i2 = spmax[d][r - (1 << d) + 1];
    if (a[i1] <= a[i2]) {
        return i2;
    } else {
        return i1;
    }
}

int main() {
    //std::ios::sync_with_stdio(0);
    //std::cin.tie(0);
    //std::cout.tie(0);
    std::cin >> n;
    a.resize(n);
    for (auto &i : a) {
        std::cin >> i;
    }
    deg.resize(n + 1);
    deg[1] = 0;
    for (int i = 2; i <= n; ++i) {
        deg[i] = deg[(i >> 1)] + 1;
    }
    spmax.resize(deg[n] + 1, std::vector<int> (n));
    spmin.resize(deg[n] + 1, std::vector<int> (n));
    for (int i = 0; i < n; ++i) {
        spmin[0][i] = a[i];
        spmax[0][i] = i;
    }
    for (int k = 1; k <= deg[n]; ++k) {
        int gr = n - (1 << k);
        for (int i = 0; i <= gr; ++i) {
            spmin[k][i] = std::min(spmin[k - 1][i], spmin[k - 1][i + (1 << (k - 1))]);
            int i1 = spmax[k - 1][i], i2 = spmax[k - 1][(i + (1 << (k - 1)))];
            if (a[i1] <= a[i2]) {
                spmax[k][i] = i2;
            } else {
                spmax[k][i] = i1;
            }
        }
    }
    /*int q = 0;
    std::cin >> q;
    while (q--) {
        int t = 0, l = 0, r = 0;
        std::cin >> t >> l >> r;
        if (t) {
            int k = Min(l, r);
            std::cout << k << '\n';
        } else {
            std::cout << Max(l, r) << '\n';
        }
    }*/
    int i = 0, cnt = 0;
    while (i < n) {
        int left = i, right = n - 1;
        while (right - left > 1) {
            int mid = (left + right) >> 1;
            if (Min(i, mid) < a[i]) {
                right = mid;
            } else {
                left = mid;
            }
        }
        if (Min(i, right) >= a[i]) {
            left = right;
        }
        ++cnt;
        i = Max(i, left) + 1;
    }
    std::cout << cnt;
    return 0;
}