#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
using namespace std;

#define int long long

vector<int> operator+(vector<int> a, vector<int> b)
{
	if (a.size() < b.size())
		swap(a, b);
	reverse(a.begin(), a.end());
	reverse(b.begin(), b.end());
	a.resize(a.size() + 1);
	for (int i = 0; i < b.size(); i++)
		a[i] += b[i];
	for (int i = 0; i < a.size() - 1; i++)
		a[i + 1] += a[i] / 10, a[i] %= 10;
	if (a.back() == 0)
		a.pop_back();
	reverse(a.begin(), a.end());
	return a;
}

vector<int> operator*(vector<int> a, int k)
{
	reverse(a.begin(), a.end());
	a.resize(a.size() + 3);
	for (int i = 0; i < a.size(); i++)
		a[i] *= k;
	for (int i = 0; i < a.size() - 1; i++)
		a[i + 1] += a[i] / 10, a[i] %= 10;
	while (a.back() == 0)
		a.pop_back();
	reverse(a.begin(), a.end());
	return a;
}

bool operator<(const vector<int> &a, const vector<int> &b)
{
	if (a.size() != b.size())
		return a.size() < b.size();
	for (int i = 0; i < a.size(); i++)
		if (a[i] != b[i])
			return a[i] < b[i];
	return false;
}

int n, m;

vector<vector<int>> deg;

vector<int> get(int x1, int y1, int x2, int y2)
{
	return deg[max(abs(x2 - x1), abs(y2 - y1))];
}

struct cell
{
	int x = 0, y = 0;
};

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int k; cin >> n >> m >> k;
	deg.resize(max(n, m) + 1);
	deg[0] = { 1 };
	for (int i = 1; i < deg.size(); i++)
		deg[i] = deg[i - 1] * 2;
	vector<cell> a(k);
	for (int i = 0; i < k; i++)
		cin >> a[i].x >> a[i].y;
	vector<int> p(k, -1), INF(10000, 9);
	vector<vector<int>> d(k, INF);
	vector<bool> used(k);
	d[0] = { 0 };
	for (int i = 0; i < k; i++)
	{
		int v = -1;
		for (int j = 0; j < k; j++)
			if (d[j] < INF && (v == -1 || d[j] < d[v]) && !used[j])
				v = j;
		if (v == -1)
			break;
		used[v] = true;
		for (int i = 0; i < k; i++)
		{
			vector<int> cost = get(a[v].x, a[v].y, a[i].x, a[i].y) + d[v];
			if (cost < d[i])
			{
				d[i] = cost;
				p[i] = v;
			}
		}
	}
	vector<int> ans;
	int ind = k - 1;
	while (true)
	{
		ans.push_back(ind + 1);
		ind = p[ind];
		if (ind == -1)
			break;
	}
	cout << ans.size() << endl;
	for (int i = ans.size() - 1; i >= 0; i--)
		cout << ans[i] << " ";
	system("pause");
}