#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

#define int long long

const int INF = 1e15;

vector<pair<int, int>> t;
vector<int> m;

void build_min(vector<int> &a, int v, int tl, int tr)
{
	if (tl == tr)
		m[v] = a[tl];
	else
	{
		int tm = (tl + tr) >> 1;
		build_min(a, v * 2, tl, tm);
		build_min(a, v * 2 + 1, tm + 1, tr);
		m[v] = min(m[v * 2], m[v * 2 + 1]);
	}
}

int ming(int v, int tl, int tr, int l, int r)
{
	if (l > r || tl > tr || l > tr || tl > r)
		return INF;
	if (l <= tl && tr <= r)
		return m[v];
	int tm = (tl + tr) >> 1;
	return min(ming(v * 2, tl, tm, l, r), ming(v * 2 + 1, tm + 1, tr, l, r));
}

void build_max(vector<int> &a, int v, int tl, int tr)
{
	if (tl == tr)
		t[v] = { a[tl], tl };
	else
	{
		int tm = (tl + tr) >> 1;
		build_max(a, v * 2, tl, tm);
		build_max(a, v * 2 + 1, tm + 1, tr);
		t[v] = max(t[v * 2], t[v * 2 + 1]);
	}
}

pair<int, int> maxg(int v, int tl, int tr, int l, int r)
{
	if (l > r || tl > tr || l > tr || tl > r)
		return { -INF, -INF };
	if (l <= tl && tr <= r)
		return t[v];
	int tm = (tl + tr) >> 1;
	return max(maxg(v * 2, tl, tm, l, r), maxg(v * 2 + 1, tm + 1, tr, l, r));
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n; cin >> n;
	vector<int> a(n);
	t.resize(n * 4); m.resize(n * 4);
	for (auto &i : a)
		cin >> i;
	build_max(a, 1, 0, n - 1);
	build_min(a, 1, 0, n - 1);
	int ans = 0;
	vector<int> right(n);
	right.back() = a.back();
	for (int i = n - 2; i >= 0; i--)
		right[i] = max(a[i], right[i + 1]);
	map<int, int> last;
	vector<int> ind(n);
	for (int i = n - 1; i >= 0; i--)
	{
		if (last[a[i]] == 0)
			ind[i] = -1;
		else
			ind[i] = last[a[i]];
		last[a[i]] = i;
	}
	for (int i = 0; i < n; i++)
	{
		int l = i, r = n;
		while (r - l > 1)
		{
			int m = (l + r) >> 1;
			if (ming(1, 0, n - 1, i, m) < a[i])
				r = m;
			else
				l = m;
		}
		i = maxg(1, 0, n - 1, i, l).second;
		ans++;
	}
	cout << ans << endl;
	system("pause");
}