#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5 + 1000;

typedef long long ll;

ll n, arr[MAXN];

struct Tree {
    ll val;
    ll mn;
    int pos, pos_mn;
    Tree *left, *right;
    Tree (ll vl, ll mnn, int ps, int ps_mn) : val(vl), mn(mnn), pos(ps), pos_mn(ps_mn), left(NULL), right(NULL) {}
};

void init(Tree *&root, int l, int r) {
    root = new Tree(0, 0, 0, 0);
    if (l + 1 == r) {
        root->val = arr[l];
        root->mn = arr[l];
        root->pos = l;
        root->pos_mn = l;
        return;
    }
    init(root->left, l, (l + r) / 2);
    init(root->right, (l + r) / 2, r);
    if (root->left->val > root->right->val) {
        root->pos = root->left->pos;
    }
    else {
        root->pos = root->right->pos;
    }
    root->val = max(root->left->val, root->right->val);
    if (root->left->mn <= root->right->mn) {
        root->pos_mn = root->left->pos_mn;
    }
    else {
        root->pos_mn = root->right->pos_mn;
    }
    root->mn = min(root->left->mn, root->right->mn);
}

pair <ll, int> MAX(Tree *&root, int l, int r, int a, int b) {
    if (l >= b || a >= r) {
        return make_pair(-1, -1);
    }
    if (l >= a && r <= b) {
        return make_pair(root->val, root->pos);
    }
    pair <ll, int> lt, rt;
    lt = MAX(root->left, l, (l + r) / 2, a, b), rt = MAX(root->right, (l + r) / 2, r, a, b);
    if (lt > rt) {
        return lt;
    }
    return rt;
}

pair <ll, int> MIN(Tree *&root, int l, int r, int a, int b) {
    if (l >= b || a >= r) {
        return make_pair((ll)1e10, -1);
    }
    if (l >= a && r <= b) {
        return make_pair(root->mn, root->pos_mn);
    }
    pair <ll, int> lt, rt;
    lt = MIN(root->left, l, (l + r) / 2, a, b), rt = MIN(root->right, (l + r) / 2, r, a, b);
    if (lt <= rt) {
        return lt;
    }
    return rt;
}

int main() {

    //freopen("in.in", "r", stdin);

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for(int i = 0; i < n; i++) {
        cin >> arr[i];
    }

    Tree *root;

    init(root, 0, n);

    int ans = 0;

    int l = 0;

    while(l < n) {
        int beg = l, en = n;
        while(beg + 1 != en) {
            int mid = (beg + en) / 2;
            pair <ll, int> p = MIN(root, 0, n, l, mid + 1);
            if (p.first == arr[l]) {
                beg = mid;
            }
            else {
                en = mid;
            }
        }
        int r = beg;
        pair <ll, int> p = MAX(root, 0, n, l, r + 1);
        l = p.second + 1;
        ans++;
    }

    cout << ans;

    return 0;
}
