//#define _CRT_SECURE_NO_WARNINGS
#include<stdio.h>
#include<algorithm>
#include<vector>
#include<set>
#include<cmath>
#include<map>

using namespace std;

long long int INF = 7e18;

struct point {
	int x, y;
};

struct path {
	long long int dist, fromx, fromy;
};
long long int pw(long long int a, int p) {
	if (p == 0)return 1;
	if (p % 2 == 1)return a * pw(a, p - 1);
	return pw(a, p / 2) * pw(a, p / 2);
}

bool operator<(point a, point b) {
	if (a.x == b.x)return a.y < b.y;
	else return a.x < b.x;
}
int main() {
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);
	set<point> arr;
	map<point, int> ind;
	for (int i = 0; i < k; i++) {
		point a;
		scanf("%d %d", &a.x, &a.y);
		ind[a] = i + 1;
		arr.insert(a);
	}
	vector<vector<path>> dp(n + 1, vector<path>(m + 1));
	for (int j = 1; j <= n; j++) {
		for (int q = 1; q <= m; q++) {
			dp[j][q].dist = INF;
		}
	}
	dp[1][1].dist = 0;
	dp[1][1].fromx = -1;
	for (int i = 0; i < k; i++) {
		for (int j = 1; j <= n; j++) {
			for (int q = 1; q <= m; q++) {
				point a;
				a.x = j;
				a.y = q;
				if (arr.find(a) != arr.end()) {
					for (auto now : arr) {
						int x = now.x;
						int y = now.y;
						if (dp[x][y].dist > dp[j][q].dist + pw(2ll, std::max(abs(x - j), abs(y - q)))) {
							dp[x][y].dist = dp[j][q].dist + pw(2ll, std::max(abs(x - j), abs(y - q)));
							dp[x][y].fromx = j;
							dp[x][y].fromy = q;
						}
					}
				}
			}
		}
	}
	vector<int> res;
	int x = n;
	int y = m;
	while (x != -1) {
		point a;
		a.x = x;
		a.y = y;
		res.push_back(ind[a]);
		int xx = dp[x][y].fromx;
		y = dp[x][y].fromy;
		x = xx;
	}
	reverse(res.begin(), res.end());
	printf("%d\n", (int)res.size());
	for (int i = 0; i < (int)res.size(); i++) {
		printf("%d ", res[i]);
	}
	//system("pause");
	return 0;
}