#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#pragma warning (disable : 4996)

const int MAXN = 4e5 + 10;

struct susegtree {
	int t[4 * MAXN];

	int sum(int v, int tl, int tr, int l, int r) {
		if (tl > tr) return 0;
		if (l <= tl && tr <= r) {
			return t[v];
		}
		if (tr < l || tl > r) return 0;
		int mid = tl + tr >> 1;
		return sum(v * 2, tl, mid, l, r) +
			sum(v * 2 + 1, mid + 1, tr, l, r);
	}

	void update(int v, int tl, int tr, int ind, int val) {
		if (tl == tr) {
			t[v] += val;
			return;
		}
		int mid = tl + tr >> 1;
		if (ind <= mid) {
			update(v * 2, tl, mid, ind, val);
		}
		else {
			update(v * 2 + 1, mid + 1, tr, ind, val);
		}
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
};

int n, a[MAXN], p, pr[MAXN], su[MAXN], indpr[MAXN], indsu[MAXN], indpr_[MAXN], indsu_[MAXN], ans[MAXN];
susegtree tpr, tsu;

bool keypr(int x, int y) {
	return pr[x] < pr[y];
}

bool keysu(int x, int y) {
	return su[x] < su[y];
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	scanf("%d %d", &n, &p);
	for (int i = 0; i < n; i++) {
		scanf("%d", &a[i]);
		su[i] = a[i] + i;
		pr[i] = a[i] + n - i;
		tsu.update(1, 0, n - 1, i, 1);
		indpr_[i] = i;
		indsu_[i] = i;
	}
	sort(indpr_, indpr_ + n, keypr);
	int l = 0;
	for (int i = 0; i < n; i++) {
		if (pr[indpr_[i]] != pr[indpr_[i - 1]]) {
			l = i;
		}
		indpr[indpr_[i]] = l;
	}
	sort(indsu_, indsu_ + n, keysu);
	l = 0;
	for (int i = 0; i < n; i++) {
		if (su[indsu_[i]] != su[indsu_[i - 1]]) {
			l = i;
		}
		indsu[indsu_[i]] = l;
	}
	/*for (int i = 1; i < n; i++) {
		if (pr[indpr[i]] == pr[indpr[i - 1]]) {
			indpr_[i] = indpr_[i - 1];
		}
		else {
			indpr_[i] = indpr[i];
		}

		if (su[indsu[i]] == su[indsu[i - 1]]) {
			indsu_[i] = indsu_[i - 1];
		}
		else {
			indsu_[i] = indsu[i];
		}
	}*/

	for (int i = 0; i < n; i++) {
		int k = tpr.sum(1, 0, n - 1, 0, indpr[i] - 1);
		k += tsu.sum(1, 0, n - 1, 0, indsu[i] - 1);
		/*for (int j = 0; j < i; j++) {
			k += pr[j] < pr[i];
		}
		for (int j = i; j < n; j++) {
			k += su[j] < su[i];
		}*/
		tpr.update(1, 0, n - 1, indpr[i], 1);
		tsu.update(1, 0, n - 1, indsu[i], -1);
		printf("%d\n", k + 1);
	}
}