#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <map>

using namespace std;

struct node {
    node *left, *right;
    int tl, tr;
    int sum = 0;
    node(int nl, int nr, int sum){
        tl = nl;
        tr = nr;
        left = nullptr;
        right = nullptr;
        sum = 0;
    }
    node(node* le, node *ri){
        tl = le -> tr;
        tr = ri -> tr;
        left = le;
        right = ri;
        sum = left -> sum + right -> sum;
    }
};

node* gen(int nl, int nr){
    if (nl == nr - 1){
        return new node(nl, nr, 0);
    }
    int mid = (nl + nr) / 2;
    node *le = gen(nl, mid);
    node *ri = gen(mid, nr);
    return new node(le, ri);
}

node* add(node* root, int x){
    if (root -> tl + 1 == root -> tr){
        return new node(root -> tl, root -> tr, root -> sum + 1);
    }
    int mid = (root -> tl + root -> tr) / 2;
    if (x >= mid){
        return new node(root -> left, add(root -> right, x));
    }
    return new node(add(root -> left, x), root -> right);
}

int get(node *root, int nl, int nr){
    if (nl <= root -> tl && root -> tr <= nr){
        return root -> sum;
    }
    if (nl >= root -> tr || nr <= root -> tl){
        return 0;
    }
    return get(root -> left, nl, nr) + get(root -> right, nl, nr);
}

int main() {
    int n;
    cin >> n;
    vector <pair <long long, long long> > a(n);
    set <long long> b;
    for (int i = 0; i < n; i++){
        cin >> a[i].first >> a[i].second;
        b.insert(a[i].second);
    }
    sort(a.begin(), a.end());
    map <long long, int> c;
    for (int i = 0; i < b.size(); i++){
        c[*b.begin()] = i;
        b.erase(b.begin());
    }
    vector <node*> d(n);
    d[0] = gen(0, n);
    for (int i = 0; i < n - 1; i++){
        d[i + 1] = add(d[i], c[a[i].second]);
    }
    long long res = 0;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < n; j++){
            res = max(res, a[i].first * (n - i) + a[j].second * get(d[i], c[a[j].second], n));
        }
    }
    cout << res;
    return 0;
}