#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <stack>
using namespace std;
int inf = 2e9, n;
vector <int> a;
struct node {
	node *left, *right;
	int tl, tr, maxa, p;
	node(int a = 0, int b = 0) : tl(a), tr(b){
		p = n;
		maxa = inf;
		left = NULL;
		right = NULL;
	}
};

node* build(int l, int r) {
	if (l >= r)
		return 0;
	node* v = new node(l, r);
	if (l + 1 == r) {
		v->maxa = a[l];
		v->p = l;
		return v;
	}
	v->left = build(l, (l + r) / 2);
	v->right = build((l + r) / 2, r);
	if (v->left->maxa <= v->right->maxa)
		v->maxa = v->right->maxa, v->p = v->right->p;
	else
		v->maxa = v->left->maxa, v->p = v->left->p;
	return v;
}

int get_max(node*v, int l, int r) {
	if ((v == NULL) || (v->tl >= r) || (v->tr <= l))
		return -1;
	if (v->tl >= l && v->tr <= r)
		return v->p;
	int p1 = get_max(v->left, l, r);
	int p2 = get_max(v->right, l, r);
	if (p1 == -1)
		return p2;
	if (p2 == -1)
		return p1;
	if (a[p1] <= a[p2])
		return p2;
	else
		return p1;
}

int main() {
	cin >> n;
	a.resize(n);
	vector <int> nxt(n, n);
	stack <int> st;

	for (int i = 0; i < n; i++) {
		cin >> a[i];
		while (!st.empty() && a[st.top()] > a[i])
			nxt[st.top()] = i, st.pop();
		st.push(i);
	}
	node* root = build(0, n);
	int ans = 0;
	int  p = 0;
	while (p < n) {
		ans++;
		p = get_max(root, p, nxt[p]) + 1;
	}
	cout << ans;
	return 0;
}