#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

const ll INF = 1000000000000000000;

int len(pair<int, int> f1, pair<int, int> f2) {
	return 1 << (max(abs(f1.first - f2.first), abs(f1.second - f2.second)));
}

int main()
{
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int> > all(k);
	for (int i = 0; i < k; i++) {
		cin >> all[i].first >> all[i].second;
	}
	vector<vector<int> > g(k, vector<int>(k));
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			g[i][j] = len(all[i], all[j]);
			//cout << g[i][j] << ' ';
		}
		//cout << endl;
	}
	vector<ll> dist(k, INF);
	vector<bool> used(k);
	vector<int> pr(k, -1);
	dist[0] = 0;
	for (int i = 0; i < k; i++) {
		int u = -1;
		for (int j = 0; j < k; j++) {
			if (!used[j] && (u == -1 || dist[j] < dist[u])) {
				u = j;
			}
		}
		if (u == -1) break;
		used[u] = true;
		for (int j = 0; j < k; j++) {
			if (dist[j] > dist[u] + g[u][j]) {
				dist[j] = dist[u] + g[u][j];
				pr[j] = u;
			}
		}
	}
	/*for (int i = 0; i < k; i++) {
		cout << dist[i] << ' ';
	}
	cout << endl;*/
	int last = k - 1;
	vector<int> ans;
	while (last != -1) {
		ans.push_back(last);
		last = pr[last];
	}
	reverse(ans.begin(), ans.end());
	cout << (int)ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++) {
		cout << ans[i] + 1 << ' ';
	}
	cout << endl;
    return 0;
}

