#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>

using namespace std;
const int maxn = 1000;

struct ll {
	bitset<maxn> val;
};

ll sum(ll a, int ind) {
	for (int i = ind; i < maxn; i++) {
		if (!a.val[i]) {
			a.val[i] = 1;
			break;
		}
		a.val[i] = 0;
	}
	return a;
}

bool operator <(ll a, ll b) {
	return a.val.to_string() < b.val.to_string();
}

bool operator >(ll a, ll b) {
	return a.val.to_string() > b.val.to_string();
}

ll INF;

int len(pair<int, int> f1, pair<int, int> f2) {
	return max(abs(f1.first - f2.first), abs(f1.second - f2.second));
}

int main()
{
	INF = sum(INF, maxn - 1);
	int n, m, k;
	cin >> n >> m >> k;
	vector<pair<int, int> > all(k);
	for (int i = 0; i < k; i++) {
		cin >> all[i].first >> all[i].second;
	}
	vector<vector<int> > g(k, vector<int>(k));
	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			g[i][j] = len(all[i], all[j]);
			//cout << g[i][j] << ' ';
		}
		//cout << endl;
	}
	vector<ll> dist(k, INF);
	vector<bool> used(k);
	vector<int> pr(k, -1);
	dist[0] = ll();
	for (int i = 0; i < k; i++) {
		int u = -1;
		for (int j = 0; j < k; j++) {
			if (!used[j] && (u == -1 || dist[j] < dist[u])) {
				u = j;
			}
		}
		if (u == -1) break;
		used[u] = true;
		for (int j = 0; j < k; j++) {
			//cout << dist[j].val << ' ' << sum(dist[u], g[u][j]).val << endl;
			if (dist[j] > sum(dist[u], g[u][j])) {
				//cout << "relax" << endl;
				dist[j] = sum(dist[u], g[u][j]);
				pr[j] = u;
			}
		}
	}
	/*for (int i = 0; i < k; i++) {
		cout << dist[i] << ' ';
	}
	cout << endl;*/
	int last = k - 1;
	vector<int> ans;
	while (last != -1) {
		ans.push_back(last);
		last = pr[last];
	}
	reverse(ans.begin(), ans.end());
	cout << (int)ans.size() << endl;
	for (int i = 0; i < (int)ans.size(); i++) {
		cout << ans[i] + 1 << ' ';
	}
	cout << endl;
    return 0;
}

