#include <iostream>
#include <vector>
#include <algorithm>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,avx,mmx,abm,popcnt,tune=native")

using namespace std;

struct fenw {
	vector<int> t;
	void init(int n) {
		t.assign(n, 0);
	}
	void update(int i) {
		while (i < (int)t.size()) {
			t[i]++;
			i = (i | (i + 1));
		}
	}
	int sum(int i) {
		int ans = 0;
		while (i >= 0) {
			//cout << i << endl;
			ans += t[i];
			i = (i & (i + 1)) - 1;
		}
		return ans;
	}
};

int know(int val, vector<int> cur) {
	sort(cur.begin(), cur.end());
	return lower_bound(cur.begin(), cur.end(), val) - cur.begin();
}

int main()
{
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, p;
	cin >> n >> p;
	vector<int> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}
	vector<int> a1(n), a2(n);
	for (int i = 0; i < n; i++) {
		a1[i] = a[i] + i;
		a2[i] = a[i] + (n - i - 1);
	}
	sort(a1.begin(), a1.end());
	sort(a2.begin(), a2.end());
	vector<int> cur;
	for (int i = 0; i < n; i++) {
		cur.clear();
		int d = min(i, n - i - 1);
		for (int j = 0; j < i; j++) {
			if (j <= i - d) cur.push_back(a[j]);
			else cur.push_back(a[j] + (j - i + d));
		}
		for (int j = n - 1; j > i; j--) {
			if (j >= i + d) cur.push_back(a[j]);
			else cur.push_back(a[j] + (i + d - j));
		}
		int var1 = know(a[i] + d, cur);
		int var2 = lower_bound(a1.begin(), a1.end(), a[i] + i) - a1.begin();
		int var3 = lower_bound(a2.begin(), a2.end(), a[i] + (n - i - 1)) - a2.begin();
		cout << max(var1, max(var2, var3)) + 1 << '\n';
	}
    return 0;
}

