#include <iostream>
#include <cstdio>
#include <vector>
#include <deque>
#include <cmath>
#include <algorithm>
typedef long long ll;
typedef long double ld;

using namespace std;

const int N = 400001, M = 1 << 19;
int n, p;
int a[N], ans[N];
int tr[M * 2];

void init() {
	for (int i = 0; i < M * 2; i++)
		tr[i] = 0;
}
void add(int v) {
	for (int i = M + v; i > 0; i /= 2)
		tr[i]++;
}
int sum(int cl, int cr, int v=1, int l=0, int r=M) {
	if (cr <= l || r <= cl)
		return 0;
	if (cl <= l && r <= cr)
		return tr[v];
	return sum(cl, cr, v * 2, l, (l + r) / 2) + sum(cl, cr, v * 2 + 1, (l + r) / 2, r);
}

void solve1() {
	vector<int> x(n);
	for (int i = 0; i < n; i++)
		x[i] = a[i] - i;
	sort(x.begin(), x.end());
	init();
	for (int i = 0; i < n; i++) {
		int pos = lower_bound(x.begin(), x.end(), a[i] - i) - x.begin();
		ans[i] += sum(0, pos);
		add(pos);
	}
	//return;
	for (int i = 0; i < n; i++)
		x[i] = a[i] + i;
	sort(x.begin(), x.end());
	init();
	for (int i = n - 1; i >= 0; i--) {
		int pos = lower_bound(x.begin(), x.end(), a[i] + i) - x.begin();
		ans[i] += sum(0, pos);
		add(pos);
	}
}

int getm(int p, int x, int y) {
	if (x != -1 && p <= x || y != -1 && y <= p)
		return a[p];
	int ans = n;
	if (x != -1)
		ans = min(ans, p - x);
	if (y != -1)
		ans = min(ans, y - p);
	return a[p] + ans;
}

void solve2() {
	for (int i = 0; i < n; i++) {
		for (int j = -1; j < n; j++)
			for (int k = -1; k < n; k++)
				if (k == -1 || j <= k) {
					int dd = getm(i, j, k), ca = 0;
					for (int l = 0; l < n; l++)
						if (getm(l, j, k) < dd)
							ca++;
					ans[i] = max(ans[i], ca);
				}
	}
}

int main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	scanf("%d%d", &n, &p);
	for (int i = 0; i < n; i++)
		scanf("%d", &a[i]);
	if (p == 1)
		solve1();
	else
		solve2();
	for (int i = 0; i < n; i++)
		printf("%d\n", ans[i] + 1);
}