#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <fstream>
#include <cmath>
#include <algorithm>
#include <queue>

using namespace std;

const int MAXN = 1007;

pair <int, int> a[MAXN];

bool dist[MAXN][MAXN];
int anc[MAXN];
bool used[MAXN];

bool best[MAXN];
bool nv[MAXN];

void mcopy(bool a[], bool b[]) {
    for (int i = 0; i < MAXN; ++i) b[i] = a[i];
}

bool mless(bool a[], bool b[]) {
    for (int i = MAXN - 1; i >= 0; --i) {
        if (!a[i] && b[i]) return true;
        if (!b[i] && a[i]) return false;
    }
    return false;
}

void add(bool a[], int pos) {
    for (int i = pos; i < MAXN; ++i) {
        if (!a[i]) {
            a[i] = true;
            break;
        }
        else {
            a[i] = false;
        }
    }
}

int getr(int i, int j) {
    return max(abs(a[i].first - a[j].first), abs(a[i].second - a[j].second));
}

void print(bool a[]) {
    for (int i = 0; i < 10; ++i) cout << a[i];
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n, m, k;
    cin >> n >> m >> k;

    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    for (int i = 0; i < k; ++i) anc[i] = -1;

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < MAXN; ++j) {
            dist[i][j] = true;
        }
    }

    for (int i = 0; i < MAXN; ++i) dist[0][i] = false;

    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < MAXN; ++j) best[j] = 1;
        int u = -1;

        for (int j = 0; j < k; ++j) {
            if (used[j]) continue;
            if (mless(dist[j], best)) {
                u = j;
                mcopy(dist[j], best);
            }
        }

        used[u] = true;

        for (int j = 0; j < k; ++j) {
            if (used[j]) continue;
            mcopy(best, nv);
            add(nv, getr(u, j));
            if (mless(nv, dist[j])) {
                anc[j] = u;
                mcopy(nv, dist[j]);
            }
        }
    }

    vector <int> ans;
    int curr = k - 1;
    while (curr != -1) {
        ans.push_back(curr);
        curr = anc[curr];
    }
    reverse(ans.begin(), ans.end());

    cout << ans.size() << '\n';
    for (int elem : ans) {
        cout << elem + 1 << ' ';
    }
    cout << '\n';

    return 0;
}

