#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <fstream>
#include <queue>

using namespace std;

const int MAXN = 3e5 + 7;

int a[MAXN];
int dp[MAXN];
int pr[MAXN];

int tree[MAXN * 4];

int mmin(int l, int r) {
    if (l == -1) return r;
    if (r == -1) return l;
    if (a[l] <= a[r]) return l;
    else return r;
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        tree[v] = tl;
        return;
    }

    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm + 1, tr);
    tree[v] = mmin(tree[v * 2 + 1], tree[v * 2 + 2]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (tr < l || r < tl) return -1;
    if (l <= tl && tr <= r) return tree[v];
    int tm = (tl + tr) / 2;
    return mmin(get(v * 2 + 1, tl, tm, l, r), get(v * 2 + 2, tm + 1, tr, l, r));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> a[i];

    for (int i = 0; i < n; ++i) pr[i] = -1;

    vector <int> st;
    for (int i = n - 1; i >= 0; --i) {
        while (st.size() && a[st.back()] < a[i]) {
            pr[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }

    build(0, 0, n - 1);
    for (int i = 0; i < n; ++i) {
        int left = pr[i] + 1;
        int l = get(0, 0, n - 1, left, i);
        dp[i + 1] = dp[l] + 1;
    }

    cout << dp[n] << '\n';
    return 0;
}

