#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <fstream>
#include <queue>

using namespace std;
#define int long long

const int MAXN = 4e5 + 7;
const int INF = 2e9 + 7;

int a[MAXN];

struct Node {
    int sum;
    Node *l, *r;
};

Node *init() {
    Node *t = new Node;
    t->sum = 0;
    t->l = t->r = NULL;
    return t;
}

void push(Node *t) {
    if (!t->l) t->l = init();
    if (!t->r) t->r = init();
}

void upd(Node *t, int tl, int tr, int p, int x) {
    if (tl == tr) {
        t->sum += x;
        return;
    }

    int tm = (tl + tr) / 2;
    push(t);
    if (p <= tm) {
        upd(t->l, tl, tm, p, x);
    }
    else {
        upd(t->r, tm + 1, tr, p, x);
    }

    t->sum += x;
}

int get(Node *t, int tl, int tr, int l, int r) {
    if (tr < l || r < tl) return 0;
    if (l <= tl && tr <= r) return t->sum;
    int tm = (tl + tr) / 2;
    push(t);
    return get(t->l, tl, tm, l, r) + get(t->r, tm + 1, tr, l, r);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n, p;
    cin >> n >> p;

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    Node *l = init();
    Node *r = init();

    for (int i = 0; i < n; ++i) {
        upd(r, 0, INF, a[i] + i + MAXN, 1);
    }

    for (int i = 0; i < n; ++i) {
        int res = get(l, 0, INF, 0, a[i] - i - 1 + MAXN);
        res += get(r, 0, INF, 0, a[i] + i - 1 + MAXN);
        cout << res + 1 << '\n';
        upd(r, 0, INF, a[i] + i + MAXN, -1);
        upd(l, 0, INF, a[i] - i + MAXN, 1);
    }

    return 0;
}

