#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>
#include <fstream>
#include <queue>

using namespace std;

const int MAXN = 2e5 + 7;
const int INF = 2e9 + 7;
const int SZ = 2e7;

int a[MAXN];

struct Node {
    int sum;
    int l, r;
};

Node tree[SZ];

int u = 0;

int init() {
    return u++;
}

void push(Node *t) {
    if (t->l == -1) t->l = u++;
    if (t->r == -1) t->r = u++;
}

void upd(Node *t, int tl, int tr, int p, int x) {
    if (tl == tr) {
        t->sum += x;
        return;
    }

    int tm = (tl + tr) / 2;
    push(t);
    if (p <= tm) {
        upd(&tree[t->l], tl, tm, p, x);
    }
    else {
        upd(&tree[t->r], tm + 1, tr, p, x);
    }

    t->sum += x;
}

int get(Node *t, int tl, int tr, int l, int r) {
    if (tr < l || r < tl) return 0;
    if (l <= tl && tr <= r) return t->sum;
    int tm = (tl + tr) / 2;
    push(t);
    return get(&tree[t->l], tl, tm, l, r) + get(&tree[t->r], tm + 1, tr, l, r);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //freopen("input.txt", "r", stdin);

    int n, p;
    cin >> n >> p;

    for (int i = 0; i < SZ; ++i) {
        tree[i].sum = 0;
        tree[i].l = tree[i].r = -1;
    }

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    init();
    init();

    for (int i = 0; i < n; ++i) {
        upd(&tree[1], 0, INF, a[i] + i + MAXN, 1);
    }

    for (int i = 0; i < n; ++i) {
        int res = get(&tree[0], 0, INF, 0, a[i] - i - 1 + MAXN);
        res += get(&tree[1], 0, INF, 0, a[i] + i - 1 + MAXN);
        cout << res + 1 << '\n';
        upd(&tree[1], 0, INF, a[i] + i + MAXN, -1);
        upd(&tree[0], 0, INF, a[i] - i + MAXN, 1);
    }

    return 0;
}

