#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

struct st
{
	ll l, r, mx, mx_n;

	st * left, * right;

	st()
	{
		mx = 0;
		mx_n = -1;
		left = right = nullptr;
	}

	st(ll a, ll l1, ll r1)
	{
		left = right = nullptr;
		mx = a;
		l = l1;
		r = r1;
	}

	pair<ll, ll> get_mx()
	{
		if (this == nullptr)
		{
			return { 0, -1 };
		}
		return { mx, mx_n };
	}

	pair<ll, ll> get_segment_mx(ll l1, ll r1)
	{
		if (this == nullptr || l1 >= r || r1 <= l)
		{
			return { 0, -1 };
		}
		if (l1 <= l && r1 >= r)
		{
			return {mx, mx_n};
		}
		return max(left->get_segment_mx(l1, r1), right->get_segment_mx(l1, r1));
	}

	void upd()
	{
		if (this == nullptr || l + 1 == r || l == r)
		{
			return;
		}
		if (left->get_mx() > right->get_mx())
		{
			mx = left->get_mx().first;
			mx_n = left->get_mx().second;
		}
		else
		{
			mx = right->get_mx().first;
			mx_n = right->get_mx().second;
		}
	}

	void build(vector <ll> &v, ll l1, ll r1)
	{
		l = l1, r = r1;
		if (l == r)
		{
			return;
		}
		if (l + 1 == r)
		{
			mx = v[l];
			mx_n = l;
			return;
		}
		left = new st;
		right = new st;
		left->build(v, l1, (r1 + l1) / 2), right->build(v, (r1 + l1) / 2, r1);
		this->upd();
	}
};

int main()
{
	ll n;
	cin >> n;
	vector <ll> v(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> v[i];
	}
	st * root = new st();
	root->build(v, 0, n);
	vector <ll> less(n, n);
	for (int i = n - 2; i >= 0; --i)
	{
		if (v[i] > v[i + 1])
		{
			less[i] = i + 1;
		}
		else
		{
			ll temp = i + 1;
			while (temp < n)
			{
				if (v[temp] < v[i])
				{
					break;
				}
				temp = less[temp];
			}
			less[i] = temp;
		}
	}
	ll mx = v[0], mx_n = 0, mn = v[0], mn_n = 0, ans = 0, temp = 0;
	while(temp < n)
	{
		temp = root->get_segment_mx(temp, less[temp]).second + 1;
		++ans;
	}
	cout << ans;
	return 0;
}
/*
6
2 3 1 1 5 1
*/