#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int MAX_N = 10000 + 20;

int cnt_num[MAX_N];

struct my_num{
    bool cnt[MAX_N];
    my_num() {
        for (int i = 0; i < MAX_N; i++) {
            cnt[i] = 0;
        }
    }
    void ins(int pos, int x) {
        cnt[pos] += x;
    }
    my_num(int pos) {
        for (int i = 0; i < MAX_N; i++) cnt[i] = 0;
        cnt[pos] = 1;
    }
    void full() {
        for (int i = 0; i < MAX_N - 10; i++) {
            cnt[i] = 1;
        }
    }
    void relax() {
        for (int i = 0; i < MAX_N - 1; i++) {
            cnt_num[i + 1] += cnt_num[i] / 2;
            cnt[i] = cnt_num[i] % 2;
        }
    }
    my_num operator + (my_num a) {
        my_num ans;
        //cout << endl << endl;
        //print();
        //a.print();
        for (int i = 0; i < MAX_N; i++) {
            cnt_num[i] = (int) cnt[i] + (int) a.cnt[i];
        }
         ans.relax();
        //ans.print();
        //cout << endl << endl;
        return ans;
    }
    void print() {
        for (int i = 5; i >= 0; i--) cout << cnt[i] << ' ';
        cout << endl;
    }
};

bool operator < (const my_num a, const my_num b) {
    for (int i = MAX_N - 1; i >= 0; i--) {
        if (a.cnt[i] != b.cnt[i]) return (a.cnt[i] < b.cnt[i]);
    }
    return 0;
}

struct edge{
    int x, y, num;
    my_num w;
    edge(int x, int y, int num, my_num w) {
        this->x = x;
        this->y = y;
        this->num = num;
        this->w = w;
    }
};

vector <edge> g[MAX_N];

int main() {
    int n, m, k, x, y;
    cin >> n >> m >> k;
    pair <int, int> arr[k];
    int pos_to_num[n][m];
    pair <int, int> num_to_pos[k];
    for (int i = 0; i < k; i++) {
        cin >> x >> y;
        arr[i] = {x, y};
        pos_to_num[x][y] = k;
        num_to_pos[i] = {x, y};
    }
    int pos;
    for (int i = 0; i < k; i++) {
        for (int j = 0; j < k; j++) {
            if (i == j) continue;
            pos = max(abs(num_to_pos[i].first - num_to_pos[j].first), abs(num_to_pos[i].second - num_to_pos[j].second));
            //cout << i << ' ' << j << ' ' << pos << endl;
            g[i].push_back(edge(num_to_pos[j].first, num_to_pos[j].second, j, my_num(pos)));
        }
    }
    my_num dist[k];
    dist[0] = my_num();
    bool visited[k];
    set <pair <my_num, int> > dists;
    for (int i = 1; i < k; i++) {
        dist[i].full();
        visited[i] = 0;
        dists.insert(make_pair(dist[i], i));
    }
    vector <int> q;
    int v = 0;
    int prevv[k];
    prevv[0] = -1;
    while (1) {
        //cout << v << endl;
        //dist[v].print();
        visited[v] = 1;
        for (edge elem : g[v]) {
            if (!visited[elem.num] && dist[v] + elem.w < dist[elem.num]) {
                dists.erase({dist[elem.num], elem.num});
                dists.insert({dist[v] + elem.w, elem.num});
                dist[elem.num] = dist[v] + elem.w;
                prevv[elem.num] = v;
            }
        }
        if (dists.empty()) break;
        v = (*dists.begin()).second;
        dists.erase(*dists.begin());
    }
    vector <int> ans;
    int now = k - 1;
    while (now != -1) {
        ans.push_back(now);
        now = prevv[now];
    }
    cout << ans.size() << endl;
    for (int i = ans.size() - 1; i >= 0; i--) cout << ans[i] + 1 << ' ';
    cout << endl;
    return 0;
}
