#include <bits/stdc++.h>

using namespace std;

int n;

void build(int v, int tree_l, int tree_r, vector <pair <int, int> > &tree, vector <int> &a)
{
    if (tree_l + 1 == tree_r)
    {
        tree[v] = {tree_l, tree_l};
        return;
    }

    int tree_m = (tree_r + tree_l) / 2;

    build(2 * v, tree_l, tree_m, tree, a);
    build(2 * v + 1, tree_m, tree_r, tree, a);

    tree[v] = tree[2 * v + 1];
    if (a[tree[2 * v].first] <= a[tree[2 * v + 1].first])
    {
        tree[v].first = tree[2 * v].first;
    }

    if (a[tree[2 * v].second] >= a[tree[2 * v + 1].second])
    {
        tree[v].second = tree[2 * v].second;
    }

}

pair <int, int> get(int v, int tree_l, int tree_r, int left, int right, vector <pair <int, int> > &tree, vector <int> &a)
{
    if (left <= tree_l && tree_r <= right)
    {
        return tree[v];
    }

    if (left >= tree_r || right <= tree_l)
    {
        return {-2, -2};
    }

    int tree_m = (tree_r + tree_l) / 2;

    pair <int, int> first_son = get(2 * v, tree_l, tree_m, left, right, tree, a);
    pair <int, int> second_son = get(2 * v + 1, tree_m, tree_r, left, right, tree, a);

    if (first_son.first == -2)
    {
        return second_son;
    }

    if (second_son.first == -2)
    {
        return first_son;
    }

    pair <int, int> res = second_son;
    if (a[first_son.first] <= a[second_son.first])
    {
        res.first = first_son.first;
    }

    if (a[first_son.second] >= a[second_son.second])
    {
        res.second = first_son.second;
    }

    return res;
}

int solve(vector <int> &a, int left, int right, vector <pair <int, int> > &tree)
{
    pair <int, int> g = get(1, 0, n, left, right, tree, a);
    int mx = g.second, mn = g.first;

    if (mn == left && mx + 1 == right)
    {
        return 1;
    }

    if (mx + 1 == right)
    {
        return solve(a, left, mn, tree) + solve(a, mn, right, tree);
    }

    return solve(a, left, mx + 1, tree) + solve(a, mx + 1, right, tree);
}

int main()
{
    vector <pair <int, int> > tree(4 * n + 1, {-2, -2});
    cin >> n;
    vector <int> a(n, 0);

    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }

    build(1, 0, n, tree, a);

    cout << solve(a, 0, n, tree);
}
