#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<vector>
#include<algorithm>
#include<stdio.h>
#include<math.h>
#include<string>
#include<stack>
#include<queue>
#include<set>
#include<map>
#include<tuple>

using namespace std;

struct node {
	pair<int,int> x;
	long long y = rand() << 16 + rand();
	int sz = 1;
	node*l = NULL, *r = NULL;
	node() {};
	node(pair<int,int> x) :x(x) {};
};

int safe(node*a) {
	return a == NULL ? 0 : a->sz;
}

void recalc(node*a) {
	if (a != NULL) {
		a->sz = safe(a->l) + safe(a->r) + 1;
	}
}

node*merge(node*a, node*b) {
	if (a == NULL) {
		return b;
	}
	if (b == NULL) {
		return a;
	}
	if (a->y > b->y) {
		a->r = merge(a->r, b);
		recalc(a); 
		return a;
	}
	b->l = merge(a, b->l);
	recalc(b);
	return b;
}

pair<node*, node*>split(node*a, pair<int,int> x) {
	if (a == NULL) {
		return make_pair(a, a);
	}
	if (a->x > x) {
		pair<node*, node*>t = split(a->l, x);
		a->l = t.second;
		t.second = a;
		recalc(a);
		return t;
	}
	pair<node*, node*>t = split(a->r, x);
	a->r = t.first;
	t.first = a;
	recalc(a);
	return t;
}

void add(node*&a, pair<int,int> x) {
	pair<node*, node*>t = split(a, x);
	node*n = new node(x);
	t.first = merge(t.first, n);
	a = merge(t.first, t.second);
}

int get(node*a, pair<int,int> x) {
	pair<node*, node*>t = split(a, x);
	int ans = safe(t.first);
	a = merge(t.first, t.second);
	return ans;
}

void del(node*&a) {
	if (a == NULL) {
		return;
	}
	del(a->l);
	del(a->r);
	delete a;
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, p;
	cin >> n >> p;
	vector<int>v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	if (p == 2) {
		vector<int>ans(n, 0);
		vector<pair<int,int>>x(n);
		for (int i = 0; i < n; i++) {
			x[i] = { i + v[i],i };
		}
		sort(x.begin(), x.end());
		int last = x[0].first;
		ans[x[0].second] = 0;
		for (int i = 1; i < n; i++) {
			if (last < x[i].first) {
				last = x[i].first;
				ans[x[i].second] = i;
			}
			else {
				ans[x[i].second] = ans[x[i - 1].second];
			}
		}
		for (int i = 0; i < n; i++) {
			x[i] = { n-1-i+v[i],i };
		}
		sort(x.begin(), x.end());
		last = x[0].first;
		for (int i = 1; i < n; i++) {
			if (last < x[i].first) {
				last = x[i].first;
				ans[x[i].second] = max(ans[x[i].second],i);
			}
			else {
				ans[x[i].second] = max(ans[x[i].second],ans[x[i - 1].second]);
			}
		}
		for (int i = 0; i < n; i++) {
			int x = v[i] + min(i, n - i - 1);
			int a = 0;
			for (int j = 0; j < n; j++) {
				int y = v[j];
				if (j < i) {
					if (j > 2 * i - n) {
						y += min(i, n - i - 1) + (j - i);
					}
				}
				else {
					if (j < 2 * i) {
						y += min(i, n - i - 1) - (j - i);
					}
				}
				if (y < x) {
					a++;
				}
			}
			ans[i] = max(a, ans[i]);
			cout << ans[i]+1 << '\n';
		}
		return 0;
	}
	vector<int>ans(n, 0);
	node*a = NULL;
	for (int i = 0; i < n; i++) {
		int x = get(a, { v[i]-i,-i });
		ans[i] = x;
		add(a, { v[i]-i,i });
	}
	del(a);
	a = NULL;
	for (int i = n-1; i >=0 ; i--) {
		int x = get(a, { v[i]-(n-i),-i });
		ans[i] += x;
		add(a, { v[i]-(n-i),i });
	}
	for (int i = 0; i < n; i++) {
		cout << ans[i]+1 << '\n';
	}
}