#include <iostream>
#include <vector>
#define endl '\n'

using namespace std;

typedef long long ll;

struct node {
    ll val;
    int size;
    ll y;
    node *left, *right;
    node(ll x = 0) {
        val = x;
        size = 1;
        y = rand();
        left = 0;
        right = 0;
    }
};

int gets(node *root) {
    if (!root) {
        return 0;
    }
    return root->size;
}

void relax(node *root) {
    if (!root) {
        return;
    }
    root->size = gets(root->right) + gets(root->left) + 1;
}

pair<node*, node*> split(node *root, ll x) {
    if (!root) {
        return {0, 0};
    }
    if (root->val <= x) {
        auto res = split(root->right, x);
        root->right = res.first;
        relax(root);
        return {root, res.second};
    }
    else {
        auto res = split(root->left, x);
        root->left = res.second;
        relax(root);
        return {res.first, root};
    }
}

node* merge(node *l, node *r) {
    if (!l) {
        return r;
    }
    if (!r) {
        return l;
    }
    if (l->y < r->y) {
        r->left = merge(l, r->left);
        relax(r);
        return r;
    }
    else {
        l->right = merge(l->right, r);
        relax(l);
        return l;
    }
}

void del(node *&root, ll x) {
    auto res = split(root, x);
    auto res2 = split(res.first, x - 1);
    root = merge(res2.first, res.second);
}

void add(node *&root, ll x) {
    auto cr = new node(x);
    auto res = split(root, x);
    root = merge(merge(res.first, cr), res.second);
}

int kth(node *&root, ll x) {
    auto res = split(root, x - 1);
    int ans = gets(res.first);
    root = merge(res.first, res.second);
    return ans;
}

int f(int ind, int a, int b) {
    return min(abs(ind - a), abs(ind - b));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    int n, p;
    cin >> n >> p;
    vector<ll> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    if (p == 1) {
        node *l = 0, *r = 0;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            add(r, (v[i] + i) * 1000000 + i);
        }
        for (int i = 0; i < n; ++i) {
            ans = kth(l, (v[i] - i) * 1000000) + kth(r, (v[i] + i) * 1000000);
            add(l, (v[i] - i) * 1000000 + i);
            del(r, (v[i] + i) * 1000000 + i);
            cout << ans + 1 << endl;
        }
    }
    else {
        for (int i = 0; i < n; ++i) {
            int ans = 0;
            if (i * 2 >= n) {
                int cans = 0;
                int d = f(i, 0, 0);
                for (int j = 0; j < n; ++j) {
                    if (v[j] + j < v[i] + d) {
                        ans++;
                    }
                }
                
                d = n - i - 1;
                for (int j = 0; j < n; ++j) {
                    if (v[j] + (abs(i - j) < d ? f(j, n - 1, i - d) : 0) < v[i] + d) {
                        cans++;
                    }
                }
                cout << max(ans, cans) + 1 << endl;
            }
            else {
                int cans = 0;
                int d = f(i, n - 1, n - 1);
                for (int j = 0; j < n; ++j) {
                    if (v[j] + f(j, n - 1, n - 1) < v[i] + d) {
                        ans++;
                    }
                }
                
                d = i;
                for (int j = 0; j < n; ++j) {
                    if (v[j] + (abs(i - j) < d ? f(j, 0, i + d) : 0) < v[i] + d) {
                        cans++;
                    }
                }
                
                cout << max(ans, cans) + 1 << endl;
            }
        }
    }
}