#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;

struct Node{
    Node* left;
    Node* right;
    pair <int, int> val;
    int l, r;
    Node(int l1, int r1) {
        left = nullptr;
        right = nullptr;
        val = {0, 0};
        l = l1;
        r = r1;
    }
};

Node* build(int l, int r) {
    Node* v = new Node(l, r);
    if (r - l > 1) {
        v -> left = build(l, (l + r) / 2);
        v -> right = build((l + r) / 2, r);
    }
    return v;
}

void update(Node* v) {
    v -> val = max(v -> left -> val, v -> right -> val);
}

void change(Node* v, int k, int x) {
    if (k < v -> l || k >= v -> r) return;
    if (v -> l == k && v -> r == k + 1) {
        v -> val = {x, k};
        return;
    }
    change(v -> left, k, x);
    change(v -> right, k, x);
    update(v);
}

pair <int, int> get(Node* v, int l, int r) {
    if (v -> l >= r || v -> r <= l) return {0, 0};
    if (v -> l >= l && v -> r <= r) return v -> val;
    return max(get(v -> left, l, r), get(v -> right, l, r));
}

int main()
{
    int n;
    cin >> n;
    vector <int> a(n);
    Node* root = build(0, n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        change(root, i, a[i]);
    }
    int cur = 0, ans = 0;
    for (int i = 1; i < n; i++) {
        if (a[i] < a[cur]) {
            while (cur < i) {
                auto temp = get(root, cur, i);
                cur = temp.second + 1;
                ans++;
            }
        }
    }
    while (cur < n) {
        auto temp = get(root, cur, n);
        cur = temp.second + 1;
        ans++;
    }
    cout << ans;
    return 0;
}
