#include <iostream>
#include <algorithm>
#include <queue>
#include <stack>
#include <vector>

using namespace std;
typedef long long ll;

#define size(v) ((int)v.size())
#define all(v) v.begin(), v.end()

const int maxn = 400000;
int a[maxn], b[maxn], c[maxn];
int n;

void bfs() {
	queue<int> q;
	for (int i = 0; i < n; ++i)
		if (b[i] == 0)
			q.push(i);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		if (v + 1 < n && b[v + 1] > b[v] + 1) {
			b[v + 1] = b[v] + 1;
			q.push(v + 1);
		}
		if (v - 1 > -1 && b[v - 1] > b[v] + 1) {
			b[v - 1] = b[v] + 1;
			q.push(v - 1);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> a[0];
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int m = 1; m < (1 << n); ++m) {
		fill(b, b + n, (int)1e9);
		for (int i = 0; i < n; ++i)
			if (m & (1 << i))
				b[i] = 0;
		bfs();
		for (int i = 0; i < n; ++i) {
			int cnt = 0;
			for (int j = 0; j < n; ++j)
				if (b[j] + a[j] < b[i] + a[i])
					++cnt;
			c[i] = max(c[i], cnt);
		}
	}
	for (int i = 0; i < n; ++i)
		cout << c[i] + 1 << '\n';
	return 0;
}