#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define IO ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

const int MAXN = 1 << 19, LG = 20;
int a[MAXN];
int t[MAXN];
int nxt[MAXN][LG];
const int INF = 2e9;

struct seg_tree {
	seg_tree() {
		for (int i = 0; i < MAXN * 2; ++i)
			t[i] = INF;
	}
	void build(int v, int vl, int vr) {
		if (vl == vr) {
			t[v] = a[vl];
			return;
		}
		int vm = (vl + vr) / 2;
		build(v * 2, vl, vm);
		build(v * 2 + 1, vm + 1, vr);
		t[v] = min(t[v * 2], t[v * 2 + 1]);
	}
	void build() {
        build(1, 0, MAXN - 1);
	}
	int get_min(int v, int vl, int vr, int l, int r) {
		if (vl > r || vr < l) return INF;
		if (l <= vl && vr <= r) return t[v];
		int vm = (vl + vr) / 2;
		return min(get_min(v * 2, vl, vm, l, r), get_min(v * 2 + 1, vm + 1, vr, l, r));
	}
	int get_min(int l, int r) {
		return get_min(1, 0, MAXN - 1, l, r);
	}
};

seg_tree kek;

bool ok(int l, int r) {
	return kek.get_min(l, r) == a[l];
}

int main() {
	IO;

	//freopen("inputA.txt", "r", stdin);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = n; i < MAXN; ++i)
		a[i] = INF;
	kek.build();
	vector<pair<int, int>> s;
	for (int i = 0; i < n; ++i) {
		while (!s.empty()) {
			if (s.back().f <= a[i]) {
				nxt[s.back().s][0] = i;
				s.pop_back();
			}
			else break;
		}
		s.pb({a[i], i});
	}
    for (auto i : s)
        nxt[i.s][0] = i.s;
	for (int i = n - 1; i >= 0; --i)
		for (int lg = 1; lg < LG; ++lg)
			nxt[i][lg] = nxt[nxt[i][lg - 1]][lg - 1];

	int l = 0, ans = 0;
	while (l < n) {
		int to = l;
		int cl = l;
		for (int lg = LG - 1; lg >= 0; --lg) {
			int to = nxt[cl][lg];
			if (ok(l, to))
				cl = to;
		}
		++ans;
		l = cl + 1;
	}
	cout << ans;
	return 0;
}
