#include <bits/stdc++.h>

#define f first
#define s second
#define pb push_back
#define IO ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)
#define all(a) (a).begin(), (a).end()
using namespace std;

template<typename T1, typename T2> inline void chkmin(T1 & x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2> inline void chkmax(T1 & x, T2 y) {if (x < y) x = y;}

const int MAXN = 4e5 + 100;
int a[MAXN], ans[MAXN];
int n;

struct fnw {
	int *t;
	fnw() {
		t = new int[MAXN];
		memset(t, 0, sizeof(int) * MAXN);
	}
	void reset() {
        memset(t, 0, sizeof(int) * MAXN);
    }
	void add(int pos, int val) {
		for (int i = pos; i < MAXN; i |= (i + 1))
			t[i] += val;
	}
	int get_sum(int r) {
		int res = 0;
		for (int i = r; i > 0; i = (i & (i + 1)) - 1)
			res += t[i];
		return res;
	}
};

int get_less(fnw & a, int r) {
	return a.get_sum(r - 1);
}

int get(int i, int l, int r) {
    if (l <= -1 && r >= n) return 0;
    int ct = a[i], res = 0;
    if (r >= n) {
        ct += i - l;
        for (int i = 0; i <= l; ++i)
            res += a[i] < ct;
        for (int i = l + 1; i < n; ++i)
            res += (a[i] + i - l) < ct;
        return res;
    }
    if (l <= -1) {
        ct += r - i;
        for (int i = r; i < n; ++i)
            res += a[i] < ct;
        for (int i = 0; i < r; ++i)
            res += (a[i] + r - i) < ct;
        return res;
    }
    ct += min(i - l, r - i), res = 0;
    for (int i = 0; i <= l; ++i)
        res += a[i] < ct;
    for (int i = r; i < n; ++i)
        res += a[i] < ct;
    for (int i = l + 1; i < r; ++i)
        res += (a[i] + min(i - l, r - i)) < ct;
    return res;
}

struct node {
    int x, y, add, cnt, sz;
    node *l, *r;
    node(int _x) {
        x = _x;
        cnt = sz = 1;
        y = (rand() << 16) + rand();
        add = 0;
        l = r = nullptr;
    }
};

void add(node *v, int val) {
    if (!v) return;
    v->x += val;
    v->add += val;
}

void push(node *a) {
    if (!a) return;
    add(a->l, a->add);
    add(a->r, a->add);
    a->add = 0;
}

int get_sz(node *a) {
    if (!a) return 0;
    return a->sz;
}

void upd(node *a) {
    if (!a) return;
    a->sz = a->cnt + get_sz(a->l) + get_sz(a->r);
}

pair<node*, node*> split(node *a, int x) {
    if (!a) return {nullptr, nullptr};
    push(a);
    if (a->x <= x) {
        auto tmp = split(a->r, x);
        a->r = tmp.f;
        upd(a);
        return {a, tmp.s};
    }
    else {
        auto tmp = split(a->l, x);
        a->l = tmp.s;
        upd(a);
        return {tmp.f, a};
    }
}

node *merge(node *a, node *b) {
    if (!a) return b;
    if (!b) return a;
    if (a->y > b->y) {
        push(a);
        a->r = merge(a->r, b);
        upd(a);
        return a;
    }
    else {
        push(b);
        b->l = merge(a, b->l);
        upd(b);
        return b;
    }
}

void add_el(node * &a, int x) {
    auto tmp = split(a, x - 1);
    auto tmp1 = split(tmp.s, x);
    if (!tmp1.f)
        tmp1.f = new node(x);
    else {
        ++tmp1.f->cnt;
        ++tmp1.f->sz;
    }
    a = merge(tmp.f, merge(tmp1.f, tmp1.s));
}

void del_el(node * &a, int x) {
    auto tmp = split(a, x - 1);
    auto tmp1 = split(tmp.s, x);
    //cout << "deleting" << x << endl;

    --tmp1.f->cnt, --tmp1.f->sz;
    if (!tmp1.f->cnt)
        tmp1.f = nullptr;

    a = merge(tmp.f, merge(tmp1.f, tmp1.s));
}

int get_less(node *a, int x) {
    if (!a) return 0;
    push(a);
    if (a->x <= x)
        return get_sz(a->l) + get_less(a->r, x) + a->cnt * (a->x < x);
    else
        return get_less(a->l, x);
}

int main() {
    IO;
    //freopen("inputC.txt", "r", stdin);
    int p;
    cin >> n >> p;
    vector<int> after_as(n), before_as(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        after_as[i] = a[i] + i + 1;
        before_as[i] = a[i] - i;
    }

    unordered_map<int, int> dafter, dbefore;
    sort(all(after_as));
    sort(all(before_as));
    int nafter = unique(all(after_as)) - after_as.begin();
    int nbefore = unique(all(before_as)) - before_as.begin();

    for (int i = 0; i < nafter; ++i) {
    	dafter[after_as[i]] = i + 1;
    }
    for (int i = 0; i < nbefore; ++i) {
    	dbefore[before_as[i]] = i + 1;
    }

    if (p == 1) {
    	fnw after, before;

        for (int i = 0; i < n; ++i)
            after.add(dafter[a[i] + i + 1], 1);
        for (int i = 0; i < n; ++i) {
        	after.add(dafter[a[i] + i + 1], -1);

            ans[i] = get_less(before, dbefore[a[i] - i]) + get_less(after, dafter[a[i] + i + 1]) + 1;

            before.add(dbefore[a[i] - i], 1);
        }
    }
    else {
        for (int i = 0; i < n; ++i) {
            node *l, *r, *mid;
            //solving for left
            l = r = mid = nullptr;
            for (int i = 0; i < n; ++i) {
                add_el(mid, a[i] + i + 1);
            }
            for (int lb = 0; lb < n; ++lb) {
                add(mid, -1);
                del_el(mid, a[lb]);
                add_el(l, a[lb]);
                //chkmax(ans[i], get_less(l, a[i] + max(0, i - lb)) + get_less(mid, a[i] + max(0, i - lb)));
            }
            //solving for right
            /*l = r = mid = nullptr;
            for (int i = 0; i < n; ++i)
                add_el(mid, a[i] + n - i);
            for (int rb = n - 1; rb >= 0; --rb) {
                add(mid, -1);
            	del_el(mid, a[rb]);
            	add_el(r, a[rb]);
            	//chkmax(ans[i], get_less(mid, a[i] + max(0, rb - i)) + get_less(r, a[i] + max(0, rb - i)));
            }
            //solving for both
            l = r = mid = nullptr;
            int lb = i - 1, rb = i + 1, cd = 1;
            while (lb >= 0 && rb < n) {
                ++cd;
                --lb;
                ++rb;
            }
            --cd, ++lb, --rb;
            for (int i = lb + 1; i < rb; ++i)
                add_el(mid, a[i] + min(abs(rb - i), abs(lb - i)));
            for (int i = 0; i <= lb; ++i)
                add_el(l, a[i]);
            for (int i = rb; i < n; ++i)
                add_el(r, a[i]);
            //chkmax(ans[i], get_less(l, a[i] + cd) + get_less(r, a[i] + cd) + get_less(mid, a[i] + cd));

            while (cd > 1) {
                --cd;
                ++lb, --rb;
                add(mid, -1);
                del_el(mid, a[lb]);
                del_el(mid, a[rb]);
                add_el(l, a[lb]);
                add_el(r, a[rb]);

                //chkmax(ans[i], get_less(l, a[i] + cd) + get_less(r, a[i] + cd) + get_less(mid, a[i] + cd));
            }/**/
            for (int dist = 0; dist < n; ++dist)
                chkmax(ans[i], get(i, i - dist, i + dist));
        }
    }
    //cout << "ans" << endl;
    for (int i = 0; i < n; ++i)
        cout << ans[i] + 1 << '\n';
    return 0;
}
