#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <fstream>
#include <algorithm>
#include <iomanip>
#include <ctime>
#define ll long long
#define null NULL
#define int long long

using namespace std;

const ll MOD = 1e9 + 7;

struct solver {

	int n;
	vector<int> a, b;

	solver() {}

	void init(vector<int> _a) {
		a = _a;
		n = a.size();
		b.resize(n);
	}

	void add(int val) {
		//cout << "adding " << val << endl;
		int pos = lower_bound(a.begin(), a.end(), val) - a.begin();
		for (int i = 0; i <= pos; ++i) {
			b[i]++;
		}
	}

	int get(int val) {
		//cout << "getting " << val << endl;
		int res = 0;
		int pos = upper_bound(a.begin(), a.end(), val) - a.begin();
		for (int i = 0; i < pos; ++i) {
			res = max(res, a[i] * b[i]);
		}
		//cout << "returned " << res << endl;
		return res;
	}

};

struct buyer {
	int a, b;
	buyer() {}
};

bool a_cmp(buyer a, buyer b) {
	return a.a < b.a;
}

bool b_cmp(buyer a, buyer b) {
	return a.b < b.b;
}

const int INF = 2e9;
int n, ans;
vector<buyer> a;
vector<int> bs;
solver S;

signed main() {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].a >> a[i].b;
	}
	sort(a.begin(), a.end(), a_cmp);
	for (int i = 0; i < n; ++i) {
		bs.push_back(a[i].b);
	}
	int plus_price = a[0].a;
	int plus_cnt = n;
	ans = plus_price * plus_cnt;
	S.init(bs);
	//cout << "ans0 = " << ans << endl;
	for (int i = 0; i < n; ++i) {
		if (i == n - 1)
			plus_price = INF;
		else
			plus_price = a[i + 1].a;
		plus_cnt--;
		int res = plus_cnt * plus_price;
		//cout << "plus_price = " << plus_price << endl;
		//cout << "res0 = " << res << endl;
		S.add(a[i].b);
		res += S.get(plus_price);
		//cout << "res1 = " << res << endl;
		ans = max(ans, res);
	}
	cout << ans << endl;
}