#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

#define inb push_back
#define X first
#define Y second
#define all(v) (v).begin(), (v).end()

const int M = 4e5 + 5;

int n, p, a[M], ans[M], mx[M], mn[M], d[M], bans[M], t[M];

int nxt(int k) { return k | (k + 1); }
int prv(int k) { return (k & (k + 1)) - 1; }

int get(int x)
{
	int ans = 0;
	for (int i = x; i >= 0; i = prv(i))
		ans += t[i];
	return ans;
}

void upd(int x)
{
	for (int i = x; i < n; i = nxt(i))
		t[i]++;
}

void update()
{
	for (int i = 0; i < n; ++i)
		bans[i] = ans[i];
	sort(bans, bans + n);
	for (int i = n - 1, x; i >= 0; --i)
	{
		x = lower_bound(bans, bans + n, ans[i]) - bans;
		mn[i] += get(x - 1);
		upd(x);
	}
	fill(t, t + n, 0);
	int bal = 0;
	for (int i = 0; i < n; ++i)
		bans[i] = ans[i] - bal, bal += 2;
	sort(bans, bans + n);
	bal = 0;
	for (int i = 0, x; i < n; ++i)
	{
		x = lower_bound(bans, bans + n, ans[i] - bal) - bans;
		mn[i] += get(x - 1);
		upd(x);
		bal += 2;
	}
	for (int i = 0; i < n; ++i)
		mx[i] = mn[i] + 1;
}

void solve(int msk)
{
	int l = 0, r = 0;
	for (int j = 0; j < n; ++j)
		if (msk & (1 << j))
			d[l++] = j;
	for (int i = 0; i < n; ++i)
	{
		if (msk & (1 << i)) ++r;
		int x = n;
		if (r) x = min(x, abs(i - d[r - 1]));
		x = min(x, abs(i - d[r]));
		ans[i] = x + a[i];
		bans[i] = ans[i];
	}
	sort(bans, bans + n);
	for (int i = 0; i < n; ++i)
	{
		int x = lower_bound(bans, bans + n, ans[i]) - bans;
		mx[i] = max(mx[i], x + 1);
	}
}

void check(int l, int r)
{
	for (int i = 0; i < n; ++i)
	{
		ans[i] = a[i];
		if (l < i && i < r) ans[i] += min(i - l, r - i);
		bans[i] = ans[i];
	}
	sort(bans, bans + n);
	for (int i = 0; i < n; ++i)
		mx[i] = max(mx[i], (int)(lower_bound(bans, bans + n, ans[i]) - bans + 1));
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> p;
	for (int i = 0; i < n; ++i) cin >> a[i];

	if (p == 1)
	{
		for (int i = 0; i < n; ++i)
			ans[i] = i + a[i];
		update();
	}
	else
	{
		for (int i = -1; i < n; ++i)
			for (int j = n; j > i; --j)
				check(i, j);
	}

	for (int i = 0; i < n; ++i)
		cout << mx[i] << '\n';
}