#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <string>
#include <ctime>
#include <cstring>
#include <bitset>

#define fi first
#define se second

using namespace std;
const long long MAXN = 2e5;
const long long INF = 1e9 + 100;
const long long INFL = 1e18 + 100;

struct V{
    long long x;
    long long max_x;
    pair<long long, long long> fp;
    long long l;
    long long r;

    V(){
        x = 0;
        max_x = 0;
        fp = {0, 0};
        l = -1;
        r = -1;
    }
};

struct Tree{
    long long sz;
    V mas[MAXN * 50];

    void Init(){
        sz = 1;
        mas[0] = V();
    }

    void Push(long long v, long long cl, long long cr){
        if (cl + 1 == cr){
            return;
        }

        if (mas[v].l == -1){
            mas[sz] = V();
            mas[v].l = sz++;
        }

        if (mas[v].r == -1){
            mas[sz] = V();
            mas[v].r = sz++;
        }

        long long cm = (cl + cr) / 2;

        long long u = mas[v].l;

        mas[u].fp = {mas[u].fp.fi + mas[v].fp.fi, mas[u].fp.se + mas[v].fp.se};
        mas[u].x += ((cm - cl - 1) * mas[v].fp.se + mas[v].fp.fi);
        mas[u].max_x = max(mas[u].max_x, mas[u].x);

        u = mas[v].r;

        mas[u].fp = {mas[u].fp.fi + mas[v].fp.fi + (cm - cl) * mas[v].fp.se, mas[u].fp.se + mas[v].fp.se};
        mas[u].x += ((cr - cl - 1) * mas[v].fp.se + mas[v].fp.fi);
        mas[u].max_x = max(mas[u].max_x, mas[u].x);

        mas[v].fp = {0, 0};
    }

    void Add(long long v, long long l, long long r, long long cl, long long cr, long long a, long long b){
        if ((cr <= l) || (r <= cl)){
            return;
        }

        Push(v, cl, cr);

        if ((l <= cl) && (cr <= r)){
            mas[v].x += (cr - cl - 1) * b + a;
            mas[v].fp.fi += a;
            mas[v].fp.se += b;
            mas[v].max_x = max(mas[v].max_x, mas[v].x);
        } else {
            long long cm = (cl + cr) / 2;

            Add(mas[v].l, l, r, cl, cm, a, b);
            Add(mas[v].r, l, r, cm, cr, a + (cm - cl) * b, b);

            mas[v].max_x = max(mas[mas[v].l].max_x, mas[mas[v].r].max_x);
        }
    }

    void Add(long long l, long long r, long long a, long long b){
        Add(0, l, r, 0, INF, a, b);
    }

    long long Get(long long v, long long l, long long r, long long cl, long long cr){
        if ((r <= cl) || (cr <= l)){
            return -INFL;
        }

        Push(v, cl, cr);

        if ((l <= cl) && (cr <= r)){
            return mas[v].max_x;
        } else {
            long long cm = (cl + cr) / 2;

            return max(Get(mas[v].l, l, r, cl, cm), Get(mas[v].r, l, r, cm, cr));
        }
    }

    long long Get(long long l, long long r){
        return Get(0, l, r, 0, INF);
    }
};

long long n;
Tree tr;

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    tr.Init();

    for (long long i = 0; i < n; ++i){
        long long a, b;
        cin >> a >> b;
        tr.Add(0, a + 1, 0, 1);
    }

    cout << tr.Get(0, INF) << endl;

    return 0;
}
