#include <iostream>
#include <vector>
#include <cmath>
#include <cstdio>
#include <cstdlib>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <bitset>
#include <ctime>
#include <string>
#include <cstring>
#include <deque>

#define fi first
#define se second

using namespace std;
const int MAXN = 4e5 + 100;
const int INF = 1e9 + 100;

struct Fenv{
    int mas[MAXN * 2];

    void Init(){
        fill(mas, mas + MAXN * 2, 0);
    }

    int Get(int i){
        int ans = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1){
            ans += mas[i];
        }
        return ans;
    }

    int Get(int l, int r){
        return Get(r - 1) - Get(l - 1);
    }

    void Upd(int i, int x){
        for (; i < MAXN * 2; i = (i | (i + 1))){
            mas[i] += x;
        }
    }
};

int n, p;
int mas[MAXN];
Fenv fn;
int ans[MAXN];

bool pr(int v){
    return ((0 <= v) && (v < n));
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n >> p;
    for (int i = 0; i < n; ++i){
        cin >> mas[i];
    }

    if (p == 1){
        vector<int> st;
        for (int i = 0; i < n; ++i){
            st.push_back(mas[i] + (n - i - 1));
            st.push_back(mas[i] + i);
        }

        sort(st.begin(), st.end());
        auto it = unique(st.begin(), st.end());
        st.erase(it, st.end());

        unordered_map<int, int> mp;
        int o = 0;

        for (auto e : st){
            mp[e] = o++;
        }

        fn.Init();

        for (int i = 0; i < n; ++i){
            int a = mp[mas[i] + (n - i - 1)];
            fn.Upd(a, 1);
            ans[i] += fn.Get(0, a);
        }

        fn.Init();
        for (int i = n - 1; i >= 0; --i){
            int a = mp[mas[i] + i];
            fn.Upd(a, 1);
            ans[i] += fn.Get(0, a);
        }
        for (int i = 0; i < n; ++i){
            cout << ans[i] + 1 << '\n';
        }
        cout << endl;
    } else {
        for (int i = 0; i < n; ++i){
            for (int j = 0; j <= n; ++j){
                vector<int> d(n, INF);
                deque<int> dq;

                for (int l = 0; l < n; ++l){
                    if (abs(l - i) >= j){
                        d[l] = 0;
                        dq.push_back(l);
                    }
                }

                if (dq.size() == 0){
                    break;
                }

                while (dq.size()){
                    int v = dq.front();
                    dq.pop_front();

                    if (pr(v - 1) && (d[v - 1] > d[v] + 1)){
                        d[v - 1] = d[v] + 1;
                        dq.push_back(v - 1);
                    }

                    if (pr(v + 1) && (d[v + 1] > d[v] + 1)){
                        d[v + 1] = d[v] + 1;
                        dq.push_back(v + 1);
                    }
                }

                vector<int> m2(n);
                for (int l = 0; l < n; ++l){
                    m2[l] = mas[l] + d[l];
                }

                int kek = 0;
                for (int l = 0; l < n; ++l){
                    if (m2[i] > m2[l]) kek++;
                }

                ans[i] = max(ans[i], kek + 1);
            }
            cout << ans[i] << '\n';
        }
        cout << endl;
    }

    return 0;
}
