#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>	
#include <math.h>
#include <string>
using namespace std;
typedef long long ll;
typedef long double db;
#define fs first
#define sc second
#define endl '\n'
#define sz size()
#define mp make_pair
#define all(g) (g.begin()),(g.end())

struct Node {
	int x, y;
	Node(int xx = -1e9, int yy = -1) :x(xx), y(yy) {}
	Node operator +(Node d) {
		if (x == d.x) {
			if (y > d.y)return *this;
			else return d;
		}
		if (x > d.x)
			return *this;
		return d;
	}
};
const int max_n = 1 << 19;

struct Segment_Tree {
#define tm (tl+tr)/2
	vector<Node> t;
	Segment_Tree(vector<int> a) {
		t.resize(max_n * 2, Node());
		for (int i = 0; i < a.size(); i++) {
			t[i + max_n] = Node(a[i], i);
		}
		for (int i = max_n - 1; i >= 1; i--) {
			t[i] = t[i * 2] + t[i * 2 + 1];
		}
	}
	Node get(int l, int r, int v = 1, int tl = 0, int tr = max_n - 1) {
		if (tr<l || tl>r)return Node();
		if (tl >= l && tr <= r)return t[v];
		return get(l, r, v * 2, tl, tm) + get(l, r, v * 2 + 1, tm + 1, tr);
	}
};


signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<int> a(n + 1);
	vector<int> pos(n, n);
	for (int i = 0; i < n; i++)
		cin >> a[i];
	a[n] = -1e9;
	vector<int> st;
	st.push_back(n);
	for (int i = 0; i < n; i++) {
		while (a[st.back()] > a[i]) {
			pos[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}
	int ans = 0;
	int l = 0;
	Segment_Tree t = *new Segment_Tree(a);
	while (l != n) {
		int r = t.get(l, pos[l]).y;
		ans++;
		l = r + 1;
	}
	cout << ans << endl;
#ifdef _MSC_VER
	system("pause");
#endif
	return 0;
}