#include <algorithm>
#include <string>
#include <bitset>
#include <map>
#include <set>
#include <queue>
#include <utility>
#include <cassert>
#include <cstdio>
#include <cmath>
#include <fstream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

template<class C> void chkmin(C& a, C b) { if (a > b) a = b; }
template<class C> void chkmax(C& a, C b) { if (a < b) a = b; }

#include <iostream>
//ifstream cin("test.in");
//ofstream cout("test.out");

const int MAXN = 4e5 + 7;

pair<int, int> a[MAXN];
pair<int, int> reserv[MAXN];
int res[MAXN];

void Count(int l, int r) {
	if (l >= r - 1) return;
	int m = (l + r) / 2;
	Count(l, m);
	Count(m, r);
	int i = l, j = m, k = l;
	while (i != m || j != r) {
		if (j == r || (i != m) && (a[i].first <= a[j].first)) {
			res[a[i].second] += j - m;
			reserv[k++] = a[i++];
		} else {
			reserv[k++] = a[j++];
		}
	}
	for (int i = l; i < r; ++i)
		a[i] = reserv[i];
}

int xs[MAXN];
int finres[MAXN];

int main() {
	int n, p;
	cin >> n >> p;
	for (int i = 0; i < n; ++i) {
		cin >> xs[i];
	}
	for (int i = 0; i < n; ++i) {
		a[i] = { xs[i] + i, i };
	}
	Count(0, n);
	for (int i = 0; i < n; ++i) {
		a[n - 1 - i] = { xs[i] + i, i };
	}
	Count(0, n);
	for (int i = 0; i < n; ++i) {
		finres[i] = res[i];
		res[i] = 0;
	}
	for (int i = 0; i < n; ++i) {
		a[n - 1 - i] = { xs[i] - i, i };
	}
	Count(0, n);
	for (int i = 0; i < n; ++i) {
		a[i] = { xs[i] - i, i };
	}
	Count(0, n);
	for (int i = 0; i < n; ++i) {
		chkmax(finres[i], res[i]);
		res[i] = 0;
		int d = min(i, n - 1 - i);
		int l = i - d;
		int r = i + d;
		//int l = max(0, 2 * i - n + 1);
		//int r = min(n, 2 * i + 1);
		for (int j = l; j < i; ++j) {
			res[i] += xs[j] < (xs[i] + i - j);
		}
		for (int j = i + 1; j < r; ++j) {
			res[i] += xs[j] < (xs[i] + j - i);
		}
		for (int j = 0; j < l; ++j) {
			res[i] += xs[j] < (xs[i] + d);
		}
		for (int j = r; j < n; ++j) {
			res[i] += xs[j] < (xs[i] + d);
		}
		chkmax(finres[i], res[i]);
	}
	for (int i = 0; i < n; ++i) {
		cout << finres[i] + 1 << '\n';
	}
}

