#include <fstream>
#include <iostream>
#include <cmath>
#include <vector>
#include <climits>

using namespace std;
int n;
vector<int> arr_min, arr_max, tree_min, tree_max;

int get_min(int x, int l, int r, int A, int B) {
    if (r < A or l > B) {
        return n;
    }
    if (A <= l and r <= B) {
        return tree_min[x];
    }
    int m = (l + r) / 2;
    int y = get_min(2 * x, l, m, A, B),
            z = get_min(2 * x + 1, m + 1, r, A, B);
    if (arr_min[y] <= arr_min[z]) {
        return y;
    } else {
        return z;
    }
}

int get_max(int x, int l, int r, int A, int B) {
    if (r < A or l > B) {
        return n;
    }
    if (A <= l and r <= B) {
        return tree_max[x];
    }
    int m = (l + r) / 2;
    int y = get_max(2 * x, l, m, A, B),
            z = get_max(2 * x + 1, m + 1, r, A, B);
    if (arr_max[y] > arr_max[z]) {
        return y;
    } else {
        return z;
    }
}

int find_result(int l, int r) {
    if (l > r or l < 0 or r > n - 1) {
        return 0;
    }
    if (l == r) {
        return 1;
    }
    int min_p = get_min(1, 1, n, l + 1, r + 1);
    int max_p = get_max(1, 1, n, l + 1, r + 1);
    if (min_p <= max_p) {
        return 1 + find_result(l, min_p - 1) + find_result(max_p + 1, r);
    } else {
        return find_result(max_p + 1, min_p - 1) + find_result(l, max_p) + find_result(min_p, r);
    }
}

int main() {
//    ifstream cin("input.txt");
    cin >> n;
    int size = (int) pow(2, ceil(log2(n)));
    arr_min.resize(size + 1, INT_MAX);
    arr_max.resize(size + 1, INT_MIN);
    tree_min.resize(2 * size, n);
    tree_max.resize(2 * size, n);
    for (int i = 0; i < n; i++) {
        cin >> arr_min[i];
        arr_max[i] = arr_min[i];
    }
    for (int i = 0; i < size; i++) {
        tree_min[i + size] = i;
        tree_max[i + size] = i;
    }
    for (int i = size - 1; i > 0; i--) {
        if (arr_min[tree_min[2 * i]] <= arr_min[tree_min[2 * i + 1]]) {
            tree_min[i] = tree_min[2 * i];
        } else {
            tree_min[i] = tree_min[2 * i + 1];
        }
        if (arr_max[tree_max[2 * i]] > arr_max[tree_max[2 * i + 1]]) {
            tree_max[i] = tree_max[2 * i];
        } else {
            tree_max[i] = tree_max[2 * i + 1];
        }
    }
    cout << find_result(0, n - 1);
    return 0;
}