#include <bits/stdc++.h>

using namespace std;

#define null NULL
#define ll long long
#define ld long double
#define prev prev228
#define left left228
#define right right228
#define index index228
#define forn(i, n) for (int i = 1; i <= (int)n; ++i)
#define firn(i, n) for (int i = 0; i < (int)n; ++i)


const int maxn = 300 * 1000 + 228, inf = 1e9 + 228;



struct node
{
	int mn;
	int l, r;
	node() {
		mn = inf;
		l = r = 0;
	}
};


struct Segment_Tree
{
	vector<node> d;

	Segment_Tree(int n) {
		int sz = 1;
		while (sz < n) sz <<= 1;
		sz <<= 1;
		d.resize(sz + 5, node());
	}


	void build(int l, int r, int v = 1) {
		d[v].l = l;
		d[v].r = r;
		if (l == r) return ;
		int m = (l + r) >> 1;
		build(l, m, v << 1);
		build(m + 1, r, v << 1 | 1);
	}


	void upd(int i, int x, int v = 1) {
		if (d[v].l == d[v].r) {
			d[v].mn = x;
		} else {
			int m = (d[v].l + d[v].r) >> 1;
			if (i <= m) {
				upd(i, x, v << 1);
			} else {
				upd(i, x, v << 1 | 1);
			}
			d[v].mn = min(d[v << 1].mn, d[v << 1 | 1].mn);
		}
	}

	int get(int l, int r, int v = 1) {
		if (l > r || d[v].l > r || d[v].r < l) {
			return inf;
		}
		if (l <= d[v].l && d[v].r <= r) {
			return d[v].mn;
		}
		return min(get(l, r, v << 1), get(l, r, v << 1 | 1));
	}
};


int a[maxn];

int dp[maxn], left[maxn];

int n;

void precalc() {
	vector<int> st;
	forn(i, n) left[i] = 0;
	for (int i = n; i > 0; --i) {
		while (!st.empty() && a[st.back()] < a[i]) {
			left[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}
}



signed main() {
	ios_base::sync_with_stdio(false);
	cin >> n;
	forn(i, n) {
		cin >> a[i];
		dp[i] = inf;
	}
	precalc();
	Segment_Tree St = Segment_Tree(n + 1);
	St.build(0, n);
	St.upd(0, 0);
	St.upd(1, 1);
	dp[0] = 0;
	dp[1] = 1;
	vector<int> st;
	st.push_back(1);
	//forn(i, n) {
	//	cout << left[i] << " ";
	//}
	//cout << "\n";
	for (int i = 2; i <= n; ++i) {
		while (!st.empty() && a[st.back()] > a[i]) {
			//dp[st.back() - 1] = inf;
			St.upd(st.back() - 1, inf);
			//cout << "set " << st.back() - 1 << " inf\n";
			st.pop_back();
		}
		st.push_back(i);
		//cout << "left[" << i << "]=" << left[i] << endl;
		//for (int j = left[i]; j < i; ++j) {
			//dp[i] = min(dp[i], dp[j] + 1);
			//if (i == 5) {
			//	cout << "j=" << j << " <- " << dp[j] << " + 1\n";
			//}
		//}
		St.upd(i, St.get(left[i], i - 1) + 1);
		//cout << "dp[" << i << "]=" << dp[i] << "\n";
	}
	cout << St.get(n, n) << "\n";
	return 0;
}