#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

struct ord_set
{
	int n, s;
	int* arr0;
	int* tree;
	ord_set(int* tree, int* arr0, int n) : arr0(arr0), tree(tree), n(n)
	{
		sort(arr0, arr0 + n);
		s = unique(arr0, arr0 + n) - arr0;
	}
	inline void change(int x, int val)
	{
		int k = lower_bound(arr0, arr0 + s, x) - arr0;
		for (int i = k; i < n; i = i | i + 1)
			tree[i] += val;
	}
	inline int ord(int x)
	{
		int k = lower_bound(arr0, arr0 + s, x) - arr0, ret = 0;
		for (int i = k - 1; i >= 0; i = (i & i + 1) - 1)
			ret += tree[i];
		return ret;
	}
};

const int maxn = 400000;
int ap0[maxn] = {}, am0[maxn] = {}, arr0[maxn] = {};
int tp[maxn] = {}, tm[maxn] = {}, ta[maxn] = {};

int main()
{
	ios_base::sync_with_stdio(0);
	int n, p;
	cin >> n >> p;
	assert(p == 2);
	for (int i = 0; i < n; i++)
		cin >> arr0[i];
	vector<int> ap(n), am(n), arr(n);
	for (int i = 0; i < n; i++)
	{
		ap0[i] = arr0[i] + i;
		am0[i] = arr0[i] - i;
	}
	for (int i = 0; i < n; i++)
	{
		arr[i] = arr0[i];
		ap[i] = ap0[i];
		am[i] = am0[i];
	}
	ord_set L(tp, ap0, n);
	ord_set R(tm, am0, n);
	ord_set T(ta, arr0, n);
	vector<int> ans(n);
	for (int i = 0; i < n; i++)
	{
		L.change(ap[i], 1);
		R.change(am[i], 1);
		T.change(arr[i], 1);
	}
	for (int i = 0; i < n; i++)
		ans[i] = max(L.ord(ap[i]), R.ord(am[i])) + 1;
	fill(L.tree, L.tree + n, 0);
	fill(R.tree, R.tree + n, 0);
	int l = 0, r = 0;
	for (int i = 0; i < n; i++)
	{
		while (r < n && r - i <= i - l)
		{
			T.change(arr[r], -1);
			R.change(am[r++], 1);
		}
		while (i - l >= r - i)
		{
			T.change(arr[l], 1);
			L.change(ap[l++], -1);
		}
		//cerr << T.ord(arr[i] + min(i, n - i - 1)) << " " << L.ord(ap[i]) << " " << R.ord(am[i]) << "\n";
		cout << max(ans[i], T.ord(arr[i] + min(i, n - i - 1)) + L.ord(ap[i]) + R.ord(am[i]) + 1) << "\n";
		L.change(ap[i], 1);
		R.change(am[i], -1);
	}
	return 0;
}