#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

bool rev_cmp(int a, int b)
{
	return a > b;
}

int next(int x, const vector<int> &arr)
{
	int p = upper_bound(arr.begin(), arr.end(), x, rev_cmp) - arr.begin();
	if (p == arr.size())
		return -1;
	return arr[p];
}

struct my_cmp
{
	bool operator ()(const vector<int> &a, const vector<int> &b)
	{
		int l = a.size() - 1, r = b.size() - 1;
		for (; l >= 0 && r >= 0; --l, --r)
		{
			if (a[l] < b[r])
				return 1;
			if (a[l] > b[r])
				return 0;
		}
		return r >= 0;
	}
};

const int maxn = 2005;
bool ans[maxn] = {};

int main()
{
	int n;
	cin >> n;
	vector<vector<int> > arr(n);
	for (int i = 0; i < n; i++)
	{
		string s;
		cin >> s;
		int L = s.length();
		for (int j = 0; j < L; j++)
			if (s[j] == '1')
				arr[i].push_back(L - j - 1);
		reverse(arr[i].begin(), arr[i].end());
	}
	priority_queue<vector<int>, vector<vector<int> >, my_cmp> q;
	for (int i = 0; i < n; i++)
		q.push(arr[i]);
	for (int i = maxn - 1; i >= 0; i--)
	{
		if (q.empty())
			break;
		if (q.top().back() == i)
		{
			ans[i] = 1;
			auto p = q.top();
			q.pop();
			p.pop_back();
			if (p.size())
				q.push(p);
			continue;
		}
		bool f = 0;
		auto qc = q;
		for (int j = i - 1; j >= 0; --j)
		{
			if (q.empty())
				break;
			if (q.top().back() > j)
			{
				f = 1;
				break;
			}
			if (q.top().back() == j)
			{
				auto p = q.top();
				q.pop();
				p.pop_back();
				if (p.size())
					q.push(p);
				continue;
			}
			q.pop();
		}
		if (q.size())
			f = 1;
		q = qc;
		if (f)
		{
			q.pop();
			ans[i] = 1;
		}
	}
	int L = maxn - 1;
	for (; !ans[L]; --L);
	for (int i = L; i >= 0; --i)
		cout << ans[i];
	return 0;
}