#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 4e9;


int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, m, k;
	cin >> n >> m >> k;

	vector<vector<bool> > f(n, vector<bool> (m, 0));
	vector<vector<int> > num(n, vector<int>(m, -1));
	vector<vector<int> > prev(n, vector<int>(m, -1));
	vector<vector<ll> > dp(n, vector<ll>(m, INF));
	vector<pair<int, int>> v(k);

	for (int i = 0; i < k; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		f[a][b] = true;
		num[a][b] = i;
		v[i] = {a, b};
	}

	dp[0][0] = 0;

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			for (int a = 0; a < n; a++) {
				for (int b = 0; b < m; b++) {
					if (num[a][b] == -1)
						continue;
					int len = max(abs(i - a), abs(j - b));
					ll now = (1LL << len) + dp[a][b];
					if (dp[i][j] > now) {
						dp[i][j] = now;
						prev[i][j] = num[a][b];
					}
				}
			}
		}
	}

	int x = n - 1, y = m - 1;

	vector<int> ans;
	while (x > 0 || y > 0) {
		ans.push_back(num[x][y]);
		int ind = prev[x][y];
		x = v[ind].first;
		y = v[ind].second;
	}
	ans.push_back(0);

	reverse(ans.begin(), ans.end());

	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << ' ';

	return 0;
}