#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>
#include <sstream>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 4e9;


int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int n, m, k;
	cin >> n >> m >> k;

	vector<int> x(k), y(k);

	for (int i = 0; i < k; i++) {
		cin >> x[i] >> y[i];
		x[i]--, y[i]--;
	}

	vector<vector<pair<int, ll>>> g(n);

	for (int i = 0; i < k; i++) {
		for (int j = 0; j < k; j++) {
			int len = 1 << max(abs(x[i] - x[j]), abs(y[i] - y[j]));
			g[i].push_back({j, len});
		}
	}

	vector<ll> dist(k, INF);
	vector<bool> used(k);
	dist[0] = 0;

	vector<int> prev(k);

	while(true) {
		int ind = -1;
		ll mi = INF;
		for (int j = 0; j < k; j++) {
			if (!used[j] && dist[j] < mi) {
				mi = dist[j];
				ind = j;
			}
		}

		if (ind == -1)
			break;

		used[ind] = true;

		for (auto p : g[ind]) {
			if (dist[p.first] > dist[ind] + p.second) {
				dist[p.first] = dist[ind] + p.second;
				prev[p.first] = ind;
			}
		}
	}

	int now = k - 1;
	vector<int> ans;
	while (now > 0) {
		ans.push_back(now);
		now = prev[now];
	}
	ans.push_back(0);
	reverse(ans.begin(), ans.end());

	cout << ans.size() << endl;
	for (int i : ans)
		cout << i + 1 << ' ';

	return 0;
}