// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define mp make_pair
#define pb push_back
#define ld long double
#define pas(x) cout << #x << ' ' << x << 1endl;


struct stree
{
    int k;
    vector<int> t;
    stree(int n) {
        k = 1;
        while (k <= n) k *= 2;
        t.assign(2 * k, 0);
    }

    void update(int p, int v) {
    	p += k;
    	while (p > 0) {
    		t[p] += v;
    		p /= 2;
    	}
    }
 
    int get_sum(int l, int r) {
        int res = 0;
        for (l += k, r += k; l <= r; l /= 2, r /= 2) {
            if (l % 2 == 1) {
               res += t[l];
                l++;
            }
            if (r % 2 == 0) {
                res += t[r];
                r--;
            }
        }
        return res;
    }
};




int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	int n; cin >> n;
	int p; cin >> p;
	vector<int> a(n);

	for (int &i : a) cin >> i;

	vector<int> left(n), right(n);
	vector<pii> vl, vr;
	for (int i = 0; i < n; i++) {
		left[i] = a[i] - i;
		right[i] = a[i] + i;
		vl.pb({left[i], i});
		vr.pb({right[i], i});
	}
	sort(vl.begin(), vl.end());
	sort(vr.begin(), vr.end());

	vector<int> res(n);
	stree l(n), r(n);
	vector<int> to_update;
	for (int i = 0; i < n; i++) {
		if (i > 0 && vl[i - 1].first < vl[i].first) {
			for (int i : to_update) l.update(i, 1);
			to_update.clear();
		}
		int pos = vl[i].second, val = vl[i].first;
		res[pos] += l.get_sum(0, pos);
		to_update.pb(pos);
	}
	for (int i : to_update) l.update(i, 1);
	to_update.clear();

	for (int i = 0; i < n; i++) {
		int pos = vr[i].second, val = vr[i].first;
		res[pos] += r.get_sum(pos, n);
		r.update(pos, 1);
	}
	// for (int i : left) cout << i << ' ';
	// cout << endl;
	// for (int i : right) cout << i << ' ';
		// cout << endl;
	for (int i : res) cout << i + 1 << ' ';
	cout << endl;


	return 0;
}