#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

struct Cell
{
	int x;
	int y;

	
	bool operator == (Cell b)
	{
		return x == b.x && y == b.y;
	}
};

int main()
{
	ios_base::sync_with_stdio(0);

	int n, m, q;
	cin >> n >> m >> q;

	vector<vector<int>> field(n, vector<int>(m));
	for (int j = 0; j < n; j++)
	{
		for (int i = 0; i < m; i++)
		{
			cin >> field[j][i];
		}
	}

	vector<set<pair<int, pair<int, int>>>> x(m);
	vector<set<pair<int, pair<int, int>>>> y(n);

	for (int j = 0; j < n; j++)
	{
		for (int i = 0; i < m; i++)
		{
			pair<int, int> temp;
			temp.first = i;
			temp.second = j;

			y[j].insert({ field[j][i], temp });
		}
	}

	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < n; j++)
		{
			pair<int, int> temp;
			temp.first = i;
			temp.second = j;

			x[i].insert({ field[j][i], temp });
		}
	}

	
	for (int i = 0; i < q; i++)
	{
		int r, c, val;
		cin >> r >> c >> val;
		r--; c--;

		pair<int, int> temp = { c, r };
		y[r].erase({ field[r][c], temp });
		y[r].insert({ val, temp });
		x[c].erase({ field[r][c], temp });
		x[c].insert({ val, temp });

		int counter = 0;
		if (n < m)
		{
			for (int k = 0; k < n; k++)
			{
				pair<int, int> t1 = (--y[k].end())->second;
				pair<int, int> t2 = (--x[t1.first].end())->second;

				if (t1 == t2)
					counter++;
			}
		}
		else
		{
			for (int k = 0; k < m; k++)
			{
				pair<int, int> t1 = (--x[k].end())->second;
				pair<int, int> t2 = (--y[t1.second].end())->second;

				if (t1 == t2)
					counter++;
			}
		}
		cout << counter << endl;
	}

	system("pause");
	return 0;
}