#include <iostream>
#include <cmath>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <map>

using namespace std;

struct Cell
{
	int x;
	int y;

	
	bool operator == (Cell b)
	{
		return x == b.x && y == b.y;
	}
};

int main()
{
	ios_base::sync_with_stdio(0);

	int n, m, q;
	cin >> n >> m >> q;

	vector<vector<int>> field(n, vector<int>(m));
	for (int j = 0; j < n; j++)
	{
		for (int i = 0; i < m; i++)
		{
			cin >> field[j][i];
		}
	}

	vector<set<pair<int, pair<int, int>>>> x(m);
	vector<set<pair<int, pair<int, int>>>> y(n);

	for (int j = 0; j < n; j++)
	{
		for (int i = 0; i < m; i++)
		{
			pair<int, int> temp;
			temp.first = i;
			temp.second = j;

			y[j].insert({ field[j][i], temp });
		}
	}

	for (int i = 0; i < m; i++)
	{
		for (int j = 0; j < n; j++)
		{
			pair<int, int> temp;
			temp.first = i;
			temp.second = j;

			x[i].insert({ field[j][i], temp });
		}
	}

	int counter = 0;
	if (n < m)
	{
		for (int k = 0; k < n; k++)
		{
			pair<int, int> t1 = (--y[k].end())->second;
			pair<int, int> t2 = (--x[t1.first].end())->second;

			if (t1 == t2)
				counter++;
		}
	}
	else
	{
		for (int k = 0; k < m; k++)
		{
			pair<int, int> t1 = (--x[k].end())->second;
			pair<int, int> t2 = (--y[t1.second].end())->second;

			if (t1 == t2)
				counter++;
		}
	}
	
	for (int i = 0; i < q; i++)
	{
		int r, c, val;
		cin >> r >> c >> val;
		r--; c--;

		vector<pair<int, int>> bef, aft;
		pair<int, int> ty1 = (--y[r].end())->second;
		pair<int, int> ty2 = (--x[ty1.first].end())->second;
		if (ty1 == ty2)
			bef.push_back(ty1);
		pair<int, int> tx1 = (--x[c].end())->second;
		pair<int, int> tx2 = (--y[ty1.second].end())->second;
		if (tx1 == tx2)
			bef.push_back(tx1);
		if (bef.size() == 2 && bef[0] == bef[1])
			bef.pop_back();

		pair<int, int> temp = { c, r };
		y[r].erase({ field[r][c], temp });
		y[r].insert({ val, temp });
		x[c].erase({ field[r][c], temp });
		x[c].insert({ val, temp });

		pair<int, int> ty11 = (--y[r].end())->second;
		pair<int, int> ty21 = (--x[ty11.first].end())->second;
		if (ty11 == ty21)
			aft.push_back(ty11);
		pair<int, int> tx11 = (--x[c].end())->second;
		pair<int, int> tx21 = (--y[ty11.second].end())->second;
		if (tx11 == tx21)
			aft.push_back(tx11);
		if (aft.size() == 2 && aft[0] == aft[1])
			aft.pop_back();

		counter += aft.size() - bef.size();

		cout << counter << endl;
	}

	system("pause");
	return 0;
}