#include <iostream>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <cmath>

using namespace std;
const int inf = 1e9 + 7;

struct Data
{
	int mi;
	int mii;
	int ma;
	int mai;

	Data() : mi(inf), ma(-1) {}
};

vector<Data> tree;

pair<int, int> cntMin (int x, int l, int r, int a, int b)
{
	if (r < a || b < l)
		return { 0, inf };
	if (a <= l && r <= b)
		return { tree[x].mii, tree[x].mi };

	int m = (l + r) / 2;

	auto v1 = cntMin(2 * x, l, m, a, b);
	auto v2 = cntMin(2 * x + 1, m + 1, r, a, b);

	if (v1.second < v2.second)
		return v1;
	else
		return v2;
}

pair<int, int> cntMax(int x, int l, int r, int a, int b)
{
	if (r < a || b < l)
		return { 0, -1 };
	if (a <= l && r <= b)
		return { tree[x].mai, tree[x].ma };

	int m = (l + r) / 2;

	auto v1 = cntMax(2 * x, l, m, a, b);
	auto v2 = cntMax(2 * x + 1, m + 1, r, a, b);

	if (v1.second > v2.second)
		return v1;
	else
		return v2;
}

int getMax(int a, int b)
{
	int n = (int)tree.size() / 2;
	return cntMax(1, 1, n, a, b).first;
}

int getMin(int a, int b)
{
	int n = (int)tree.size() / 2;
	return cntMin(1, 1, n, a, b).first;
}

int rec(int l, int r)
{
	if (r < l)
		return 0;

	int maxi = getMax(l, r);
	int mini = getMin(l, r);

	if (maxi >= mini)
	{
		return rec(l, mini - 1) + rec(maxi + 1, r) + 1;
	}
	else
	{
		return rec(l, maxi) + rec(maxi + 1, mini - 1) + rec(mini, r);
	}
}


int main()
{
	ios_base::sync_with_stdio(0);

	int n;
	cin >> n;

	int sz = pow(2, ceil(log2(n)));

	tree.resize(2 * sz);
	for (int i = sz; i < sz + n; i++)
	{
		int temp;
		cin >> temp;
		tree[i].mi = tree[i].ma = temp;
		tree[i].mii = tree[i].mai = i - sz + 1;

	}
		
	for (int i = sz - 1; i > 0; i--)
	{
		if (tree[2 * i].mi <= tree[2 * i + 1].mi)
		{
			tree[i].mi = tree[2 * i].mi;
			tree[i].mii = tree[2 * i].mii;
		}
		else
		{
			tree[i].mi = tree[2 * i + 1].mi;
			tree[i].mii = tree[2 * i + 1].mii;
		}

		if (tree[2 * i].ma > tree[2 * i + 1].ma)
		{
			tree[i].ma = tree[2 * i].ma;
			tree[i].mai = tree[2 * i].mai;
		}
		else
		{
			tree[i].ma = tree[2 * i + 1].ma;
			tree[i].mai = tree[2 * i + 1].mai;
		}
	}

	cout << rec(1, n) << endl;

	system("pause");
	return 0;
}