#pragma GCC optimize("Ofast,unroll-loops")

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define len(v) ((int)v.size())
#define all(v) v.begin(), v.end()
#define pb push_back
#define mp make_pair
// #define int ll

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return true;
	}
	return false;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return true;
	}
	return false;
}

void run();

signed main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

struct bfenv
{
	vector<int> tree;
	int n;

	bfenv(int n) : n(n)
	{
		tree.resize(n, 0);
	}

	int f(int i)
	{
		return i & (-i);
	}

	int get(int idx)
	{
		int sm = 0;
		for (; idx > 0; idx -= f(idx))
			sm += tree[idx];
		return sm;
	}

	void plus(int idx, int v)
	{
		for (; idx < n; idx += f(idx))
			tree[idx] += v;
	}
};

struct fenv
{
	unordered_map<int, int> tree;
	int maxn;

	fenv(int n)
	{
		maxn = n;
		tree.rehash(20000003);
	}

	int f(int i)
	{
		return i & (-i);
	}

	int get(int idx)
	{
		int sm = 0;
		for (; idx > 0; idx -= f(idx))
			if (tree.count(idx))
				sm += tree[idx];
		return sm;
	}

	void plus(int i, int v)
	{
		unsigned int idx = i;
		for (; idx < maxn; idx += f(idx))
			if (tree.count(idx))
				tree[idx] += v;
			else
				tree[idx] = v;
	}
};

vector<int> solve1(vector<int> arr)
{
	fenv r(1010000000), l(1010000000);
	int n = len(arr);
	for (int i = n - 1; i > -1; --i)
		r.plus(arr[i] + i, 1);
	vector<int> ans;
	for (int i = 0; i < n; ++i)
	{
		r.plus(arr[i] + i, -1);
		int k = l.get(arr[i] + (n - i) - 1) + r.get(arr[i] + i - 1);
		ans.pb(k + 1);
		l.plus(arr[i] + (n - i), 1);
	}
	return ans;
}

vector<int> slow_solve1(vector<int> arr)
{
	int n = len(arr);
	vector<int> ans(n);
	for (int i = 0; i < n; ++i)
	{
		int cnt = 0;
		for (int j = 0; j < n; ++j)
			if (arr[j] + abs(i - j) < arr[i])
				++cnt;
		ans[i] = cnt + 1;
	}
	return ans;
}

vector<int> solve2(vector<int> arr)
{
	int n = len(arr);
	vector<int> ans(n, -1);
	pair<int, int> *a = new pair<int, int>[n];
	for (int i = -1; i <= n; ++i)
		for (int j = i + 1; j <= n - (i == -1); ++j)
		{
			for (int k = 0; k < n; ++k)
			{
				if (k <= i)
					a[k] = {arr[k], k};
				if (k > i && k < j)
				{
					int d1 = 1000000000;
					int d2 = d1;
					if (i != -1)
						d1 = k - i;
					if (j != n)
						d2 = j - k;
					a[k] = {arr[k] + min(d1, d2), k};
				}
				if (k >= j)
					a[k] = {arr[k], k};
			}
			sort(a, a + n);
			int l = 0;
			for (int k = 0; k < n; ++k)
			{
				if (k > 0 && a[k].first != a[k - 1].first)
					l = k;
				cmax(ans[a[k].second], l + 1);
			}
		}
	return ans;
}

void run()
{
	int n, p;
	cin >> n >> p;
	vector<int> arr(n);
	for (auto &x : arr)
	{
		cin >> x;
	}
	if (p == 1)
		for (auto &x : solve1(arr))
			cout << x << "\n";
	else
		for (auto &x : solve2(arr))
			cout << x << "\n";
}