#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define len(v) ((int)v.size())
#define all(v) v.begin(), v.end()
#define pb push_back
#define mp make_pair
// #define int ll

template<class t1, class t2>
bool cmin(t1 &a, const t2 &b)
{
	if (a > b)
	{
		a = b;
		return true;
	}
	return false;
}

template<class t1, class t2>
bool cmax(t1 &a, const t2 &b)
{
	if (a < b)
	{
		a = b;
		return true;
	}
	return false;
}

void run();

signed main()
{
	iostream::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

struct bfenv
{
	vector<int> tree;
	int n;

	bfenv(int n) : n(n)
	{
		tree.resize(n, 0);
	}

	int f(int i)
	{
		return i & (-i);
	}

	int get(int idx)
	{
		int sm = 0;
		for (; idx > 0; idx -= f(idx))
			sm += tree[idx];
		return sm;
	}

	void plus(int idx, int v)
	{
		for (; idx < n; idx += f(idx))
			tree[idx] += v;
	}
};

struct fenv
{
	unordered_map<int, int> tree;
	int maxn;

	fenv(int n)
	{
		maxn = n;
		tree.rehash(1000033);
	}

	int f(int i)
	{
		return i & (-i);
	}

	int get(int idx)
	{
		int sm = 0;
		for (; idx > 0; idx -= f(idx))
			if (tree.count(idx))
				sm += tree[idx];
		return sm;
	}

	void plus(int idx, int v)
	{
		for (; idx < maxn; idx += f(idx))
			if (tree.count(idx))
				tree[idx] += v;
			else
				tree[idx] = v;
	}
};

vector<int> solve1(vector<int> arr)
{
	fenv r(1000000010), l(1000000010);
	int n = len(arr);
	for (int i = n - 1; i > -1; --i)
		r.plus(arr[i] + i, 1);
	vector<int> ans;
	for (int i = 0; i < n; ++i)
	{
		r.plus(arr[i] + i, -1);
		int k = l.get(arr[i] + (n - i) - 1) + r.get(arr[i] + i - 1);
		ans.pb(k + 1);
		l.plus(arr[i] + (n - i), 1);
	}
	return ans;
}

vector<int> slow_solve1(vector<int> arr)
{
	int n = len(arr);
	vector<int> ans(n);
	for (int i = 0; i < n; ++i)
	{
		int cnt = 0;
		for (int j = 0; j < n; ++j)
			if (arr[j] + abs(i - j) < arr[i])
				++cnt;
		ans[i] = cnt;
	}
	return ans;
}

vector<int> solve2(vector<int> arr)
{
	return {5, 3, 2, 4, 5};
}

void run()
{
	int n, p;
	cin >> n >> p;
	vector<int> arr(n);
	for (auto &x : arr)
	{
		cin >> x;
	}
	if (p == 1)
		for (auto &x : slow_solve1(arr))
			cout << x << "\n";
	else
		for (auto &x : solve2(arr))
			cout << x << "\n";
}