import java.awt.*;
import java.math.BigInteger;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Scanner;

public class D {
    BigInteger[][] w;
    Point[] arr;
    BigInteger[] power;
    D(){
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        int m = in.nextInt();
        int k = in.nextInt();
        w = new BigInteger[k][k];
        power = new BigInteger[Math.max(n, m)];
        power[0] = BigInteger.ONE;
        BigInteger two = BigInteger.valueOf(2);
        for(int i=1;i<power.length;i++){
            power[i] = power[i-1].multiply(two);
        }
        arr = new Point[k];
        for(int i=0;i<k;i++){
            arr[i] = new Point(in.nextInt(), in.nextInt());
        }
        for(int i=0;i<k;i++){
            for(int j=0;j<k;j++){
                w[i][j] = w[j][i] = power[Math.max(Math.abs(arr[i].x-arr[j].x), Math.abs(arr[i].y-arr[j].y))];
            }
        }
        boolean[] used = new boolean[k];
        Arrays.fill(used, false);
        BigInteger[] d = new BigInteger[k];
        Arrays.fill(d, null);
        d[0] = BigInteger.ZERO;
        while(true){
            int u = -1;
            for(int i=0;i<k;i++){
                if(!used[i] && d[i]!=null && (u==-1 || d[i].compareTo(d[u])<0)){
                    u = i;
                }
            }
            if(u==-1) break;
            used[u] = true;
            for(int v=0;v<k;v++){
                BigInteger newd = d[u].add(w[u][v]);
                if(d[v]==null || newd.compareTo(d[v])<0){
                    d[v] = newd;
                }
            }
        }
        ArrayDeque<Integer> st = new ArrayDeque<>();
        st.push(k);
        int v = k-1;
        while(v!=0) {
            for (int u = 0; u < k; u++) {
                if (d[u].add(w[u][v]).compareTo(d[v]) == 0) {
                    st.push(u + 1);
                    v = u;
                }
            }
        }
        System.out.println(st.size());
        String s = "";
        while(!st.isEmpty()){
            s+=(st.pop()+" ");
        }
        System.out.println(s);
    }
    public static void main(String[] args){
        new D();
    }
}
