#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <string>
typedef long long ll;
const int Q = 1 << 21;
int tmin[2 * Q];
int tmax[2 * Q];
int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a > b ? a : b;
}
const int INF = 1e9+10;
void add(int x, int p)
{
	p += Q;
	tmin[p] = x;
	tmax[p] = x;
	p /= 2;
	while (p > 0)
	{
		tmin[p] = min(tmin[p * 2], tmin[p * 2 + 1]);
		tmax[p] = max(tmax[p * 2], tmax[p * 2 + 1]);
		p /= 2;
	}
}
int searchmin(int L, int R)
{
	int ans = INF;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
			ans = min(ans, tmin[L++]);
		if (R & 1)
			ans = min(ans, tmin[--R]);
	}
	return ans;
}
int searchmax(int L, int R)
{
	int ans = 0;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
			ans = max(ans, tmax[L++]);
		if (R & 1)
			ans = max(ans, tmax[--R]);
	}
	return ans;
}

using namespace std;

int main()
{
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++)
	{
		cin >> a[i];
		add(a[i], i);
	}
	int i = 0, j = n - 1;
	int p = 3;
	int ans = 0;
	while (i < j)
	{
		int ma = searchmax(i, j + 1);
		int mi = searchmin(i, j + 1);
		if (a[i] > mi && a[j] == ma)
		{
			if (p == 2)
				ans++;
			p = 1;
			i++;
		}
		if (a[j] < ma && a[i] == mi)
		{
			if (p == 1)
				ans++;
			p = 2;
			j--;
		}
		if (a[j] < ma && a[i] > mi)
		{
			if (p == 1 || p == 2 || p == 3)
				ans += 2;
			p = 3;
			i++;
			j--;
		}
		if (a[j] == ma && a[i] == mi)
		{
			ans++;
			break;
		}
	}
	if (i == j)
		ans++;
	cout << ans;
	system("pause");
	return 0;
}