#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>
#include <string>
typedef long long ll;

using namespace std;
const int Q = 1 << 21;
int tmin[2 * Q];
int tmax[2 * Q];
int min(int a, int b)
{
	return a < b ? a : b;
}
int max(int a, int b)
{
	return a > b ? a : b;
}
const int INF = 1e9+10;
void add(int x, int p)
{
	p += Q;
	tmin[p] = x;
	tmax[p] = x;
	p /= 2;
	while (p > 0)
	{
		tmin[p] = min(tmin[p * 2], tmin[p * 2 + 1]);
		tmax[p] = max(tmax[p * 2], tmax[p * 2 + 1]);
		p /= 2;
	}
}
int searchmin(int L, int R)
{
	int ans = INF;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
			ans = min(ans, tmin[L++]);
		if (R & 1)
			ans = min(ans, tmin[--R]);
	}
	return ans;
}
int searchmax(int L, int R)
{
	int ans = 0;
	for (L += Q, R += Q; L < R; L /= 2, R /= 2)
	{
		if (L & 1)
			ans = max(ans, tmax[L++]);
		if (R & 1)
			ans = max(ans, tmax[--R]);
	}
	return ans;
}
int solve(int st, vector <int> &a)
{
	int mi = a[st];
	int ma = 0, mp = st;
	int i = st + 1;
	while (i < a.size() && a[i] >= mi)
	{
		if (a[i] >= ma)
		{
			ma = a[i];
			mp = i;
			int m = searchmax(i + 1, a.size());
			if (m < ma)
				break;
		}
		i++;
	}
	return mp+1;
}
int main()
{
	//freopen("out.txt", "r", stdin);
	int n;
	cin >> n;
	vector <int> a(n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &a[i]);
		add(a[i], i);
	}
	int i = 0;
	int ans = 0;
	while (i < n)
	{
		i = solve(i, a);
		ans++;
	}
	cout << ans;
	system("pause");
	return 0;
}