#include <iostream>
#include <set>

using namespace std;

void update(set<pair<int, int> >& points, int* rows, int* cols, int* pbr, int* pbc, int* data, int m, int x, int y, int val)
{
    if(pbr[x] >= 0 && data[x * m + pbr[x]] < val)
    {
        pbc[pbr[x]] = -1;
        points.erase(make_pair(x, pbr[x]));
        pbr[x] = -1;
    }
    if(pbc[y] >= 0 && data[pbc[y] * m + y] < val)
    {
        pbr[pbc[y]] = -1;
        points.erase(make_pair(pbc[y], y));
        pbc[y] = -1;
    }
    rows[x] = max(rows[x], val);
    cols[y] = max(cols[y], val);
    data[x * m + y] = val;
    if(val == rows[x] && val == cols[y])
    {
        pbr[x] = y;
        pbc[y] = x;
        points.insert(make_pair(x, y));
    }
}

int main()
{
    int n, m, q;
    cin >> n >> m >> q;
    set<pair<int, int> > points;
    points.insert(make_pair(n - 1, m - 1));
    int rows[n], cols[m];
    for(int i = 0; i < n; i++)
        rows[i] = i * m + m - 1 - n * m;
    for(int j = 0; j < m; j++)
        cols[j] = (n - 1) * m + j - n * m;
    int pbr[n], pbc[m];
    int data[n * m];
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
        {
            int coord = i * m + j;
            data[coord] = coord - n * m;
        }
    for(int i = 0; i < n; i++)
        pbr[i] = -1;
    for(int j = 0; j < m; j++)
        pbc[j] = -1;
    pbr[n - 1] = m - 1;
    pbc[m - 1] = n - 1;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
        {
            int cur;
            cin >> cur;
            update(points, rows, cols, pbr, pbc, data, m, i, j, cur);
        }
    for(int i = 0; i < q; i++)
    {
        int x, y, val;
        cin >> x >> y >> val;
        x--;
        y--;
        update(points, rows, cols, pbr, pbc, data, m, x, y, val);
        cout << points.size() << endl;
    }
    return 0;
}
