#include <bitset>
#include <iostream>
using namespace std;

#define MAX_BITS 10000

bitset<MAX_BITS> a;
bitset<MAX_BITS> b;
bitset<MAX_BITS> c;

void increment(bitset<MAX_BITS>& a) {
    for (int i = 0; i < MAX_BITS; ++i) {
        a[i] = a[i] ^ 1;
        if(a[i] == 1)
            break;
    }
}

void add(bitset<MAX_BITS>& a, bitset<MAX_BITS>& b) {
    int c = 0;
    for (int i = 0; i < MAX_BITS; ++i) {
        c = a[i] + b[i] + c;
        a[i] = c & 1;
        c = (c >> 1);
    }
}

void sum(bitset<MAX_BITS>& a, bitset<MAX_BITS>& b, bitset<MAX_BITS>& r) {
    int c = 0;
    for (int i = 0; i < MAX_BITS; ++i) {
        c = a[i] + b[i] + c;
        r[i] = c & 1;
        c = (c >> 1);
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> b;
        while(sum(a, b, c), (a | b) != c)
            increment(b);
        a |= b;
    }
    bool print = false;
    for (int i = MAX_BITS; i--;)
        if(print || a[i])
            print = true, cout << a[i];
    return 0;
}
