#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <random>
const long long INF = 1e17;
const int ln = 10;

using namespace std;





struct Node{
    int x;
    int y;
    int sz;
    int cnt;
    Node *L;
    Node *R;
};

Node *emp;

Node *create_Node(int x){
    Node *t = new Node;
    t->x = x;
    t->y = (rand() << 16) ^ rand();
    t->L = emp;
    t->R = emp;
    t->sz = 1;
    t->cnt = 1;
    return t;
}


int get_sz(Node *t){
    if (t == emp){
        return 0;
    }
    return (t->sz);
}

void update(Node *t){
    if (t != emp){
        t->sz = get_sz(t->L) + get_sz(t->R) + t->cnt;
    }
}

pair <Node*, Node*> Split(Node *t, int x){
    if (t == emp){
        return make_pair(emp, emp);
    }
    if (t->x > x){
        pair <Node*, Node*> p = Split(t->L, x);
        t->L = p.second;
        update(t);
        return make_pair(p.first, t);
    }
    else{
        pair <Node*, Node*> p = Split(t->R, x);
        t->R = p.first;
        update(t);
        return make_pair(t, p.second);
    }
}

Node *Merge(Node *L, Node *R){
    if (L == emp){
        return R;
    }
    if (R == emp){
        return L;
    }
    if (L->y > R->y){
        L->R = Merge(L->R, R);
        update(L);
        return L;
    }
    else{
        R->L = Merge(L, R->L);
        update(R);
        return R;
    }
}


Node *root;


void prt2(Node *t){
    if (t != emp){
        prt2(t->L);
        cout << t->x << ' ';
        prt2(t->R);
    }
}

void prt(){
    prt2(root);
    cout << endl;
}

void Add (int x){
    pair <Node*, Node*> p = Split(root, x - 1);
    Node *L = p.first;
    pair <Node*, Node*> p2 = Split(p.second, x);
    Node *M = p2.first;
    Node *R = p2.second;
    /*
    cout << "ADD " << x << endl;
    cout << "LX" << endl;
    prt2(L);
    cout << endl;
    cout << "MX" << endl;
    prt2(M);
    cout << endl;
    cout << "GX" << endl;
    prt2(R);
    cout << endl;
    cout << "ENDADD";
    */
    if (M == emp){
        M = create_Node(x);
    }
    else{
        M->cnt += 1;
        M->sz += 1;
    }
    root = Merge(L, Merge(M, R));
    /*
    cout << "LAST" << endl;
    prt();
    cout << endl << endl;
    */
}

long long get(long long x){
    pair <Node*, Node*> p = Split(root, x - 1);
    long long ans = x * get_sz(p.second);
    root = Merge(p.first, p.second);
    return ans;
}

int main(){
    root = emp;
    int n;
    cin >> n;
    vector <pair <long long, long long> > v(n);
    for (int i = 0; i < n; i++){
        long long x, y;
        cin >> x >> y;
        v[i] = make_pair(x, y);
    }
    sort(v.begin(), v.end());

    long long gans = -INF;

    for (int i = 0; i <= n; i++){
        //prt();
        long long cans = 0;
        if (i != n){
            cans = v[i].first * (n - i);
        }
        long long ans = 0;
        for (int k = 0; (ln * (k + 1) <= i); k++){
            int L = min(ln * k, i);
            int R = min(ln * (k + 1), i);
            while (R - L > 1){
                int M1 = (L * 2 + R) / 3;
                int M2 = (L + 2 * R) / 3;
                if (get(v[M1].second) > get(v[M2].second)){
                    R = M2;
                }
                else{
                    L = M1;
                }
            }
            ans = max(ans, max(get(v[L].second), get(v[R].second)));
            //cout << ln * k << ' ' << ln * (k + 1) << ' ' << ans << endl;

        }
        gans = max(gans, ans + cans);
        if (i != n){
            Add(v[i].second);
        }
    }
    cout << gans << endl;
}
