#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

struct ST {
    vector<pair<int, int>> T;
    ST(vector<int> v) {
        int N = 1;
        while (N < v.size()) N *= 2;
        v.resize(N);
        T.resize(2 * N, {0, 0});
        for (int i = 0; i < N; i++) {
            T[i + N] = {v[i], i};
        }
        for (int i = N - 1; i > 0; i--) {
            T[i] = max(T[i * 2], T[i * 2 + 1]);
        }
    }
    int get_max(int l, int r) {
        pair<int, int> ans = {0, 0};
        l += T.size() / 2;
        r += T.size() / 2;
        while (r >= l) {
            if (r % 2 == 0) {
                ans = max(ans, T[r]);
                r--;
            }
            if (l % 2 == 1) {
                ans = max(ans, T[l]);
                l++;
            }
            r /= 2;
            l /= 2;
        }
        return ans.second;
    }
};

int main() {
    cin.sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> arr(n + 1);
    for (int i = 1; i <= n; i++) cin >> arr[i];
    vector<int> st;
    vector<int> nxt(n + 1, arr.size() - 1);
    for (int i = 1; i < arr.size(); i++) {
        while (st.size() != 0 && arr[st[st.size() - 1]] > arr[i]) {
            nxt[st[st.size() - 1]] = i;
            st.pop_back();
        }
        st.push_back(i);
    }
    ST T = {arr};
    int ans = 0;
    int i = 1;
    while (i < arr.size() && ans < n + 1) {
        int j = T.get_max(i, nxt[i]);
        ans += 1;
        i = j + 1;
        /*cout << i << " " << j << endl;
        cout << arr[i] << endl;
        cout << arr.size() << endl << endl;*/
    }
    cout << ans << endl;
    return 0;
}