#include <iostream>
#include <vector>

using namespace std;

const int INF = 1e9;

vector<int> arr;
vector<pair<int, int>> ans;
int n;

inline void split(int l, int r) {
    vector<int> l1;
    for (int i = l + 1; i <= r; i += 2) l1.push_back(arr[i]);
    for (int i = l; i <= r; i += 2) l1.push_back(arr[i]);
    for (int i = 0; i < l1.size(); i++) {
        arr[i + l] = l1[i];
    }
    ans.push_back({l + 1, r + 1});
}

inline int get_mn(int i) {
    int pos = n - 1;
    for (int j = i; j < n; j++) if (arr[j] < arr[pos]) pos = j;
    return pos;
}

inline void to_pos(int from, int to) {
    while (from != to) {
        if ((from - to) % 2 == 0) {
            split(to + 1, from);
        } else {
            split(to, from);
        }
        from = get_mn(to);
    }
}

int main() {
    cin.sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    arr.resize(n);
    for (int i = 0; i < n; i++) cin >> arr[i];
    for (int i = 0; i < n; i++) {
        to_pos(get_mn(i), i);
    }
    cout << ans.size() << endl;
    for (auto el: ans) cout << el.first << " " << el.second << "\n";
    return 0;
}