#include <bits/stdc++.h>

using namespace std;

#define int int64_t
#define se second
#define fi first
#define mp make_pair
#define endl '\n'

template <typename T1, typename T2>
ostream & operator << (ostream & out, pair <T1, T2> p)
{
    out << p.fi << " " << p.se << endl;
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p) {
    in >> p.fi >> p.se;
    return in;
}

template <typename T>
istream & operator >> (istream & in, vector <T> & arr) {
    for (auto & x : arr)
        in >> x;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> arr) {
    for (auto x : arr)
        out << x << " ";
    out << endl;
    return out;
}

struct dist {
    bitset <600> arr;

    dist(){}

    dist(bitset<600> arr_) {
        arr = arr_;
    }

    dist(int a) {
        arr[a] = 1;
    }

    friend dist operator + (dist a, dist b) {
        bitset<600> now;
        int carry = 0;
        for (int i = 0; i < 600; ++i) {
            int sum = a.arr[i] + b.arr[i] + carry;
            now[i] = sum % 2;
            carry = sum / 2;
        }
        return dist(now);
    }

    friend bool operator < (dist a, dist b)
    {
        //cout << "a = ";
        //for (int i = 0; i < 5; ++i) {
        //    cout << a.arr[i] << " ";
        //}
        //cout << endl;
        //cout << "b = ";
        //for (int i = 0; i < 5; ++i)
        //    cout << b.arr[i] << " ";
        //cout << endl;
        for (int i = 599; i >= 0; --i) {
            if (a.arr[i] < b.arr[i]) {
                //cout << "true" << endl;
                return true;
            }
            if (a.arr[i] > b.arr[i]) {
                //cout << "false" << endl;
                return false;
            }
        }
        return false;
    }

    friend ostream & operator << (ostream & out, dist a) {
        for (int i = 0; i < 10; ++i) {
            out << a.arr[i] << " ";
        }
        out << endl;
        return out;
    }
};

vector <vector <dist> > g;

void dijkstra(int s, int f) {
    int n = g.size();
    vector <dist> d(n, dist(9));
    vector <bool> used(n, false);
    vector <int> prev(n);
    prev[s] = -1;
    d[s] = dist();
    for (int i = 0; i < n; ++i) {
        int u = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (u == -1 || d[j] < d[u]))
                u = j;
        }
        used[u] = true;
        for (int j = 0; j < n; ++j) {
            if (d[u] + g[u][j] < d[j]) {
                d[j] = d[u] + g[u][j];
                prev[j] = u;
            }
        }
    }
    int now = f;
    vector <int> ans;
    while (now != -1) {
        ans.push_back(now + 1);
        now = prev[now];
    }
    reverse(ans.begin(), ans.end());
    cout << ans.size() << endl;
    cout << ans << endl;
}

signed main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0);
    //cout.tie(0);


    int n, m, k;
    cin >> n >> m >> k;
    vector <pair <int, int> > arr(k);
    cin >> arr;
    g.resize(k, vector <dist> (k));
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            if (i == j)
                continue;
            g[i][j] = dist(max(abs(arr[i].fi - arr[j].fi), abs(arr[i].se - arr[j].se)));
        }
    }
    dijkstra(0, k - 1);
    //cout << g[1][0] + g[1][2] << endl;
    return 0;
}
