
#pragma gcc optimize("Ofast,unroll-loops")
#pragma gcc options("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <climits>
#include <iterator>

using namespace std;
using ll = long long;
using ipair = pair<int, int>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define vect vector

int n;
vect<int> logs(300001, 0);

struct t {
	int val, id;

	const bool operator<(const t& tt) const {
		return val < tt.val || (val == tt.val && id < tt.id);
	}
	const bool operator>(const t& tt) const {
		return val > tt.val || (val == tt.val && id > tt.id);
	}

	t() {}
	t(int val, int id) : val(val), id(id) {}
};

struct sparsemin {
	vect<vect<t>> st;

	t getmin(int l, int r) {
		int ln = logs[r - l];
		return min(st[ln][l], st[ln][r - (1 << ln)]);
	}

	sparsemin() {}
	sparsemin(vect<t> ar) {
		st.resize(logs[ar.size()] + 1);
		st[0] = ar;
		for (int i = 1; i < st.size(); ++i) {
			for (int j = 0; j <= ar.size() - (1 << i); ++j) {
				st[i].pb(min(st[i - 1][j], st[i - 1][j + (1 << (i - 1))]));
			}
		}
	}
};

struct sparsemax {
	vect<vect<t>> st;

	t getmax(int l, int r) {
		int ln = logs[r - l];
		return max(st[ln][l], st[ln][r - (1 << ln)]);
	}

	sparsemax() {}
	sparsemax(vect<t> ar) {
		st.resize(logs[ar.size()] + 1);
		st[0] = ar;
		for (int i = 1; i < st.size(); ++i) {
			for (int j = 0; j <= ar.size() - (1 << i); ++j) {
				st[i].pb(max(st[i - 1][j], st[i - 1][j + (1 << (i - 1))]));
			}
		}
	}
};

sparsemin smin;
sparsemax smax;

int genans(int l, int r) {
	if (r - l <= 0) { return 0; }
	if (r - l == 1) { return 1; }
	int lb = smin.getmin(l, r).id;
	int rb = smax.getmax(l, r).id;
	if (lb < rb) { return 1 + genans(l, lb) + genans(rb + 1, r); }
	else { return genans(l, rb + 1) + genans(rb + 1, lb) + genans(lb, r); }
}

signed main() {
	cin >> n;
	int cur = 0, nxt = 2;
	for (int i = 2; i <= n; ++i) {
		if (i == nxt) { ++cur; nxt *= 2; }
		logs[i] = cur;
	}
	vect<t> ts(n);
	for (int i = 0; i < n; ++i) { cin >> ts[i].val; ts[i].id = i; }

	smin = sparsemin(ts);
	smax = sparsemax(ts);

	cout << genans(0, n);
	//system("pause");
}
