#pragma gcc optimize("Ofast,unroll-loops")
#pragma gcc options("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <climits>
#include <iterator>

using namespace std;
using ll = long long;
using ipair = pair<int, int>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define vect vector
#define lwb lower_bound
#define upb upper_bound

struct SB {
	int x, y, id, t;

	const bool operator<(const SB& sb) const {
		return x < sb.x || (x == sb.x && t < sb.t);
	}

	SB() {}
	SB(int x, int y, int id, int t) : x(x), y(y), id(id), t(t) {}
};


struct FT {
	vect<int> ar, fen;


	void inc(int y) {
		int id = (int)(lwb(all(ar), y) - ar.begin());
		for (int i = id; i < fen.size(); i |= (i + 1)) { ++fen[i]; }
	}

	int psum(int r) { // already id
		int res = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1) { res += fen[i]; }
		return res;
	}

	int sum(int l, int r) { // not id and [)
		int lb = (int)(lwb(all(ar), l) - ar.begin());
		int rb = (int)(lwb(all(ar), r) - ar.begin()) - 1;

		if (rb < 0) { return 0; }
		else if (lb <= 0) { return psum(rb); }
		else { return psum(rb) - psum(lb - 1); }
	}

	FT() {}
	FT(vect<int> ar) : ar(ar) {
		fen.assign(ar.size(), 0);
	}
};

signed main() {
	int n, p, cur = 0; cin >> n >> p; --p;
	vect<int> tn(n), tm(n), tp(n); 
	for (auto& it : tn) { 
		cin >> it; 
		tm[cur] = it - cur; 
		tp[cur] = it + cur;
		++cur;
	}


	if (!p) {
		vect<int> ans(n, 1);
		FT ftm = FT(tm), ftp = FT(tp);
		vect<SB> sbm, sbp;
		for (int i = 0; i < n; ++i) {
			sbm.pb({ i, tm[i], -1, 0 });
			sbm.pb({ i, tm[i], i, -1 });

			sbp.pb({ i, tp[i], -1, 0 });
			sbp.pb({ i, tp[i], i, 1 });
		}

		sort(all(sbm));
		for (auto it : sbm) {
			if (it.t == 0) { ftm.inc(it.y); }
			else if (it.t == -1) { ans[it.id] += ftm.sum(0, it.y); }
		}

		sort(all(sbp));
		for (auto it : sbp) {
			if (it.t == 0) { ftp.inc(it.y); }
			else if (it.t == 1) { ans[it.id] -= ftp.sum(0, it.y); }
		}
		for (int i = 0; i < n; ++i) { ans[i] += ftp.sum(0, tp[i]); }

		for (auto it : ans) { cout << it << endl; }
	}
	else {

	}
	system("pause");
}