#pragma gcc optimize("Ofast,unroll-loops,O1,O2,O3")
#pragma gcc options("sse,sse2,sse3,sse4,popcnt,tune=native")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <climits>
#include <iterator>

using namespace std;
using ll = long long;
using ipair = pair<int, int>;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define vect vector
#define lwb lower_bound
#define upb upper_bound

struct SB {
	int x, y, id, t;

	const bool operator<(const SB& sb) const {
		return x < sb.x || (x == sb.x && t < sb.t);
	}

	SB() {}
	SB(int x, int y, int id, int t) : x(x), y(y), id(id), t(t) {}
};


struct FT {
	vect<int> ar, fen;


	void inc(int y) {
		int id = (int)(lwb(all(ar), y) - ar.begin());
		for (int i = id; i < fen.size(); i |= (i + 1)) { ++fen[i]; }
	}

	int psum(int r) { // already id
		int res = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1) { res += fen[i]; }
		return res;
	}

	int sum(int l, int r) { // not id and [)
		int lb = (int)(lwb(all(ar), l) - ar.begin());
		int rb = (int)(lwb(all(ar), r) - ar.begin()) - 1;

		if (rb < 0) { return 0; }
		else if (lb <= 0) { return psum(rb); }
		else { return psum(rb) - psum(lb - 1); }
	}

	FT() {}
	FT(vect<int> arr) {
		sort(all(arr));
		ar = arr;
		fen.assign(ar.size(), 0);
	}
};

void main7() {
	int n, p, cur = 0;
	scanf("%d%*c%d%*c", &n, &p);
	--p;
	vect<int> tn(n), tm(n), tp(n); 
	for (auto& it : tn) { 
		scanf("%d%*c", &it);
		tm[cur] = it - cur; 
		tp[cur] = it + cur;
		++cur;
	}


	if (!p) {
		vect<int> ans(n, 1);
		FT ftm = FT(tm), ftp = FT(tp);
		vect<SB> sbm, sbp;
		for (int i = 0; i < n; ++i) {
			sbm.pb({ i, tm[i], -1, 0 });
			sbm.pb({ i, tm[i], i, -1 });

			sbp.pb({ i, tp[i], -1, 0 });
			sbp.pb({ i, tp[i], i, 1 });
		}

		sort(all(sbm));
		for (auto it : sbm) {
			if (it.t == 0) { ftm.inc(it.y); }
			else if (it.t == -1) { ans[it.id] += ftm.sum(-INT_MAX / 2, it.y); }
		}

		sort(all(sbp));
		for (auto it : sbp) {
			if (it.t == 0) { ftp.inc(it.y); }
			else if (it.t == 1) { ans[it.id] -= ftp.sum(-INT_MAX / 2, it.y); }
		}
		for (int i = 0; i < n; ++i) { ans[i] += ftp.sum(-INT_MAX / 2, tp[i]); }

		for (auto it : ans) { cout << it << endl; }
	}
	else {
		vect<int> ans1(n, 1), ans2(n, 1);
		FT ftm = FT(tm), ftp = FT(tp), ftn = FT(tn);
		vect<SB> sbm, sbn, sbp;

		for (int i = 0; i < n; ++i) {
			sbm.pb({ i, tm[i], -1, 0 });
			sbp.pb({ i, tp[i], -1, 0 });
			sbn.pb({ i, tn[i], -1, 0 });

			if (i <= (n - 1) / 2 && i > 0) {
				sbp.pb({ i, tp[i], i, -11 });
				
				sbm.pb({ i, tm[i], i, 12 });
				sbm.pb({ i * 2, tm[i], i, -12 });

				sbn.pb({ i * 2, tp[i], i, -13 });
			}
			else if (i > (n - 1) / 2 && i < n - 1) {
				int k = n - 1 - i;

				sbn.pb({ i - k, tn[i] + k, i, 21 });

				sbp.pb({ i - k, tp[i], i, 22 });
				sbp.pb({ i, tp[i], i, -22 });

				sbm.pb({ i, tm[i], i, 23 });
			}
		}

		sort(all(sbm));
		for (auto it : sbm) {
			if (it.t == 0) { ftm.inc(it.y); }
			else if (it.t == 12) { ans2[it.id] -= ftm.sum(-INT_MAX, it.y); }
			else if (it.t == -12) { ans2[it.id] += ftm.sum(-INT_MAX, it.y); }
			else if (it.t == 23) { ans2[it.id] -= ftm.sum(-INT_MAX, it.y); }
		}

		sort(all(sbn));
		for (auto it : sbn) {
			if (it.t == 0) { ftn.inc(it.y); }
			else if (it.t == -12) { ans2[it.id] -= ftn.sum(-INT_MAX, it.y); }
			else if (it.t == 21) { ans2[it.id] += ftn.sum(-INT_MAX, it.y); }
			else if (it.t == -13) { ans2[it.id] -= ftn.sum(-INT_MAX, it.y); }
		}

		sort(all(sbp));
		for (auto it : sbp) {
			if (it.t == 0) { ftp.inc(it.y); }
			else if (it.t == -11) { ans2[it.id] += ftp.sum(-INT_MAX, it.y); }
			else if (it.t == 22) { ans2[it.id] -= ftp.sum(-INT_MAX, it.y); }
			else if (it.t == -22) { ans2[it.id] += ftp.sum(-INT_MAX, it.y); }
		}

		for (int i = 0; i < n; ++i) {
			if (i <= (n - 1) / 2) {
				ans1[i] += ftm.sum(-INT_MAX, tm[i]);
				if (i > 0) { ans2[i] += ftn.sum(-INT_MAX, tp[i]); }// 13
			}
			else {
				ans1[i] += ftp.sum(-INT_MAX, tp[i]);
				if (i < n - 1) { ans2[i] += ftm.sum(-INT_MAX, tm[i]); }// 23
			}
		}


		for (int i = 0; i < n; ++i) {
			printf("%d\n", max(ans1[i], ans2[i]));
		}
	}
}