import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.lang.reflect.Executable;
import java.util.Arrays;
import java.util.Locale;
import java.util.Random;
import java.util.StringTokenizer;

public class Main {

    class Tree {
        int x, y, cnt;
        Tree l, r;

        Tree(int x, int y) {
            this.x = x;
            this.y = y;
            cnt = 1;
        }

        Tree(int x, int y, Tree L, Tree R) {
            this.x = x;
            this.y = y;
            l = L;
            r = R;
            cnt = 1 + getCnt(L) + getCnt(R);
        }
    }

    class Pair {
        Tree f, s;

        Pair(Tree f, Tree s) {
            this.f = f;
            this.s = s;
        }
    }

    int getCnt(Tree t) {
        if (t == null) return 0;
        return t.cnt;
    }

    void up(Tree t) {
        if (t == null) return;
        t.cnt = 1 + getCnt(t.l) + getCnt(t.r);
    }

    Tree merge(Tree L, Tree R) {
        if (L == null) return R;
        if (R == null) return L;
        if (L.y > R.y) {
            L.r = merge(L.r, R);
            up(L);
            return L;
        } else {
            R.l = merge(L, R.l);
            up(R);
            return R;
        }

    }

    Pair split(Tree t, int key) {
        if (t == null) return new Pair(null, null);
        if (t.x > key) {
            Pair p = split(t.l, key);
            t.l = p.s;
            up(t);
            return new Pair(p.f, t);
        } else {
            Pair p = split(t.r, key);
            t.r = p.f;
            up(t);
            return new Pair(t, p.s);
        }
    }

    Random rd = new Random();

    void add(int key) {
        Pair p = split(t, key);
        t = merge(merge(p.f, new Tree(key, rd.nextInt())), p.s);
    }

    Tree t;

    int get(Tree t, int key) {
        if(t == null) return 0;
        if(t.x > key){
            return get(t.l, key);
        }else return getCnt(t.l) + 1 + get(t.r, key);
    }

    public void solve() throws IOException {
        int n = nextInt(), type = nextInt();
        int a[] = new int[n], f[] = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            f[i] = a[i] + i;
        }
        int ans[] = new int[n];
        for (int i = n - 1; i >= 0; i--) {
            ans[i] += get(t, f[i] - 1);
            add(f[i]);
        }
        t = null;
        for (int i = 0; i < n; i++) {
            f[i] = a[i] + (n - 1 - i);
        }
        for (int i = 0; i < n; i++) {
            ans[i] += get(t, f[i] - 1);
            add(f[i]);
        }
        for (int i = 0; i < n; i++) {
            out.println(ans[i] + 1);
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
}
