#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cassert>
#include <vector>
#include <map>

using namespace std;

const int MAXN = 2e5 + 10;

vector <vector <int> > a;
int x[MAXN], y[MAXN];
map <int, pair <int, int> > pos;

bool check(int c) {
    pair <int, int> p = pos[c];
    return x[p.first] == c && y[p.second] == c;
}

int main() {
    ios_base::sync_with_stdio(false);
    int n, m, q; cin >> n >> m >> q;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        a[i].resize(m);
        for (int j = 0; j < m; j++) {
            cin >> a[i][j];
            pos[a[i][j]] = make_pair(i, j);
        }
    }

    for (int i = 0; i < n; i++) {
        x[i] = 0;
        for (int j = 0; j < m; j++)
            x[i] = max(x[i], a[i][j]);
    }


    for (int j = 0; j < m; j++) {
        y[j] = 0;
        for (int i = 0; i < n; i++)
            y[j] = max(y[j], a[i][j]);
    }

    int res = 0;
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            if (x[i] == y[j])
                res++;

    for (int test = 0; test < q; test++) {
        int i, j, c; cin >> i >> j >> c; i--, j--;
        int checki = x[i], checkj = y[j];
        if (check(checki))
            res--;
        if (check(checkj) && !check(a[i][j]))
            res--;
        x[i] = max(x[i], c);
        y[j] = max(y[j], c);
        pos[c] = make_pair(i, j);
        a[i][j] = c;
        if (check(c))
            res++;
        cout << res << endl;
    }

    return 0;
}
