#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 3e5;
const int INF = 1e9 + 7;

int a[MAXN];
int nxt[MAXN];

set <pair <int, int> > s;

int get_min(int l, int r) {
    int res = INF;
    for (int i = l; i <= r; i++)
        if (res > a[i])
            res = a[i];
    return res;
}

int get_max_id(int l, int r) {
    int res = -1, id = -1;
    for (int i = l; i <= r; i++)
        if (res <= a[i]) {
            res = a[i];
            id = i;
        }
    return id;
}

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int n; cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    for (int i = 0; i < n; i++) {
        int l = i, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (get_min(i, m) == a[i])
                l = m;
            else
                r = m;
        }
        nxt[i] = l;
    }

    int l = 0, res = 0;
    while (l < n) {
        int r = get_max_id(l, nxt[l]);
        l = r + 1;
        res++;
    }

    cout << res << endl;

    return 0;
}
