#include <iostream>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <cassert>
#include <set>

using namespace std;

const int MAXN = 4e5 + 100;

int n;
int a[MAXN], res[MAXN];

vector <int> all;

int find_all(int val) {
    int l = 0, r = (int)all.size();
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (all[m] == val)
            return m;
        if (all[m] < val)
            l = m + 1;
        if (all[m] > val)
            r = m;
    }
    return l;
}

struct Kek {

    int d[4 * MAXN];

    vector <int> k;

    void init() {
        k.clear();
        for (int i = 0; i < 4 * MAXN; i++)
            d[i] = 0;
    }

    void add(int i, int l, int r, int pos, int val) {
        if (l == r) {
            d[i] += val;
            return;
        }
        int m = (l + r) / 2;
        if (pos <= m)
            add(2 * i, l, m, pos, val);
        else
            add(2 * i + 1, m + 1, r, pos, val);
        d[i] = d[2 * i] + d[2 * i + 1];
    }

    void insert(int v) {
        //add(1, 0, MAXN - 1, v, 1);
        k.push_back(v);
    }

    int get(int i, int l, int r, int ql, int qr) {
        if (ql > r || l > qr)
            return 0;
        if (ql <= l && r <= qr)
            return d[i];
        int m = (l + r) / 2;
        return get(2 * i, l, m, ql, qr) + get(2 * i + 1, m + 1, r, ql, qr);
    }

    int get_lt(int v) {
        //return get(1, 0, MAXN - 1, 0, v - 1);

        int res = 0;
        for (int i = 0; i < (int)k.size(); i++)
            if (k[i] < v)
                res++;
        return res;
    }

} kek;

int main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);

    int p; cin >> n >> p;
    for (int i = 0; i < n; i++)
        cin >> a[i];

    fill(res, res + MAXN, 0);

    for (int i = 0; i < n; i++)
        all.push_back(a[i] - i);
    sort(all.begin(), all.end());
    all.resize(unique(all.begin(), all.end()) - all.begin());

    int add;
    kek.init(); add = 0;
    for (int i = 0; i < n; i++) {
        res[i] += kek.get_lt(find_all(a[i] - add));
        kek.insert(find_all(a[i] - add));
        add++;
    }
    kek.init(); add = 0;
    for (int i = n - 1; i >= 0; i--) {
        res[i] += kek.get_lt(find_all(a[i] - add));
        kek.insert(find_all(a[i] - add));
        add++;
    }

    for (int i = 0; i < n; i++)
        cout << res[i] + 1 << endl;

    return 0;
}
