#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
typedef long long ll;
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back

struct fenwick {
	std::vector<int> f;

	fenwick(int n) {
		f.resize(n);
	}

	void add(int x, int value) {
		for (int i = x; i < f.size(); i = (i | (i + 1))) {
			f[i] += value;
		}
	}

	int get(int r) {
		int summ = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
			summ += f[i];
		}
		return summ;
	}
};

int getInd(int x, std::vector<ll> &a) {
	auto it = std::lower_bound(a.begin(), a.end(), x);
	return it - a.begin();
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int n;
	scanf("%d", &n);
	std::vector<ll> b(n), a(n);
	std::vector<std::pair<int, int>> cur;
	FOR(i, n) {
		std::cin >> b[i] >> a[i];
		cur.pb({ b[i], a[i] });
	}
	std::sort(cur.begin(), cur.end());
	ll answ = 0;
	if (a.back() == 0) {
		std::sort(b.begin(), b.end());
		FOR(i, n) {
			int ind = i;
			if ((n - ind) * (b[i]) > answ) {
				answ = (n - ind) * (b[i]);
			}
		}
	}
	else {
		std::vector<ll> compress = a;
		std::sort(compress.begin(), compress.end());
		fenwick f(n);
		FOR(i, n) {
			f.add(getInd(compress[i], compress), 1);
		}
		for (int i = n - 1; i >= 0; --i) {
			f.add(getInd(cur[i].second, compress), -1);
			for (int j = 0; j < n; ++j) {
				ll curansw = (n - i) * cur[i].first + (i - f.get(getInd(compress[j], compress) - 1)) * compress[j];
				answ = std::max(answ, curansw);
			}
		}
	}
	printf("%lld", answ);
}