#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <cmath>
typedef long long ll;
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define pb push_back
const int N = 501;
 
struct NUM {
    std::vector<short> nums;
 
    NUM() { nums.resize(N, 0); }
    NUM(short x) {
        nums.resize(N, 0);
        nums[x] = 1;
    }
    void operator+=(short x) {
        nums[x]++;
        short d = 0;
        for (short i = x; i < N; ++i) {
            d += nums[i];
            nums[i] = d % 2;
            d /= 2;
            if (d == 0) {
                return;
            }
        }
    }
 
    friend bool operator<(NUM first, NUM second) {
		return first.nums < second.nums;
    }
    friend bool operator>(NUM first, NUM second) {
		return first.nums > second.nums;
    }
};
 
int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    int n, m, k;
    std::cin >> n >> m >> k;
    std::vector<std::pair<short, short>> points(k);
    std::vector<std::vector<short>> g(k, std::vector<short>(k));
    FOR(i, k) {
        std::cin >> points[i].first >> points[i].second;
    }
    FOR(i, k) {
        FOR(j, k) {
            g[i][j] = std::max(abs(points[i].first - points[j].first), abs(points[i].second - points[j].second));
        }
    }
    std::vector<short> p(k, -1);
    std::vector<NUM> d(k, NUM(N - 1));
    d[0] = NUM();
    std::set<std::pair<NUM, short>> dijk;
    dijk.insert({ d[0], 0 });
    while (!dijk.empty()) {
        int v = dijk.begin()->second;
        dijk.erase(dijk.begin());
        for (int i = 0; i < k; ++i) {
            NUM to = d[v];
            to += g[v][i];
            if (d[i] > to) {
                d[i] = to;
                dijk.insert({ d[i], i });
                p[i] = v;
            }
        }
    }
    std::vector<int> answ;
    short cur = k - 1;
    while (cur != -1) {
        answ.pb(cur);
        cur = p[cur];
    }
    std::cout << answ.size() << '\n';
    for (int i = answ.size() - 1; i >= 0; --i) {
        std::cout << answ[i] + 1 << ' ';
    }
}