#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
const int N = 3e5;
std::pair<int, int> merge(std::pair<int, int> first, std::pair<int, int> second) {
	return std::max(first, second);
}

struct seg_tree {
	std::vector<std::pair<int, int>> tree;

	seg_tree() {
		tree.resize(4 * N);
	}
	void add(int v, int tl, int tr, int ind, int x) {
		if (tl == tr && ind == tl) {
			tree[v] = { x, ind };
			return;
		}
		int tm = (tl + tr) / 2;
		if (tm >= ind) {
			add(v * 2, tl, tm, ind, x);
		}
		else {
			add(v * 2 + 1, tm + 1, tr, ind, x);
		}
		tree[v] = merge(tree[v * 2], tree[v * 2 + 1]);
	}
	std::pair<int, int> get(int v, int tl, int tr, int l, int r) {
		if (l > r) {
			return { 0, -1 };
		}
		if (tl == l && tr == r) {
			return tree[v];
		}
		int tm = (tl + tr) / 2;
		return merge(get(v * 2, tl, tm, l, std::min(r, tm)), get(v * 2 + 1, tm + 1, tr, std::max(l, tm + 1), r));
	}

};

int main() {
	int n;
	std::cin >> n;
	std::vector<int>a(n), used(n);
	std::set<int> left;
	left.insert(n);
	std::vector<std::pair<int, int>>b;
	seg_tree cur;
	FOR(i, n) {
		std::cin >> a[i];
		cur.add(1, 0, n - 1, i, a[i]);
		b.push_back({ a[i], i });
	}
	std::sort(b.begin(), b.end());
	ll answ = 0;
	for (int i = 0; i < b.size(); ++i) {
		if (used[b[i].second]) {
			continue;
		}
		auto it = left.lower_bound(b[i].first);
		int ind = *it - 1;
		std::pair<int, int> get = cur.get(1, 0, n - 1, b[i].second, ind);
		answ++;
		for (int q = b[i].second; q <= get.second; ++q) {
			used[q] = 1;
		}
		left.insert(b[i].second);
	}
	std::cout << answ;
}