#include <iostream>
#include <vector>
#include <cassert>
#include <set>
#include <algorithm>
#include <cstdio>
#define FOR(i, n) for (int i = 0; i < n; ++i)
typedef long long ll;
struct fenwick {
	std::vector<int> f;

	fenwick(int n) {
		f.resize(n + 10);
	}

	void add(int x, int val) {
		for (int i = x; i < f.size(); i = (i | (i + 1))) {
			f[i] += val;
		}
	}
	int get(int r) {
		int sum = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
			sum += f[i];
		}
		return sum;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};

int getInd(int x, std::vector<int>&a) {
	auto it = std::lower_bound(a.begin(), a.end(), x);
	return it - a.begin();
}

int main() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(0);
	int n, p;
	std::cin >> n >> p;
	std::vector<int>a(n);
	FOR(i, n) {
		std::cin >> a[i];
	}
	if (p == 1) {
		std::vector<int> answ(n);
		std::vector<int> compress1, compress2;
		fenwick first(n), second(n);
		FOR(i, n) {
			compress1.push_back(a[i] - i);
			compress2.push_back(a[i] + i);
		}
		std::sort(compress1.begin(), compress1.end());
		std::sort(compress2.begin(), compress2.end());
		FOR(i, n) {
			second.add(getInd(a[i] + i, compress2), 1);
		}
		FOR(j, n) {
			int f1 = second.get(getInd(a[j] + j, compress2) - 1);
			int f2 = first.get(getInd(a[j] - j, compress1) - 1);
			second.add(getInd(a[j] + j, compress2), -1);
			first.add(getInd(a[j] - j, compress1), 1);
			std::cout << f1 + f2 + 1 << '\n';
		}
	}
	else {
		int max = (1 << n);
		std::vector<int>answ(n);
		for (int asd = 1; asd <= 3; ++asd) {
			int mask;
			if (asd == 1) {
				mask = (1 << (n - 1));
			}
			if (asd == 2) {
				mask = (1);
			}
			if (asd == 3) {
				mask = (1 << (n - 1)) + 1;
			}
			std::vector<int> m;
			for (int j = 0; j < n; ++j) {
				if ((mask >> j) & 1) {
					m.push_back(j);
				}
			}
			std::vector<std::pair<int, int>>cur;
			int pointer2 = 0;
			for (int j = 0; j < n; ++j) {
				while (pointer2 < m.size() && m[pointer2] < j) {
					pointer2++;
				}
				int first = -1e9, second = -1e9;
				if (pointer2 != m.size()) {
					first = m[pointer2];
				}
				if (pointer2 != 0) {
					second = m[pointer2 - 1];
				}
				cur.push_back({ std::min(abs(first - j), abs(second - j)) + a[j], j });
			}
			std::sort(cur.begin(), cur.end());
			int pointer = 0;
			for (int i = 0; i < n; ++i) {
				while (pointer < n && cur[pointer].first < cur[i].first) {
					pointer++;
				}
				answ[cur[i].second] = std::max(answ[cur[i].second], pointer);
			}
		}
		FOR(i, n) {
			std::cout << answ[i] + 1 << '\n';
		}
	}
	return 0;
}