#include <bits/stdc++.h>

#define mp make_pair

typedef std::pair<int, int> pii;

const int N = 400100;

struct ins
{
    int tree[N];
    std::vector<int> coor;
    int m;
    void init(std::vector<int> &v)
    {
        coor = v;
        std::sort(coor.begin(), coor.end());
        auto last = std::unique(coor.begin(), coor.end());
        m = last - coor.begin();                
        for (int i = 0; i <= m; ++i)
            tree[i] = 0;
    }
        
    int get(int a)
    {
        int ind = std::lower_bound(coor.begin(), coor.begin() + m, a) - coor.begin();
        int sum = 0;
        for (int j = ind; j > 0; j = (j & (j - 1)))
            sum += tree[j]; 
        return sum;                
    }

    void add(int a, int c)
    {
        int ind = std::lower_bound(coor.begin(), coor.begin() + m, a) - coor.begin();
        for (int j = ind + 1; j <= m; j += (j & (-j)))
            tree[j] += c;
    }
};

namespace alpha
{
std::vector<int> solve(int* a, int n)
{
    std::vector<int> coor;
    for (int i = 0; i < n; ++i)
        coor.push_back(a[i] - i);
    ins h;
    h.init(coor);
    std::vector<int> ans;
    ans.resize(n);
    for (int i = 0; i < n; ++i)
    {
        ans[i] = h.get(a[i] - i);
        h.add(a[i] - i, 1);    
    }                    
    return ans;
}

void get_ans(int n)
{
    int a[n];
    for (int i = 0; i < n; ++i)
        scanf("%d", a + i);
    std::vector<int> v1 = solve(a, n);
    std::reverse(a, a + n);
    std::vector<int> v2 = solve(a, n);
    std::reverse(v2.begin(), v2.end());
    for (int i = 0; i < n; ++i)
        printf("%d\n", 1 + v1[i] + v2[i]);
}
}

namespace beta
{

std::vector<int> do_hard(int* a, int n)
{
    int k = (n + 1) / 2;
    std::vector<int> ans;
    ans.assign(k, 1);
    ins h1;
    std::vector<int> v;
    for (int i = 0; i < k; ++i)
        v.push_back(a[i] + i);
    h1.init(v);
    for (int i = 0; i < k; ++i)
    {
        ans[i] += h1.get(a[i] + i);
        h1.add(a[i] + i, 1);
    }
    ins h2;
    ins h3;
    v.clear();
    for (int i = 0; i < n; ++i)
        v.push_back(a[i]);
    h2.init(v);
    v.clear();
    for (int i = 0; i < n; ++i)
        v.push_back(a[i] - i);
    h3.init(v);
    int yk = n - 1;
    if (n % 2 == 0)
    {
        h2.add(a[yk], 1);
        --yk;
    }
    for (int i = yk; i >= k; --i)
        h3.add(a[i] - i, 1);
    for (int i = k - 1; i > 0; --i)
    {
        ans[i] += h2.get(a[i] + i);
        ans[i] += h3.get(a[i] - i);
        h2.add(a[yk], 1);
        h3.add(a[yk] - yk, -1);
        --yk;
        h2.add(a[yk], 1);
        h3.add(a[yk] - yk, -1);
        h3.add(a[i] - i, 1);
        --yk;
    }
    ans[0] = 1;
    return ans;
}
void get_ans(int n)
{
    int a[n];
    for (int i = 0; i < n; ++i)
        scanf("%d", a + i);
    int ans[n];
    for (int i = 0; i < n; ++i)
        ans[i] = 0;
    int tr1[n];
    for (int i = 0; i < n; ++i)
        tr1[i] = a[i] + i;
    std::sort(tr1, tr1 + n);
    for (int i = 0; i < n; ++i)
        ans[i] = std::max(ans[i], (int)((std::lower_bound(tr1, tr1 + n, a[i] + i) - tr1) + 1));
    int tr2[n];
    for (int i = 0; i < n; ++i)
        tr2[i] = a[i] - i;
    std::sort(tr2, tr2 + n);
    for (int i = 0; i < n; ++i)
        ans[i] = std::max(ans[i], (int)((std::lower_bound(tr2, tr2 + n, a[i] - i) - tr2) + 1));
    std::vector<int> ansle = do_hard(a, n);
    std::reverse(a, a + n);
    std::vector<int> ansr = do_hard(a, n);
    for (int i = 0; i < ansle.size(); ++i)
        ans[i] = std::max(ans[i], ansle[i]);
    for (int i = 0; i < ansr.size(); ++i)
        ans[n - i - 1] = std::max(ans[n - i - 1], ansr[i]);
    for (int i : ans)
        printf("%d\n", i);
}
}

int main()
{
    int n, p;
    while (scanf("%d %d", &n, &p) == 2)
        if (p == 1)
            alpha::get_ans(n);
        else
            beta::get_ans(n);
    return 0;
}