import java.util.Scanner;

public class A {
    static int n, a[];
    static TreeRange tr;

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        tr = new TreeRange(a);
        System.out.println(solve(0, n - 1));
    }

    static int solve(int l, int r) {
        if (l > r) {
            return 0;
        }
        if (l == r) {
            return 1;
        }
        int max = tr.max(l, r);
        int min = tr.min(l, r);
        if (a[min] != a[l]) {
            return solve(l, min - 1) + solve(min, r);
        }
        if (a[max] != a[r]) {
            return solve(l, max) + solve(max + 1, r);
        }
        return 1;
    }

    static class TreeRange {
        int m;
        int x[];
        int y[];
        static int compMin(int i, int j){
            if(i == -1){
                return j;
            }
            if(j == -1){
                return i;
            }
            if(a[Math.min(i, j)] <= a[Math.max(i, j)]){
                return Math.min(i, j);
            }
            return Math.max(i, j);
        }
        static int compMax(int i, int j){
            if(i == -1){
                return j;
            }
            if(j == -1){
                return i;
            }
            if(a[Math.min(i, j)] > a[Math.max(i, j)]){
                return Math.min(i, j);
            }
            return Math.max(i, j);
        }
        TreeRange(int a[]) {
            m = init(a.length);
            x = new int[2 * m];
            y = new int[2 * m];
            for (int i = 0; i < n; i++) {
                x[i + m] = i;
                y[i + m] = i;
            }
            for (int i = n; i < m; i++) {
                x[i + m] = -1;
                y[i + m] = -1;
            }
            for (int i = m - 1; i >= 1; i--) {
                x[i] = compMin(x[2 * i], x[2 * i + 1]);
                y[i] = compMax(y[2 * i], y[2 * i + 1]);
            }
        }

        int min(int l, int r) {
            /*int ans = l;
            int min = a[l];
            for (int i = l; i <= r; i++) {
                if (a[i] < min) {
                    min = a[i];
                    ans = i;
                }
            }
            */
            return minFromTop(0, m - 1, l, r, 1);
        }

        int max(int l, int r) {
           /* int ans = r;
            int max = a[r];
            for (int i = r; i >= l; i--) {
                if (a[i] > max) {
                    max = a[i];
                    ans = i;
                }
            }
            return ans;
            */
           return maxFromTop(0, m - 1, l, r, 1);
        }

        int minFromTop(int L, int R, int l, int r, int v) {
            if (l > R || L > r) {
                return -1;
            }
            if(L >= l && R <= r) {
                return x[v];
            }
            int first = minFromTop(L, (L + R) / 2, l, r, 2 * v);
            int second = minFromTop((L + R) / 2 + 1, R, l, r, 2 * v + 1);
            return compMin(minFromTop(L, (L + R) / 2, l, r, 2 * v), minFromTop((L + R) / 2 + 1, R, l, r, 2 * v + 1));
        }
        int maxFromTop(int L, int R, int l, int r, int v) {
            if (L == R) {
                return L;
            }
            if (l > R || L > r) {
                return -1;
            }
            if(L >= l && R <= r) {
                return y[v];
            }
            return compMax(maxFromTop(L, (L + R) / 2, l, r, 2 * v), maxFromTop((L + R) / 2 + 1, R, l, r, 2 * v + 1));
        }
        int init(int k) {
            int ans = 1;
            while (ans < k) {
                ans *= 2;
            }
            return ans;
        }
    }
}
