import java.util.Scanner;

public class A {
    static int n, a[];
    static table tr;

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        n = in.nextInt();
        a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = in.nextInt();
        }
        tr = new table(a);
        System.out.println(solve(0, n - 1));
    }

    static int solve(int l, int r) {
        if (l > r) {
            return 0;
        }
        if (l == r) {
            return 1;
        }
        int max = tr.max(l, r);
        int min = tr.min(l, r);
        if (a[min] != a[l]) {
            return solve(l, min - 1) + solve(min, r);
        }
        if (a[max] != a[r]) {
            return solve(l, max) + solve(max + 1, r);
        }
        return 1;
    }

    static class table {
        int k;
        int x[][];
        int y[][];
        int pow[];

        table(int a[]) {
            k = log(n);
            x = new int[k + 1][n];
            y = new int[k + 1][n];
            pow = new int[k + 1];
            pow[0] = 1;
            for (int j = 1; j <= k; j++) {
                pow[j] = 2 * pow[j - 1];
            }
            for (int i = 0; i < n; i++) {
                x[0][i] = i;
                y[0][i] = i;
            }
            for (int j = 1; j <= k; j++) {
                x[j][k] = compMin(x[j - 1][k], x[j - 1][k + pow[j - 1]]);
                y[j][k] = compMax(x[j - 1][k], x[j - 1][k + pow[j - 1]]);
            }
        }

        int min(int l, int r) {
            if (l == r) {
                return l;
            }
            int log = log(r - l + 1);
            return compMin(x[log][l], min(l + pow[log], r));
        }

        int max(int l, int r) {
            if (l == r) {
                return l;
            }
            int log = log(r - l + 1);
            return compMax(x[log][l], max(l + pow[log], r));
        }

        int log(int m) {
            int ans = 0;
            while (m > 1) {
                m /= 2;
            }
            return ans;
        }

        static int compMin(int i, int j) {
            if (i >= n) {
                return j;
            }
            if (j >= n) {
                return i;
            }
            if (a[Math.min(i, j)] <= a[Math.max(i, j)]) {
                return Math.min(i, j);
            }
            return Math.max(i, j);
        }

        static int compMax(int i, int j) {
            if (i >= n) {
                return j;
            }
            if (j >= n) {
                return i;
            }
            if (a[Math.min(i, j)] > a[Math.max(i, j)]) {
                return Math.min(i, j);
            }
            return Math.max(i, j);
        }
    }
}
