#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define ll long long
using namespace std;

struct person {
	ll a, b;
	person() {}
	person(ll a, ll b) : a(a), b(b) {}
};

bool cmp(const person &x, const person &y) {
	return (x.a < y.a || (x.a == y.a && x.b < y.b));
}

struct st {
	ll c, left, right, mx, mxi;
	st *l, *r;
	st() {}
	st(ll left, ll right) : left(left), right(right), l(nullptr), r(nullptr), c(0), mx(0), mxi(0) {}
};
typedef st *pst;

vector<person> a;
vector<ll> r, lt, eqs;
map<ll, ll> ind;

void build(pst &v, ll left, ll right) {
	v = new st(left, right);
	if (left == right) {
		v->mx = eqs[left];
		return;
	}
	ll mid = (left + right) / 2;
	build(v->l, left, mid);
	build(v->r, mid + 1, right);
}

void inc(pst &v, ll ind) {
	v->c++;
	if (v->left == v->right) {
		v->mxi++;
		return;
	}
	if (ind <= v->l->right)
		inc(v->l, ind);
	else
		inc(v->r, ind);
	if (v->l->mx*(v->r->c + v->l->mxi) > v->r->mx*v->r->mxi)
		v->mx = v->l->mx, v->mxi = v->l->mxi + v->r->c;
	else
		v->mx = v->r->mx, v->mxi = v->r->mxi;
}

int main() {
	//-------------------------------------------------------------
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);            //
	//freopen("Text.txt", "r", stdin);                           //
	//-------------------------------------------------------------
	int n;
	cin >> n;
	a.assign(n, person(0, 0));
	int i;
	for (i = 0; i < n; i++) {
		cin >> a[i].a >> a[i].b;
		if (ind.count(a[i].b) == 0)
			ind[a[i].b] = 1;
	}
	sort(a.begin(), a.end(), cmp);
	pst s = nullptr;
	ll siz = ind.size();
	eqs.assign(siz, 0);
	ll c = 0;
	for (auto &it : ind) {
		it.second = c++;
		eqs[it.second] = it.first;
	}
	build(s, 0, siz - 1);
	ll ans = 0, tmp;
	for (i = 0; i < n; i++) {
		tmp = s->mx*s->mxi;
		inc(s, ind[a[i].b]);
		tmp += a[i].a*(n - i);
		ans = max(ans, tmp);
	}
	cout << ans;
}