#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#define ll long long
using namespace std;

struct person {
	ll a, b;
	person() {}
	person(ll a, ll b) : a(a), b(b) {}
};

bool cmp(const person &x, const person &y) {
	return (x.a < y.a || (x.a == y.a && x.b < y.b));
}

struct st {
	ll c, left, right;
	st *l, *r;
	st() {}
	st(ll left, ll right) : left(left), right(right), l(nullptr), r(nullptr), c(0) {}
};
typedef st *pst;

vector<person> a;
vector<ll> r, lt;
map<ll, ll> ind;

void build(pst &v, ll left, ll right) {
	v = new st(left, right);
	if (left == right)
		return;
	ll mid = (left + right) / 2;
	build(v->l, left, mid);
	build(v->r, mid + 1, right);
}

ll get_mx(pst &v, ll l, ll r) {
	if (v->left == l && v->right == r)
		return v->c;
	ll ans = 0;
	if (l <= v->l->right)
		ans += get_mx(v->l, l, min(r, v->l->right));
	if (r >= v->r->left)
		ans += get_mx(v->r, max(l, v->r->left), r);
	return ans;
}

void inc(pst &v, ll ind) {
	v->c++;
	if (v->left == v->right)
		return;
	if (ind <= v->l->right)
		inc(v->l, ind);
	else
		inc(v->r, ind);
}

int main() {
	//-------------------------------------------------------------
	ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);			 //
	//freopen("Text.txt", "r", stdin);							 //
	//-------------------------------------------------------------
	int n;
	cin >> n;
	a.assign(n, person(0, 0));
	int i;
	for (i = 0; i < n; i++) {
		cin >> a[i].a >> a[i].b;
		if (ind.count(a[i].b) == 0)
			ind[a[i].b] = 1;
	}
	sort(a.begin(), a.end(), cmp);
	pst s = nullptr;
	ll siz = ind.size();
	build(s, 0, siz - 1);
	ll c = 0;
	for (auto &it : ind)
		it.second = c++;
	ll ans = 0, tmp;
	for (i = 0; i < n; i++) {
		tmp = 0;
		for (auto &j : ind)
			tmp = max(tmp, j.first * get_mx(s, j.second, siz - 1));
		inc(s, ind[a[i].b]);
		tmp += a[i].a*(n - i);
		ans = max(ans, tmp);
	}
	cout << ans;
}