#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

struct Number{
    vector <bool> a;

    Number(int x) {
        a.resize(511);
        a[x] = 1;
    }

    Number() {
        a.resize(511);
    }

    Number operator+(Number other) {
        Number ans = Number();
        int c = 0;
        for (int i = 0; i < a.size(); i++) {
            int d = a[i] + other.a[i] + c;
            ans.a[i] = d % 2;
            c = d >> 1;
        }
        return ans;
    }

    bool operator<(Number other) {
        int i = a.size() - 1;
        while (i > 0 && a[i] == other.a[i]) i--;
        return a[i] < other.a[i];
    }
};

Number INF = Number(510);

int main()
{
    int n, p, k;
    cin >> n >> p >> k;
    vector <pair <int, int> > a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i].first >> a[i].second;
    }
    vector <Number> d(k, INF);
    d[0] = Number();
    vector <bool> used(k, 0);
    vector <int> pr(k, -1);
    for (int i = 0; i < k; i++) {
        Number m = INF;
        int id;
        for (int j = 0; j < k; j++) {
            if (used[j]) continue;
            if (d[j] < m) {
                m = d[j];
                id = j;
            }
        }
        if (id == k - 1) {
            break;
        }
        used[id] = true;
        for (int j = 0; j < k; j++) {
            Number e = Number(max(abs(a[id].first - a[j].first), abs(a[id].second - a[j].second)));
            //cout << (d[j] < INF) << " " << (d[id]  < INF) << endl;
            if (e + d[id] < d[j]) {
                d[j] = e + d[id];
                pr[j] = id;
            }
        }
    }
    vector <int> path = {k - 1};
    int cur = k - 1;
    while (cur) {
        //cout << cur << endl;
        cur = pr[cur];
        path.push_back(cur);
    }
    reverse(path.begin(), path.end());
    cout << path.size() << endl;
    for (int i : path) {
        cout << i + 1 << " ";
    }
    return 0;
}
