#include <iostream>
#include <vector>

using namespace std;

struct Node{
    Node *L = nullptr, *R = nullptr;
    int l, r;
    int mx, id, mn;

    Node() {

    }

    void update() {
        if (L->mx > R->mx) {
            mx = L->mx;
            id = L->id;
        }
        else {
            mx = R->mx;
            id = R->id;
        }
        mn = min(L->mn, R->mn);
    }
};

const int INF = 1e9 + 548;
vector <int> a;

Node* build(int l, int r) {
    Node* v = new Node();
    v->l = l;
    v->r = r;
    if (l == r) {
        v->mx = v->mn = a[l];
        v->id = l;
    }
    else {
        int m = (r + l) / 2;
        v->L = build(l, m);
        v->R = build(m + 1, r);
        v->update();
    }
    return v;
}

pair <int, int> getmx(Node* v, int l, int r) {
    //cout << v-> l << " " << v->r << " " << l << " " << r << endl;
    if (v->r < l || v->l > r) {
        return {-1, -1};
    }
    if (v->l >= l && v->r <= r) {
        //cout << v->l << " " << v->r << " " << v->id << endl;
        return {v->mx, v->id};
    }
    auto p1 = getmx(v->L, l, r), p2 = getmx(v->R, l, r);
    return max(p1, p2);
}

int getmn(Node* v, int l, int r) {
    //cout << v-> l << " " << v->r << " " << l << " " << r << endl;
    if (v->r < l || v->l > r) {
        return INF;
    }
    if (v->l >= l && v->r <= r) {
        return v->mn;
    }
    return min(getmn(v->L, l, r), getmn(v->R, l, r));
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    int n;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    Node* root = build(0, n - 1);
    int k = 0, i = 0;
    while (i < n) {
        int l = i - 1, r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            int mn = getmn(root, i, m);
            //cout << m << " " << mn << endl;
            //cout << endl;
            if (mn < a[i]) {
                r = m;
            }
            else {
                l = m;
            }
        }
        //cout << l << endl;
        auto p = getmx(root, i, l);
        k++;
        //cout << p.first << " " << p.second << endl;
        i = p.second + 1;
    }
    cout << k;
    return 0;
}
