#include <bits/stdc++.h>

using namespace std;

struct Node{
    Node *l = nullptr, *r = nullptr;
    int x, y;
    int sz;

    Node(int val) {
        x = val;
        y = (rand() << 16) + rand();
        sz = 1;
    }

    void update() {
        sz = 1;
        if (l) {
            sz += l->sz;
        }
        if (r) {
            sz += r->sz;
        }
    }
};

int getsz(Node* v) {
    if (v) {
        return v->sz;
    }
    return 0;
}

Node* merge(Node* a, Node* b) {
    if (!a) {
        return b;
    }
    if (!b) {
        return a;
    }
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        a->update();
        return a;
    }
    else {
        b->l = merge(a, b->l);
        b->update();
        return b;
    }
}

pair <Node*, Node*> split(Node* v, int x) {
    if (!v) {
        return {nullptr, nullptr};
    }
    if (v->x >= x) {
        auto p = split(v->l, x);
        v->l = p.second;
        v->update();
        return {p.first, v};
    }
    else {
        auto p = split(v->r, x);
        v->r = p.first;
        v->update();
        return {v, p.second};
    }
}

int a[400000], b[400000], ans[400000];

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(nullptr);
    cin.tie(nullptr);
    srand(time(NULL));
    int n, p;
    cin >> n >> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        b[i] = a[i] + i;
    }
    Node* root = nullptr;
    for (int i = n - 1; i >= 0; i--) {
        auto p = split(root, b[i]);
        ans[i] += getsz(p.first);
        root = merge(p.first, merge(new Node(b[i]), p.second));
    }
    for (int i = 0; i < n; i++) {
        b[i] = a[i] + n - i - 1;
    }
    root = nullptr;
    for (int i = 0; i < n; i++) {
        auto p = split(root, b[i]);
        ans[i] += getsz(p.first);
        root = merge(p.first, merge(new Node(b[i]), p.second));
    }
    for (int i = 0; i < n; i++) {
        cout << ans[i] + 1 << endl;
    }
    return 0;
}
