#include <iostream>
#include <cstdio>
#include <cassert>
#include <cmath>
#include <climits>
#include <cstdlib>
#include <vector>
#include <algorithm>

using namespace std;
typedef unsigned int index;

struct Block
{
	vector<int> zn;
	//vector<pair<int, int>> st;
	long long get(int add) const
	{
		long long ans = 0;
		for (index i = 0; i < zn.size(); i++)
		{
			if (ans < zn[i] * (long long)(zn.size() - i + add))
				ans = zn[i] * (long long)(zn.size() - i + add);
		}
		return ans;
	}
	Block(const vector<int> &nw): zn(nw)
	{
		sort(zn.begin(), zn.end());
	}
	void erase(int a)
	{
		for (index i = 0; i < zn.size(); i++)
		{
			if (zn[i] == a)
			{
				zn.erase(zn.begin() + i);
				break;
			}
		}
	}
};

long long get(const vector<Block> &blocks)
{
	long long ans = 0;
	int prf = 0;
	for (auto i: blocks)
	{
		ans = max(ans, i.get(prf));
		prf += (int)i.zn.size();
	}
	return ans;
}

void erase(vector<Block> &blocks, int a)
{
	for (index i = 0; i < blocks.size(); i++)
	{
		if (blocks[i].zn[0] < a)
		{
			blocks[i].erase(a);
			if (blocks[i].zn.size() == 0)
			{
				blocks.erase(blocks.begin() + i);
			}
			return;
		}
	}
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n;
	cin >> n;
	vector<pair<int, int>> a(n);
	const size_t MAX_BLOCK = 500;
	vector<Block> blocks;
	for (auto &i: a)
		cin >> i.first >> i.second;
	sort(a.rbegin(), a.rend());
	vector<int> cur;
	for (index i = 0; i < n; i++)
	{
		cur.push_back(a[i].second);
		if ((cur.size()) % MAX_BLOCK == 0)
		{
			blocks.push_back(Block(cur));
			cur.clear();
		}
	}
	if (cur.size() > 0)
	{
		blocks.push_back(Block(cur));
		cur.clear();
	}
	long long ans = get(blocks);
	for (index i = 0; i < n; i++)
	{
		erase(blocks, a[i].second);
		ans = max(ans, a[i].first * (long long)(i + 1) + get(blocks));
	}
	cout << ans << endl;
	return 0;
}
