#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cassert>
#include <climits>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;
typedef unsigned int index;

void splice(index l, size_t r, vector<index> &a)
{
	vector<index> cp(a.begin() + l, a.begin() + r);
	index cur = 0;
	for (index i = 1; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
	for (index i = 0; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
}

vector<index> spliceb(index l, size_t r, vector<index> a)
{
	vector<index> cp(a.begin() + l, a.begin() + r);
	index cur = 0;
	for (index i = 1; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
	for (index i = 0; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
	return a;
}

index find(index i, vector<index> &a)
{
	for (index j = 0; j < a.size(); j++)
		if (a[j] == i)
			return j;
	return (index)-1;
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n;
	cin >> n;
	vector<index> a(n);
	for (auto &i: a)
		cin >> i, i--;
	vector<pair<index, size_t>> ans;
	for (index i = 0; i < n / 2; i++)
	{
		index cur = find(i, a);
		index j = (index)n - i - 1;
		index cur2 = find(j, a);
		while (cur != i or cur2 != j)
		{
			if (cur2 == j)
			{
				if ((cur - i) % 2 == 1)
				{
					size_t r = j;
					splice(i, r, a); 
					ans.push_back({i, r});
				}
				else
				{
					size_t r = j;
					splice(i + 1, r, a); 
					ans.push_back({i + 1, r});
				}
			}
			else if (cur == i)
			{
				if ((cur2 - i) % 2 == 0)
				{
					size_t r = j + 1;
					splice(i + 2, r, a); 
					ans.push_back({i + 2, r});
				}
				else
				{
					size_t r = j + 1;
					splice(i + 1, r, a); 
					ans.push_back({i + 1, r});
				}
			}
			else
			{
				if ((cur - cur2) % 2 == 0)
				{
					splice(cur2, cur2 + 2, a);
					ans.push_back({cur2, cur2 + 2});
				}
				cur = find(i, a);
				cur2 = find(j, a);
				if ((cur - i) % 2 == 1)
				{
					size_t r = j + 1;
					auto x = spliceb(i, r, a);
					index c = find(i, x);
					index d = find(j, x);
					if ((c - d) % 2 == 0 and c != i and d != j)
					{
						r--;
					}
					splice(i, r, a); 
					ans.push_back({i, r});
				}
				else
				{
					size_t r = j + 1;
					auto x = spliceb(i + 1, r, a);
					index c = find(i, x);
					index d = find(j, x);
					if ((c - d) % 2 == 0 and c != i and d != j)
					{
						r--;
					}
					splice(i + 1, r, a); 
					ans.push_back({i + 1, r});
				}
			}
			cur = find(i, a);
			cur2 = find(j, a);
		}
	}
	assert(ans.size() <= 16000);
	cout << ans.size() << endl;
	for (auto i: ans)
		cout << i.first + 1 << " " << i.second << endl;
}
