#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cassert>
#include <climits>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;
typedef unsigned int index;

void splice(index l, size_t r, vector<index> &a)
{
	vector<index> cp(a.begin() + l, a.begin() + r);
	index cur = 0;
	for (index i = 1; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
	for (index i = 0; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
}

vector<index> spliceb(index l, size_t r, vector<index> a)
{
	vector<index> cp(a.begin() + l, a.begin() + r);
	index cur = 0;
	for (index i = 1; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
	for (index i = 0; i < r - l; i += 2)
		a[l + cur] = cp[i], cur++;
	return a;
}

index find(index i, vector<index> &a)
{
	for (index j = 0; j < a.size(); j++)
		if (a[j] == i)
			return j;
	return (index)-1;
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	size_t n;
	cin >> n;
	vector<index> a(n);
	for (auto &i: a)
		cin >> i, i--;
	vector<pair<index, size_t>> ans;
	index i = 0, j = (index)n - 1;
	index cur = find(i, a), cur2 = find(j, a);
	while (i < j)
	{
		if (cur == i)
		{
			i++;
			cur = find(i, a);
		}
		else if (cur2 == j)
		{
			j--;
			cur2 = find(j, a);
		}
		else
		{
			if ((cur - cur2) % 2 == 0)
			{
				size_t r;
				if (cur > cur2)
					r = cur + 1;
				else 
					r = j + 1;
				while ((r - cur) % 4 != 2)
					r--;
				splice(cur2, r, a);
				ans.push_back({cur2, r});
			}
			else
			{
				if ((cur - i) % 2 == 1)
				{
					size_t r = j + 1;
					splice(i, r, a); 
					ans.push_back({i, r});
				}
				else
				{
					size_t r = j + 1;
					splice(i + 1, r, a); 
					ans.push_back({i + 1, r});
				}
			}
			cur = find(i, a);
			cur2 = find(j, a);
		}
	}
	cout << ans.size() << endl;
	for (auto k: ans)
		cout << k.first + 1 << " " << k.second << endl;
}
