#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cassert>
#include <climits>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;
typedef unsigned int index;

void upd(index v, index tl, size_t tr, index pos, vector<size_t> &t)
{
	if (pos < tl or pos >= tr)
		return;
	if (tr - tl == 1)
	{
		t[v]++;
		return;
	}
	size_t tm = (tl + tr) / 2;
	upd(2 * v + 1, tl, tm, pos, t);
	upd(2 * v + 2, (index)tm, tr, pos, t);
	t[v] = t[2 * v + 1] + t[2 * v + 2];
}

size_t get(index v, index tl, size_t tr, index l, size_t r, vector<size_t> &t)
{
	if (tl >= r or tr <= l)
		return 0;
	if (l <= tl and tr <= r)
		return t[v];
	size_t tm = (tl + tr) / 2;
	return get(2 * v + 1, tl, tm, l, r, t) + get(2 * v + 2, (index)tm, tr, l, r, t);
}

vector<size_t> ans(const vector<int> &a)
{
	vector<pair<int, index>> b(a.size());
	for (index i = 0; i < a.size(); i++)
	{
		b[i] = {a[i] - (int)i, i};
	}
	sort(b.begin(), b.end(), [](pair<int, index> x, pair<int, index> y)
			{
				return x.first < y.first or (x.first == y.first and x.second > y.second);
			});
	vector<size_t> ans(a.size());
	vector<size_t> t(4 * a.size());
	for (index i = 0; i < a.size(); i++)
	{
		ans[b[i].second] = get(0, 0, a.size(), 0, b[i].second, t);
		upd(0, 0, a.size(), b[i].second, t);
	}
	return ans;
}

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
#endif
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	size_t n, p;
	cin >> n >> p;
	vector<int> a(n);
	for (auto &i: a)
		cin >> i;
	if (p == 1)
	{
		auto x = ans(a);
		reverse(a.begin(), a.end());
		auto y = ans(a);
		reverse(y.begin(), y.end());
		for (index i = 0; i < n; i++)
		{
			cout << x[i] + y[i] + 1 << "\n";
		}
	}
}
