#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
//#include "Source.h"

using namespace std;

typedef long long ll;

vector<pair<int, int> > v;

const int MAXN = 600;

bool bless(vector<int>& v1, vector<int>& v2) {
	if (v1.size() < v2.size())
		return true;
	else if (v1.size() > v2.size())
		return false;
	for (int i = v1.size() - 1; i >= 0; --i)
		if (v1[i] < v2[i])
			return true;
		else if (v1[i] > v2[i])
			return false;
	return false;
}

void norm(vector<int>& v) {
	for (int i = 0; i < v.size(); ++i) {
		if (v[i] >= 2) {
			if (v.size() == i + 1)
				v.push_back(0);
			v[i + 1] += v[i] / 2;
		}
		v[i] %= 2;
	}
}

void dijkstr() {
	int k = v.size();
	vector<vector<int> > dp(k, vector<int> (MAXN, 1));
	vector<int> p(k, -1);
	dp[0] = { 0 };
	vector<char> used(k, 0);
	for (int i = 0; i < k; ++i) {
		int id = -1;
		for (int z = 0; z < k; ++z){
			if (!used[z] && (id == -1 || bless(dp[z], dp[id]))) 
				id = z;
		}
		if (id == -1 || dp[id].size() == MAXN)
			break;
		used[id] = 1;
		for (int j = 0; j < k; ++j) {
			if (j == id)
				continue;
			vector<int> to = dp[id];
			int dist = max(abs(v[id].first - v[j].first), abs(v[id].second - v[j].second));
			while (to.size() <= dist)
				to.push_back(0);
			to[dist]++;
			norm(to);
			if (bless(to, dp[j])) {
				dp[j] = to;
				p[j] = id;
			}
		}
	}
	vector<int> output = {k - 1};
	int cur = k - 1;
	while (cur != 0) {
		cur = p[cur];
		output.push_back(cur);
	}
	reverse(output.begin(), output.end());
	cout << output.size() << '\n';
	for (int a : output)
		cout << a + 1 << ' ';
}

void solve() {
	int n, m, k;
	cin >> n >> m >> k;
	v.resize(k);
	for (int i = 0; i < k; ++i)
		cin >> v[i].first >> v[i].second;
	dijkstr();
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif
	solve();
	return 0;
}