#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
//#include "Source.h"

using namespace std;

typedef long long ll;

const int MSIZE = 4e5;
const ll INF = 2e9;

ll tree[MSIZE * 4];


void add(int v, int tl, int tr, int pos, ll val) {
	if (tl == tr) {
		tree[v] += val;
		return;
	}
	int tm = (tl + tr) / 2;
	if (pos <= tm)
		add(v * 2, tl, tm, pos, val);
	else
		add(v * 2 + 1, tm + 1, tr, pos, val);
	tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

ll get(int v, int tl, int tr, int l, int r) {
	if (l > r)
		return 0;
	if (tl == l && tr == r)
		return tree[v];
	int tm = (tl + tr) / 2;
	return get(v * 2, tl, tm, l, min(r, tm)) + get(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}

vector<ll> work(int n, vector<ll>& a) {
	vector<ll> res(n, 0);
	for (int i = 0; i < MSIZE * 4; ++i)
		tree[i] = 0;
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		v[i] = a[i] - i;
	vector<ll> temp = v;
	map<ll, ll> mp;
	sort(temp.begin(), temp.end());
	temp.resize(unique(temp.begin(), temp.end()) - temp.begin());
	for (int i = 0; i < temp.size(); ++i)
		mp[temp[i]] = i;
	for (int i = 0; i < n; ++i)
		v[i] = mp[v[i]];
	for (int i = 0; i < v.size(); ++i) {
		res[i] += get(1, 0, n - 1, 0, v[i] - 1);
		add(1, 0, n - 1, v[i], 1);
	}
	return res;
}

void solve() {
	int n, p;
	cin >> n >> p;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<ll> res1 = work(n, a);
	reverse(a.begin(), a.end());
	vector<ll> res2 = work(n, a);
	reverse(res2.begin(), res2.end());
	for (int i = 0; i < n; ++i)
		cout << res1[i] + res2[i] + 1 << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif 
	solve();

	return 0;
}
