#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
//#include "Source.h"

using namespace std;

typedef long long ll;

const int MSIZE = 4e5;
const ll INF = 2e9;

ll tree[MSIZE];
int n;
void add(int i, ll delta) {
	for (; i < n; i = i | (i + 1))
		tree[i] += delta;
}

ll get(ll i) {
	ll res = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		res += tree[i];
	return res;
}

int get(int l, int r) {
	return get(r) - get(l - 1);
}

vector<ll> work(vector<ll>& a) {
	vector<ll> res(n, 0);
	for (int i = 0; i < MSIZE; ++i)
		tree[i] = 0;
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		v[i] = a[i] - i;
	vector<ll> temp = v;
	unordered_map<ll, ll> mp;
	sort(temp.begin(), temp.end());
	temp.resize(unique(temp.begin(), temp.end()) - temp.begin());
	for (int i = 0; i < temp.size(); ++i)
		mp[temp[i]] = i;
	for (int i = 0; i < n; ++i)
		v[i] = mp[v[i]];
	for (int i = 0; i < v.size(); ++i) {
		res[i] += get(0, v[i] - 1);
		add(v[i], 1);
	}
	return res;
}

void solve() {
	int p;
	cin >> n >> p;
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<ll> res1 = work(a);
	reverse(a.begin(), a.end());
	vector<ll> res2 = work(a);
	reverse(res2.begin(), res2.end());
	for (int i = 0; i < n; ++i)
		cout << res1[i] + res2[i] + 1 << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif 
	solve();
	return 0;
}
