#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
//#include "Source.h"

using namespace std;

typedef long long ll;

const int MSIZE = 4e5;
const ll INF = 2e9;

int n;

void add(int i, ll delta, vector<ll>& t) {
	for (; i < n; i = i | (i + 1))
		t[i] += delta;
}

ll get(ll i, vector<ll>& t) {
	ll res = 0;
	for (; i >= 0; i = (i & (i + 1)) - 1)
		res += t[i];
	return res;
}

int get(int l, int r, vector<ll>& t) {
	return get(r, t) - get(l - 1, t);
}

vector<ll> work1(vector<ll>& a) {
	vector<ll> tree(n, 0);
	vector<ll> res(n, 0);
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		v[i] = a[i] - i;
	vector<ll> temp = v;
	unordered_map<ll, ll> mp;
	sort(temp.begin(), temp.end());
	temp.resize(unique(temp.begin(), temp.end()) - temp.begin());
	for (int i = 0; i < temp.size(); ++i)
		mp[temp[i]] = i;
	for (int i = 0; i < n; ++i)
		v[i] = mp[v[i]];
	for (int i = 0; i < v.size(); ++i) {
		res[i] += get(0, v[i] - 1, tree);
		add(v[i], 1, tree);
	}
	return res;
}

void solve1() {
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<ll> res1 = work1(a);
	reverse(a.begin(), a.end());
	vector<ll> res2 = work1(a);
	reverse(res2.begin(), res2.end());
	for (int i = 0; i < n; ++i)
		cout << res1[i] + res2[i] + 1 << '\n';
}

/*
vector<ll> work3(vector<ll>& a) {
	vector<ll> res(n, 0), tree(n, 0), v(n);
	vector<ll> temp;
	set<pair<ll, ll> > st;
	for (int i = 0; i < n; ++i)
		temp.push_back(a[i]);

	unordered_map<ll, ll> mp;
	sort(temp.begin(), temp.end());
	temp.resize(unique(temp.begin(), temp.end()) - temp.begin());
	for (int i = 0; i < temp.size(); ++i) {
		mp[temp[i]] = i;
		st.insert({temp[i], i});
	}
	for (int i = 0; i < n; ++i)
		v[i] = mp[a[i]];

	int lastl = -1;
	for (int i = 0; i < n; ++i) {
		int dist = min(i, n - i - 1);
		while (lastl != i - dist) {
			lastl++;
			if (lastl > 0) 
				add(v[lastl - 1], 1, tree);
		}
		auto it = (--st.upper_bound({a[i] + dist, INF}));
		res[i] += get(0, it->second, tree);
		//cout << res[i] << " " << it->first << " " << it->second << endl;
	}
	return res;
}

vector<ll> work2(vector<ll>& a) {
	vector<ll> res(n, 0);
	vector<ll> tree(n, 0);
	vector<ll> v(n);
	for (int i = 0; i < n; ++i)
		v[i] = a[i] + i;

	vector<ll> temp = v;
	unordered_map<ll, ll> mp;
	sort(temp.begin(), temp.end());
	temp.resize(unique(temp.begin(), temp.end()) - temp.begin());
	for (int i = 0; i < temp.size(); ++i)
		mp[temp[i]] = i;
	for (int i = 0; i < n; ++i)
		v[i] = mp[v[i]];

	int lastl = -1;
	for (int i = 0; i < n; ++i) {
		int dist = min(i, n - i - 1);
		while (lastl != i - dist) {
			lastl++;
			if (lastl > 0) {
				add(v[lastl - 1], -1, tree);
			}
		}
		res[i] += get(0, v[i] - 1, tree);
		add(v[i], 1, tree);
	}
	vector<ll> tmpres = work3(a);
	for (int i = 0; i < tmpres.size(); ++i) {
		cout << res[i] << " " << tmpres[i] << endl;
		res[i] += tmpres[i];
	}
	return res;
}

void solve2() {
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<ll> res1 = work2(a);
	reverse(a.begin(), a.end());
	vector<ll> res2 = work2(a);
	reverse(res2.begin(), res2.end());
	for (int i = 0; i < n; ++i)
		cout << res1[i] + res2[i] + 1 << '\n';
}*/

void solve2() {
	vector<ll> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	vector<ll> res(n, 0);
	for (int i = 0; i < n; ++i) {
		for (int dist = 0; dist < n; ++dist) {
			vector<ll> temp = a;
			int flag = 0;
			if (i - dist > 0) {
				flag = 1;
				for(int j = i - dist; j <= min(n - 1, i + dist); ++j)
					temp[j] += (j - (i - dist) + 1);
			}
			if (i + dist < n - 1) {
				for (int j = i + dist; j >= max(0, i - dist); --j)
					if (flag == 0)
						temp[j] += ((i + dist) - j + 1);
					else
						temp[j] = min(temp[j], a[j] + ((i + dist) - j + 1));
			}
			ll cnt = 0;
			for (int j = 0; j < n; ++j)
				if (temp[j] < temp[i])
					cnt++;
			res[i] = max(res[i], cnt);
		}
	}
	for (int a : res)
		cout << a + 1 << '\n';
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
#ifdef Sam
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
#endif 
	int p;
	cin >> n >> p;
	if (p == 1)
		solve1();
	else
		solve2();
	return 0;
}
