#include <iostream>
#include <vector>
#include <deque>
#include <algorithm>

using namespace std;

int n;
vector <int> a;
vector <pair <int, int>> t;

void build(int v, int tl, int tr) {
	if (tl == tr)
		return void(t[v] = { tl, tr });

	int tm = (tl + tr) / 2;
	build(2 * v, tl, tm);
	build(2 * v + 1, tm + 1, tr);

	if (a[t[2 * v].first] <= a[t[2 * v + 1].first])
		t[v].first = t[2 * v].first;
	else
		t[v].first = t[2 * v + 1].first;

	if (a[t[2 * v].second] > a[t[2 * v + 1].second])
		t[v].second = t[2 * v].second;
	else
		t[v].second = t[2 * v + 1].second;
}

int get_min(int v, int tl, int tr, int l, int r) {
	if (r < l)
		return -1;
	if (tl == l && tr == r)
		return t[v].first;

	int tm = (tl + tr) / 2;

	int x1 = get_min(2 * v, tl, tm, l, min(tm, r));
	int x2 = get_min(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);

	if (x1 == -1 && x2 == -1) return -1;
	else if (x1 == -1) return x2;
	else if (x2 == -1) return x1;
	else
		if (a[x1] <= a[x2])
			return x1;
		else
			return x2;
}

int get_max(int v, int tl, int tr, int l, int r) {
	if (r < l)
		return -1;
	if (tl == l && tr == r)
		return t[v].second;

	int tm = (tl + tr) / 2;

	int x1 = get_max(2 * v, tl, tm, l, min(tm, r));
	int x2 = get_max(2 * v + 1, tm + 1, tr, max(tm + 1, l), r);

	if (x1 == -1 && x2 == -1) return -1;
	else if (x1 == -1) return x2;
	else if (x2 == -1) return x1;
	else
		if (a[x1] > a[x2])
			return x1;
		else
			return x2;
}

int get_ans(int l, int r) {
	if (r < l)
		return 0;

	int x1 = get_min(1, 0, n - 1, l, r);
	int x2 = get_max(1, 0, n - 1, x1, r);

	return get_ans(l, x1 - 1) + get_ans(x2 + 1, r) + 1;
}

int main() {
	cin >> n;

	a.resize(n);
	t.resize(4 * n + 10);
	for (int i = 0; i < n; i++) cin >> a[i];

	build(1, 0, n - 1);

	cout << get_ans(0, n - 1);

	return 0;
}