import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class D {
    public static void main(String[] args) throws IOException {
        BufferedReader b = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer s = new StringTokenizer(b.readLine());
        s.nextToken();
        s.nextToken();
        int k = Integer.parseInt(s.nextToken());
        BigInteger[][] shapes = new BigInteger[k][k];
        int[] x = new int[k];
        int[] y = new int[k];
        for (int i = 0; i < k; i++) {
            s = new StringTokenizer(b.readLine());
            x[i] = Integer.parseInt(s.nextToken());
            y[i] = Integer.parseInt(s.nextToken());
        }
        for (int i = 0; i < k; i++) {
            for (int j = i; j < k; j++) {
                shapes[i][j] = new BigInteger("2");
                shapes[i][j] = shapes[i][j].pow(Math.max(Math.abs(x[i] - x[j]), Math.abs(y[i] - y[j])));
            }
        }
        Node[] length = new Node[k];
        boolean[] was = new boolean[k];
        PriorityQueue<Node> al = new PriorityQueue<>();
        for (int i = 0; i < k; i++) {
            length[i] = new Node(i, shapes[0][i].abs());
            al.add(length[i]);
        }
        while (!al.isEmpty()) {
            Node now = al.poll();
            if (now.num == (k - 1)) {
                break;
            }
            was[now.num] = true;
            for (int i = 0; i < k; i++) {
                if (was[i]) {
                    continue;
                }
                if (now.val.add(shapes[Math.min(now.num, i)][Math.max(now.num, i)]).compareTo(length[i].val) < 0) {
                    al.remove(length[i]);
                    length[i].val = now.val.add(shapes[Math.min(now.num, i)][Math.max(now.num, i)]);
                    length[i].pNum = now.num;
                    al.add(length[i]);
                }
            }
        }
        ArrayList<Integer> out = new ArrayList<>();
        Node no = length[k - 1];
        out.add(no.num);
        while (no.num != 0) {
            out.add(no.pNum);
            no = length[no.pNum];
        }
        System.out.println(out.size());
        StringBuilder ss  = new StringBuilder();
        for (int i = out.size() - 1; i > -1; i--) {
            ss.append((out.get(i) + 1) + " ");
        }
        System.out.println(ss);
        return;
    }
}

class Node implements Comparable<Node> {
    int num;
    BigInteger val;
    int pNum;

    Node(int nu, BigInteger bi) {
        num = nu;
        val = bi;
        pNum = 0;
    }

    @Override
    public int compareTo(Node o) {
        return val.compareTo(o.val);
    }
}