#include <iostream>
#include <fstream>
#include <set>
#include <vector>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <list>
#include <stack>
#include <queue>
#include <algorithm>
#include <string>
#include <functional>
#include <cassert>
#include <cmath>
#include <climits>
using namespace std;
//#define DEBUG
#ifdef  DEBUG
ifstream input("input.txt");
ofstream output("output.txt");
#define cin input
#define cout output
#endif //  DEBUG

struct T {
	int x, pos;
};


struct SegmentTreeMin{
	int size, power, shift;
	T *base, *shared, d;

	T op(T a, T b) {
		if (a.x == b.x)return (a.pos < b.pos) ? a : b;
		return ((a.x < b.x) ? a : b);
	}

	SegmentTreeMin(int p, T def) {

		d = def;
		power = p;
		size = (1 << p) << 1;
		shift = (1 << p) - 1;
		base = new T[size];
		shared = base + shift;
		fill_n(base, size, d);

	}

	void Build() {
		for (int i = shift - 1; i >= 0; i--)base[i] = op(base[2 * i + 1], base[2 * i + 2]);
	}

	T Query(int l, int r) {
		T res = d;
		l += shift;
		r += shift;
		while (r > l) {
			if ((l & 1) == 0) {
				res = op(res, base[l]);
				l++;
			}

			if ((r & 1) == 1) {
				res = op(res, base[r]);
				r--;
			}

			l = (l - 1) >> 1;
			r = (r - 1) >> 1;
		}

		if (l == r)res = op(res, base[l]);
		return res;
	}

};


struct SegmentTreeMax {
	int size, power, shift;
	T *base, *shared, d;
	
	T op(T a, T b) {
		if (a.x == b.x)return (a.pos > b.pos) ? a : b;
		return ((a.x > b.x) ? a : b);
	}

	SegmentTreeMax(int p, T def) {
		
		d = def;
		power = p;
		size = (1 << p) << 1;
		shift = (1 << p) - 1;
		base = new T[size];
		shared = base + shift;
		fill_n(base, size, d);
		
	}

	void Build() {
		for (int i = shift - 1; i >= 0; i--)base[i] = op(base[2 * i + 1], base[2 * i + 2]);
	}

	T Query(int l, int r) {
		T res = d;
		l += shift;
		r += shift;
		while (r > l) {
			if ((l & 1) == 0) {
				res = op(res, base[l]);
				l++;
			}

			if ((r & 1) == 1) {
				res = op(res, base[r]);
				r--;
			}

			l = (l - 1) >> 1;
			r = (r - 1) >> 1;
		}

		if (l == r)res = op(res, base[l]);
		return res;
	}

};

int *a, n;

SegmentTreeMax *maxtree;
SegmentTreeMin *mintree;



int lmin(int l, int r) {
	return mintree->Query(l, r).pos;
	int ans = l;
	for (int i = l; i <= r; i++) {
		if (a[i] < a[ans]) ans = i;
	}
	return ans;
}

int rmax(int l, int r) {
	return maxtree->Query(l, r).pos;
	int ans = l;
	for (int i = l; i <= r; i++) {
		if (a[i] >= a[ans])ans = i;
	}
	return ans;
}

int gans(int l, int r) {
	if (l == r)return 1;
	if (l > r) return 0;

	int lm = lmin(l, r);
	int rm = rmax(l, r);
	if (rm < lm) {
		return gans(l, rm) + gans(rm + 1, lm - 1) + gans(lm, r);
	}
	else {
		return gans(l, lm - 1) + gans(rm + 1, r) + 1;
	}
}



int main() {
	
	
	cin >> n;
	a = new int[n+1];
	for (int i = 0; i < n; i++)cin >> a[i];
	
	mintree = new SegmentTreeMin(log2(n) + 1, { INT32_MAX / 2, -1 });
	maxtree = new SegmentTreeMax(log2(n) + 1, { -INT32_MAX / 2, -1 });

	for (int i = 0; i < n; i++) {
		mintree->shared[i] = maxtree->shared[i] = { a[i],i };
	}
	mintree->Build();
	maxtree->Build();

	cout << gans(0, n - 1);
	return 0;
}
