#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define all(x) (x).begin(), (x).end()
#define rep(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define f first
#define s second

const int MAXN = 150005;
const int MAXV = 1e9 + 7;

struct node {
	ll cnt;
	node *left, *right;
	node() {
		left = right = nullptr;
		cnt = 0;
	}
};

int n;
pair<ll, ll> a[MAXN];
int ord[MAXN];
node *root;

ll get(node *v) {
	if (v == nullptr) return 0;
	return v->cnt;
}

ll query(node *v, int tl, int tr, int l, int r) {
	if (r <= tl || tr <= l) return 0;
	if (l <= tl && tr <= r) return get(v);
	if (v == nullptr) return 0;
	
	int tm = tl + (tr - tl) / 2;
	ll a = query(v->left, tl, tm, l, r);
	ll b = query(v->right, tm, tr, l, r);
	return a + b;
}

node* update(node *v, int tl, int tr, int pos, int val) {
	if (v == nullptr) v = new node();
	if (tr - tl == 1) {
		v->cnt += val;
		return v;
	}
	int tm = tl + (tr - tl) / 2;
	if (pos < tm) {
		v->left = update(v->left, tl, tm, pos, val);
	} else {
		v->right = update(v->right, tm, tr, pos, val);
	}
	v->cnt = get(v->left) + get(v->right);
	return v;
}

ll get_ans(int pos) {
	ll s = query(root, 0, MAXV, pos, MAXV) * pos;
	return s;
}

int main() {
	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;
	rep(i, n) {
		cin >> a[i].f >> a[i].s;
		ord[i] = a[i].s;
	}
	// cout << endl;

	sort(a, a + n);
	sort(ord, ord + n);
	reverse(a, a + n);

	rep(i, n) {
		root = update(root, 0, MAXV, a[i].s, 1);
	}

	ll mx = INT_MIN, ps = -1;
	root = update(root, 0, MAXV, a[0].s, -1);
	for (int p2 = 0; p2 < n; ++p2) {
		if (ord[p2] > a[0].f) continue;
		ll s2 = get_ans(ord[p2]);
		if (s2 > mx) {
			mx = s2;
			ps = p2;
		}
	}
	ll p2 = ps, res = a[0].f + get_ans(ord[p2]);

	for (int p1 = 1; p1 < n; ++p1) {
		root = update(root, 0, MAXV, a[p1].s, -1);
		res = max(res, get_ans(ord[p2]) + a[p1].f * (p1 + 1));
		while (true) {
			if (p2 == n - 1) break;
			if (get_ans(ord[p2 + 1]) > get_ans(ord[p2])) {
				p2++;
			} else {
				break;
			}
			if (p1 > p2) {
				res = max(res, get_ans(a[p1].f) + a[p1].f * (p1 + 1));
			} else {
				res = max(res, get_ans(ord[p2]) + a[p1].f * (p1 + 1));
			}
		}
	}
	cout << res << endl;
}